## 25th Feb after discussion with GS. Trying to make general script to do to lots of core stuff.
## USE MICRONS AND HOURS FOR EVERYTHING IF POSS. Make order of columns nice (don't change those used by MATLAB analysis code).
## Put all outputs into a protected subfolder.
## Need to export CSVs AND also plot them. Not clear a priori what scale to plot on etc. 
dir.create("core")
dir.create("core/noborder")

## Pre-running tasks
# import as dataset TissueHeightR.csv

## THIS VERSION IS FOR NOBORDER. Do that first then make other versions.
## Append all things with _noborder.

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% #### %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##

load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")

# INSERT -- div-div lifetimes, print raw CSV
lifetimes_noborder <- cellinfoDB %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% select(cell_id, first_occ, last_occ)
lifetimes_noborder$lifetime <- (lifetimes_noborder$last_occ - lifetimes_noborder$first_occ)*2.5/60
lifetimes_noborder <- lifetimes_noborder %>% select(lifetime)
write.csv(lifetimes_noborder,file="core/noborder/lifetimes_noborder.csv")
# END INSERT

# CDRATE
CDrate_noborder <- multi_db_query(movieDirs, mqf_cg_roi_rate_CD, "anterior") %>% 
  chunk_time_into_intervals(3600) %>%
  group_by(movie, roi,interval_mid) %>%
  summarise(avgCDrate=mean(cell_loss_rate),
            semCD=se(cell_loss_rate),
            time_sec=interval_mid[1],
            dev_time=mean(dev_time))

# Cumulative count of cell divisions
disappearsbydiv_noborder <- cellinfoDB %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,last_occ)
count_div_noborder <- frames %>% select(frame)
# cross join to get every combination of frame and dropout times
count_div_noborder <- merge(x = count_div_noborder, y = disappearsbydiv_noborder, by = NULL)
# then filter
count_div_noborder <- count_div_noborder %>% filter(last_occ < frame)
count_div_noborder <- count_div_noborder %>% select(frame) %>% group_by(frame) %>% summarise(count = n())
count_div_noborder$dev_time <- count_div_noborder$frame*2.5/60
count_div_noborder <- count_div_noborder %>% select(frame,dev_time,count)

# T1 RATE noborder but irrespective of direction.
  T1rate_noborder <- multi_db_query(movieDirs, mqf_cg_roi_rate_T1, "anterior") %>% 
    chunk_time_into_intervals(deltaT = 3600) %>%
    group_by(movie, roi,interval_mid) %>%
    summarise(avgT1rate=mean(cell_topo_rate),
              semT1=se(cell_topo_rate),
              time_sec=interval_mid[1],
              dev_time=mean(dev_time))
# possible to do cumulation of T1s too?

# cdNematic avg plot KERNSIZE 11 IN COMMON WITH OTHER STUFF
avgCDNematic <- multi_db_query(movieDirs, mqf_cg_roi_unit_nematics_CD, "anterior", kernSize = 11)
avgCDNematic <- avgCDNematic %>% select(frame,dev_time,cgCDxx_smooth,cgCDxy_smooth)
#exclude NA
avgCDNematic <- avgCDNematic %>% filter(is.na(cgCDxx_smooth) == FALSE) %>% filter(is.na(cgCDxy_smooth) == FALSE)

# Cellarea
cellarea_noborder <- cellsDB %>% filter(cell_id %in% roiHistoNoborder$cell_id ) %>% select(cell_id,frame,area) %>% group_by(frame) %>% summarise(avgarea = mean(area)*0.207^2,sd_area = sd(area)*0.207^2 )
cellarea_noborder$dev_time <- cellarea_noborder$frame * 2.5/60
cellarea_noborder <- cellarea_noborder[,c(1,4,2,3)]
# Cellnumber
cellnumber_noborder <- cellsDB %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,frame) %>% group_by(frame) %>% summarise(n = n())
cellnumber_noborder$dev_time <- cellnumber_noborder$frame * 2.5/60
cellnumber_noborder <- cellnumber_noborder[,c(1,3,2)]

# avg cell elongs _xx and _xy
cellelongs_noborder <- mqf_cg_roi_nematics_cell_elong(movieDir = "time", rois = "anterior") %>% select(frame,dev_time,cgExx_smooth, cgExy_smooth)

# Totalarea
totalarea_noborder <- cellarea_noborder %>% dt.merge(cellnumber_noborder,by="frame")
totalarea_noborder$total_area <- totalarea_noborder$n * totalarea_noborder$avgarea
totalarea_noborder$dev_time <- totalarea_noborder$frame*2.5/60 
totalarea_noborder <- totalarea_noborder %>% select(frame,dev_time,total_area)

# lifetime data noborder. Can I do this like p and alpha in 50 frame bins to get avg lifetime as fn of first_occ?
lifetimes_noborder <- cellinfoDB %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,first_occ,last_occ)
lifetimes_noborder$lifetime <- lifetimes_noborder$last_occ - lifetimes_noborder$first_occ

lifetimes_trend_noborder <- frames %>% select(frame) %>% filter(frame %% 50 == 0)
lifetimes_trend_noborder <- lifetimes_trend_noborder %>% rename(min_frame = frame)
lifetimes_trend_noborder$max_frame <- lifetimes_trend_noborder$min_frame + 50 
for (row in 1:nrow(lifetimes_trend_noborder)) {
  lifetimes_trend_noborder[row,"n_div"] = lifetimes_noborder %>% filter(first_occ > lifetimes_trend_noborder[row,"min_frame"] & first_occ < lifetimes_trend_noborder[row,"max_frame"]) %>% nrow()
}
for (row in 1:nrow(lifetimes_trend_noborder)) {
  lifetimes_trend_noborder[row,"mean_life"] = (lifetimes_noborder %>% filter(first_occ > lifetimes_trend_noborder[row,"min_frame"] & first_occ < lifetimes_trend_noborder[row,"max_frame"]))$lifetime %>% mean()
}
for (row in 1:nrow(lifetimes_trend_noborder)) {
  lifetimes_trend_noborder[row,"sd_life"] = (lifetimes_noborder %>% filter(first_occ > lifetimes_trend_noborder[row,"min_frame"] & first_occ < lifetimes_trend_noborder[row,"max_frame"]))$lifetime %>% sd()
}
lifetimes_trend_noborder$dev_time <- ((lifetimes_trend_noborder$min_frame + lifetimes_trend_noborder$max_frame)/2) * 2.5/60
lifetimes_trend_noborder <- lifetimes_trend_noborder %>% select(min_frame,max_frame,dev_time,n_div,mean_life,sd_life)
lifetimes_trend_noborder$mean_life <- lifetimes_trend_noborder$mean_life*2.5/60
lifetimes_trend_noborder$sd_life <- lifetimes_trend_noborder$sd_life*2.5/60

## do higher resolution 25 frame bins
lifetimes_trend_noborder_25 <- frames %>% select(frame) %>% filter(frame %% 25 == 0)
lifetimes_trend_noborder_25 <- lifetimes_trend_noborder_25 %>% rename(min_frame = frame)
lifetimes_trend_noborder_25$max_frame <- lifetimes_trend_noborder_25$min_frame + 25 
for (row in 1:nrow(lifetimes_trend_noborder_25)) {
  lifetimes_trend_noborder_25[row,"n_div"] = lifetimes_noborder %>% filter(first_occ > lifetimes_trend_noborder_25[row,"min_frame"] & first_occ < lifetimes_trend_noborder_25[row,"max_frame"]) %>% nrow()
}
for (row in 1:nrow(lifetimes_trend_noborder_25)) {
  lifetimes_trend_noborder_25[row,"mean_life"] = (lifetimes_noborder %>% filter(first_occ > lifetimes_trend_noborder_25[row,"min_frame"] & first_occ < lifetimes_trend_noborder_25[row,"max_frame"]))$lifetime %>% mean()
}
for (row in 1:nrow(lifetimes_trend_noborder_25)) {
  lifetimes_trend_noborder_25[row,"sd_life"] = (lifetimes_noborder %>% filter(first_occ > lifetimes_trend_noborder_25[row,"min_frame"] & first_occ < lifetimes_trend_noborder_25[row,"max_frame"]))$lifetime %>% sd()
}
lifetimes_trend_noborder_25$dev_time <- ((lifetimes_trend_noborder_25$min_frame + lifetimes_trend_noborder_25$max_frame)/2) * 2.5/60
lifetimes_trend_noborder_25 <- lifetimes_trend_noborder_25 %>% select(min_frame,max_frame,dev_time,n_div,mean_life,sd_life)
lifetimes_trend_noborder_25$mean_life <- lifetimes_trend_noborder_25$mean_life*2.5/60
lifetimes_trend_noborder_25$sd_life <- lifetimes_trend_noborder_25$sd_life*2.5/60


# IsoContrib
isoContrib <- multi_db_query(movieDirs, mqf_cg_roi_rate_isotropic_contrib, c("anterior"),kernSize=21) 
deltaT=150 # sampling (150 seconds WTs etc. )
avgIsoDefRateInterpolated <- isoContrib %>%
  align_movie_start(movieDirs) %>%
  mutate(min_dev_time=min(dev_time),
         max_dev_time=max(dev_time)) %>% 
  group_by(movie, roi, isoContrib) %>%
  # here, we do a linear interpolation of the data (60 sec per point)
  do({
    with(., approx(dev_time, value.ma,
                   xout = seq(min_dev_time[1], max_dev_time[1],
                              by = deltaT/3600), method = "linear")) %>% as.df()
  }) %>%
  rename(dev_time=x, value.ma=y) %>%
  filter(!is.na(value.ma)) %>%
  ungroup() %>% mutate(movieNb=length(unique(movie))) %>% 
  group_by(roi, isoContrib, dev_time) %>%
  # Make sure that further calculations will be done on values present in all compared movies
  filter(n()==movieNb) %>% ungroup()

# average data between the 3 movies amongst ROI  
avgIsoDefRateSummary <- avgIsoDefRateInterpolated %>%
  group_by(roi, isoContrib, dev_time) %>%
  summarise(value.avg=mean(value.ma), value.sd=sd(value.ma))

avgIsoDefCum <- avgIsoDefRateInterpolated %>%
  group_by(movie, roi, isoContrib) %>%
  mutate(timeInt=c(0,diff(dev_time)), value.cumsum=cumsum(value.ma*timeInt)) %>% 
  group_by(roi, isoContrib, dev_time) %>%
  summarise(cumsum.avg=mean(value.cumsum), cumsum.sd=sd(value.cumsum))

# Shear Stuff (run sm shear_calc with correct roi_bt first!)
# SHEAR
selectedRois <- "anterior"
shearData <- multi_db_query(movieDirs, mqf_cg_roi_rate_shear, selectedRois)

shearRateSlim <- subset(shearData, (tensor=="CEwithCT" | tensor=="correlationEffects" |
                                      tensor=="nu" | tensor=="ShearT1" | 
                                      tensor=="ShearT2" | tensor=="ShearCD" | tensor=="sumContrib"))
shearRateSlim$tensor <- factor(shearRateSlim$tensor, 
                               levels=c("ShearCD", "CEwithCT", "correlationEffects",
                                        "nu", "ShearT1", "ShearT2", "sumContrib"),
                               labels=c("cell_division", "cell_elongation_change",
                                        "correlation_effects","total_shear","T1", "T2","sumContrib"))

# interpolate data
deltaT=150
shearRateInterpolated <- shearRateSlim %>% 
  align_movie_start(movieDirs) %>%
  select(-c(xy,yx,yy,xy.ma,yx.ma,yy.ma, TimeInt.ma,
            phi, norm,time_sec,timeInt_sec,closestFrame,time_shift)) %>%
  mutate(min_dev_time=min(dev_time),
         max_dev_time=max(dev_time)) %>% 
  group_by(movie, roi, tensor) %>%
  do({
    with(., approx(dev_time, xx.ma,
                   xout = seq(min_dev_time[1], max_dev_time[1],
                              by = deltaT/3600), method = "linear")) %>% as.df()
  }) %>%
  rename(dev_time=x, XX=y) %>% 
  filter(!is.na(XX)) %>%
  ungroup() %>% mutate(movieNb=length(unique(movie))) %>% 
  group_by(roi, tensor, dev_time) %>%
  # Make sure that further calculations will be done on values present in all compared movies
  filter(n()==movieNb) %>% ungroup()

# average data between the 3 movies amongst ROI
shearRateSummary <- shearRateInterpolated %>%
  group_by(roi, tensor, dev_time) %>%
  summarise(xx.avg=mean(XX), xx.sd=sd(XX))

shearCumSumSummary <- shearRateInterpolated %>%
  group_by(movie, roi, tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(XX*timeInt)) %>%
  group_by(roi, tensor, dev_time) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))

# Vxx and Vyy using the fine resolution shear rate and avgIso stuff. Not using the weird 'smoothed' rate I did before here.
# I guess can smooth this afterward anyway. 
shearRateSummary_total_only <- shearRateSummary %>% filter(tensor == "sumContrib")
avgIsoDefRateSummary_total_only <- avgIsoDefRateSummary %>% filter(isoContrib == "sumContrib")
shearRateSummary_total_only$approx_time <- round(shearRateSummary_total_only$dev_time,2)
avgIsoDefRateSummary_total_only$approx_time <- round(avgIsoDefRateSummary_total_only$dev_time,2)


vxx_and_vyy <- avgIsoDefRateSummary_total_only %>% dt.merge(shearRateSummary_total_only,by="approx_time") %>% select(dev_time.x,value.avg,value.sd,xx.avg,xx.sd) %>% rename(dev_time = dev_time.x)
# create vxx and vyy as instructed by GS
vxx_and_vyy$vxx <- (vxx_and_vyy$value.avg + vxx_and_vyy$xx.avg)/2
vxx_and_vyy$vyy <- (vxx_and_vyy$value.avg - vxx_and_vyy$xx.avg)/2
# propagate the stdeviation which is the same for vxx and vyy (assumes independence I think)
vxx_and_vyy$propagatederror <- sqrt(vxx_and_vyy$value.sd^2 + vxx_and_vyy$xx.sd^2)
# then need to plot it with standard deviation represented by ribbon.
# but to get into same form as before I need them all with a COMMON vii column, with 
vxx_and_vyy <- vxx_and_vyy %>% select(dev_time, vxx, vyy)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
# Stuff needing tissue height. Load TissueHeightR.csv as data. First Height Itself

## CAREFUL WITH TIME

TissueHeightTime <- as.data.frame(TissueHeightR$V1) %>% rename("time" = "TissueHeightR$V1")
TissueHeightTime$time <- TissueHeightTime$time/2.5
TissueHeightHeight <- as.data.frame(TissueHeightR$V2) %>% rename("height" = "TissueHeightR$V2")
#intermediate interpolation table
f <- approxfun(TissueHeightTime$time,TissueHeightHeight$height)
#get one data per frame up to frame e.g. 479 where the interpolation can't be done as outside range
TissueHeightPerFrame <- as.data.frame(f(seq(from=0,to=max(TissueHeightTime$time) -1 ,by=1)))
colnames(TissueHeightPerFrame) <- "height"
frames_height <- frames %>% filter(frame <= max(TissueHeightTime$time) -1 )
TissueHeightInterp <- frames_height
TissueHeightInterp$height <- TissueHeightPerFrame$height
TissueHeightInterp$dev_time <- TissueHeightInterp$frame*2.5/60
TissueHeightInterp <- TissueHeightInterp %>% select(frame,dev_time,height)

# Cellvolume
cellvolume_noborder <- cellarea_noborder %>% dt.merge(TissueHeightInterp,by="frame")
cellvolume_noborder$avgvolume <- cellvolume_noborder$avgarea*cellvolume_noborder$height 
cellvolume_noborder$sd_volume <- cellvolume_noborder$sd_area*cellvolume_noborder$height
cellvolume_noborder <- cellvolume_noborder %>% select(frame,avgvolume,sd_volume)
cellvolume_noborder$dev_time <- cellvolume_noborder$frame*2.5/60
cellvolume_noborder <- cellvolume_noborder %>% select(frame,dev_time,avgvolume,sd_volume)

# totalvolume
totalvolume_noborder <- totalarea_noborder %>% dt.merge(TissueHeightInterp,by="frame")
totalvolume_noborder$total_volume <- totalvolume_noborder$total_area*totalvolume_noborder$height
totalvolume_noborder <- totalvolume_noborder %>% select(frame,total_volume)
totalvolume_noborder$dev_time <- totalvolume_noborder$frame*2.5/60
totalvolume_noborder <- totalvolume_noborder %>% select(frame,dev_time,total_volume)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
# Red cell related stuff. EXCLUDE SOPS FROM DROPOUT_FULL_NOBORDER 
load("time/roi_BT/SOP_cell_id.RData")

dropout_full_noborder <- cellinfoDB %>% filter(disappears_by == "Unclassified") %>% select(cell_id,first_occ) %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(!(cell_id %in% SOP_cell_id$cell_id))
count_dropout_noborder <- frames %>% select(frame)
# cross join to get every combination of frame and dropout times
count_dropout_noborder <- merge(x = count_dropout_noborder, y = dropout_full_noborder, by = NULL)
# then filter
count_dropout_noborder <- count_dropout_noborder %>% filter(first_occ < frame)
count_dropout_noborder <- count_dropout_noborder %>% select(frame) %>% group_by(frame) %>% summarise(count = n())
count_dropout_noborder$dev_time <- count_dropout_noborder$frame*2.5/60
count_dropout_noborder <- count_dropout_noborder %>% select(frame,dev_time,count)

# p and alpha. get cdNematics_noborder first. Make sure non-spoofed lgRoiSmoothed in use, so that anterior means noborder. 
cdNematics_noborder <- mqf_fg_unit_nematics_CD(movieDir, rois = "anterior")
pandalpha <- frames %>% select(frame) %>% filter(frame %% 25 == 0)
pandalpha <- pandalpha %>% rename(min_frame = frame)
pandalpha$max_frame <- pandalpha$min_frame + 25 
# first get the number of divisions within the interval.
for (row in 1:nrow(pandalpha)) {
  pandalpha[row,"n_div"] = cdNematics_noborder %>% filter(frame > pandalpha[row,"min_frame"] & frame < pandalpha[row,"max_frame"]) %>% nrow()
}
# then calculate p as 1 minus the fraction of divisions that create two non-red cells
for (row in 1:nrow(pandalpha)) {
  pandalpha[row,"p"] = 1 - ((cdNematics_noborder %>% filter(frame > pandalpha[row,"min_frame"] & frame < pandalpha[row,"max_frame"]) %>% filter(!(left_daughter_cell_id %in% dropout_full_noborder$cell_id) & !(right_daughter_cell_id %in% dropout_full_noborder$cell_id)) %>% nrow())/ pandalpha[row,"n_div"])
}
# then calculate alpha..
for (row in 1:nrow(pandalpha)) {
  pandalpha[row,"alpha"] = ((cdNematics_noborder %>% filter(frame > pandalpha[row,"min_frame"] & frame < pandalpha[row,"max_frame"]) %>% filter((left_daughter_cell_id %in% dropout_full_noborder$cell_id) & (right_daughter_cell_id %in% dropout_full_noborder$cell_id)) %>% nrow())/ (pandalpha[row,"n_div"]*pandalpha[row,"p"]))
}

# put dev_time in middle of bin
pandalpha$dev_time <- ((pandalpha$min_frame + pandalpha$max_frame)/2) * 2.5/60
pandalpha <- pandalpha %>% select(min_frame,max_frame,dev_time,n_div,p,alpha)

# initial final and red cell nred data etc. in noborder. this is only div-div cells remember.
app_dis_by_div <- cellinfoDB %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% select(cell_id)
initial_areas_daughters_noborder <- cellinfoDB %>% select(cell_id,first_occ) %>% rename(frame = first_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(initial_area = area) %>% rename(first_occ = frame)
# then do the final areas too
final_areas <- cellinfoDB %>% select(cell_id,last_occ) %>% rename(frame = last_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(final_area = area) %>% rename(last_occ = frame)
# merge and keep only div-div cells in noborder region
initial_areas_daughters_noborder <- initial_areas_daughters_noborder %>% dt.merge(final_areas, by = "cell_id") %>% filter(cell_id %in% app_dis_by_div$cell_id) %>% filter(cell_id %in% roiHistoNoborder$cell_id)
# mistake lol
initial_final_areas_daughters_noborder <- initial_areas_daughters_noborder
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(cellinfoDB %>% select(cell_id, left_daughter_cell_id, right_daughter_cell_id),by="cell_id")
initial_final_areas_daughters_noborder$nred <- as.numeric(initial_final_areas_daughters_noborder$left_daughter_cell_id %in% dropout_full_noborder$cell_id) + as.numeric(initial_final_areas_daughters_noborder$right_daughter_cell_id %in% dropout_full_noborder$cell_id)
# re order columns to be like before
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder[,c(1,2,4,3,5,6,7,8)]

## %%%%%% more sophisticated red cell stuff 5 March, GS requests. 

## p and alpha for cells whose mother neighboured a red cell in its last time
load("time/topochanges/cellNeighbors.RData")
cdNematics_noborder_redneighbour <- cdNematics_noborder %>% select(frame, mother_cell_id, left_daughter_cell_id, right_daughter_cell_id)
# load in cellNeighbours from file then
cdNematics_noborder_redneighbour <- cdNematics_noborder_redneighbour %>% rename(cell_id = mother_cell_id) 
# subtract 1 from frame ,very important!
cdNematics_noborder_redneighbour$frame <- cdNematics_noborder_redneighbour$frame - 1
cdNematics_noborder_redneighbour <- cdNematics_noborder_redneighbour %>% dt.merge(cellNeighbors,by=c("frame","cell_id"))
# select ones where a neighbour is red. will have multiplicity here...
cdNematics_noborder_redneighbour <- cdNematics_noborder_redneighbour %>% filter(neighbor_cell_id %in% dropout_full_noborder$cell_id)
# add one back on to frame, unselect neighbor cell, and unique()
cdNematics_noborder_redneighbour$frame <- cdNematics_noborder_redneighbour$frame +1
cdNematics_noborder_redneighbour <- cdNematics_noborder_redneighbour %>% select(-neighbor_cell_id) %>% unique()
# now calculate p for this restricted set
pandalpha_redneighbour <- frames %>% select(frame) %>% filter(frame %% 50 == 0)
pandalpha_redneighbour <- pandalpha_redneighbour %>% rename(min_frame = frame)
pandalpha_redneighbour$max_frame <- pandalpha_redneighbour$min_frame + 50 
# first get the number of divisions within the interval.
for (row in 1:nrow(pandalpha_redneighbour)) {
  pandalpha_redneighbour[row,"n_div"] = cdNematics_noborder_redneighbour %>% filter(frame > pandalpha_redneighbour[row,"min_frame"] & frame < pandalpha_redneighbour[row,"max_frame"]) %>% nrow()
}
# then calculate p as 1 minus the fraction of divisions that create two non-red cells
for (row in 1:nrow(pandalpha_redneighbour)) {
  pandalpha_redneighbour[row,"p"] = 1 - ((cdNematics_noborder_redneighbour %>% filter(frame > pandalpha_redneighbour[row,"min_frame"] & frame < pandalpha_redneighbour[row,"max_frame"]) %>% filter(!(left_daughter_cell_id %in% dropout_full_noborder$cell_id) & !(right_daughter_cell_id %in% dropout_full_noborder$cell_id)) %>% nrow())/ pandalpha_redneighbour[row,"n_div"])
}
# then calculate alpha..
for (row in 1:nrow(pandalpha_redneighbour)) {
  pandalpha_redneighbour[row,"alpha"] = ((cdNematics_noborder_redneighbour %>% filter(frame > pandalpha_redneighbour[row,"min_frame"] & frame < pandalpha_redneighbour[row,"max_frame"]) %>% filter((left_daughter_cell_id %in% dropout_full_noborder$cell_id) & (right_daughter_cell_id %in% dropout_full_noborder$cell_id)) %>% nrow())/ (pandalpha_redneighbour[row,"n_div"]*pandalpha_redneighbour[row,"p"]))
}
# put dev_time in middle of bin
pandalpha_redneighbour$dev_time <- ((pandalpha_redneighbour$min_frame + pandalpha_redneighbour$max_frame)/2) * 2.5/60
pandalpha_redneighbour <- pandalpha_redneighbour %>% select(min_frame,max_frame,dev_time,n_div,p,alpha)

## the opposite: p and alpha only for mother cells NOT in contact with a red cell. 
cdNematics_noborder_NOredneighbour <- cdNematics_noborder %>% select(frame, mother_cell_id, left_daughter_cell_id, right_daughter_cell_id)
# load in cellNeighbours from file then
cdNematics_noborder_NOredneighbour <- cdNematics_noborder_NOredneighbour %>% rename(cell_id = mother_cell_id) 
# subtract 1 from frame ,very important!
cdNematics_noborder_NOredneighbour$frame <- cdNematics_noborder_NOredneighbour$frame - 1
cdNematics_noborder_NOredneighbour <- cdNematics_noborder_NOredneighbour %>% dt.merge(cellNeighbors,by=c("frame","cell_id"))
# select ones where NO NEIGHBOUR IS RED. easiest to use the list I've already made and negate it.
cdNematics_noborder_NOredneighbour <- cdNematics_noborder_NOredneighbour %>% filter(!(cell_id %in% cdNematics_noborder_redneighbour$cell_id))
# add one back on to frame, unselect neighbor cell, and unique()
cdNematics_noborder_NOredneighbour$frame <- cdNematics_noborder_NOredneighbour$frame +1
cdNematics_noborder_NOredneighbour <- cdNematics_noborder_NOredneighbour %>% select(-neighbor_cell_id) %>% unique()
# now calculate p for this restricted set
pandalpha_NOredneighbour <- frames %>% select(frame) %>% filter(frame %% 50 == 0)
pandalpha_NOredneighbour <- pandalpha_NOredneighbour %>% rename(min_frame = frame)
pandalpha_NOredneighbour$max_frame <- pandalpha_NOredneighbour$min_frame + 50 
# first get the number of divisions within the interval.
for (row in 1:nrow(pandalpha_NOredneighbour)) {
  pandalpha_NOredneighbour[row,"n_div"] = cdNematics_noborder_NOredneighbour %>% filter(frame > pandalpha_NOredneighbour[row,"min_frame"] & frame < pandalpha_NOredneighbour[row,"max_frame"]) %>% nrow()
}
# then calculate p as 1 minus the fraction of divisions that create two non-red cells
for (row in 1:nrow(pandalpha_NOredneighbour)) {
  pandalpha_NOredneighbour[row,"p"] = 1 - ((cdNematics_noborder_NOredneighbour %>% filter(frame > pandalpha_NOredneighbour[row,"min_frame"] & frame < pandalpha_NOredneighbour[row,"max_frame"]) %>% filter(!(left_daughter_cell_id %in% dropout_full_noborder$cell_id) & !(right_daughter_cell_id %in% dropout_full_noborder$cell_id)) %>% nrow())/ pandalpha_NOredneighbour[row,"n_div"])
}
# then calculate alpha..
for (row in 1:nrow(pandalpha_NOredneighbour)) {
  pandalpha_NOredneighbour[row,"alpha"] = ((cdNematics_noborder_NOredneighbour %>% filter(frame > pandalpha_NOredneighbour[row,"min_frame"] & frame < pandalpha_NOredneighbour[row,"max_frame"]) %>% filter((left_daughter_cell_id %in% dropout_full_noborder$cell_id) & (right_daughter_cell_id %in% dropout_full_noborder$cell_id)) %>% nrow())/ (pandalpha_NOredneighbour[row,"n_div"]*pandalpha_NOredneighbour[row,"p"]))
}
# put dev_time in middle of bin
pandalpha_NOredneighbour$dev_time <- ((pandalpha_NOredneighbour$min_frame + pandalpha_NOredneighbour$max_frame)/2) * 2.5/60
pandalpha_NOredneighbour <- pandalpha_NOredneighbour %>% select(min_frame,max_frame,dev_time,n_div,p,alpha)


## %%%%%%%%%%%%%%%%%%%%%%% EXTRA GS REQUEST 27 FEB 2019
## CREATE A TABLE OF 8 COLUMNS TO ADD TO THE INITIAL_FINAL_AREAS_DAUGHTERS_NOBORDER FILE.
## for cells that div_div and are in noborder.
## how many neighbours (IN NOBORDER) do they have in final frame
## how many red neighbours (IN NOBORDER etc.) do they have in final frame
## how many 2nd nearest neighbours do they have in final frame
## how many red 2nd nearest neighbours do they have in final frame. 
## and similarly for all four but cumulated over their life
## build from cell_id and then do a merge and then re-sort the order of columns probably.

## 2 APRIL CHANGES: want to make it so that second neighbourhood is ONLY second neighbours not first neighbours. and separate
## 3 APRIL CHANGES: allow for second neighbours (e.g.) connected via a first neighbour that isn't necessarily in the ROI

neighbours_red <- cellinfoDB %>% filter(disappears_by == "Division") %>% filter(appears_by == "Division") %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id, last_occ)
load("time/topochanges/cellNeighbors.RData") # has multiplicity remember
cellNeighbors <- cellNeighbors # %>% 3 APRIL!!! Allow any cell neighbour now. Apply filtering later. filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(neighbor_cell_id %in% roiHistoNoborder$cell_id) # only count neigbhbors in noborder as that's where red cells are defined.
neighbours_red <- neighbours_red %>% dt.merge(cellNeighbors,by="cell_id") # this gets the first neighbours for each cell

#separate out here. save for later..
firstneighbours_red <- neighbours_red
firstneighbours_red$neigh_red <- as.integer(firstneighbours_red$neighbor_cell_id %in% dropout_full_noborder$cell_id)

# now get the second neighbours . frame must be the same because we require neighbor_cell is a neighbor of cell at the same time second_neighbor is a neighbor of neighbor_cell. try this. CHECK AFTER
neighbours_red <- cellNeighbors %>% rename(second_neighbor = neighbor_cell_id) %>% rename(neighbor_cell_id = cell_id) %>% dt.merge(neighbours_red,by=c("neighbor_cell_id","frame"), allow.cartesian=TRUE)
neighbours_red <- neighbours_red %>% filter(cell_id != second_neighbor)
# 2 april change! remove any cases where second neighbour is a member of the first neighbourship at the same frame for the same cell
neighbours_red <- anti_join(neighbours_red %>% rename(temp = second_neighbor), firstneighbours_red %>% rename(temp = neighbor_cell_id),by=c("frame","cell_id","last_occ","temp")) %>% rename(second_neighbor = temp)
neighbours_red <- neighbours_red %>% select(cell_id,frame,last_occ,neighbor_cell_id,second_neighbor) #reorder columns

# separate out here.
secondneighbours_red <- neighbours_red %>% select(cell_id,last_occ,frame,second_neighbor) %>% unique()
secondneighbours_red$sec_neigh_red <-  as.integer(secondneighbours_red$second_neighbor %in% dropout_full_noborder$cell_id)

# 3 APRIL CHANGE after creating all separated-out tables: allow only neighbours which are inside noborder
firstneighbours_red <- firstneighbours_red %>% filter(neighbor_cell_id %in% roiHistoNoborder$cell_id)
secondneighbours_red <- secondneighbours_red %>% filter(second_neighbor %in% roiHistoNoborder$cell_id)

# now do this version of table for final frame only and do the counts. 
firstneighbours_red_last_frame <- firstneighbours_red %>% filter(last_occ == frame)
firstneighbours_red_last_frame <- firstneighbours_red_last_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]) )
secondneighbours_red_last_frame <- secondneighbours_red %>% filter(last_occ == frame)
secondneighbours_red_last_frame <- secondneighbours_red_last_frame %>% group_by(cell_id) %>% summarise(n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1]) )
#combine
neighbours_red_last_frame <- firstneighbours_red_last_frame %>% dt.merge(secondneighbours_red_last_frame,by="cell_id")

# now do version for all frames 
firstneighbours_red_all_frame <- firstneighbours_red 
firstneighbours_red_all_frame <- firstneighbours_red_all_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]) )
secondneighbours_red_all_frame <- secondneighbours_red
secondneighbours_red_all_frame <- secondneighbours_red_all_frame %>% group_by(cell_id) %>% summarise(n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1]) )
neighbours_red_all_frame <- firstneighbours_red_all_frame %>% dt.merge(secondneighbours_red_all_frame,by="cell_id")

#merge onto end
initial_final_areas_daughters_noborder$cell_id_merge <- initial_areas_daughters_noborder$cell_id
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(neighbours_red_last_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% rename(n_neigh_last = n_neigh, nred_neigh_last = nred_neigh, n_sec_neigh_last = n_sec_neigh, nred_sec_neigh_last = nred_sec_neigh)

initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(neighbours_red_all_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% select(-cell_id_merge)

## %%%%%%

## GS EXTRA REQUEST -- file with for every cell in every frame, the:
## center_x, center_y, velocity_x, velocity_y, area, elong_xx, elong_xy 
pos_vol_etc <- cellsDB %>% select(frame,cell_id,center_x,center_y,area,elong_xx,elong_xy)
pos_vol_etc <- pos_vol_etc %>% filter(cell_id %in% roiHistoNoborder$cell_id)
frameminus1 <- pos_vol_etc
frameminus1$frame <- frameminus1$frame - 1
pos_vol_etc <- frameminus1 %>% select(frame,cell_id,center_x,center_y) %>% dt.merge(pos_vol_etc, by = c("frame", "cell_id"))

pos_vol_etc$v_x = pos_vol_etc$center_x.x - pos_vol_etc$center_x.y
pos_vol_etc$v_y = pos_vol_etc$center_y.x - pos_vol_etc$center_y.y
pos_vol_etc$center_y = pos_vol_etc$center_y.y
pos_vol_etc$center_x = pos_vol_etc$center_x.y
pos_vol_etc$dev_time = pos_vol_etc$frame*2.5/60
pos_vol_etc$center_x = pos_vol_etc$center_x*0.207
pos_vol_etc$center_y = pos_vol_etc$center_y*0.207
pos_vol_etc$v_x = pos_vol_etc$v_x*0.207 / (2.5/60)
pos_vol_etc$v_y = pos_vol_etc$v_y*0.207 / (2.5/60)
pos_vol_etc$area = pos_vol_etc$area*0.207^2
pos_vol_etc <- pos_vol_etc %>% select(frame,dev_time,cell_id,center_x,center_y,v_x,v_y,area,elong_xx,elong_xy)

lastocc_pos_vol_etc <- cellinfoDB %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,last_occ) %>% dt.merge(cellsDB,by="cell_id") %>% filter(frame == last_occ)
lastocc_pos_vol_etc <- lastocc_pos_vol_etc %>% mutate(v_x=NaN,v_y=NaN,center_x=center_x*0.207,center_y=center_y*0.207,dev_time=frame*2.5/60,area=area*0.207^2)
lastocc_pos_vol_etc <- lastocc_pos_vol_etc %>% select(frame,dev_time,cell_id,center_x,center_y,v_x,v_y,area,elong_xx,elong_xy)
pos_vol_etc <- rbind(pos_vol_etc,lastocc_pos_vol_etc)

## set of non-red, non-SOP pos_vol_etc
pos_vol_etc_dividing_cells_noborder <- pos_vol_etc %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(!(cell_id %in% dropout_full_noborder$cell_id)) %>% filter(!(cell_id %in% SOP_cell_id$cell_id ))
pos_vol_etc_SOPs <- pos_vol_etc %>% filter(cell_id %in% SOP_cell_id$cell_id)
pos_vol_etc_redcells <- pos_vol_etc %>% filter(cell_id %in% dropout_full_noborder$cell_id)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
## CSVS! ## put into core/noborder folder.
write.csv(pos_vol_etc,file="core/noborder/pos_vol_etc.csv")
write.csv(pos_vol_etc_dividing_cells_noborder,file="core/noborder/pos_vol_etc_dividing_cells_noborder.csv")
write.csv(pos_vol_etc_redcells,file="core/noborder/pos_vol_etc_redcells.csv")
write.csv(pos_vol_etc_SOPs,file="core/noborder/pos_vol_etc_SOPs.csv")


write.csv(CDrate_noborder,file="core/noborder/CDrate_noborder.csv")
write.csv(count_div_noborder,file="core/noborder/count_div_noborder.csv")

write.csv(T1rate_noborder,file="core/noborder/T1rate_noborder.csv")
write.csv(avgCDNematic,file="core/noborder/avgCDNematic.csv")


write.csv(cellarea_noborder,file="core/noborder/cellarea_noborder.csv")
write.csv(cellelongs_noborder,file="core/noborder/cellelongs_noborder.csv")

write.csv(totalarea_noborder,file="core/noborder/totalarea_noborder.csv")
write.csv(cellnumber_noborder,file="core/noborder/cellnumber_noborder.csv")

write.csv(avgIsoDefCum,file="core/noborder/avgIsoDefCum_ks21.csv")
write.csv(avgIsoDefRateSummary,file="core/noborder/avgIsoDefRateSummary_ks21.csv")

# write.csv(avgIsoDefCum,file="core/noborder/avgIsoDefCum_ks1.csv")
# write.csv(avgIsoDefRateSummary,file="core/noborder/avgIsoDefRateSummary_ks1.csv")

write.csv(shearCumSumSummary,file="core/noborder/shearCumSumSummary.csv")
write.csv(shearRateSummary,file="core/noborder/shearRateSummary.csv")

write.csv(vxx_and_vyy,file="core/noborder/vxx_and_vyy.csv")
write.csv(lifetimes_trend_noborder,file="core/noborder/lifetimes_trend_noborder.csv")
write.csv(lifetimes_trend_noborder_25,file="core/noborder/lifetimes_trend_noborder_25.csv")

write.csv(TissueHeightInterp,file="core/noborder/TissueHeightInterp.csv")
write.csv(totalvolume_noborder,file="core/noborder/totalvolume_noborder.csv")
write.csv(cellvolume_noborder,file="core/noborder/cellvolume_noborder.csv")

write.csv(count_dropout_noborder,file="core/noborder/count_dropout_noborder.csv")
write.csv(pandalpha,file="core/noborder/pandalpha.csv")
write.csv(pandalpha_redneighbour,file="core/noborder/pandalpha_redneighbour.csv")
write.csv(pandalpha_NOredneighbour,file="core/noborder/pandalpha_NOredneighbour.csv")

write.csv(initial_final_areas_daughters_noborder,file="core/noborder/initial_final_areas_daughters_noborder.csv")


## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
## PLOT PDFS ## put into core/noborder folder. 
## not putting axis restrictions on here but can do ad hoc as needed. impossible to predict sensible range a priori really. 
# CD rate
myplot <- ggplot(CDrate_noborder, aes(dev_time, avgCDrate)) + 
  geom_line(size = 2)+
  geom_point(size=2, color="black") +
  theme(text = element_text(size = 18)) +
  geom_errorbar(aes(ymin=(avgCDrate-semCD), ymax=(avgCDrate+semCD)),
                size=1, width=1, color="black") +
  ylab(expression(paste("CD rate [", cell^-1, h^-1,"]"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("CD rate +- sem")
pdf("core/noborder/CDrate_noborder.pdf")
print(myplot)
dev.off()

# count divisions noborder pdf
myplot <- ggplot(count_div_noborder, aes(dev_time, count)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("count"))) + 
  ggtitle("cumulative count divisions noborder")
pdf("core/noborder/count_div_noborder.pdf")
print(myplot)
dev.off()

# T1 rate noborder pdf

myplot <- ggplot(T1rate_noborder, aes(dev_time, avgT1rate)) + 
  geom_line(size = 2)+
  geom_point(size=2, color="black") +
  theme(text = element_text(size = 18)) +
  geom_errorbar(aes(ymin=(avgT1rate-semT1), ymax=(avgT1rate+semT1)),
                size=1, width=1, color="black") +
  ylab(expression(paste("T1 rate [", cell^-1, h^-1,"]"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("T1 rate +- sem")
pdf("core/noborder/T1rate_noborder.pdf")
print(myplot)
dev.off()

# CDNEMATIC XX
myplot <- ggplot(avgCDNematic, aes(dev_time, cgCDxx_smooth)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("cgCDxx_smooth"))) + 
  ylim((0-max(abs(avgCDNematic$cgCDxx_smooth))),(0+max(abs(avgCDNematic$cgCDxx_smooth)))) + 
  ggtitle("cgCDxx_smooth noborder")
pdf("core/noborder/avgCDNematic.pdf")
print(myplot)
dev.off()

# cellarea
myplot <- ggplot(cellarea_noborder, aes(dev_time, avgarea)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("avg area (um2)"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("avg area")
pdf("core/noborder/cellarea_noborder.pdf")
print(myplot)
dev.off()

# cellelong xx SYMMETRIC Y LIMITS
myplot <- ggplot(cellelongs_noborder, aes(dev_time, cgExx_smooth)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("elong_xx"))) + 
  ylim((0-max(abs(cellelongs_noborder$cgExx_smooth))),(0+max(abs(cellelongs_noborder$cgExx_smooth)))) + 
  ggtitle("avg elong_xx")
pdf("core/noborder/cellelong_noborder_xx.pdf")
print(myplot)
dev.off()

# cellelong xy
myplot <- ggplot(cellelongs_noborder, aes(dev_time, cgExy_smooth)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("elong_xy"))) + 
  ylim((0-max(abs(cellelongs_noborder$cgExy_smooth))),(0+max(abs(cellelongs_noborder$cgExy_smooth)))) + 
  ggtitle("avg elong_xy")
pdf("core/noborder/cellelong_noborder_xy.pdf")
print(myplot)
dev.off()

# sd area normalised by mean
myplot <- ggplot(cellarea_noborder, aes(dev_time, sd_area/avgarea)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("normalised sd on area"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("normalised sd on area")
pdf("core/noborder/sd_area_nomalised_noborder.pdf")
print(myplot)
dev.off()

# total area
myplot <- ggplot(totalarea_noborder, aes(dev_time, total_area)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("total area (um2)"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("total noborder area")
pdf("core/noborder/total_area_noborder.pdf")
print(myplot)
dev.off()

# cell number
myplot <- ggplot(cellnumber_noborder, aes(dev_time, n)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("cell number"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("cellnumber noborder")
pdf("core/noborder/cellnumber_noborder.pdf")
print(myplot)
dev.off()

# avgisodef cumulative. -1 lower limit on Y to keep account of exrtrusion etc. 
myplot <- ggplot(avgIsoDefCum, aes(dev_time, cumsum.avg, color=isoContrib)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(cumsum.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=isoContrib),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  ylim(-1,NA) + 
  ggtitle("cumulative isotropic deformation")
pdf("core/noborder/isotropic_cumul_noborder.pdf")
print(myplot)
dev.off()

# avgisodef rate. symmetric y axis
myplot <- ggplot(avgIsoDefRateSummary, aes(dev_time, value.avg, color=isoContrib)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(value.avg-value.sd), ymax=(value.avg+value.sd), fill=isoContrib),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("deformation rate (",h^-1,")"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  ylim((0-max(abs(avgIsoDefRateSummary$value.avg))),(0+max(abs(avgIsoDefRateSummary$value.avg)))) + 
  ggtitle("rates of isotropic deformation")
pdf("core/noborder/isotropic_rate_noborder.pdf")
print(myplot)
dev.off()

# shear deformation rate. symmetric y axis.
myplot <- ggplot(shearRateSummary, aes(dev_time, xx.avg, color=tensor)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(xx.avg-xx.sd), ymax=(xx.avg+xx.sd), fill=tensor),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("rate xx (",h^-1,")"))) +
  scale_color_manual(values=shearColors) +
  scale_fill_manual(values=shearColors) +
  ylim((0-max(abs(shearRateSummary$xx.avg))),(0+max(abs(shearRateSummary$xx.avg)))) +
  ggtitle("shear rates xx")
pdf("core/noborder/shear_rate_noborder.pdf")
print(myplot)
dev.off()

# shear deformation rate restricted set (t1, total, cell elong only)
myplot <- ggplot(shearRateSummary %>% filter(tensor == "T1" | tensor == "cell_elongation_change" | tensor == "total_shear"), aes(dev_time, xx.avg, color=tensor)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(xx.avg-xx.sd), ymax=(xx.avg+xx.sd), fill=tensor),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("rate xx (",h^-1,")"))) +
  scale_color_manual(values=shearColors) +
  scale_fill_manual(values=shearColors) +
  ylim((0-max(abs(shearRateSummary$xx.avg))),(0+max(abs(shearRateSummary$xx.avg)))) +
  ggtitle("shear rates xx")
pdf("core/noborder/shear_rate_restricted_noborder.pdf")
print(myplot)
dev.off()

# shear deformation cumul
myplot <- ggplot(shearCumSumSummary, aes(dev_time, xxCumSum.avg, color=tensor)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(xxCumSum.avg-xxCumSum.sd), ymax=(xxCumSum.avg+xxCumSum.sd), fill=tensor),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("shear xx cumul"))) +
  scale_color_manual(values=shearColors) +
  scale_fill_manual(values=shearColors) +
  ylim((0-max(abs(shearCumSumSummary$xxCumSum.avg))),(0+max(abs(shearCumSumSummary$xxCumSum.avg)))) +
  ggtitle("cumul shear")
pdf("core/noborder/shear_cumul_noborder.pdf")
print(myplot)
dev.off()

# shear deformation cumul restricted set
myplot <- ggplot(shearCumSumSummary %>% filter(tensor == "T1" | tensor == "total_shear" | tensor == "cell_elongation_change"), aes(dev_time, xxCumSum.avg, color=tensor)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(xxCumSum.avg-xxCumSum.sd), ymax=(xxCumSum.avg+xxCumSum.sd), fill=tensor),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("shear xx cumul"))) +
  scale_color_manual(values=shearColors) +
  scale_fill_manual(values=shearColors) +
  ylim((0-max(abs(shearCumSumSummary$xxCumSum.avg))),(0+max(abs(shearCumSumSummary$xxCumSum.avg)))) +
  ggtitle("cumul shear")
pdf("core/noborder/shear_cumul_restricted_noborder.pdf")
print(myplot)
dev.off()

# unified vxx vyy and viso plot. 0 to NA y axis.
viso <- vxx_and_vyy
viso$vii <- viso$vxx + viso$vyy
viso <- viso %>% select(dev_time,vii)
viso$series <- "iso"
# tidy up
vxx <- vxx_and_vyy %>% select(dev_time,vxx) %>% rename(vii = vxx)
vxx$series <- "vxx"
vyy <- vxx_and_vyy %>% select(dev_time,vyy) %>% rename(vii = vyy)
vyy$series <- "vyy"
# rbind join them all together so they can be plotted with a similar command to the isocontrib stuff:
vxx_vyy_viso <- rbind(vxx,vyy,viso) %>% arrange(dev_time)

myplot<-ggplot(vxx_vyy_viso, aes(dev_time, vii, color=series)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  xlab("Time (h)")+
  ylab(expression(paste("deformation rate (",h^-1,")"))) +
  scale_color_manual(values=c("vxx" = "red","vyy"="green","iso"="blue")) +
  scale_fill_manual(values=c("vxx" = "red","vyy"="green","iso"="blue")) +
  ylim(0,NA) +
  ggtitle("vxx, vyy and total iso deformation rates")
pdf("core/noborder/vxx_vyy_and_viso.pdf")
print(myplot)
dev.off()

# lifetime in 50 frame bins like p and alpha plot PDF
myplot <- ggplot(lifetimes_trend_noborder, aes(dev_time, mean_life)) + 
  geom_line(size = 2)+
  geom_point(size=2, color="black") +
  theme(text = element_text(size = 18)) +
  geom_errorbar(aes(ymin=(mean_life-(sd_life/sqrt(n_div))), ymax=(mean_life+(sd_life/sqrt(n_div)))),
                size=1, width=1, color="black") +
  scale_y_continuous(limits=c(0,NA)) +
  ylab(expression(paste("mean lifetime (h)"))) + 
  ggtitle("mean lifetime +- sem")
pdf("core/noborder/lifetimes_trend_noborder.pdf")
print(myplot)
dev.off()

# tissue height
myplot <- ggplot(TissueHeightInterp, aes(dev_time, height)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("height (um)"))) + 
  scale_y_continuous(limits=c(0,40)) +
  scale_x_continuous(limits=c(0,20)) +
  ggtitle("tissue height interpolated WT")
pdf("core/noborder/tissue_height_interpolated.pdf")
print(myplot)
dev.off()

# total volume
myplot <- ggplot(totalvolume_noborder, aes(dev_time, total_volume)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("total volume (um3)"))) + 
  scale_y_continuous(limits=c(0,NA)) +
  ggtitle("total noborder volume")
pdf("core/noborder/total_volume_noborder.pdf")
print(myplot)
dev.off()

# cellvolume
myplot <- ggplot(cellvolume_noborder, aes(dev_time, avgvolume)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("avg volume (um3)"))) + 
  scale_y_continuous(limits=c(0,NA)) +
  ggtitle("avg volume")
pdf("core/noborder/cellvolume_noborder.pdf")
print(myplot)
dev.off()

# sd volume normalised by mean
myplot <- ggplot(cellvolume_noborder, aes(dev_time, sd_volume/avgvolume)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("normalised sd on volume"))) + 
  scale_y_continuous(limits=c(0,NA)) +
  ggtitle("normalised sd on area")
pdf("core/noborder/sd_volume_nomalised_noborder.pdf")
print(myplot)
dev.off()

# count_dropout pdf
myplot <- ggplot(count_dropout_noborder, aes(dev_time, count)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("count"))) + 
  ggtitle("cumulative count dropout cells")
pdf("core/noborder/count_dropout_noborder.pdf")
print(myplot)
dev.off()

# p and alpha pdf
pplot <- pandalpha %>% select(dev_time,p)
pplot$series <- "p"
pplot <- pplot %>% rename(data = p)
alphaplot <- pandalpha %>% select(dev_time,alpha)
alphaplot$series <- "alpha"
alphaplot <- alphaplot %>% rename(data = alpha)
pandalphaplot <- rbind(pplot,alphaplot)
pandalphaplot <- pandalphaplot %>% arrange(dev_time)

myplot<-ggplot(pandalphaplot, aes(dev_time, data, color=series)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  xlab("Time (h)")+
  ylab(expression(paste("p or alpha"))) +
  scale_color_manual(values=c("p" = "black","alpha"="red")) +
  scale_fill_manual(values=c("p" = "black","alpha"="red")) +
  xlim(0,20) +
  ggtitle("p WT ")
pdf("core/noborder/pandalphaplot.pdf")
print(myplot)
dev.off()


## INSERT ... a quick fitting procedure for P like for the SOP fitting in cumul counts. 
## 19 MARCH 2020. using this to check the p and alpha fit again for the sharpness parameter of the hillfunction.
## note the switch times for p are these

## JJW CHANGE 3rd APRIL 2020. Not shifting to 16h start time messes up the sharpness parameter,
## though probably not the switch time so much. re-do the fits all over again!

## WT1 p and alpha respectively
# switchtime <- 26.4 
# hillcoeff <- 42
# switchtime <- 25
# hillcoeff <- 42
# WT2
# switchtime <- 27.8 
# hillcoeff <- 32
# switchtime <- 27
# hillcoeff <- 38
#WT3
# switchtime <- 26 
# hillcoeff <- 40
# switchtime <- 25.2
# hillcoeff <- 40
# WT4
# switchtime <- 25.4 
# hillcoeff <- 46
# switchtime <- 24.6
# hillcoeff <- 36

switchtime <- 25.4 # 9.3
hillcoeff <- 46
totalSOPs <- 1
myplot <- ggplot(pandalphaplot %>% filter(series == "p"), aes(dev_time+16, data)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("p"))) + 
  ggtitle(paste("switchtime, hillcoeff", switchtime, hillcoeff)) + 
  stat_function(fun = function(.x)              totalSOPs*(.x/switchtime)^hillcoeff / ((.x/switchtime)^(hillcoeff) + 1) , colour = "red", size = 2   ) 
pdf("core/noborder/p_sigmoid_quick_fit.pdf")
print(myplot)
dev.off()
## END P FITTING INSERT

## ALPHA fitting insert
switchtime <- 24.6
hillcoeff <- 36
totalSOPs <- 1
myplot <- ggplot(pandalphaplot %>% filter(series == "alpha"), aes(dev_time+16, data)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("alpha"))) + 
  ggtitle(paste("switchtime, hillcoeff", switchtime, hillcoeff)) + 
  stat_function(fun = function(.x)              totalSOPs*(.x/switchtime)^hillcoeff / ((.x/switchtime)^(hillcoeff) + 1) , colour = "red", size = 2   ) 
pdf("core/noborder/alpha_sigmoid_quick_fit.pdf")
print(myplot)
dev.off()
## END alpha FITTING INSERT







# p only comparing redneighbour to NOredneighbour
pplot_redneighbour <- pandalpha_redneighbour %>% select(dev_time,p)
pplot_redneighbour$series <- "redneighbour"
pplot_redneighbour <- pplot_redneighbour %>% rename(data = p)
pplot_NOredneighbour <- pandalpha_NOredneighbour %>% select(dev_time,p)
pplot_NOredneighbour$series <- "NOredneighbour"
pplot_NOredneighbour <- pplot_NOredneighbour %>% rename(data = p)
pplot_red_and_nored <- rbind(pplot_redneighbour,pplot_NOredneighbour)
myplot<-ggplot(pplot_red_and_nored, aes(dev_time, data, color=series)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  xlab("Time (h)")+
  ylab(expression(paste("p"))) +
  scale_color_manual(values=c("redneighbour" = "red","NOredneighbour"="black")) +
  scale_fill_manual(values=c("redneighbour" = "red","NOredneighbour"="black")) +
  ggtitle("p for redneighbour and NOredneighbour ")
pdf("core/noborder/pplot_red_and_nored.pdf")
print(myplot)
dev.off()

# alpha comparison redneighbour and noredneighbour
alphaplot_redneighbour <- pandalpha_redneighbour %>% select(dev_time,alpha)
alphaplot_redneighbour$series <- "redneighbour"
alphaplot_redneighbour <- alphaplot_redneighbour %>% rename(data = alpha)
alphaplot_NOredneighbour <- pandalpha_NOredneighbour %>% select(dev_time,alpha)
alphaplot_NOredneighbour$series <- "NOredneighbour"
alphaplot_NOredneighbour <- alphaplot_NOredneighbour %>% rename(data = alpha)
alphaplot_red_and_nored <- rbind(alphaplot_redneighbour,alphaplot_NOredneighbour)
myplot <- ggplot(alphaplot_red_and_nored, aes(dev_time, data, color=series)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  xlab("Time (h)")+
  ylab(expression(paste("alpha"))) +
  scale_color_manual(values=c("redneighbour" = "red","NOredneighbour"="black")) +
  scale_fill_manual(values=c("redneighbour" = "red","NOredneighbour"="black")) +
  ggtitle("alpha for redneighbour and NOredneighbour ")
pdf("core/noborder/alphaplot_red_and_nored.pdf")
print(myplot)
dev.off()



## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
## MOVIES ## put into core/noborder folder. 

# area movie. of noborder. make sure lgRoiSmoothed not spoofed etc. 
cellarea_shape_noborder <- mqf_fg_cell_area(movieDir, rois = c("anterior"), cellContour = T)
render_movie(cellarea_shape_noborder, "core/noborder/cellarea_shape_noborder.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=area*0.207^2)),
  scale_fill_gradientn(name="area (um2)",
                       colours=c("black", "blue", "green", "yellow", "red"),
                       # ignore possible outliers by trimming the area distribution
                       limits=c(0,quantile(cellarea_shape_noborder$area*0.207^2, probs = 99.9/100)),
                       na.value = "red")
))

# elongation nematic movie (anterior == noborder with non spoofed lgRoiSmoothed)
cellElongNematics <- mqf_fg_nematics_cell_elong(movieDir, "anterior") 
render_movie(cellElongNematics, "core/noborder/cellElongNematics.mp4", list(
  geom_segment(aes(x=x1,y=y1,xend=x2,yend=y2),
               size=1, alpha=0.7, lineend="round", color="red", na.rm=T) 
))

# lifetimes movie. restricted limits to resolve differences etc. na value is black.
cellshapes_lifetime <- lifetimes_noborder %>% select(cell_id,lifetime) %>% dt.merge(cellshapes,by="cell_id")
render_movie(cellshapes_lifetime, "core/noborder/cellshapes_lifetime.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=lifetime*2.5/60)),
  scale_fill_gradientn(name="lifetime (hr)",
                       colors  = jet.colors(7),
                       # ignore tails of distribution
                       limits=c(2,6),
                       na.value = "black")
))

# cell volume movie. individual cell volumes. careful with the units of area. in this file it is pixels so the multiplication by 0.207^2 then takes place.
cellvolume_shape_noborder <- cellarea_shape_noborder
cellvolume_shape_noborder  <- TissueHeightInterp %>% select(frame,height) %>% dt.merge(cellvolume_shape_noborder ,by="frame")
# calculate volume doing it in um^3 because the height data is in um
cellvolume_shape_noborder$volume <- cellvolume_shape_noborder$area * (0.207^2) * cellvolume_shape_noborder$height
render_movie(cellvolume_shape_noborder, "core/noborder/cellvolume_shape_noborder.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=volume)),
  scale_fill_gradientn(name="volume (um3)",
                       colours=c("black", "blue", "green", "yellow", "red"),
                       # ignore possible outliers by trimming the area distribution. doing manually here, not satisfactory really. why does the limits change in time here whereas in the area thing it didn't.
                       limits=c(0,2000),
                       na.value = "red")
))

# red cell movie without SOPs
cellshapes_dropout_noborder <- cellshapes %>% dt.merge(dropout_full_noborder,by="cell_id")
cellshapes_dropout_noborder$dropout <- "TRUE"
cellshapes_notdropout <- cellshapes %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(!(cell_id%in%dropout_full_noborder$cell_id))
cellshapes_notdropout$dropout <- "FALSE"
# rearrange dropout cellshapes before rbind
cellshapes_dropout_noborder <- cellshapes_dropout_noborder %>% select(frame,cell_id,x_pos,y_pos,bond_order,dropout)
cellshapes_dropout_and_notdropout_noborder <- rbind(cellshapes_notdropout,cellshapes_dropout_noborder)
  render_movie(cellshapes_dropout_and_notdropout_noborder, "core/noborder/cellshapes_dropout_noborder.mp4", list( 
    # geometrical layer to represent cells as polygons
    geom_polygon(aes(x_pos, y_pos, group=cell_id, fill = dropout), alpha=0.5), # this was 0.75 before, trying this for overlaying multiple with transparency. see evernote. 
    scale_fill_manual(values=c("FALSE"="white", "TRUE"="red"))
  ))

# red cell movie with SOPs in different colour 
cellshapes_SOP <- cellshapes %>% filter(cell_id %in% SOP_cell_id$cell_id) 
cellshapes_SOP$dropout <- "SOP"
cellshapes_SOP <- cellshapes_SOP %>% select(frame,cell_id,x_pos,y_pos,bond_order,dropout)
cellshapes_dropout_notdropout_SOP_noborder <- rbind(cellshapes_notdropout %>% filter(!(cell_id %in% cellshapes_SOP$cell_id)),cellshapes_dropout_noborder,cellshapes_SOP)
render_movie(cellshapes_dropout_notdropout_SOP_noborder, "core/noborder/cellshapes_dropout_notdropout_SOP_noborder.mp4", list( 
  # geometrical layer to represent cells as polygons
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill = dropout), alpha=0.75),
  scale_fill_manual(values=c("FALSE"="darkgreen", "TRUE"="red", "SOP"="green"))
))



# red cell movie with mothers of red cells in blue 
dropout_mothers_noborder <- cellinfoDB %>% filter(left_daughter_cell_id %in% dropout_full_noborder$cell_id | right_daughter_cell_id %in% dropout_full_noborder$cell_id) %>% select(cell_id)
cellshapes_dropout_mothers_noborder <- cellshapes %>% filter(cell_id %in% dropout_mothers_noborder$cell_id) 
cellshapes_dropout_mothers_noborder$dropout <- "MOTHER"
cellshapes_dropout_mothers_noborder <- cellshapes_dropout_mothers_noborder %>% select(frame,cell_id,x_pos,y_pos,bond_order,dropout)
cellshapes_dropout_notdropout_mother_noborder <- rbind(cellshapes_notdropout %>% filter(!(cell_id %in% dropout_mothers_noborder$cell_id)),cellshapes_dropout_noborder,cellshapes_dropout_mothers_noborder)
render_movie(cellshapes_dropout_notdropout_mother_noborder, "core/noborder/cellshapes_dropout_notdropout_mother_noborder.mp4", list( 
  # geometrical layer to represent cells as polygons
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill = dropout), alpha=0.75),
  scale_fill_manual(values=c("FALSE"="darkgreen", "TRUE"="red", "MOTHER"="blue"))
))

## make an ROI movie. Useful in general, and e.g. for choosing what 'limit time' to use for nest-specific data in _anterior and _posterior.
# roi movie including noborder.
roimovie_anterior <- roiBothNests %>% filter(roi == "anterior") %>% filter(!(cell_id %in% roiHistoNoborder$cell_id))
roimovie_anterior$roi <- "anterior"
roimovie_posterior <- roiBothNests %>% filter(roi == "posterior")
roimovie_posterior$roi <- "posterior"
roimovie_noborder <- roiHistoNoborder
roimovie_noborder$roi <- "noborder"
roimovie <- rbind(roimovie_anterior,roimovie_posterior,roimovie_noborder)
cellshapes_roimovie <- cellshapes %>% dt.merge(roimovie, by = "cell_id")
render_movie(cellshapes_roimovie, "core/cellshapes_roimovie.mp4", list( 
  # geometrical layer to represent cells as polygons
  geom_polygon(aes(x_pos, y_pos, group=cell_id,fill = roi), alpha=0.75),
  scale_fill_manual(values=c("anterior"="green", "posterior"="red","noborder" = "purple"))
))

roimovie_anterior <- roiBothNests %>% filter(roi == "anterior")
roimovie_anterior$roi <- "anterior"
roimovie_posterior <- roiBothNests %>% filter(roi == "posterior")
roimovie_posterior$roi <- "posterior"
roimovieBothNests <- rbind(roimovie_anterior,roimovie_posterior)
cellshapes_roimovieBothNests <- cellshapes %>% dt.merge(roimovieBothNests, by = "cell_id")
render_movie(cellshapes_roimovieBothNests %>% filter(roi != "noborder"), "cellshapes_roimovie_BothNests.mp4", list( 
  # geometrical layer to represent cells as polygons
  geom_polygon(aes(x_pos, y_pos, group=cell_id,fill = roi), alpha=0.75),
  scale_fill_manual(values=c("anterior"="green", "posterior"="red","noborder" = "purple"))
))

# T1 movie -- nematics, gain loss colours. DO WITHOUT LEGEND
t1nematics <- mqf_fg_unit_nematics_T1(movieDir, "anterior", cellContour = T) 
t1nematics$type <- factor(t1nematics$type, levels = c("gain", "loss", "gain_and_loss"))
T1cols = c("gain"="red", "loss"="green", "gain_and_loss"="blue")

render_movie(t1nematics, "core/noborder/T1_movie.mp4", list( 
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=t1_type), alpha=0.5, color="grey"),
  scale_fill_manual(values = T1cols, drop = FALSE, labels = c("gain","loss", "gain_and_loss", guide = FALSE)),
  theme(legend.position="none"),
  geom_segment(aes(x=x1,y=y1,xend=x2,yend=y2),
               size=1, alpha=0.7, lineend="round", color="red", na.rm=T),
  ggtitle("T1s. red: gain, green: loss, blue: g&l")
))


# false colour lineages movie 
all_lineages <- unique(cellsWithLin %>% select(lineage_group))
#make that many distinct colors
pal <- data.frame(iwanthue(count(all_lineages)$n)) #NB MUST SOURCE iwanthue.R is the good one I think
colnames(pal) <- "color"
all_lineages$color <- pal$color
cellsWithLinWithColor <- cellsWithLin %>% dt.merge(all_lineages,by="lineage_group")
render_movie(cellsWithLinWithColor %>% filter(cell_id %in% roiHistoNoborder$cell_id), "cells_color_lineages_noborder.mp4", list(
  geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),, alpha=0.7),
  scale_fill_identity(guide = "none")
))



#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## SHEAR XY ADDITION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# SHEAR
selectedRois <- c("anterior")
shearData <- multi_db_query(movieDirs, mqf_cg_roi_rate_shear, selectedRois)

shearRateSlim <- subset(shearData, (tensor=="CEwithCT" | tensor=="correlationEffects" |
                                      tensor=="nu" | tensor=="ShearT1" | 
                                      tensor=="ShearT2" | tensor=="ShearCD" | tensor=="sumContrib" ))
shearRateSlim$tensor <- factor(shearRateSlim$tensor, 
                               levels=c("ShearCD", "CEwithCT", "correlationEffects",
                                        "nu", "ShearT1", "ShearT2", "sumContrib"),
                               labels=c("cell_division", "cell_elongation_change",
                                        "correlation_effects","total_shear","T1", "T2", "sumContrib"))

# interpolate data
deltaT=150
shearRateInterpolated <- shearRateSlim %>% 
  align_movie_start(movieDirs) %>%
  select(-c(yx,yy,yx.ma,yy.ma, TimeInt.ma,
            phi, norm,time_sec,timeInt_sec,closestFrame,time_shift)) %>%
  mutate(min_dev_time=min(dev_time),
         max_dev_time=max(dev_time)) %>% 
  group_by(movie, roi, tensor) %>%
  do({
    with(., approx(dev_time, xy.ma,
                   xout = seq(min_dev_time[1], max_dev_time[1],
                              by = deltaT/3600), method = "linear")) %>% as.df()
  }) %>%
  rename(dev_time=x, XY=y) %>% 
  filter(!is.na(XY)) %>%
  ungroup() %>% mutate(movieNb=length(unique(movie))) %>% 
  group_by(roi, tensor, dev_time) %>%
  # Make sure that further calculations will be done on values present in all compared movies
  filter(n()==movieNb) %>% ungroup()

# average data between the 3 movies amongst ROI
shearRateSummary_XY <- shearRateInterpolated %>%
  group_by(roi, tensor, dev_time) %>%
  summarise(xy.avg=mean(XY), xy.sd=sd(XY))

shearCumSumSummary_XY <- shearRateInterpolated %>%
  group_by(movie, roi, tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xy=cumsum(XY*timeInt)) %>%
  group_by(roi, tensor, dev_time) %>%
  summarise(xyCumSum.avg=mean(cumSum_xy, na.rm = F), xyCumSum.sd=sd(cumSum_xy, na.rm = F))


write.csv(shearCumSumSummary_XY,file="core/noborder/shearCumSumSummary_XY.csv")
write.csv(shearRateSummary_XY,file="core/noborder/shearRateSummary_XY.csv")
## SHEAR XY ADDITION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%






