## 25th Feb after discussion with GS. Trying to make general script to do to lots of core stuff.
## USE MICRONS AND HOURS FOR EVERYTHING IF POSS. Make order of columns nice (don't change those used by MATLAB analysis code).
## Put all outputs into a protected subfolder.
## Need to export CSVs AND also plot them. Not clear a priori what scale to plot on etc. 
dir.create("core")
dir.create("core/posterior")

# set a 'limit time' in hours beyond which not to print out any data in CSV or PDF sections
limit_time <- 1000 # unlimited

## Pre-running tasks
# import as dataset TissueHeightR.csv

## THIS VERSION IS FOR POSTERIOR. Do that first then make other versions.
## Append all things with _posterior.
## Find and inspect all instances of _posterior

## NOTES!
## SPOOF LGROISMOOTHED BEFORE RUNNING THIS USING ROICELLSBT INSTEAD
## CREATE FAKE SHEAR_CONTRIB FROM SPOOFED TOO, WHICH WILL THUS CONTAIN BOTH ANTERIOR AND POSTERIOR DATA.
## CAREFUL WITH SHEAR CONTRIBS PART. I HAD TO FIX TISSUE MINER CODE TO MAKE IT NOT COUNT EXTRA SHEAR_CONTRIB FOLDERS. 
## don't create any dropout cell and SOP stuff in here,.

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% #### %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##

load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "posterior" | roi == "posterior")
roiPosterior <- roiCellsBT %>% filter(roi == "posterior")

# INSERT -- div-div lifetimes, print raw CSV
lifetimes_posterior <- cellinfoDB %>% filter(cell_id %in% roiPosterior$cell_id) %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% select(cell_id, first_occ, last_occ)
lifetimes_posterior$lifetime <- (lifetimes_posterior$last_occ - lifetimes_posterior$first_occ)*2.5/60
lifetimes_posterior <- lifetimes_posterior %>% select(lifetime)
write.csv(lifetimes_posterior,file="core/posterior/lifetimes_posterior.csv")
# END INSERT

# CDRATE
CDrate_posterior <- multi_db_query(movieDirs, mqf_cg_roi_rate_CD, "posterior") %>% 
  chunk_time_into_intervals(3600) %>%
  group_by(movie, roi,interval_mid) %>%
  summarise(avgCDrate=mean(cell_loss_rate),
            semCD=se(cell_loss_rate),
            time_sec=interval_mid[1],
            dev_time=mean(dev_time))

# Cumulative count of cell divisions
disappearsbydiv_posterior <- cellinfoDB %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiPosterior$cell_id) %>% select(cell_id,last_occ)
count_div_posterior <- frames %>% select(frame)
# cross join to get every combination of frame and dropout times
count_div_posterior <- merge(x = count_div_posterior, y = disappearsbydiv_posterior, by = NULL)
# then filter
count_div_posterior <- count_div_posterior %>% filter(last_occ < frame)
count_div_posterior <- count_div_posterior %>% select(frame) %>% group_by(frame) %>% summarise(count = n())
count_div_posterior$dev_time <- count_div_posterior$frame*2.5/60
count_div_posterior <- count_div_posterior %>% select(frame,dev_time,count)

# T1 RATE  but irrespective of direction.
T1rate_posterior <- multi_db_query(movieDirs, mqf_cg_roi_rate_T1, "posterior") %>% 
  chunk_time_into_intervals(deltaT = 3600) %>%
  group_by(movie, roi,interval_mid) %>%
  summarise(avgT1rate=mean(cell_topo_rate),
            semT1=se(cell_topo_rate),
            time_sec=interval_mid[1],
            dev_time=mean(dev_time))
# possible to do cumulation of T1s too?

# Cellarea
cellarea_posterior <- cellsDB %>% filter(cell_id %in% roiPosterior$cell_id ) %>% select(cell_id,frame,area) %>% group_by(frame) %>% summarise(avgarea = mean(area)*0.207^2,sd_area = sd(area)*0.207^2 )
cellarea_posterior$dev_time <- cellarea_posterior$frame * 2.5/60
cellarea_posterior <- cellarea_posterior[,c(1,4,2,3)]

# cdNematic avg plot KERNSIZE 11 IN COMMON WITH OTHER STUFF
avgCDNematic <- multi_db_query(movieDirs, mqf_cg_roi_unit_nematics_CD, "posterior", kernSize = 11)
avgCDNematic <- avgCDNematic %>% select(frame,dev_time,cgCDxx_smooth,cgCDxy_smooth)
#exclude NA
avgCDNematic <- avgCDNematic %>% filter(is.na(cgCDxx_smooth) == FALSE) %>% filter(is.na(cgCDxy_smooth) == FALSE)

# avg cell elongs _xx and _xy
cellelongs_posterior <- mqf_cg_roi_nematics_cell_elong(movieDir = "time", rois = "posterior") %>% select(frame,dev_time,cgExx_smooth, cgExy_smooth)

# Cellnumber
cellnumber_posterior <- cellsDB %>% filter(cell_id %in% roiPosterior$cell_id) %>% select(cell_id,frame) %>% group_by(frame) %>% summarise(n = n())
cellnumber_posterior$dev_time <- cellnumber_posterior$frame * 2.5/60
cellnumber_posterior <- cellnumber_posterior[,c(1,3,2)]

# Totalarea
totalarea_posterior <- cellarea_posterior %>% dt.merge(cellnumber_posterior,by="frame")
totalarea_posterior$total_area <- totalarea_posterior$n * totalarea_posterior$avgarea
totalarea_posterior$dev_time <- totalarea_posterior$frame*2.5/60 
totalarea_posterior <- totalarea_posterior %>% select(frame,dev_time,total_area)

# lifetime data posterior. Can I do this like p and alpha in 50 frame bins to get avg lifetime as fn of first_occ?
lifetimes_posterior <- cellinfoDB %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiPosterior$cell_id) %>% select(cell_id,first_occ,last_occ)
lifetimes_posterior$lifetime <- lifetimes_posterior$last_occ - lifetimes_posterior$first_occ

lifetimes_trend_posterior <- frames %>% select(frame) %>% filter(frame %% 50 == 0)
lifetimes_trend_posterior <- lifetimes_trend_posterior %>% rename(min_frame = frame)
lifetimes_trend_posterior$max_frame <- lifetimes_trend_posterior$min_frame + 50 
for (row in 1:nrow(lifetimes_trend_posterior)) {
  lifetimes_trend_posterior[row,"n_div"] = lifetimes_posterior %>% filter(first_occ > lifetimes_trend_posterior[row,"min_frame"] & first_occ < lifetimes_trend_posterior[row,"max_frame"]) %>% nrow()
}
for (row in 1:nrow(lifetimes_trend_posterior)) {
  lifetimes_trend_posterior[row,"mean_life"] = (lifetimes_posterior %>% filter(first_occ > lifetimes_trend_posterior[row,"min_frame"] & first_occ < lifetimes_trend_posterior[row,"max_frame"]))$lifetime %>% mean()
}
for (row in 1:nrow(lifetimes_trend_posterior)) {
  lifetimes_trend_posterior[row,"sd_life"] = (lifetimes_posterior %>% filter(first_occ > lifetimes_trend_posterior[row,"min_frame"] & first_occ < lifetimes_trend_posterior[row,"max_frame"]))$lifetime %>% sd()
}
lifetimes_trend_posterior$dev_time <- ((lifetimes_trend_posterior$min_frame + lifetimes_trend_posterior$max_frame)/2) * 2.5/60
lifetimes_trend_posterior <- lifetimes_trend_posterior %>% select(min_frame,max_frame,dev_time,n_div,mean_life,sd_life)
lifetimes_trend_posterior$mean_life <- lifetimes_trend_posterior$mean_life*2.5/60
lifetimes_trend_posterior$sd_life <- lifetimes_trend_posterior$sd_life*2.5/60


# IsoContrib
isoContrib <- multi_db_query(movieDirs, mqf_cg_roi_rate_isotropic_contrib, c("posterior")) 
deltaT=150 # sampling (150 seconds WTs etc. )
avgIsoDefRateInterpolated <- isoContrib %>%
  align_movie_start(movieDirs) %>%
  mutate(min_dev_time=min(dev_time),
         max_dev_time=max(dev_time)) %>% 
  group_by(movie, roi, isoContrib) %>%
  # here, we do a linear interpolation of the data (60 sec per point)
  do({
    with(., approx(dev_time, value.ma,
                   xout = seq(min_dev_time[1], max_dev_time[1],
                              by = deltaT/3600), method = "linear")) %>% as.df()
  }) %>%
  rename(dev_time=x, value.ma=y) %>%
  filter(!is.na(value.ma)) %>%
  ungroup() %>% mutate(movieNb=length(unique(movie))) %>% 
  group_by(roi, isoContrib, dev_time) %>%
  # Make sure that further calculations will be done on values present in all compared movies
  filter(n()==movieNb) %>% ungroup()

# average data between the 3 movies amongst ROI  
avgIsoDefRateSummary <- avgIsoDefRateInterpolated %>%
  group_by(roi, isoContrib, dev_time) %>%
  summarise(value.avg=mean(value.ma), value.sd=sd(value.ma))

avgIsoDefCum <- avgIsoDefRateInterpolated %>%
  group_by(movie, roi, isoContrib) %>%
  mutate(timeInt=c(0,diff(dev_time)), value.cumsum=cumsum(value.ma*timeInt)) %>% 
  group_by(roi, isoContrib, dev_time) %>%
  summarise(cumsum.avg=mean(value.cumsum), cumsum.sd=sd(value.cumsum))

# Shear Stuff (run sm shear_calc with correct roi_bt first!)
# SHEAR
selectedRois <- "posterior"
shearData <- multi_db_query(movieDirs, mqf_cg_roi_rate_shear, selectedRois)

shearRateSlim <- subset(shearData, (tensor=="CEwithCT" | tensor=="correlationEffects" |
                                      tensor=="nu" | tensor=="ShearT1" | 
                                      tensor=="ShearT2" | tensor=="ShearCD" | tensor=="sumContrib"))
shearRateSlim$tensor <- factor(shearRateSlim$tensor, 
                               levels=c("ShearCD", "CEwithCT", "correlationEffects",
                                        "nu", "ShearT1", "ShearT2","sumContrib"),
                               labels=c("cell_division", "cell_elongation_change",
                                        "correlation_effects","total_shear","T1", "T2","sumContrib"))

# interpolate data
deltaT=150
shearRateInterpolated <- shearRateSlim %>% 
  align_movie_start(movieDirs) %>%
  select(-c(xy,yx,yy,xy.ma,yx.ma,yy.ma, TimeInt.ma,
            phi, norm,time_sec,timeInt_sec,closestFrame,time_shift)) %>%
  mutate(min_dev_time=min(dev_time),
         max_dev_time=max(dev_time)) %>% 
  group_by(movie, roi, tensor) %>%
  do({
    with(., approx(dev_time, xx.ma,
                   xout = seq(min_dev_time[1], max_dev_time[1],
                              by = deltaT/3600), method = "linear")) %>% as.df()
  }) %>%
  rename(dev_time=x, XX=y) %>% 
  filter(!is.na(XX)) %>%
  ungroup() %>% mutate(movieNb=length(unique(movie))) %>% 
  group_by(roi, tensor, dev_time) %>%
  # Make sure that further calculations will be done on values present in all compared movies
  filter(n()==movieNb) %>% ungroup()

# average data between the 3 movies amongst ROI
shearRateSummary <- shearRateInterpolated %>%
  group_by(roi, tensor, dev_time) %>%
  summarise(xx.avg=mean(XX), xx.sd=sd(XX))

shearCumSumSummary <- shearRateInterpolated %>%
  group_by(movie, roi, tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(XX*timeInt)) %>%
  group_by(roi, tensor, dev_time) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))

# Vxx and Vyy using the fine resolution shear rate and avgIso stuff. Not using the weird 'smoothed' rate I did before here.
# I guess can smooth this afterward anyway. 
shearRateSummary_total_only <- shearRateSummary %>% filter(tensor == "sumContrib")
avgIsoDefRateSummary_total_only <- avgIsoDefRateSummary %>% filter(isoContrib == "sumContrib")
shearRateSummary_total_only$approx_time <- round(shearRateSummary_total_only$dev_time,2)
avgIsoDefRateSummary_total_only$approx_time <- round(avgIsoDefRateSummary_total_only$dev_time,2)


vxx_and_vyy <- avgIsoDefRateSummary_total_only %>% dt.merge(shearRateSummary_total_only,by="approx_time") %>% select(dev_time.x,value.avg,value.sd,xx.avg,xx.sd) %>% rename(dev_time = dev_time.x)
# create vxx and vyy as instructed by GS
vxx_and_vyy$vxx <- (vxx_and_vyy$value.avg + vxx_and_vyy$xx.avg)/2
vxx_and_vyy$vyy <- (vxx_and_vyy$value.avg - vxx_and_vyy$xx.avg)/2
# propagate the stdeviation which is the same for vxx and vyy (assumes independence I think)
vxx_and_vyy$propagatederror <- sqrt(vxx_and_vyy$value.sd^2 + vxx_and_vyy$xx.sd^2)
# then need to plot it with standard deviation represented by ribbon.
# but to get into same form as before I need them all with a COMMON vii column, with 
vxx_and_vyy <- vxx_and_vyy %>% select(dev_time, vxx, vyy)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
# Stuff needing tissue height. Load TissueHeightR.csv as data. First Height Itself
TissueHeightTime <- as.data.frame(TissueHeightR$V1) %>% rename("time" = "TissueHeightR$V1")
TissueHeightTime$time <- TissueHeightTime$time/2.5
TissueHeightHeight <- as.data.frame(TissueHeightR$V2) %>% rename("height" = "TissueHeightR$V2")
#intermediate interpolation table
f <- approxfun(TissueHeightTime$time,TissueHeightHeight$height)
#get one data per frame up to frame e.g. 479 where the interpolation can't be done as outside range
TissueHeightPerFrame <- as.data.frame(f(seq(from=0,to=max(TissueHeightTime$time) -1 ,by=1)))
colnames(TissueHeightPerFrame) <- "height"
frames_height <- frames %>% filter(frame <= max(TissueHeightTime$time) -1 )
TissueHeightInterp <- frames_height
TissueHeightInterp$height <- TissueHeightPerFrame$height
TissueHeightInterp$dev_time <- TissueHeightInterp$frame*2.5/60
TissueHeightInterp <- TissueHeightInterp %>% select(frame,dev_time,height)

# Cellvolume
cellvolume_posterior <- cellarea_posterior %>% dt.merge(TissueHeightInterp,by="frame")
cellvolume_posterior$avgvolume <- cellvolume_posterior$avgarea*cellvolume_posterior$height 
cellvolume_posterior$sd_volume <- cellvolume_posterior$sd_area*cellvolume_posterior$height
cellvolume_posterior <- cellvolume_posterior %>% select(frame,avgvolume,sd_volume)
cellvolume_posterior$dev_time <- cellvolume_posterior$frame*2.5/60
cellvolume_posterior <- cellvolume_posterior %>% select(frame,dev_time,avgvolume,sd_volume)

# totalvolume
totalvolume_posterior <- totalarea_posterior %>% dt.merge(TissueHeightInterp,by="frame")
totalvolume_posterior$total_volume <- totalvolume_posterior$total_area*totalvolume_posterior$height
totalvolume_posterior <- totalvolume_posterior %>% select(frame,total_volume)
totalvolume_posterior$dev_time <- totalvolume_posterior$frame*2.5/60
totalvolume_posterior <- totalvolume_posterior %>% select(frame,dev_time,total_volume)

pos_vol_etc <- cellsDB %>% select(frame,cell_id,center_x,center_y,area,elong_xx,elong_xy)
pos_vol_etc <- pos_vol_etc %>% filter(cell_id %in% roiPosterior$cell_id)
frameminus1 <- pos_vol_etc
frameminus1$frame <- frameminus1$frame - 1
pos_vol_etc <- frameminus1 %>% select(frame,cell_id,center_x,center_y) %>% dt.merge(pos_vol_etc , by = c("frame", "cell_id"))
pos_vol_etc$v_x = pos_vol_etc$center_x.x - pos_vol_etc$center_x.y
pos_vol_etc$v_y = pos_vol_etc$center_y.x - pos_vol_etc$center_y.y
pos_vol_etc$center_y = pos_vol_etc$center_y.y
pos_vol_etc$center_x = pos_vol_etc$center_x.y
pos_vol_etc$dev_time = pos_vol_etc$frame*2.5/60
pos_vol_etc$center_x = pos_vol_etc$center_x*0.207
pos_vol_etc$center_y = pos_vol_etc$center_y*0.207
pos_vol_etc$v_x = pos_vol_etc$v_x*0.207 / (2.5/60)
pos_vol_etc$v_y = pos_vol_etc$v_y*0.207 / (2.5/60)
pos_vol_etc$area = pos_vol_etc$area*0.207^2
pos_vol_etc <- pos_vol_etc %>% select(frame,dev_time,cell_id,center_x,center_y,v_x,v_y,area,elong_xx,elong_xy)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
# Red cell related stuff. REMOVED IN THIS VERSION. ONLY VALID IN NOBORDER.

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
## CSVS! ## put into core/posterior folder.
write.csv(CDrate_posterior %>% filter(dev_time < limit_time),file="core/posterior/CDrate_posterior.csv")
write.csv(count_div_posterior %>% filter(dev_time < limit_time),file="core/posterior/count_div_posterior.csv")
write.csv(cellarea_posterior %>% filter(dev_time < limit_time),file="core/posterior/cellarea_posterior.csv")
write.csv(cellelongs_posterior,file="core/posterior/cellelongs_posterior.csv")

write.csv(T1rate_posterior,file="core/posterior/T1rate_posterior.csv")

write.csv(totalarea_posterior %>% filter(dev_time < limit_time),file="core/posterior/totalarea_posterior.csv")
write.csv(cellnumber_posterior %>% filter(dev_time < limit_time),file="core/posterior/cellnumber_posterior.csv")

write.csv(avgCDNematic,file="core/posterior/avgCDNematic.csv")

write.csv(avgIsoDefCum %>% filter(dev_time < limit_time),file="core/posterior/avgIsoDefCum.csv")
write.csv(avgIsoDefRateSummary %>% filter(dev_time < limit_time),file="core/posterior/avgIsoDefRateSummary.csv")
write.csv(shearCumSumSummary %>% filter(dev_time < limit_time),file="core/posterior/shearCumSumSummary.csv")
write.csv(shearRateSummary %>% filter(dev_time < limit_time),file="core/posterior/shearRateSummary.csv")

write.csv(vxx_and_vyy %>% filter(dev_time < limit_time),file="core/posterior/vxx_and_vyy.csv")
write.csv(lifetimes_trend_posterior %>% filter(dev_time < limit_time),file="core/posterior/lifetimes_trend_posterior.csv")

write.csv(totalvolume_posterior %>% filter(dev_time < limit_time),file="core/posterior/totalvolume_posterior.csv")
write.csv(cellvolume_posterior %>% filter(dev_time < limit_time),file="core/posterior/cellvolume_posterior.csv")

write.csv(pos_vol_etc,file="core/posterior/pos_vol_etc.csv")

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
## PLOT PDFS ## put into core/posterior folder. 
## not putting axis restrictions on here but can do ad hoc as needed. impossible to predict sensible range a priori really. 
# CD rate
myplot <- ggplot(CDrate_posterior %>% filter(dev_time < limit_time), aes(dev_time, avgCDrate)) + 
  geom_line(size = 2)+
  geom_point(size=2, color="black") +
  theme(text = element_text(size = 18)) +
  geom_errorbar(aes(ymin=(avgCDrate-semCD), ymax=(avgCDrate+semCD)),
                size=1, width=1, color="black") +
  ylab(expression(paste("CD rate [", cell^-1, h^-1,"]"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("CD rate +- sem")
pdf("core/posterior/CDrate_posterior.pdf")
print(myplot)
dev.off()

# count divisions posterior pdf
myplot <- ggplot(count_div_posterior %>% filter(dev_time < limit_time), aes(dev_time, count)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("count"))) + 
  ggtitle("cumulative count divisions posterior")
pdf("core/posterior/count_div_posterior.pdf")
print(myplot)
dev.off()

# cellarea
myplot <- ggplot(cellarea_posterior %>% filter(dev_time < limit_time), aes(dev_time, avgarea)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("avg area (um2)"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("avg area")
pdf("core/posterior/cellarea_posterior.pdf")
print(myplot)
dev.off()

myplot <- ggplot(T1rate_posterior, aes(dev_time, avgT1rate)) + 
  geom_line(size = 2)+
  geom_point(size=2, color="black") +
  theme(text = element_text(size = 18)) +
  geom_errorbar(aes(ymin=(avgT1rate-semT1), ymax=(avgT1rate+semT1)),
                size=1, width=1, color="black") +
  ylab(expression(paste("T1 rate [", cell^-1, h^-1,"]"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("T1 rate +- sem")
pdf("core/posterior/T1rate_posterior.pdf")
print(myplot)
dev.off()

# CDNEMATIC XX
myplot <- ggplot(avgCDNematic, aes(dev_time, cgCDxx_smooth)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("cgCDxx_smooth"))) + 
  ylim((0-max(abs(avgCDNematic$cgCDxx_smooth))),(0+max(abs(avgCDNematic$cgCDxx_smooth)))) + 
  ggtitle("cgCDxx_smooth posterior")
pdf("core/posterior/avgCDNematic.pdf")
print(myplot)
dev.off()

# cellelong xx
myplot <- ggplot(cellelongs_posterior, aes(dev_time, cgExx_smooth)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("elong_xx"))) + 
  ylim((0-max(abs(cellelongs_posterior$cgExx_smooth))),(0+max(abs(cellelongs_posterior$cgExx_smooth)))) + 
  ggtitle("avg elong_xx")
pdf("core/posterior/cellelong_posterior_xx.pdf")
print(myplot)
dev.off()
# cellelong xy
myplot <- ggplot(cellelongs_posterior, aes(dev_time, cgExy_smooth)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("elong_xy"))) + 
  ylim((0-max(abs(cellelongs_posterior$cgExy_smooth))),(0+max(abs(cellelongs_posterior$cgExy_smooth)))) + 
  ggtitle("avg elong_xy")
pdf("core/posterior/cellelong_posterior_xy.pdf")
print(myplot)
dev.off()

# sd area normalised by mean
myplot <- ggplot(cellarea_posterior %>% filter(dev_time < limit_time), aes(dev_time, sd_area/avgarea)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("normalised sd on area"))) +
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("normalised sd on area")
pdf("core/posterior/sd_area_nomalised_posterior.pdf")
print(myplot)
dev.off()

# total area
myplot <- ggplot(totalarea_posterior %>% filter(dev_time < limit_time), aes(dev_time, total_area)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("total area (um2)"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("total posterior area")
pdf("core/posterior/total_area_posterior.pdf")
print(myplot)
dev.off()

# cell number
myplot <- ggplot(cellnumber_posterior %>% filter(dev_time < limit_time), aes(dev_time, n)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("cell number"))) + 
  scale_y_continuous(limits = c(0,NA)) + 
  ggtitle("cellnumber posterior")
pdf("core/posterior/cellnumber_posterior.pdf")
print(myplot)
dev.off()

# avgisodef cumulative
myplot <- ggplot(avgIsoDefCum %>% filter(dev_time < limit_time), aes(dev_time, cumsum.avg, color=isoContrib)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(cumsum.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=isoContrib),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  ylim(-1,NA) + 
  ggtitle("cumulative isotropic deformation")
pdf("core/posterior/isotropic_cumul_posterior.pdf")
print(myplot)
dev.off()

# avgisodef rate
myplot <- ggplot(avgIsoDefRateSummary %>% filter(dev_time < limit_time), aes(dev_time, value.avg, color=isoContrib)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(value.avg-value.sd), ymax=(value.avg+value.sd), fill=isoContrib),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("deformation rate (",h^-1,")"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  ylim((0-max(abs(avgIsoDefRateSummary$value.avg))),(0+max(abs(avgIsoDefRateSummary$value.avg)))) +
  ggtitle("rates of isotropic deformation")
pdf("core/posterior/isotropic_rate_posterior.pdf")
print(myplot)
dev.off()

# shear deformation rate
myplot <- ggplot(shearRateSummary %>% filter(dev_time < limit_time), aes(dev_time, xx.avg, color=tensor)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(xx.avg-xx.sd), ymax=(xx.avg+xx.sd), fill=tensor),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("rate xx (",h^-1,")"))) +
  scale_color_manual(values=shearColors) +
  scale_fill_manual(values=shearColors) +
  ylim((0-max(abs(shearRateSummary$xx.avg))),(0+max(abs(shearRateSummary$xx.avg)))) +
  ggtitle("shear rates xx")
pdf("core/posterior/shear_rate_posterior.pdf")
print(myplot)
dev.off()

# shear deformation rate restricted set (t1, total, cell elong only)
myplot <- ggplot(shearRateSummary %>% filter(tensor == "T1" | tensor == "cell_elongation_change" | tensor == "total_shear") %>% filter(dev_time < limit_time), aes(dev_time, xx.avg, color=tensor)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(xx.avg-xx.sd), ymax=(xx.avg+xx.sd), fill=tensor),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("rate xx (",h^-1,")"))) +
  scale_color_manual(values=shearColors) +
  scale_fill_manual(values=shearColors) +
  ylim((0-max(abs(shearRateSummary$xx.avg))),(0+max(abs(shearRateSummary$xx.avg)))) +
  ggtitle("shear rates xx")
pdf("core/posterior/shear_rate_restricted_posterior.pdf")
print(myplot)
dev.off()

# shear deformation cumul
myplot <- ggplot(shearCumSumSummary %>% filter(dev_time < limit_time), aes(dev_time, xxCumSum.avg, color=tensor)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(xxCumSum.avg-xxCumSum.sd), ymax=(xxCumSum.avg+xxCumSum.sd), fill=tensor),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("shear xx cumul"))) +
  scale_color_manual(values=shearColors) +
  scale_fill_manual(values=shearColors) +
  ylim((0-max(abs(shearCumSumSummary$xxCumSum.avg))),(0+max(abs(shearCumSumSummary$xxCumSum.avg)))) +
  ggtitle("cumul shear")
pdf("core/posterior/shear_cumul_posterior.pdf")
print(myplot)
dev.off()

# shear deformation cumul restricted set
myplot <- ggplot(shearCumSumSummary %>% filter(tensor == "T1" | tensor == "total_shear" | tensor == "cell_elongation_change") %>% filter(dev_time < limit_time), aes(dev_time, xxCumSum.avg, color=tensor)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  geom_ribbon(aes(ymin=(xxCumSum.avg-xxCumSum.sd), ymax=(xxCumSum.avg+xxCumSum.sd), fill=tensor),
              alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (h)")+
  ylab(expression(paste("shear xx cumul"))) +
  scale_color_manual(values=shearColors) +
  scale_fill_manual(values=shearColors) +
  ylim((0-max(abs(shearCumSumSummary$xxCumSum.avg))),(0+max(abs(shearCumSumSummary$xxCumSum.avg)))) +
  ggtitle("cumul shear")
pdf("core/posterior/shear_cumul_restricted_posterior.pdf")
print(myplot)
dev.off()

# unified vxx vyy and viso plot 
viso <- vxx_and_vyy
viso$vii <- viso$vxx + viso$vyy
viso <- viso %>% select(dev_time,vii)
viso$series <- "iso"
# tidy up
vxx <- vxx_and_vyy %>% select(dev_time,vxx) %>% rename(vii = vxx)
vxx$series <- "vxx"
vyy <- vxx_and_vyy %>% select(dev_time,vyy) %>% rename(vii = vyy)
vyy$series <- "vyy"
# rbind join them all together so they can be plotted with a similar command to the isocontrib stuff:
vxx_vyy_viso <- rbind(vxx,vyy,viso) %>% arrange(dev_time)

myplot<-ggplot(vxx_vyy_viso %>% filter(dev_time < limit_time), aes(dev_time, vii, color=series)) +
  geom_line(size=2) + 
  theme(text = element_text(size = 18)) +
  xlab("Time (h)")+
  ylab(expression(paste("deformation rate (",h^-1,")"))) +
  scale_color_manual(values=c("vxx" = "red","vyy"="green","iso"="blue")) +
  scale_fill_manual(values=c("vxx" = "red","vyy"="green","iso"="blue")) +
  ylim(0,NA) +
  ggtitle("vxx, vyy and total iso deformation rates")
pdf("core/posterior/vxx_vyy_and_viso.pdf")
print(myplot)
dev.off()


# lifetime in 50 frame bins like p and alpha plot PDF
myplot <- ggplot(lifetimes_trend_posterior %>% filter(dev_time < limit_time), aes(dev_time, mean_life)) + 
  geom_line(size = 2)+
  geom_point(size=2, color="black") +
  theme(text = element_text(size = 18)) +
  geom_errorbar(aes(ymin=(mean_life-(sd_life/sqrt(n_div))), ymax=(mean_life+(sd_life/sqrt(n_div)))),
                size=1, width=1, color="black") +
  scale_y_continuous(limits=c(0,NA)) +
  ylab(expression(paste("mean lifetime (h)"))) + 
  ggtitle("mean lifetime +- sem")
pdf("core/posterior/lifetimes_trend_posterior.pdf")
print(myplot)
dev.off()

# tissue height
# don't do in posterior version.

# total volume
myplot <- ggplot(totalvolume_posterior %>% filter(dev_time < limit_time), aes(dev_time, total_volume)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("total volume (um3)"))) +
  scale_y_continuous(limits=c(0,NA)) +
  ggtitle("total posterior volume")
pdf("core/posterior/total_volume_posterior.pdf")
print(myplot)
dev.off()

# cellvolume
myplot <- ggplot(cellvolume_posterior %>% filter(dev_time < limit_time), aes(dev_time, avgvolume)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("avg volume (um3)"))) + 
  scale_y_continuous(limits=c(0,NA)) +
  ggtitle("avg volume")
pdf("core/posterior/cellvolume_posterior.pdf")
print(myplot)
dev.off()

# sd volume normalised by mean
myplot <- ggplot(cellvolume_posterior %>% filter(dev_time < limit_time), aes(dev_time, sd_volume/avgvolume)) + 
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("normalised sd on volume"))) + 
  scale_y_continuous(limits=c(0,NA)) +
  ggtitle("normalised sd on area")
pdf("core/posterior/sd_volume_nomalised_posterior.pdf")
print(myplot)
dev.off()


## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##
## MOVIES ## put into core/posterior folder. 

# area movie. of posterior. make sure lgRoiSmoothed not spoofed etc. 
cellarea_shape_posterior <- mqf_fg_cell_area(movieDir, rois = c("posterior"), cellContour = T)
render_movie(cellarea_shape_posterior, "core/posterior/cellarea_shape_posterior.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=area*0.207^2)),
  scale_fill_gradientn(name="area (um2)",
                       colours=c("black", "blue", "green", "yellow", "red"),
                       # ignore possible outliers by trimming the area distribution
                       limits=c(0,quantile(cellarea_shape_posterior$area*0.207^2, probs = 99.9/100)),
                       na.value = "red")
))

# elongation nematic movie (posterior == posterior with non spoofed lgRoiSmoothed)
cellElongNematics <- mqf_fg_nematics_cell_elong(movieDir, "posterior") 
render_movie(cellElongNematics, "core/posterior/cellElongNematics.mp4", list(
  geom_segment(aes(x=x1,y=y1,xend=x2,yend=y2),
               size=1, alpha=0.7, lineend="round", color="red", na.rm=T) 
))

# lifetimes movie. restricted limits to resolve differences etc. na value is black.
cellshapes_lifetime <- lifetimes_posterior %>% select(cell_id,lifetime) %>% dt.merge(cellshapes,by="cell_id")
render_movie(cellshapes_lifetime, "core/posterior/cellshapes_lifetime.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=lifetime*2.5/60)),
  scale_fill_gradientn(name="lifetime (hr)",
                       colors  = jet.colors(7),
                       # ignore tails of distribution
                       limits=c(2,6),
                       na.value = "black")
))

# cell volume movie. individual cell volumes. careful with the units of area. in this file it is pixels so the multiplication by 0.207^2 then takes place.
cellvolume_shape_posterior <- cellarea_shape_posterior
cellvolume_shape_posterior  <- TissueHeightInterp %>% select(frame,height) %>% dt.merge(cellvolume_shape_posterior ,by="frame")
# calculate volume doing it in um^3 because the height data is in um
cellvolume_shape_posterior$volume <- cellvolume_shape_posterior$area * (0.207^2) * cellvolume_shape_posterior$height
render_movie(cellvolume_shape_posterior, "core/posterior/cellvolume_shape_posterior.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=volume)),
  scale_fill_gradientn(name="volume (um3)",
                       colours=c("black", "blue", "green", "yellow", "red"),
                       # ignore possible outliers by trimming the area distribution. doing manually here, not satisfactory really. why does the limits change in time here whereas in the area thing it didn't.
                       limits=c(0,2000),
                       na.value = "red")
))




#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## SHEAR XY ADDITION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# SHEAR
selectedRois <- c("posterior")
shearData <- multi_db_query(movieDirs, mqf_cg_roi_rate_shear, selectedRois)

shearRateSlim <- subset(shearData, (tensor=="CEwithCT" | tensor=="correlationEffects" |
                                      tensor=="nu" | tensor=="ShearT1" | 
                                      tensor=="ShearT2" | tensor=="ShearCD"))
shearRateSlim$tensor <- factor(shearRateSlim$tensor, 
                               levels=c("ShearCD", "CEwithCT", "correlationEffects",
                                        "nu", "ShearT1", "ShearT2"),
                               labels=c("cell_division", "cell_elongation_change",
                                        "correlation_effects","total_shear","T1", "T2"))

# interpolate data
deltaT=150
shearRateInterpolated <- shearRateSlim %>% 
  align_movie_start(movieDirs) %>%
  select(-c(yx,yy,yx.ma,yy.ma, TimeInt.ma,
            phi, norm,time_sec,timeInt_sec,closestFrame,time_shift)) %>%
  mutate(min_dev_time=min(dev_time),
         max_dev_time=max(dev_time)) %>% 
  group_by(movie, roi, tensor) %>%
  do({
    with(., approx(dev_time, xy.ma,
                   xout = seq(min_dev_time[1], max_dev_time[1],
                              by = deltaT/3600), method = "linear")) %>% as.df()
  }) %>%
  rename(dev_time=x, XY=y) %>% 
  filter(!is.na(XY)) %>%
  ungroup() %>% mutate(movieNb=length(unique(movie))) %>% 
  group_by(roi, tensor, dev_time) %>%
  # Make sure that further calculations will be done on values present in all compared movies
  filter(n()==movieNb) %>% ungroup()

# average data between the 3 movies amongst ROI
shearRateSummary_XY <- shearRateInterpolated %>%
  group_by(roi, tensor, dev_time) %>%
  summarise(xy.avg=mean(XY), xy.sd=sd(XY))

shearCumSumSummary_XY <- shearRateInterpolated %>%
  group_by(movie, roi, tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xy=cumsum(XY*timeInt)) %>%
  group_by(roi, tensor, dev_time) %>%
  summarise(xyCumSum.avg=mean(cumSum_xy, na.rm = F), xyCumSum.sd=sd(cumSum_xy, na.rm = F))


write.csv(shearCumSumSummary_XY,file="core/posterior/shearCumSumSummary_XY.csv")
write.csv(shearRateSummary_XY,file="core/posterior/shearRateSummary_XY.csv")
## SHEAR XY ADDITION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%