every_nth <- function(x, nth, empty = TRUE, inverse = FALSE) 
{
  if (!inverse) {
    if(empty) {
      x[1:nth == 1] <- ""
      x
    } else {
      x[1:nth != 1]
    }
  } else {
    if(empty) {
      x[1:nth != 1] <- ""
      x
    } else {
      x[1:nth == 1]
    }
  }
}

library("egg")

## Fig 2 script. Script to make all the plots needed for figure one. 
## Try to make unsupervised. Make plots nice, i.e. right colours, thick lines, size 18 font or whatever.
## Account for offsets including in CUMULATIVE where it is a bit complicated.
## point to specific directories one by one, i.e. don't set a base directory like in the normal setup script.
## Just get the bits from the script that define colours etc.
## don't work by connecting to database just get data from files standardised which should exist. etc.

## OFFSETS (in frames) and work out common region of time. requires putting frames.RData into each WTx header folder in CSVs folder. 
## by making an offset positive we say that that data starts later in biological time.

## WRITING FIRST the actual switch times being used. for some reason I haven't written them down elsewhere so I'm having to reconstruct them by refitting WT2. 
# WT2
# switchtime <- 9.667 = 232 frames
# hillcoeff <- 10
# totalSOPs <- 46
# WT1
# switchtime must be 170 frames = 7.083 hours
# hillcoeff <- 8
# totalSOPs <- 50
# WT3 switchtime must be 165 frames = 6.875 hours
# switchtime <- 6.916
# hillcoeff <- 10
# totalSOPs <- 38
# WT4 switchtime must be 163 frames = 6.792 hours
# switchtime <- 6.792
# hillcoeff <- 10
# totalSOPs <- 41

## MMP1 JUST FOR OFFSET but keep all data -- MAY OR MAY NOT USE FOR RESTRICTING DATA RANGE.
# switchtime 10.5 = 252 therefore offset must be -20
## MMP2
# switchtime = 5.8 = 139 therefore offset must be 93


# offsets. 
offset_WT1 <- 62-62
offset_WT2 <- 0-62
offset_WT3 <- 67-62
offset_WT4 <- 69-62

## MMP1 OFFSET AND MMP2 
offset_MMP1 <- -20-62
offset_MMP2 <- 93 -62

load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/frames.RData")
frames_WT1 <- frames
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/frames.RData")
frames_WT2 <- frames
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/frames.RData")
frames_WT3 <- frames
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/frames.RData")
frames_WT4 <- frames
# REMOVE IF NECESSARY
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/MMP1/frames.RData")
frames_MMP1 <- frames %>% filter(frame <= 399)
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/MMP2/frames.RData")
frames_MMP2 <- frames

max_realframe_WT1 <- max(frames_WT1$frame) + offset_WT1
max_realframe_WT2 <- max(frames_WT2$frame) + offset_WT2
max_realframe_WT3 <- max(frames_WT3$frame) + offset_WT3
max_realframe_WT4 <- max(frames_WT4$frame) + offset_WT4
max_realframe_MMP1 <- max(frames_MMP1$frame) + offset_MMP1
max_realframe_MMP2 <- max(frames_MMP2$frame) + offset_MMP2
min_realframe_WT1 <- min(frames_WT1$frame) + offset_WT1
min_realframe_WT2 <- min(frames_WT2$frame) + offset_WT2
min_realframe_WT3 <- min(frames_WT3$frame) + offset_WT3
min_realframe_WT4 <- min(frames_WT4$frame) + offset_WT4
min_realframe_MMP1 <- min(frames_MMP1$frame) + offset_MMP1
min_realframe_MMP2 <- min(frames_MMP1$frame) + offset_MMP2

## INCLUDING MMP IN MAX AND MINTIME STUFF HERE< TURN OFF IF NECESSARY
max_realframe <- min(c(max_realframe_WT1,max_realframe_WT2,max_realframe_WT3,max_realframe_WT4)) - 1
min_realframe <- max(c(min_realframe_WT1,min_realframe_WT2,min_realframe_WT3,min_realframe_WT4)) + 1
# so the common data must lie, after offsets have been applied, within these limits on 'realframe'

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% SETUP

# R Studio doesn't seem to be grabbing this env variable.
Sys.setenv(TM_HOME = "~/tissue_miner")
scriptsDir=Sys.getenv("TM_HOME")
outDataBaseDir="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/PAPER/FIG_temp_jjw"
mcdir(outDataBaseDir)
# Load TissueMiner libraries
source(file.path(scriptsDir, "commons/TMCommons.R"))
source(file.path(scriptsDir, "db/movie_rotation/RotationFunctions.R"))
source(file.path(scriptsDir, "commons/BaseQueryFunctions.R"))
source(file.path(scriptsDir, "commons/TimeFunctions.R"))
source(file.path(scriptsDir, "config/default_config.R"))
source(file.path(scriptsDir, "iwanthue.R"))
source(file.path(scriptsDir, "commons/MovieFunctions.R"))

# Load a R library
## library("zoo")

# Set up working directory
mcdir(outDataBaseDir)

# Set general theme for graphs: more specific tuning must be done for each graph
theme_set(theme_bw())
theme_update(panel.grid.major=element_line(linetype= "dotted", color="black", size=0.2),
             panel.border = element_rect(size=0.3,color="black",fill=NA),
             axis.ticks=element_line(size=0.2),
             axis.ticks.length=unit(0.1,"cm"),
             legend.key = element_blank()
)

## a colourblind palette? -- use first four for movieColors and last FIVE (backward) for isotropColors?
# no try colour brewer instead
# The palette with black:
#cbbPalette <- c("#000000", "#E69F00", "#56B4E9", "#009E73", "#F0E442", "#0072B2", "#D55E00", "#CC79A7")

# Hardwire isotropic deformation color scheme
isotropColors <- c("division"="#E41A1C",
                   "extrusion"="#377EB8",
                   "cell_area"="#4DAF4A",
                   "sumContrib"="#984EA3",
                   "tissue_area"="#FF7F00")

library(RColorBrewer)
display.brewer.all()
display.brewer.pal(n = 9, name = 'Set1')
brewer.pal(n = 9, name = "Set1")
# "#E41A1C" "#377EB8" "#4DAF4A" "#984EA3" "#FF7F00" "#FFFF33" "#A65628" "#F781BF" "#999999"
brewer.pal(n = 8, name = "Dark2")
# "#1B9E77" "#D95F02" "#7570B3" "#E7298A" "#66A61E" "#E6AB02" "#A6761D" "#666666"


# hardwire the movie color scheme
movieColors <- c("WT1"="#1B9E77",
                 "WT2"="#D95F02",
                 "WT3"="#7570B3",
                 "WT4"="#E7298A"
)

## Shear
shearColors <- c(
  "total_shear"="blue",
  "cell_elongation_change"="darkgreen",
  "T1"="red",
  "T2"="turquoise",
  "cell_division"="orange",
  "correlation_effects"="magenta",
  "sum_contrib"="salmon",
  "sumContrib"="salmon",
  "check"="yellow",
  "crc"="pink", "cagc"="lightgreen",
  "ct"="grey",
  "J"="grey",
  "CEwithCT"="darkgreen",
  "av_total_shear"="blue",
  "nu"="blue",
  "ShearT1"="red",
  "ShearT2"="turquoise",
  "ShearCD"="orange",
  "correlationEffects"="magenta",
  "sumContrib"="salmon")

#Extras commonly needed:
#Jet Colors
jet.colors <- colorRampPalette(c("#00007F", "blue", "#007FFF", "cyan", "#7FFF7F", "yellow", "#FF7F00", "red", "#7F0000"))

# Save plot function
savePlot <- function(myPlot) {
  pdf("myPlot.pdf")
  print(myPlot)
  dev.off()
}

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% KS1 ISOTROPIC DEFORMATION OF NOBORDER ROI WT1
## use good colours. add 16hAPF plus OFFSET to the time. add frame and realframe data back in if not present.
## calculate the cumulative deformation from the offseted data, which is a bit complicated.

avgIsoDefRateSummary_WT1_ks1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT1_ks1$frame <- round(avgIsoDefRateSummary_WT1_ks1$dev_time*60/2.5)
avgIsoDefRateSummary_WT1_ks1$realframe <- avgIsoDefRateSummary_WT1_ks1$frame + offset_WT1
avgIsoDefRateSummary_WT1_ks1$realdev_time <- avgIsoDefRateSummary_WT1_ks1$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT1_ks1$roi <- as.character(avgIsoDefRateSummary_WT1_ks1$roi)
avgIsoDefRateSummary_WT1_ks1$isoContrib <- as.character(avgIsoDefRateSummary_WT1_ks1$isoContrib)

# non-ks1 too (ks11)
avgIsoDefRateSummary_WT1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT1$frame <- round(avgIsoDefRateSummary_WT1$dev_time*60/2.5)
avgIsoDefRateSummary_WT1$realframe <- avgIsoDefRateSummary_WT1$frame + offset_WT1
avgIsoDefRateSummary_WT1$realdev_time <- avgIsoDefRateSummary_WT1$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT1$roi <- as.character(avgIsoDefRateSummary_WT1$roi)
avgIsoDefRateSummary_WT1$isoContrib <- as.character(avgIsoDefRateSummary_WT1$isoContrib)

## now cumulate starting from the minimum allowed realframe, which may not be the first frame in this thing. That is why we
## do the offsetting before cumulating 

avgIsoDefCum_WT1_ks1 <- avgIsoDefRateSummary_WT1_ks1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>%
  group_by(roi, isoContrib) %>%
  mutate(timeInt=c(0,diff(dev_time)), value.cumsum=cumsum(value.avg*timeInt)) %>% 
  group_by(roi, isoContrib, dev_time, frame, realframe, realdev_time) %>%
  summarise(cumsum.avg=mean(value.cumsum), cumsum.sd=sd(value.cumsum))

myplot1 <- ggplot(avgIsoDefCum_WT1_ks1, aes(realdev_time + 16, cumsum.avg, color=isoContrib)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab("Time (hAPF)  ") +
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  #guides(fill = guide_legend(nrow = 3)) +
  #guides(color = guide_legend(nrow = 3)) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.5,3.2), expand = c(0,0)) 
myplot1 <- set_panel_size(myplot1,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("isotropic_cumul_noborder_WT1_ks1.pdf", plot = myplot1, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% KS1 ISOTROPIC DEFORMATION OF NOBORDER ROI WT2
## use good colours. add 16hAPF plus OFFSET to the time. add frame and realframe data back in if not present.
## calculate the cumulative deformation from the offseted data, which is a bit complicated.

avgIsoDefRateSummary_WT2_ks1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT2_ks1$frame <- round(avgIsoDefRateSummary_WT2_ks1$dev_time*60/2.5)
avgIsoDefRateSummary_WT2_ks1$realframe <- avgIsoDefRateSummary_WT2_ks1$frame + offset_WT2
avgIsoDefRateSummary_WT2_ks1$realdev_time <- avgIsoDefRateSummary_WT2_ks1$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT2_ks1$roi <- as.character(avgIsoDefRateSummary_WT2_ks1$roi)
avgIsoDefRateSummary_WT2_ks1$isoContrib <- as.character(avgIsoDefRateSummary_WT2_ks1$isoContrib)

# non-ks1 too (ks11)
avgIsoDefRateSummary_WT2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT2$frame <- round(avgIsoDefRateSummary_WT2$dev_time*60/2.5)
avgIsoDefRateSummary_WT2$realframe <- avgIsoDefRateSummary_WT2$frame + offset_WT2
avgIsoDefRateSummary_WT2$realdev_time <- avgIsoDefRateSummary_WT2$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT2$roi <- as.character(avgIsoDefRateSummary_WT2$roi)
avgIsoDefRateSummary_WT2$isoContrib <- as.character(avgIsoDefRateSummary_WT2$isoContrib)

## now cumulate starting from the minimum allowed realframe, which may not be the first frame in this thing. That is why we
## do the offsetting before cumulating 

avgIsoDefCum_WT2_ks1 <- avgIsoDefRateSummary_WT2_ks1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>%
  group_by(roi, isoContrib) %>%
  mutate(timeInt=c(0,diff(dev_time)), value.cumsum=cumsum(value.avg*timeInt)) %>% 
  group_by(roi, isoContrib, dev_time, frame, realframe, realdev_time) %>%
  summarise(cumsum.avg=mean(value.cumsum), cumsum.sd=sd(value.cumsum))

myplot1 <- ggplot(avgIsoDefCum_WT2_ks1, aes(realdev_time + 16, cumsum.avg, color=isoContrib)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab("Time (hAPF)  ") +
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  #guides(fill = guide_legend(nrow = 3)) +
  #guides(color = guide_legend(nrow = 3)) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.5,3.2), expand = c(0,0)) 
myplot1 <- set_panel_size(myplot1,width  = unit(39, "mm"),
                          height = unit(39*2/3, "mm"))
ggsave("isotropic_cumul_noborder_WT2_ks1.pdf", plot = myplot1, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% KS1 ISOTROPIC DEFORMATION OF NOBORDER ROI WT3
## use good colours. add 16hAPF plus OFFSET to the time. add frame and realframe data back in if not present.
## calculate the cumulative deformation from the offseted data, which is a bit complicated.

avgIsoDefRateSummary_WT3_ks1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT3_ks1$frame <- round(avgIsoDefRateSummary_WT3_ks1$dev_time*60/2.5)
avgIsoDefRateSummary_WT3_ks1$realframe <- avgIsoDefRateSummary_WT3_ks1$frame + offset_WT3
avgIsoDefRateSummary_WT3_ks1$realdev_time <- avgIsoDefRateSummary_WT3_ks1$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT3_ks1$roi <- as.character(avgIsoDefRateSummary_WT3_ks1$roi)
avgIsoDefRateSummary_WT3_ks1$isoContrib <- as.character(avgIsoDefRateSummary_WT3_ks1$isoContrib)

# non-ks1 too (ks11)
avgIsoDefRateSummary_WT3 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT3$frame <- round(avgIsoDefRateSummary_WT3$dev_time*60/2.5)
avgIsoDefRateSummary_WT3$realframe <- avgIsoDefRateSummary_WT3$frame + offset_WT3
avgIsoDefRateSummary_WT3$realdev_time <- avgIsoDefRateSummary_WT3$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT3$roi <- as.character(avgIsoDefRateSummary_WT3$roi)
avgIsoDefRateSummary_WT3$isoContrib <- as.character(avgIsoDefRateSummary_WT3$isoContrib)

## now cumulate starting from the minimum allowed realframe, which may not be the first frame in this thing. That is why we
## do the offsetting before cumulating 

avgIsoDefCum_WT3_ks1 <- avgIsoDefRateSummary_WT3_ks1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>%
  group_by(roi, isoContrib) %>%
  mutate(timeInt=c(0,diff(dev_time)), value.cumsum=cumsum(value.avg*timeInt)) %>% 
  group_by(roi, isoContrib, dev_time, frame, realframe, realdev_time) %>%
  summarise(cumsum.avg=mean(value.cumsum), cumsum.sd=sd(value.cumsum))

myplot1 <- ggplot(avgIsoDefCum_WT3_ks1, aes(realdev_time + 16, cumsum.avg, color=isoContrib)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab("Time (hAPF)  ") +
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  #guides(fill = guide_legend(nrow = 3)) +
  #guides(color = guide_legend(nrow = 3)) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.5,3.2), expand = c(0,0))
myplot1 <- set_panel_size(myplot1,width  = unit(39, "mm"),
                          height = unit(39*2/3, "mm"))
ggsave("isotropic_cumul_noborder_WT3_ks1.pdf", plot = myplot1, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% KS1 ISOTROPIC DEFORMATION OF NOBORDER ROI WT4
## use good colours. add 16hAPF plus OFFSET to the time. add frame and realframe data back in if not present.
## calculate the cumulative deformation from the offseted data, which is a bit complicated.

avgIsoDefRateSummary_WT4_ks1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT4_ks1$frame <- round(avgIsoDefRateSummary_WT4_ks1$dev_time*60/2.5)
avgIsoDefRateSummary_WT4_ks1$realframe <- avgIsoDefRateSummary_WT4_ks1$frame + offset_WT4
avgIsoDefRateSummary_WT4_ks1$realdev_time <- avgIsoDefRateSummary_WT4_ks1$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT4_ks1$roi <- as.character(avgIsoDefRateSummary_WT4_ks1$roi)
avgIsoDefRateSummary_WT4_ks1$isoContrib <- as.character(avgIsoDefRateSummary_WT4_ks1$isoContrib)

# non-ks1 too (ks11)
avgIsoDefRateSummary_WT4 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT4$frame <- round(avgIsoDefRateSummary_WT4$dev_time*60/2.5)
avgIsoDefRateSummary_WT4$realframe <- avgIsoDefRateSummary_WT4$frame + offset_WT4
avgIsoDefRateSummary_WT4$realdev_time <- avgIsoDefRateSummary_WT4$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT4$roi <- as.character(avgIsoDefRateSummary_WT4$roi)
avgIsoDefRateSummary_WT4$isoContrib <- as.character(avgIsoDefRateSummary_WT4$isoContrib)

## now cumulate starting from the minimum allowed realframe, which may not be the first frame in this thing. That is why we
## do the offsetting before cumulating 

avgIsoDefCum_WT4_ks1 <- avgIsoDefRateSummary_WT4_ks1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>%
  group_by(roi, isoContrib) %>%
  mutate(timeInt=c(0,diff(dev_time)), value.cumsum=cumsum(value.avg*timeInt)) %>% 
  group_by(roi, isoContrib, dev_time, frame, realframe, realdev_time) %>%
  summarise(cumsum.avg=mean(value.cumsum), cumsum.sd=sd(value.cumsum))

myplot1 <- ggplot(avgIsoDefCum_WT4_ks1, aes(realdev_time + 16, cumsum.avg, color=isoContrib)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab("Time (hAPF)  ") +
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  #guides(fill = guide_legend(nrow = 3)) +
  #guides(color = guide_legend(nrow = 3)) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.5,3.2), expand = c(0,0)) 
myplot1 <- set_panel_size(myplot1,width  = unit(39, "mm"),
                          height = unit(39*2/3, "mm"))
ggsave("isotropic_cumul_noborder_WT4_ks1.pdf", plot = myplot1, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Combine cumulative contribs for a given isoContrib (division here) from different WTs. USING REALDEV_TIME
## IE OFFSET DATA. 
## use good colours. add 16hAPF to the time
## rename the series to be more informative.
## restrict to realframe range, divison contrib, and label
avgIsoDefCum_allWTs_division_ks1 <- rbind(avgIsoDefCum_WT1_ks1 %>% filter(isoContrib=="division") %>% mutate(movie = "WT1"), avgIsoDefCum_WT2_ks1 %>% filter(isoContrib=="division") %>% mutate(movie = "WT2"),
                                          avgIsoDefCum_WT3_ks1 %>% filter(isoContrib=="division") %>% mutate(movie = "WT3"), avgIsoDefCum_WT4_ks1 %>% filter(isoContrib=="division") %>% mutate(movie = "WT4"))

myplot <- ggplot(avgIsoDefCum_allWTs_division_ks1, aes(realdev_time + 16, cumsum.avg, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.2,3.2), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                          height = unit(39*2/3, "mm"))
ggsave("avgIsoDefCum_allWTs_division_ks1.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Combined RATE contribs for given isoContrib (division here) from different WTs. USING REALDEV_TIME
## IE OFFSET DATA. 
avgIsoDefRateSummary_allWTs_division <- rbind(avgIsoDefRateSummary_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="division") %>% mutate(movie = "WT1"), avgIsoDefRateSummary_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="division") %>% mutate(movie = "WT2"),
                                              avgIsoDefRateSummary_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="division") %>% mutate(movie = "WT3"), avgIsoDefRateSummary_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="division") %>% mutate(movie = "WT4"))

myplot <- ggplot(avgIsoDefRateSummary_allWTs_division, aes(realdev_time + 16, value.avg, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Shear rate (hr"^"-1",")"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.34), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefRateSummary_allWTs_division.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Combine cumulative contribs for a given isoContrib (cell_area here) from different WTs. USING REALDEV_TIME
## IE OFFSET DATA. 
## use good colours. add 16hAPF to the time
## rename the series to be more informative.
## restrict to realframe range, divison contrib, and label
avgIsoDefCum_allWTs_cell_area_ks1 <- rbind(avgIsoDefCum_WT1_ks1 %>% filter(isoContrib=="cell_area") %>% mutate(movie = "WT1"), avgIsoDefCum_WT2_ks1 %>% filter(isoContrib=="cell_area") %>% mutate(movie = "WT2"),
                                          avgIsoDefCum_WT3_ks1 %>% filter(isoContrib=="cell_area") %>% mutate(movie = "WT3"), avgIsoDefCum_WT4_ks1 %>% filter(isoContrib=="cell_area") %>% mutate(movie = "WT4"))

myplot <- ggplot(avgIsoDefCum_allWTs_cell_area_ks1, aes(realdev_time + 16, cumsum.avg, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.2,3.2), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefCum_allWTs_cell_area_ks1.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Combined RATE contribs for given isoContrib (cell_area here) from different WTs. USING REALDEV_TIME
## IE OFFSET DATA. 
avgIsoDefRateSummary_allWTs_cell_area <- rbind(avgIsoDefRateSummary_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="cell_area") %>% mutate(movie = "WT1"), avgIsoDefRateSummary_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="cell_area") %>% mutate(movie = "WT2"),
                                              avgIsoDefRateSummary_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="cell_area") %>% mutate(movie = "WT3"), avgIsoDefRateSummary_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="cell_area") %>% mutate(movie = "WT4"))

myplot <- ggplot(avgIsoDefRateSummary_allWTs_cell_area, aes(realdev_time + 16, value.avg, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Shear rate (hr"^"-1",")"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  ylim(-0.3,0.3) 
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefRateSummary_allWTs_cell_area.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Combine cumulative contribs for a given isoContrib (tissue_Area here) from different WTs. USING REALDEV_TIME
## IE OFFSET DATA. 
## use good colours. add 16hAPF to the time
## rename the series to be more informative.
## restrict to realframe range, divison contrib, and label
avgIsoDefCum_allWTs_tissue_area_ks1 <- rbind(avgIsoDefCum_WT1_ks1 %>% filter(isoContrib=="tissue_area") %>% mutate(movie = "WT1"), avgIsoDefCum_WT2_ks1 %>% filter(isoContrib=="tissue_area") %>% mutate(movie = "WT2"),
                                           avgIsoDefCum_WT3_ks1 %>% filter(isoContrib=="tissue_area") %>% mutate(movie = "WT3"), avgIsoDefCum_WT4_ks1 %>% filter(isoContrib=="tissue_area") %>% mutate(movie = "WT4"))

## INSERT: WRITE THIS DATA AS R DATA FRAME TO THE FOLDER, TO HAVE THE FIG4 SCRIPT PICK IT UP AND USE TO MAKE THE VXX VYY. both cum and rate.
save(avgIsoDefRateSummary_allWTs_tissue_area,file="avgIsoDefRateSummary_allWTs_tissue_area.RData")
save(avgIsoDefCum_allWTs_tissue_area_ks1,file="avgIsoDefCum_allWTs_tissue_area_ks1.RData")

myplot <- ggplot(avgIsoDefCum_allWTs_tissue_area_ks1, aes(realdev_time + 16, cumsum.avg, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Cumulative deformation"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.2,3.2), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefCum_allWTs_tissue_area_ks1.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



  
## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Combined RATE contribs for given isoContrib (tissue_area here) from different WTs. USING REALDEV_TIME
## IE OFFSET DATA. 
avgIsoDefRateSummary_allWTs_tissue_area <- rbind(avgIsoDefRateSummary_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="tissue_area") %>% mutate(movie = "WT1"), avgIsoDefRateSummary_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="tissue_area") %>% mutate(movie = "WT2"),
                                               avgIsoDefRateSummary_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="tissue_area") %>% mutate(movie = "WT3"), avgIsoDefRateSummary_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="tissue_area") %>% mutate(movie = "WT4"))

myplot <- ggplot(avgIsoDefRateSummary_allWTs_tissue_area, aes(realdev_time + 16, value.avg, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(y min=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Shear rate (hr"^"-1",")"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.4), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefRateSummary_allWTs_tissue_area.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)




## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% DROPOUT DATA. CUMUL COUNT OF DROPOUTS
## 
countdropout_WT1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/count_dropout_noborder.csv") 
countdropout_WT1$realframe <- countdropout_WT1$frame + offset_WT1
countdropout_WT1$realdev_time <- countdropout_WT1$realframe * 2.5/60
countdropout_WT2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/count_dropout_noborder.csv") 
countdropout_WT2$realframe <- countdropout_WT2$frame + offset_WT2
countdropout_WT2$realdev_time <- countdropout_WT2$realframe * 2.5/60
countdropout_WT3 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/count_dropout_noborder.csv") 
countdropout_WT3$realframe <- countdropout_WT3$frame + offset_WT3
countdropout_WT3$realdev_time <- countdropout_WT3$realframe * 2.5/60
countdropout_WT4 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/count_dropout_noborder.csv") 
countdropout_WT4$realframe <- countdropout_WT4$frame + offset_WT4
countdropout_WT4$realdev_time <- countdropout_WT4$realframe * 2.5/60

## combine cumul counts of dropout data, restrict to realframe range and plot on same graph.
countdropout_allWTs <- rbind(countdropout_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT1", frac = count/max(count)), countdropout_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT2", frac = count/max(count)),
                            countdropout_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT3", frac = count/max(count)), countdropout_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT4", frac = count/max(count)))

myplot <- ggplot(countdropout_allWTs, aes(realdev_time + 16, frac, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Arrested cell fraction"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,1.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("countdropout_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% DROPOUT DATA. P AND MAYBE ALPHA (OR NOT?) DATA
## add in error bar std as in gs jupyter notebook on this topic
pandalpha_WT1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/pandalpha.csv") 
pandalpha_WT1$frame <- round(pandalpha_WT1$dev_time*60/2.5)
pandalpha_WT1$realframe <- pandalpha_WT1$frame + offset_WT1
pandalpha_WT1$realdev_time <- pandalpha_WT1$realframe * 2.5/60
pandalpha_WT1$std <- sqrt(pandalpha_WT1$p*(1-pandalpha_WT1$p)/pandalpha_WT1$n_div)
pandalpha_WT2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/pandalpha.csv") 
pandalpha_WT2$frame <- round(pandalpha_WT2$dev_time*60/2.5)
pandalpha_WT2$realframe <- pandalpha_WT2$frame + offset_WT2
pandalpha_WT2$realdev_time <- pandalpha_WT2$realframe * 2.5/60
pandalpha_WT2$std <- sqrt(pandalpha_WT2$p*(1-pandalpha_WT2$p)/pandalpha_WT2$n_div)
pandalpha_WT3 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/pandalpha.csv") 
pandalpha_WT3$frame <- round(pandalpha_WT3$dev_time*60/2.5)
pandalpha_WT3$realframe <- pandalpha_WT3$frame + offset_WT3
pandalpha_WT3$realdev_time <- pandalpha_WT3$realframe * 2.5/60
pandalpha_WT3$std <- sqrt(pandalpha_WT3$p*(1-pandalpha_WT3$p)/pandalpha_WT3$n_div)
pandalpha_WT4 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/pandalpha.csv") 
pandalpha_WT4$frame <- round(pandalpha_WT4$dev_time*60/2.5)
pandalpha_WT4$realframe <- pandalpha_WT4$frame + offset_WT4
pandalpha_WT4$realdev_time <- pandalpha_WT4$realframe * 2.5/60
pandalpha_WT4$std <- sqrt(pandalpha_WT4$p*(1-pandalpha_WT4$p)/pandalpha_WT4$n_div)

pandalpha_WT1$std_alpha <- sqrt(pandalpha_WT1$alpha*(1-pandalpha_WT1$alpha)/(pandalpha_WT1$p*pandalpha_WT1$n_div))
pandalpha_WT2$std_alpha <- sqrt(pandalpha_WT2$alpha*(1-pandalpha_WT2$alpha)/(pandalpha_WT2$p*pandalpha_WT2$n_div))
pandalpha_WT3$std_alpha <- sqrt(pandalpha_WT3$alpha*(1-pandalpha_WT3$alpha)/(pandalpha_WT3$p*pandalpha_WT3$n_div))
pandalpha_WT4$std_alpha <- sqrt(pandalpha_WT4$alpha*(1-pandalpha_WT4$alpha)/(pandalpha_WT4$p*pandalpha_WT4$n_div))

pandalpha_allWTs <- rbind(pandalpha_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT1"), pandalpha_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT2"),
                          pandalpha_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT3"), pandalpha_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT4"))


myplot <- ggplot(pandalpha_allWTs, aes(realdev_time + 16, p, color=movie)) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  geom_errorbar(aes(ymin=(p-std), ymax=(p+std)),
                size=0.8, width=0.425) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("p"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,1.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("p_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


myplot <- ggplot(pandalpha_allWTs, aes(realdev_time + 16, alpha, color=movie)) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  geom_errorbar(aes(ymin=(alpha-std_alpha), ymax=(alpha+std_alpha)),
                size=0.8, width=0.425) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("alpha"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,1.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("alpha_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% "prior" to P we can just plot the fraction of cells created that are quiescent.
## possible to reconstruct exactly from p and alpha, and doesn't need error bars. 
pandalpha_allWTs$fraction <- pandalpha_allWTs$p * (1 + pandalpha_allWTs$alpha) / 2
# NAs are zero in this context (alpha NA because p = 0)
pandalpha_allWTs$fraction[is.na(pandalpha_allWTs$fraction)] <- 0

myplot <- ggplot(pandalpha_allWTs, aes(realdev_time + 16, fraction, color=movie)) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Arrested fraction created"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,1.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("quiescent_fraction_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LINEAGE OCCUPANCY AND SPREAD DATA. 
## can use data within lineage_redcell_stuff for this since it contains the occupancy of lienage groups
lineage_red_occs_ranks_WT1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/lineage_redcell_stuff/lineage_red_occs_ranks.csv") 
lineage_red_occs_ranks_WT1$realframe <- lineage_red_occs_ranks_WT1$frame + offset_WT1
lineage_red_occs_ranks_WT1$realdev_time <- lineage_red_occs_ranks_WT1$realframe * 2.5/60
lineage_red_occs_ranks_WT2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/lineage_redcell_stuff/lineage_red_occs_ranks.csv") 
lineage_red_occs_ranks_WT2$realframe <- lineage_red_occs_ranks_WT2$frame + offset_WT2
lineage_red_occs_ranks_WT2$realdev_time <- lineage_red_occs_ranks_WT2$realframe * 2.5/60
lineage_red_occs_ranks_WT3 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/lineage_redcell_stuff/lineage_red_occs_ranks.csv") 
lineage_red_occs_ranks_WT3$realframe <- lineage_red_occs_ranks_WT3$frame + offset_WT3
lineage_red_occs_ranks_WT3$realdev_time <- lineage_red_occs_ranks_WT3$realframe * 2.5/60
lineage_red_occs_ranks_WT4 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/lineage_redcell_stuff/lineage_red_occs_ranks.csv") 
lineage_red_occs_ranks_WT4$realframe <- lineage_red_occs_ranks_WT4$frame + offset_WT4
lineage_red_occs_ranks_WT4$realdev_time <- lineage_red_occs_ranks_WT4$realframe * 2.5/60

# for each, calculate the mean and standard deviation of lineage occupancy.
lineage_mean_spread_WT1 <- lineage_red_occs_ranks_WT1 %>% group_by(realframe) %>% summarise(realdev_time = max(realdev_time), mean_occ = mean(occupancy), sd_occ = sd(occupancy), samples=n())
lineage_mean_spread_WT2 <- lineage_red_occs_ranks_WT2 %>% group_by(realframe) %>% summarise(realdev_time = max(realdev_time), mean_occ = mean(occupancy), sd_occ = sd(occupancy), samples=n())
lineage_mean_spread_WT3 <- lineage_red_occs_ranks_WT3 %>% group_by(realframe) %>% summarise(realdev_time = max(realdev_time), mean_occ = mean(occupancy), sd_occ = sd(occupancy), samples=n())
lineage_mean_spread_WT4 <- lineage_red_occs_ranks_WT4 %>% group_by(realframe) %>% summarise(realdev_time = max(realdev_time), mean_occ = mean(occupancy), sd_occ = sd(occupancy), samples=n())

# combine restricting to realframe range and adding labels as above.
# lineage_mean_spread_allWTs <- rbind(lineage_mean_spread_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT1"), lineage_mean_spread_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT2"),
#                                     lineage_mean_spread_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT3"), lineage_mean_spread_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% mutate(movie = "WT4"))


# GS request: try not restricting at all so any data is shown 
lineage_mean_spread_allWTs <- rbind(lineage_mean_spread_WT1 %>% mutate(movie = "WT1"), lineage_mean_spread_WT2 %>% mutate(movie = "WT2"),
                                    lineage_mean_spread_WT3 %>% mutate(movie = "WT3"), lineage_mean_spread_WT4 %>% mutate(movie = "WT4"))


myplot <- ggplot(lineage_mean_spread_allWTs, aes(realdev_time + 16, mean_occ, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
   geom_ribbon(aes(ymin=(mean_occ-sd_occ), ymax=(mean_occ+sd_occ), fill=movie),
              alpha=0.15, linetype="dotted", size=0) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Cells in lineage"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,17.5), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("lineage_mean_spread_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)




# continue.... 

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% CORRELATION (LACK THEREOF) OF LIFETIME WITH OTHER STUFF
## Not sure what to do it with here but I guess a good first one would be lifetime as a function of first occ, with error bars
## in bins, for all movies on one plot.
## reading through GS APR 2019 presentation to see what he uses. 
## first plot lifetime as function of birth time. try to get a different line for each movie, all on same graph.
## instead of using lifetimes_trend data that is pre-binned, just load initial_final_areas_daughters_noborder.csv
## and calculate various stuff.
lifetimes_etc_WT1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/initial_final_areas_daughters_noborder.csv")
lifetimes_etc_WT1$lifetime <- lifetimes_etc_WT1$last_occ - lifetimes_etc_WT1$first_occ
lifetimes_etc_WT1$movie <- "WT1"
lifetimes_etc_WT2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/initial_final_areas_daughters_noborder.csv")
lifetimes_etc_WT2$lifetime <- lifetimes_etc_WT2$last_occ - lifetimes_etc_WT2$first_occ
lifetimes_etc_WT2$movie <- "WT2"
lifetimes_etc_WT3 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/initial_final_areas_daughters_noborder.csv")
lifetimes_etc_WT3$lifetime <- lifetimes_etc_WT3$last_occ - lifetimes_etc_WT3$first_occ
lifetimes_etc_WT3$movie <- "WT3"
lifetimes_etc_WT4 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/initial_final_areas_daughters_noborder.csv")
lifetimes_etc_WT4$lifetime <- lifetimes_etc_WT4$last_occ - lifetimes_etc_WT4$first_occ
lifetimes_etc_WT4$movie <- "WT4"

# similar to the current p and alpha data, do 25 frame bins and combine. ADD OFFSETS.
lifetimes_birthtime_bin_WT1 <- lifetimes_etc_WT1 %>% mutate(mid_frame = 25*floor(first_occ / 25) + 12.5) %>% group_by(mid_frame,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% mutate(dev_time = mid_frame*2.5/60) %>% na.omit()
lifetimes_birthtime_bin_WT1$realframe <- lifetimes_birthtime_bin_WT1$mid_frame + offset_WT1
lifetimes_birthtime_bin_WT1$realdev_time <- lifetimes_birthtime_bin_WT1$realframe * 2.5/60
lifetimes_birthtime_bin_WT2 <- lifetimes_etc_WT2 %>% mutate(mid_frame = 25*floor(first_occ / 25) + 12.5) %>% group_by(mid_frame,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% mutate(dev_time = mid_frame*2.5/60) %>% na.omit()
lifetimes_birthtime_bin_WT2$realframe <- lifetimes_birthtime_bin_WT2$mid_frame + offset_WT2
lifetimes_birthtime_bin_WT2$realdev_time <- lifetimes_birthtime_bin_WT2$realframe * 2.5/60
lifetimes_birthtime_bin_WT3 <- lifetimes_etc_WT3 %>% mutate(mid_frame = 25*floor(first_occ / 25) + 12.5) %>% group_by(mid_frame,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% mutate(dev_time = mid_frame*2.5/60) %>% na.omit()
lifetimes_birthtime_bin_WT3$realframe <- lifetimes_birthtime_bin_WT3$mid_frame + offset_WT3
lifetimes_birthtime_bin_WT3$realdev_time <- lifetimes_birthtime_bin_WT3$realframe * 2.5/60
lifetimes_birthtime_bin_WT4 <- lifetimes_etc_WT4 %>% mutate(mid_frame = 25*floor(first_occ / 25) + 12.5) %>% group_by(mid_frame,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% mutate(dev_time = mid_frame*2.5/60) %>% na.omit()
lifetimes_birthtime_bin_WT4$realframe <- lifetimes_birthtime_bin_WT4$mid_frame + offset_WT4
lifetimes_birthtime_bin_WT4$realdev_time <- lifetimes_birthtime_bin_WT4$realframe * 2.5/60
lifetimes_birthtime_bin_all <- rbind(lifetimes_birthtime_bin_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_birthtime_bin_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_birthtime_bin_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_birthtime_bin_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe))

## addition. calculate the average within-bin CV for all movies.
lifetimes_birthtime_bin_all_w_CV <- lifetimes_birthtime_bin_all %>% mutate(CV = sd_lifetime/mean_lifetime)
average_CV <- lifetimes_birthtime_bin_all %>% mutate(CV = sd_lifetime/mean_lifetime)
average_CV_fn_unadjusted_dev_time <- average_CV %>% summarise(avg_CV = mean(CV)) %>% mutate(dev_time=mid_frame*2.5/60)
average_CV_unweighted <- average_CV %>% ungroup() %>% summarise(avg_CV = mean(CV))


## calculate the weighted average of CVs where the weight is the number of divisions.
average_CV_weighted <- average_CV %>% ungroup() %>% filter(realdev_time +16 < 40) %>% summarise(avg_CV = weighted.mean(CV,count))

## another addition: find the weighted average of lifetime to use as a single-value for a fullsim extension case.
average_lifetime_weighted <- lifetimes_birthtime_bin_all_w_CV %>% ungroup() %>% summarise(avg_lifetime = weighted.mean(mean_lifetime,count))


## another thing. do all the above thing about weighted avgs for CV and mean_life but for individual movies.
## WT1
average_CV_WT1 <- lifetimes_birthtime_bin_all %>% filter(movie == "WT1") %>% mutate(CV = sd_lifetime/mean_lifetime)
average_CV_fn_unadjusted_dev_time_WT1 <- average_CV_WT1 %>% summarise(avg_CV = mean(CV)) %>% mutate(dev_time=mid_frame*2.5/60)
average_CV_unweighted_WT1 <- average_CV_WT1 %>% ungroup() %>% summarise(avg_CV = mean(CV))
average_CV_weighted_WT1 <- average_CV_WT1 %>% ungroup() %>% summarise(avg_CV = weighted.mean(CV,count))
average_lifetime_weighted_WT1 <- lifetimes_birthtime_bin_all_w_CV %>% filter(movie == "WT1") %>% ungroup() %>% summarise(avg_lifetime = weighted.mean(mean_lifetime,count))
write.csv(average_CV_weighted_WT1,file="avg_CV_weighted_WT1.csv")
write.csv(average_lifetime_weighted_WT1,file="avg_lifetime_weighted_WT1.csv")
## WT2
average_CV_WT2 <- lifetimes_birthtime_bin_all %>% filter(movie == "WT2") %>% mutate(CV = sd_lifetime/mean_lifetime)
average_CV_fn_unadjusted_dev_time_WT2 <- average_CV_WT2 %>% summarise(avg_CV = mean(CV)) %>% mutate(dev_time=mid_frame*2.5/60)
average_CV_unweighted_WT2 <- average_CV_WT2 %>% ungroup() %>% summarise(avg_CV = mean(CV))
average_CV_weighted_WT2 <- average_CV_WT2 %>% ungroup() %>% summarise(avg_CV = weighted.mean(CV,count))
average_lifetime_weighted_WT2 <- lifetimes_birthtime_bin_all_w_CV %>% filter(movie == "WT2") %>% ungroup() %>% summarise(avg_lifetime = weighted.mean(mean_lifetime,count))
write.csv(average_CV_weighted_WT2,file="avg_CV_weighted_WT2.csv")
write.csv(average_lifetime_weighted_WT2,file="avg_lifetime_weighted_WT2.csv")
## WT3
average_CV_WT3 <- lifetimes_birthtime_bin_all %>% filter(movie == "WT3") %>% mutate(CV = sd_lifetime/mean_lifetime)
average_CV_fn_unadjusted_dev_time_WT3 <- average_CV_WT3 %>% summarise(avg_CV = mean(CV)) %>% mutate(dev_time=mid_frame*2.5/60)
average_CV_unweighted_WT3 <- average_CV_WT3 %>% ungroup() %>% summarise(avg_CV = mean(CV))
average_CV_weighted_WT3 <- average_CV_WT3 %>% ungroup() %>% summarise(avg_CV = weighted.mean(CV,count))
average_lifetime_weighted_WT3 <- lifetimes_birthtime_bin_all_w_CV %>% filter(movie == "WT3") %>% ungroup() %>% summarise(avg_lifetime = weighted.mean(mean_lifetime,count))
write.csv(average_CV_weighted_WT3,file="avg_CV_weighted_WT3.csv")
write.csv(average_lifetime_weighted_WT3,file="avg_lifetime_weighted_WT3.csv")
## WT4
average_CV_WT4 <- lifetimes_birthtime_bin_all %>% filter(movie == "WT4") %>% mutate(CV = sd_lifetime/mean_lifetime)
average_CV_fn_unadjusted_dev_time_WT4 <- average_CV_WT4 %>% summarise(avg_CV = mean(CV)) %>% mutate(dev_time=mid_frame*2.5/60)
average_CV_unweighted_WT4 <- average_CV_WT4 %>% ungroup() %>% summarise(avg_CV = mean(CV))
average_CV_weighted_WT4 <- average_CV_WT4 %>% ungroup() %>% summarise(avg_CV = weighted.mean(CV,count))
average_lifetime_weighted_WT4 <- lifetimes_birthtime_bin_all_w_CV %>% filter(movie == "WT4") %>% ungroup() %>% summarise(avg_lifetime = weighted.mean(mean_lifetime,count))
write.csv(average_CV_weighted_WT4,file="avg_CV_weighted_WT4.csv")
write.csv(average_lifetime_weighted_WT4,file="avg_lifetime_weighted_WT4.csv")





## calculate the weighted average of CVs where the weight is the number of divisions.
average_CV_weighted <- average_CV %>% ungroup() %>% filter(realdev_time +16 < 40) %>% summarise(avg_CV = weighted.mean(CV,count))


# plot CV over time
myplot <- ggplot(lifetimes_birthtime_bin_all_w_CV, aes(realdev_time + 16, CV, color=movie)) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Birth time (hAPF)  ")+
  ylab(expression(paste("CV"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) #+
  #scale_y_continuous(limits=c(-0.1,12.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("CVs_over_time_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)
# plot division count over time
myplot <- ggplot(lifetimes_birthtime_bin_all_w_CV, aes(realdev_time + 16, count, color=movie)) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Birth time (hAPF)  ")+
  ylab(expression(paste("n_div"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) #+
#scale_y_continuous(limits=c(-0.1,12.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("n_div_in_bin_over_time_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


### end addition


## ADDITION: add in every individual life time as single dots. make separate data set and try to superimpose in plot command below.
lifetimes_birthtime_nonbin_WT1 <- lifetimes_etc_WT1 %>% select(first_occ,lifetime,movie) %>% mutate(realframe = first_occ + offset_WT1) %>% mutate(realdev_time = realframe * 2.5/60)
lifetimes_birthtime_nonbin_WT2 <- lifetimes_etc_WT2 %>% select(first_occ,lifetime,movie) %>% mutate(realframe = first_occ + offset_WT2) %>% mutate(realdev_time = realframe * 2.5/60)
lifetimes_birthtime_nonbin_WT3 <- lifetimes_etc_WT3 %>% select(first_occ,lifetime,movie) %>% mutate(realframe = first_occ + offset_WT3) %>% mutate(realdev_time = realframe * 2.5/60)
lifetimes_birthtime_nonbin_WT4 <- lifetimes_etc_WT4 %>% select(first_occ,lifetime,movie) %>% mutate(realframe = first_occ + offset_WT4) %>% mutate(realdev_time = realframe * 2.5/60)

lifetimes_birthtime_nonbin_all <- rbind(lifetimes_birthtime_nonbin_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_birthtime_nonbin_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_birthtime_nonbin_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_birthtime_nonbin_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe))

#plot 
myplot <- ggplot(lifetimes_birthtime_bin_all, aes(realdev_time + 16, mean_lifetime, color=movie)) +
  geom_point(data=lifetimes_birthtime_nonbin_all, aes(realdev_time + 16, lifetime*2.5/60, fill = movie,color=movie),size = 0.3, alpha=0.05, show.legend = FALSE ) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  geom_errorbar(aes(ymin=(mean_lifetime-(sd_lifetime/sqrt(count))), ymax=(mean_lifetime+(sd_lifetime/sqrt(count)))),
                size=0.8, width=17/40) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Birth time (hAPF)  ")+
  ylab(expression(paste("Lifetime (h)"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,12.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("lifetimes_birthtime_bin_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


# EXTRA PLOT LIFETIMES AS FUNCTION OF DEATH TIME
# similar to the current p and alpha data, do 25 frame bins and combine. ADD OFFSETS.
lifetimes_deathtime_bin_WT1 <- lifetimes_etc_WT1 %>% mutate(mid_frame = 25*floor(last_occ / 25) + 12.5) %>% group_by(mid_frame,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% mutate(dev_time = mid_frame*2.5/60) %>% na.omit()
lifetimes_deathtime_bin_WT1$realframe <- lifetimes_deathtime_bin_WT1$mid_frame + offset_WT1
lifetimes_deathtime_bin_WT1$realdev_time <- lifetimes_deathtime_bin_WT1$realframe * 2.5/60
lifetimes_deathtime_bin_WT2 <- lifetimes_etc_WT2 %>% mutate(mid_frame = 25*floor(last_occ / 25) + 12.5) %>% group_by(mid_frame,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% mutate(dev_time = mid_frame*2.5/60) %>% na.omit()
lifetimes_deathtime_bin_WT2$realframe <- lifetimes_deathtime_bin_WT2$mid_frame + offset_WT2
lifetimes_deathtime_bin_WT2$realdev_time <- lifetimes_deathtime_bin_WT2$realframe * 2.5/60
lifetimes_deathtime_bin_WT3 <- lifetimes_etc_WT3 %>% mutate(mid_frame = 25*floor(last_occ / 25) + 12.5) %>% group_by(mid_frame,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% mutate(dev_time = mid_frame*2.5/60) %>% na.omit()
lifetimes_deathtime_bin_WT3$realframe <- lifetimes_deathtime_bin_WT3$mid_frame + offset_WT3
lifetimes_deathtime_bin_WT3$realdev_time <- lifetimes_deathtime_bin_WT3$realframe * 2.5/60
lifetimes_deathtime_bin_WT4 <- lifetimes_etc_WT4 %>% mutate(mid_frame = 25*floor(last_occ / 25) + 12.5) %>% group_by(mid_frame,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% mutate(dev_time = mid_frame*2.5/60) %>% na.omit()
lifetimes_deathtime_bin_WT4$realframe <- lifetimes_deathtime_bin_WT4$mid_frame + offset_WT4
lifetimes_deathtime_bin_WT4$realdev_time <- lifetimes_deathtime_bin_WT4$realframe * 2.5/60
lifetimes_deathtime_bin_all <- rbind(lifetimes_deathtime_bin_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_deathtime_bin_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_deathtime_bin_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_deathtime_bin_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe))


lifetimes_deathtime_nonbin_WT1 <- lifetimes_etc_WT1 %>% select(last_occ,lifetime,movie) %>% mutate(realframe = last_occ + offset_WT1) %>% mutate(realdev_time = realframe * 2.5/60)
lifetimes_deathtime_nonbin_WT2 <- lifetimes_etc_WT2 %>% select(last_occ,lifetime,movie) %>% mutate(realframe = last_occ + offset_WT2) %>% mutate(realdev_time = realframe * 2.5/60)
lifetimes_deathtime_nonbin_WT3 <- lifetimes_etc_WT3 %>% select(last_occ,lifetime,movie) %>% mutate(realframe = last_occ + offset_WT3) %>% mutate(realdev_time = realframe * 2.5/60)
lifetimes_deathtime_nonbin_WT4 <- lifetimes_etc_WT4 %>% select(last_occ,lifetime,movie) %>% mutate(realframe = last_occ + offset_WT4) %>% mutate(realdev_time = realframe * 2.5/60)

lifetimes_deathtime_nonbin_all <- rbind(lifetimes_deathtime_nonbin_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_deathtime_nonbin_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_deathtime_nonbin_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe),lifetimes_deathtime_nonbin_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe))

# EXTRA PLOT 18 FEB 2020 GS email from 17th. same as above but lifetime as function of death time instead
myplot <- ggplot(lifetimes_deathtime_bin_all, aes(realdev_time + 16, mean_lifetime, color=movie)) +
  geom_point(data=lifetimes_deathtime_nonbin_all, aes(realdev_time + 16, lifetime*2.5/60, fill = movie, color=movie),size = 0.3, alpha=0.05, show.legend = FALSE ) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  geom_errorbar(aes(ymin=(mean_lifetime-(sd_lifetime/sqrt(count))), ymax=(mean_lifetime+(sd_lifetime/sqrt(count)))),
                size=0.8, width=17/40) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("End-division time (hAPF)  ")+
  ylab(expression(paste("Lifetime (h)"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,12.1), expand = c(0,0))
  myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
  ggsave("lifetimes_deathtime_bin_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## looks good but could I add a diagonal line showing the 'light cone' sort of thing for maximum possible lifetime as function of final time? depends on movie length though. 
## no do it a bit more simply. just say that for each movie I'm could STOP SHOWING THE DATA as soon as a lifetime of roughly (some multiplier of) the average would 
## no longer be visible. The average is say roughly 4.5 hr... Hmm come back to this.

## Now do same but for cell area after birth (initial area) as seen in GS Keynote. 
# note (you idiot) that the initial area should be on the X AXIS so the first try i did of this was wrong. the binning variable changes from above. 
# try to make the bin occupancy more or less similar, about a 100-120 per bin. start with 100 pixel bins to see. 
lifetimes_initial_bin_WT1 <- lifetimes_etc_WT1 %>% mutate(mid_area = (100*(floor(initial_area / 100)) + 50)*0.207^2) %>% group_by(mid_area,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()
lifetimes_initial_bin_WT2 <- lifetimes_etc_WT2 %>% mutate(mid_area = (100*(floor(initial_area / 100)) + 50)*0.207^2) %>% group_by(mid_area,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()
lifetimes_initial_bin_WT3 <- lifetimes_etc_WT3 %>% mutate(mid_area = (100*(floor(initial_area / 100)) + 50)*0.207^2) %>% group_by(mid_area,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()
lifetimes_initial_bin_WT4 <- lifetimes_etc_WT4 %>% mutate(mid_area = (100*(floor(initial_area / 100)) + 50)*0.207^2) %>% group_by(mid_area,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()
lifetimes_initial_bin_all <- rbind(lifetimes_initial_bin_WT1,lifetimes_initial_bin_WT2,lifetimes_initial_bin_WT3,lifetimes_initial_bin_WT4)

## ADDITION: add in every individual life time as single dots. make separate data set and try to superimpose in plot command below.
lifetimes_initial_nonbin_WT1 <- lifetimes_etc_WT1 %>% select(initial_area,lifetime,movie) 
lifetimes_initial_nonbin_WT2 <- lifetimes_etc_WT2 %>% select(initial_area,lifetime,movie) 
lifetimes_initial_nonbin_WT3 <- lifetimes_etc_WT3 %>% select(initial_area,lifetime,movie) 
lifetimes_initial_nonbin_WT4 <- lifetimes_etc_WT4 %>% select(initial_area,lifetime,movie) 

lifetimes_initial_nonbin_all <- rbind(lifetimes_initial_nonbin_WT1,lifetimes_initial_nonbin_WT2,lifetimes_initial_nonbin_WT3,lifetimes_initial_nonbin_WT4)


#plot 
myplot <- ggplot(lifetimes_initial_bin_all, aes(mid_area, mean_lifetime, color=movie)) +
  geom_point(data=lifetimes_initial_nonbin_all, aes(initial_area*0.207^2, lifetime*2.5/60, fill = movie, color = movie),size = 0.3, alpha=0.05, show.legend = FALSE ) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  geom_errorbar(aes(ymin=(mean_lifetime-(sd_lifetime/sqrt(count))), ymax=(mean_lifetime+(sd_lifetime/sqrt(count)))),
                size=0.8, width=60/40) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab(expression(paste("Initial area (um"^{2},")" ))) +
  ylab(expression(paste("Lifetime (h)"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(0,60), breaks=seq(0,60,10), expand = c(0,0), labels = every_nth(seq(0,60,10), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,12.1), breaks=c(0,2,4,6,8,10,12), expand =c(0,0)) 
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("lifetimes_initial_bin_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



## GS 17 FEB 2020 18 FEB 2020: correlation coefficient for panels 2C--2F. pearson correlation I guess. 
## just try mixing all the WTs together i.e. use lifetimes_initial_bin_all.
# http://www.sthda.com/english/wiki/correlation-test-between-two-variables-in-r
CORR_lifetimes_initial_area_bin <- cor.test(lifetimes_initial_bin_all$mid_area, lifetimes_initial_bin_all$mean_lifetime, method = c("pearson"))
CORR_lifetimes_initial_area_nonbin <- cor.test(lifetimes_initial_nonbin_all$initial_area*0.207^2, lifetimes_initial_nonbin_all$lifetime*2.5/60, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_initial_area_bin$estimate, file="CORR_lifetimes_initial_area_bin_estimate.csv")
write.csv(CORR_lifetimes_initial_area_bin$p.value, file="CORR_lifetimes_initial_area_bin_pvalue.csv")
write.csv(CORR_lifetimes_initial_area_nonbin$estimate, file="CORR_lifetimes_initial_area_nonbin_estimate.csv")
write.csv(CORR_lifetimes_initial_area_nonbin$p.value, file="CORR_lifetimes_initial_area_nonbin_pvalue.csv")

## per WT (6 Oct 2020)
#WT1
CORR_lifetimes_initial_area_nonbin_WT1 <- cor.test(lifetimes_initial_nonbin_WT1$initial_area, lifetimes_initial_nonbin_WT1$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_initial_area_nonbin_WT1$estimate, file="CORR_lifetimes_initial_area_nonbin_WT1_estimate.csv")
write.csv(CORR_lifetimes_initial_area_nonbin_WT1$p.value, file="CORR_lifetimes_initial_area_nonbin_WT1_pvalue.csv")
#WT2
CORR_lifetimes_initial_area_nonbin_WT2 <- cor.test(lifetimes_initial_nonbin_WT2$initial_area, lifetimes_initial_nonbin_WT2$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_initial_area_nonbin_WT2$estimate, file="CORR_lifetimes_initial_area_nonbin_WT2_estimate.csv")
write.csv(CORR_lifetimes_initial_area_nonbin_WT2$p.value, file="CORR_lifetimes_initial_area_nonbin_WT2_pvalue.csv")
#WT3
CORR_lifetimes_initial_area_nonbin_WT3 <- cor.test(lifetimes_initial_nonbin_WT3$initial_area, lifetimes_initial_nonbin_WT3$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_initial_area_nonbin_WT3$estimate, file="CORR_lifetimes_initial_area_nonbin_WT3_estimate.csv")
write.csv(CORR_lifetimes_initial_area_nonbin_WT3$p.value, file="CORR_lifetimes_initial_area_nonbin_WT3_pvalue.csv")
#WT4
CORR_lifetimes_initial_area_nonbin_WT4 <- cor.test(lifetimes_initial_nonbin_WT4$initial_area, lifetimes_initial_nonbin_WT4$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_initial_area_nonbin_WT4$estimate, file="CORR_lifetimes_initial_area_nonbin_WT4_estimate.csv")
write.csv(CORR_lifetimes_initial_area_nonbin_WT4$p.value, file="CORR_lifetimes_initial_area_nonbin_WT4_pvalue.csv")






## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% correlation with mother lifetime. playing with bin size a bit, 
## the distribution is quite peaked so 
mothers_left_WT1 <- lifetimes_etc_WT1 %>% select(cell_id, left_daughter_cell_id) %>% rename(mother_cell_id = cell_id, cell_id = left_daughter_cell_id)
mothers_right_WT1 <- lifetimes_etc_WT1 %>% select(cell_id, right_daughter_cell_id) %>% rename(mother_cell_id = cell_id, cell_id = right_daughter_cell_id) 
mothers_WT1 <- rbind(mothers_left_WT1,mothers_right_WT1) %>% unique()
lifetime_mother_WT1 <-  lifetimes_etc_WT1 %>% select(cell_id,lifetime) %>% rename(mother_cell_id = cell_id, mother_lifetime = lifetime) %>% dt.merge(mothers_WT1,by="mother_cell_id")
lifetime_mother_WT1 <-  lifetimes_etc_WT1 %>% select(cell_id,lifetime) %>% rename(cell_id = cell_id, lifetime = lifetime) %>% dt.merge(lifetime_mother_WT1,by="cell_id")
lifetime_mother_WT1$movie <- "WT1"
lifetime_mother_bin_WT1 <- lifetime_mother_WT1 %>% mutate(mid_mother_lifetime = (10*(floor(mother_lifetime / 10)) + 5)*(2.5/60)) %>% group_by(mid_mother_lifetime,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

mothers_left_WT2 <- lifetimes_etc_WT2 %>% select(cell_id, left_daughter_cell_id) %>% rename(mother_cell_id = cell_id, cell_id = left_daughter_cell_id)
mothers_right_WT2 <- lifetimes_etc_WT2 %>% select(cell_id, right_daughter_cell_id) %>% rename(mother_cell_id = cell_id, cell_id = right_daughter_cell_id) 
mothers_WT2 <- rbind(mothers_left_WT2,mothers_right_WT2) %>% unique()
lifetime_mother_WT2 <-  lifetimes_etc_WT2 %>% select(cell_id,lifetime) %>% rename(mother_cell_id = cell_id, mother_lifetime = lifetime) %>% dt.merge(mothers_WT2,by="mother_cell_id")
lifetime_mother_WT2 <-  lifetimes_etc_WT2 %>% select(cell_id,lifetime) %>% rename(cell_id = cell_id, lifetime = lifetime) %>% dt.merge(lifetime_mother_WT2,by="cell_id")
lifetime_mother_WT2$movie <- "WT2"
lifetime_mother_bin_WT2 <- lifetime_mother_WT2 %>% mutate(mid_mother_lifetime = (10*(floor(mother_lifetime / 10)) + 5)*(2.5/60)) %>% group_by(mid_mother_lifetime,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

mothers_left_WT3 <- lifetimes_etc_WT3 %>% select(cell_id, left_daughter_cell_id) %>% rename(mother_cell_id = cell_id, cell_id = left_daughter_cell_id)
mothers_right_WT3 <- lifetimes_etc_WT3 %>% select(cell_id, right_daughter_cell_id) %>% rename(mother_cell_id = cell_id, cell_id = right_daughter_cell_id) 
mothers_WT3 <- rbind(mothers_left_WT3,mothers_right_WT3) %>% unique()
lifetime_mother_WT3 <-  lifetimes_etc_WT3 %>% select(cell_id,lifetime) %>% rename(mother_cell_id = cell_id, mother_lifetime = lifetime) %>% dt.merge(mothers_WT3,by="mother_cell_id")
lifetime_mother_WT3 <-  lifetimes_etc_WT3 %>% select(cell_id,lifetime) %>% rename(cell_id = cell_id, lifetime = lifetime) %>% dt.merge(lifetime_mother_WT3,by="cell_id")
lifetime_mother_WT3$movie <- "WT3"
lifetime_mother_bin_WT3 <- lifetime_mother_WT3 %>% mutate(mid_mother_lifetime = (10*(floor(mother_lifetime / 10)) + 5)*(2.5/60)) %>% group_by(mid_mother_lifetime,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

mothers_left_WT4 <- lifetimes_etc_WT4 %>% select(cell_id, left_daughter_cell_id) %>% rename(mother_cell_id = cell_id, cell_id = left_daughter_cell_id)
mothers_right_WT4 <- lifetimes_etc_WT4 %>% select(cell_id, right_daughter_cell_id) %>% rename(mother_cell_id = cell_id, cell_id = right_daughter_cell_id) 
mothers_WT4 <- rbind(mothers_left_WT4,mothers_right_WT4) %>% unique()
lifetime_mother_WT4 <-  lifetimes_etc_WT4 %>% select(cell_id,lifetime) %>% rename(mother_cell_id = cell_id, mother_lifetime = lifetime) %>% dt.merge(mothers_WT4,by="mother_cell_id")
lifetime_mother_WT4 <-  lifetimes_etc_WT4 %>% select(cell_id,lifetime) %>% rename(cell_id = cell_id, lifetime = lifetime) %>% dt.merge(lifetime_mother_WT4,by="cell_id")
lifetime_mother_WT4$movie <- "WT4"
lifetime_mother_bin_WT4 <- lifetime_mother_WT4 %>% mutate(mid_mother_lifetime = (10*(floor(mother_lifetime / 10)) + 5)*(2.5/60)) %>% group_by(mid_mother_lifetime,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

lifetimes_mother_bin_all <- rbind(lifetime_mother_bin_WT1,lifetime_mother_bin_WT2,lifetime_mother_bin_WT3,lifetime_mother_bin_WT4)
lifetimes_mother_nonbin_all <- rbind(lifetime_mother_WT1,lifetime_mother_WT2,lifetime_mother_WT3,lifetime_mother_WT4)

myplot <- ggplot(lifetimes_mother_bin_all, aes(mid_mother_lifetime, mean_lifetime, color=movie)) +
  geom_point(data=lifetimes_mother_nonbin_all, aes(mother_lifetime*2.5/60, lifetime*2.5/60, fill = movie, color = movie),size = 0.3, alpha=0.05, show.legend = FALSE ) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  geom_errorbar(aes(ymin=(mean_lifetime-(sd_lifetime/sqrt(count))), ymax=(mean_lifetime+(sd_lifetime/sqrt(count)))),
                size=0.8, width=12/40) + #setting error bar width to half of bin size, i,.e what i add above to the floor bit. times the units 2.5/60.
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab(expression(paste("Mother lifetime (h)"))) +
  ylab(expression(paste("Lifetime (h)"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_y_continuous(limits=c(-0.1,12.1), expand = c(0,0)) + 
  scale_x_continuous(limits=c(-0.1,12.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("lifetimes_mother_bin_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## extra GS request 17 FEB 2020 18 FEB 2020
CORR_lifetimes_mother_bin <- cor.test(lifetimes_mother_bin_all$mid_mother_lifetime, lifetimes_mother_bin_all$mean_lifetime, method = c("pearson"))
CORR_lifetimes_mother_nonbin <- cor.test(lifetimes_mother_nonbin_all$mother_lifetime*2.5/60, lifetimes_mother_nonbin_all$lifetime*2.5/60, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_mother_bin$estimate, file="CORR_lifetimes_mother_bin_estimate.csv")
write.csv(CORR_lifetimes_mother_bin$p.value, file="CORR_lifetimes_mother_bin_pvalue.csv")
write.csv(CORR_lifetimes_mother_nonbin$estimate, file="CORR_lifetimes_mothernonbin_estimate.csv")
write.csv(CORR_lifetimes_mother_nonbin$p.value, file="CORR_lifetimes_mother_nonbin_pvalue.csv")



## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# calculate lifetime as fn of AVG LIFETIME AREA for each WT and do 'no correlation plot' as above
load("/Users/john/TM_LOCAL_TEMP/WT1_redone/time/dbTablesFromParser/cellsDB.RData")
avglifearea <- cellsDB %>% group_by(cell_id) %>% summarise(avglifearea = mean(area))
lifetimes_avglifearea_nonbin_WT1 <- lifetimes_etc_WT1 %>% dt.merge(avglifearea,by="cell_id")
lifetimes_avglifearea_bin_WT1 <- lifetimes_etc_WT1 %>% dt.merge(avglifearea,by="cell_id") %>% mutate(mid_area = (100*(floor(avglifearea / 100)) + 50)*0.207^2) %>% group_by(mid_area,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

load("/Users/john/TM_LOCAL_TEMP/WT2_redone_post_anna_revision/time/dbTablesFromParser/cellsDB.RData")
avglifearea <- cellsDB %>% group_by(cell_id) %>% summarise(avglifearea = mean(area))
lifetimes_avglifearea_nonbin_WT2 <- lifetimes_etc_WT2 %>% dt.merge(avglifearea,by="cell_id")
lifetimes_avglifearea_bin_WT2 <- lifetimes_etc_WT2 %>% dt.merge(avglifearea,by="cell_id") %>% mutate(mid_area = (100*(floor(avglifearea / 100)) + 50)*0.207^2) %>% group_by(mid_area,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

load("/Users/john/TM_LOCAL_TEMP/WT3_redone/time/dbTablesFromParser/cellsDB.RData")
avglifearea <- cellsDB %>% group_by(cell_id) %>% summarise(avglifearea = mean(area))
lifetimes_avglifearea_nonbin_WT3 <- lifetimes_etc_WT3 %>% dt.merge(avglifearea,by="cell_id")
lifetimes_avglifearea_bin_WT3 <- lifetimes_etc_WT3 %>% dt.merge(avglifearea,by="cell_id") %>% mutate(mid_area = (100*(floor(avglifearea / 100)) + 50)*0.207^2) %>% group_by(mid_area,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

load("/Users/john/TM_LOCAL_TEMP/HA1/time/dbTablesFromParser/cellsDB.RData")
avglifearea <- cellsDB %>% group_by(cell_id) %>% summarise(avglifearea = mean(area))
lifetimes_avglifearea_nonbin_WT4 <- lifetimes_etc_WT4 %>% dt.merge(avglifearea,by="cell_id")
lifetimes_avglifearea_bin_WT4 <- lifetimes_etc_WT4 %>% dt.merge(avglifearea,by="cell_id") %>% mutate(mid_area = (100*(floor(avglifearea / 100)) + 50)*0.207^2) %>% group_by(mid_area,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

lifetimes_avglifearea_bin_all <- rbind(lifetimes_avglifearea_bin_WT1,lifetimes_avglifearea_bin_WT2,lifetimes_avglifearea_bin_WT3,lifetimes_avglifearea_bin_WT4)
lifetimes_avglifearea_nonbin_all <- rbind(lifetimes_avglifearea_nonbin_WT1,lifetimes_avglifearea_nonbin_WT2,lifetimes_avglifearea_nonbin_WT3,lifetimes_avglifearea_nonbin_WT4)

myplot <- ggplot(lifetimes_avglifearea_bin_all, aes(mid_area, mean_lifetime, color=movie)) +
  geom_point(data=lifetimes_avglifearea_nonbin_all, aes(avglifearea*0.207^2, lifetime*2.5/60, fill = movie, color=movie),size = 0.3, alpha=0.05, show.legend = FALSE ) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  geom_errorbar(aes(ymin=(mean_lifetime-(sd_lifetime/sqrt(count))), ymax=(mean_lifetime+(sd_lifetime/sqrt(count)))),
                size=0.8, width=100/40) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab(expression(paste("Avg. lifetime area (um"^{2},")" ))) +
  ylab(expression(paste("Lifetime (h)"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(0,100), breaks=seq(0,100,10), expand = c(0,0), labels = every_nth(seq(0,100,10), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,12.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("lifetimes_avglifearea_bin_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## extra GS request 17 FEB 2020 18 FEB 2020
CORR_lifetimes_avglifearea_bin <- cor.test(lifetimes_avglifearea_bin_all$mid_area, lifetimes_avglifearea_bin_all$mean_lifetime, method = c("pearson"))
CORR_lifetimes_avglifearea_nonbin <- cor.test(lifetimes_avglifearea_nonbin_all$initial_area*0.207^2, lifetimes_avglifearea_nonbin_all$lifetime*2.5/60, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifearea_bin$estimate, file="CORR_lifetimes_avglifearea_bin_estimate.csv")
write.csv(CORR_lifetimes_avglifearea_bin$p.value, file="CORR_lifetimes_avglifearea_bin_pvalue.csv")
write.csv(CORR_lifetimes_avglifearea_nonbin$estimate, file="CORR_lifetimes_avglifearea_nonbin_estimate.csv")
write.csv(CORR_lifetimes_avglifearea_nonbin$p.value, file="CORR_lifetimes_avglifearea_nonbin_pvalue.csv")

### extra: 6 Oct 2020 
# It would also make sense to calculate a correlation coefficient 
# for the lifetime vs area at birth, mean area, and elongation; 
# as we do it for other quantities. This is already in here, but specialise it to per-WT basis too. here and elsewhere
# where CORR_... appears.
## per WT (6 Oct 2020)
#WT1
CORR_lifetimes_avglifearea_nonbin_WT1 <- cor.test(lifetimes_avglifearea_nonbin_WT1$avglifearea, lifetimes_avglifearea_nonbin_WT1$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifearea_nonbin_WT1$estimate, file="CORR_lifetimes_avglifearea_nonbin_WT1_estimate.csv")
write.csv(CORR_lifetimes_avglifearea_nonbin_WT1$p.value, file="CORR_lifetimes_avglifearea_nonbin_WT1_pvalue.csv")
#WT2
CORR_lifetimes_avglifearea_nonbin_WT2 <- cor.test(lifetimes_avglifearea_nonbin_WT2$avglifearea, lifetimes_avglifearea_nonbin_WT2$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifearea_nonbin_WT2$estimate, file="CORR_lifetimes_avglifearea_nonbin_WT2_estimate.csv")
write.csv(CORR_lifetimes_avglifearea_nonbin_WT2$p.value, file="CORR_lifetimes_avglifearea_nonbin_WT2_pvalue.csv")
#WT3
CORR_lifetimes_avglifearea_nonbin_WT3 <- cor.test(lifetimes_avglifearea_nonbin_WT3$avglifearea, lifetimes_avglifearea_nonbin_WT3$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifearea_nonbin_WT3$estimate, file="CORR_lifetimes_avglifearea_nonbin_WT3_estimate.csv")
write.csv(CORR_lifetimes_avglifearea_nonbin_WT3$p.value, file="CORR_lifetimes_avglifearea_nonbin_WT3_pvalue.csv")
#WT4
CORR_lifetimes_avglifearea_nonbin_WT4 <- cor.test(lifetimes_avglifearea_nonbin_WT4$avglifearea, lifetimes_avglifearea_nonbin_WT4$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifearea_nonbin_WT4$estimate, file="CORR_lifetimes_avglifearea_nonbin_WT4_estimate.csv")
write.csv(CORR_lifetimes_avglifearea_nonbin_WT4$p.value, file="CORR_lifetimes_avglifearea_nonbin_WT4_pvalue.csv")






## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# calculate lifetime as fn of AVG LIFETIME NORMMMMMMMMM for each WT and do 'no correlation plot' as above
load("/Users/john/TM_LOCAL_TEMP/WT1_redone/time/dbTablesFromParser/cellsDB.RData")
avglifenorm <- cellsDB %>% group_by(cell_id) %>% summarise(avglifenorm = mean(sqrt(elong_xx^2 + elong_xy^2)))
lifetimes_avglifenorm_nonbin_WT1 <- lifetimes_etc_WT1 %>% dt.merge(avglifenorm,by="cell_id")
lifetimes_avglifenorm_bin_WT1 <- lifetimes_etc_WT1 %>% dt.merge(avglifenorm,by="cell_id") %>% mutate(mid_norm = (0.05*(floor(avglifenorm / 0.05)) + 0.025)) %>% group_by(mid_norm,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

load("/Users/john/TM_LOCAL_TEMP/WT2_redone_post_anna_revision/time/dbTablesFromParser/cellsDB.RData")
avglifenorm <- cellsDB %>% group_by(cell_id) %>% summarise(avglifenorm = mean(sqrt(elong_xx^2 + elong_xy^2)))
lifetimes_avglifenorm_nonbin_WT2 <- lifetimes_etc_WT2 %>% dt.merge(avglifenorm,by="cell_id")
lifetimes_avglifenorm_bin_WT2 <- lifetimes_etc_WT2 %>% dt.merge(avglifenorm,by="cell_id") %>% mutate(mid_norm = (0.05*(floor(avglifenorm / 0.05)) + 0.025)) %>% group_by(mid_norm,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

load("/Users/john/TM_LOCAL_TEMP/WT3_redone/time/dbTablesFromParser/cellsDB.RData")
avglifenorm <- cellsDB %>% group_by(cell_id) %>% summarise(avglifenorm = mean(sqrt(elong_xx^2 + elong_xy^2)))
lifetimes_avglifenorm_nonbin_WT3 <- lifetimes_etc_WT3 %>% dt.merge(avglifenorm,by="cell_id")
lifetimes_avglifenorm_bin_WT3 <- lifetimes_etc_WT3 %>% dt.merge(avglifenorm,by="cell_id") %>% mutate(mid_norm = (0.05*(floor(avglifenorm / 0.05)) + 0.025)) %>% group_by(mid_norm,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

load("/Users/john/TM_LOCAL_TEMP/HA1/time/dbTablesFromParser/cellsDB.RData")
avglifenorm <- cellsDB %>% group_by(cell_id) %>% summarise(avglifenorm = mean(sqrt(elong_xx^2 + elong_xy^2)))
lifetimes_avglifenorm_nonbin_WT4 <- lifetimes_etc_WT4 %>% dt.merge(avglifenorm,by="cell_id")
lifetimes_avglifenorm_bin_WT4 <- lifetimes_etc_WT4 %>% dt.merge(avglifenorm,by="cell_id") %>% mutate(mid_norm = (0.05*(floor(avglifenorm / 0.05)) + 0.025)) %>% group_by(mid_norm,movie) %>% summarise(mean_lifetime = mean(lifetime)*2.5/60, sd_lifetime = sd(lifetime)*2.5/60, count = n()) %>% na.omit()

lifetimes_avglifenorm_bin_all <- rbind(lifetimes_avglifenorm_bin_WT1,lifetimes_avglifenorm_bin_WT2,lifetimes_avglifenorm_bin_WT3,lifetimes_avglifenorm_bin_WT4)
lifetimes_avglifenorm_nonbin_all <- rbind(lifetimes_avglifenorm_nonbin_WT1,lifetimes_avglifenorm_nonbin_WT2,lifetimes_avglifenorm_nonbin_WT3,lifetimes_avglifenorm_nonbin_WT4)

myplot <- ggplot(lifetimes_avglifenorm_bin_all, aes(mid_norm, mean_lifetime, color=movie)) +
  geom_point(data=lifetimes_avglifenorm_nonbin_all, aes(avglifenorm, lifetime*2.5/60, fill = movie,color=movie),size = 0.3, alpha=0.05, show.legend = FALSE ) +
  geom_line(size=0.6) + 
  geom_point(size=0.8) + 
  geom_errorbar(aes(ymin=(mean_lifetime-(sd_lifetime/sqrt(count))), ymax=(mean_lifetime+(sd_lifetime/sqrt(count)))),
                size=0.8, width=0.7/40) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab(expression(paste("Avg. lifetime elong. norm" ))) +
  ylab(expression(paste("Lifetime (h)"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(0,0.7), breaks=seq(0,0.7,0.1), expand = c(0,0), labels = every_nth(seq(0,0.7,0.1), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,12.1), breaks=c(0,2,4,6,8,10,12),expand = c(0,0)) 
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("lifetimes_avglifenorm_bin_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## extra GS request 17 FEB 2020 18 FEB 2020
CORR_lifetimes_avglifenorm_bin <- cor.test(lifetimes_avglifenorm_bin_all$mid_norm, lifetimes_avglifenorm_bin_all$mean_lifetime, method = c("pearson"))
CORR_lifetimes_avglifenorm_nonbin <- cor.test(lifetimes_avglifenorm_nonbin_all$avglifenorm, lifetimes_avglifenorm_nonbin_all$lifetime*2.5/60, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifenorm_bin$estimate, file="CORR_lifetimes_avglifenorm_bin_estimate.csv")
write.csv(CORR_lifetimes_avglifenorm_bin$p.value, file="CORR_lifetimes_avglifenorm_bin_pvalue.csv")
write.csv(CORR_lifetimes_avglifenorm_nonbin$estimate, file="CORR_lifetimes_avglifenorm_nonbin_estimate.csv")
write.csv(CORR_lifetimes_avglifenorm_nonbin$p.value, file="CORR_lifetimes_avglifenorm_nonbin_pvalue.csv")

## specialise per WT
#WT1
CORR_lifetimes_avglifenorm_nonbin_WT1 <- cor.test(lifetimes_avglifenorm_nonbin_WT1$avglifenorm, lifetimes_avglifenorm_nonbin_WT1$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifenorm_nonbin_WT1$estimate, file="CORR_lifetimes_avglifenorm_nonbin_WT1_estimate.csv")
write.csv(CORR_lifetimes_avglifenorm_nonbin_WT1$p.value, file="CORR_lifetimes_avglifenorm_nonbin_WT1_pvalue.csv")
#WT2
CORR_lifetimes_avglifenorm_nonbin_WT2 <- cor.test(lifetimes_avglifenorm_nonbin_WT2$avglifenorm, lifetimes_avglifenorm_nonbin_WT2$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifenorm_nonbin_WT2$estimate, file="CORR_lifetimes_avglifenorm_nonbin_WT2_estimate.csv")
write.csv(CORR_lifetimes_avglifenorm_nonbin_WT2$p.value, file="CORR_lifetimes_avglifenorm_nonbin_WT2_pvalue.csv")
#WT3
CORR_lifetimes_avglifenorm_nonbin_WT3 <- cor.test(lifetimes_avglifenorm_nonbin_WT3$avglifenorm, lifetimes_avglifenorm_nonbin_WT3$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifenorm_nonbin_WT3$estimate, file="CORR_lifetimes_avglifenorm_nonbin_WT3_estimate.csv")
write.csv(CORR_lifetimes_avglifenorm_nonbin_WT3$p.value, file="CORR_lifetimes_avglifenorm_nonbin_WT3_pvalue.csv")
#WT4
CORR_lifetimes_avglifenorm_nonbin_WT4 <- cor.test(lifetimes_avglifenorm_nonbin_WT4$avglifenorm, lifetimes_avglifenorm_nonbin_WT4$lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_lifetimes_avglifenorm_nonbin_WT4$estimate, file="CORR_lifetimes_avglifenorm_nonbin_WT4_estimate.csv")
write.csv(CORR_lifetimes_avglifenorm_nonbin_WT4$p.value, file="CORR_lifetimes_avglifenorm_nonbin_WT4_pvalue.csv")



### FIG 2 (1 now) SUPPLEMENT -- SOP COUNTS AND FIT. SEPARATE, AND SUPERIMPOSED TO SHOW TIME ALIGNMENT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SOP_count_WT1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/cumul_counts/count_SOP_noborder.csv")
SOP_count_WT1$movie <- "WT1"
SOP_count_WT2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/cumul_counts/count_SOP_noborder.csv")
SOP_count_WT2$movie <- "WT2"
SOP_count_WT3 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/cumul_counts/count_SOP_noborder.csv")
SOP_count_WT3$movie <- "WT3"
SOP_count_WT4 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/cumul_counts/count_SOP_noborder.csv")
SOP_count_WT4$movie <- "WT4"

## PLOT individual WTs IN RAW TIME. IE NOT OFFSET or restricted at all.
## WT1
switchtime <- 7.083
hillcoeff <- 8
totalSOPs <- 50
myplot <- ggplot(SOP_count_WT1, aes(dev_time + 16, count, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  stat_function(fun = function(.x)  totalSOPs*((.x-16)/switchtime)^hillcoeff / (((.x-16)/switchtime)^(hillcoeff) + 1) , colour = "black", size = 0.8, linetype = "dashed"  ) +
  xlab(expression(paste("Time (raw) (hAPF)" ))) + 
  ylab(expression(paste("SOPs in noborder ROI"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) + #
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) 
  #scale_y_continuous(limits=c(-0.1,12.1), breaks=c(0,2,4,6,8,10,12),expand = c(0,0)) 
  myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                           height = unit(39*2/3, "mm"))
ggsave("SOP_count_WT1.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## WT2
switchtime <- 9.667
hillcoeff <- 10
totalSOPs <- 46
myplot <- ggplot(SOP_count_WT2, aes(dev_time + 16, count, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  stat_function(fun = function(.x)  totalSOPs*((.x-16)/switchtime)^hillcoeff / (((.x-16)/switchtime)^(hillcoeff) + 1) , colour = "black", size = 0.8, linetype = "dashed"  ) +
  xlab(expression(paste("Time (raw) (hAPF)" ))) + 
  ylab(expression(paste("SOPs in noborder ROI"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) + #
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) 
#scale_y_continuous(limits=c(-0.1,12.1), breaks=c(0,2,4,6,8,10,12),expand = c(0,0)) 
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("SOP_count_WT2.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## WT3
switchtime <- 6.916
hillcoeff <- 10
totalSOPs <- 38
myplot <- ggplot(SOP_count_WT3, aes(dev_time + 16, count, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  stat_function(fun = function(.x)  totalSOPs*((.x-16)/switchtime)^hillcoeff / (((.x-16)/switchtime)^(hillcoeff) + 1) , colour = "black", size = 0.8, linetype = "dashed"  ) +
  xlab(expression(paste("Time (raw) (hAPF)" ))) + 
  ylab(expression(paste("SOPs in noborder ROI"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) + #
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) 
#scale_y_continuous(limits=c(-0.1,12.1), breaks=c(0,2,4,6,8,10,12),expand = c(0,0)) 
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("SOP_count_WT3.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## WT4
switchtime <- 6.792
hillcoeff <- 10
totalSOPs <- 41
myplot <- ggplot(SOP_count_WT4, aes(dev_time + 16, count, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  stat_function(fun = function(.x)  totalSOPs*((.x-16)/switchtime)^hillcoeff / (((.x-16)/switchtime)^(hillcoeff) + 1) , colour = "black", size = 0.8, linetype = "dashed"  ) +
  xlab(expression(paste("Time (raw) (hAPF)" ))) + 
  ylab(expression(paste("SOPs in noborder ROI"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) + #
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) 
#scale_y_continuous(limits=c(-0.1,12.1), breaks=c(0,2,4,6,8,10,12),expand = c(0,0)) 
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("SOP_count_WT4.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## COMBINE WTS potentially with fits too (or not), with offsets relative to WT2 NOW WT1!!!.
SOP_count_WT1$realdev_time <- SOP_count_WT1$dev_time + (offset_WT1*2.5/60)
SOP_count_WT2$realdev_time <- SOP_count_WT2$dev_time + (offset_WT2*2.5/60)
SOP_count_WT3$realdev_time <- SOP_count_WT3$dev_time + (offset_WT3*2.5/60)
SOP_count_WT4$realdev_time <- SOP_count_WT4$dev_time + (offset_WT4*2.5/60)
## Also define a proportional count of SOP number
SOP_count_WT1$rel_count <- SOP_count_WT1$count/max(SOP_count_WT1$count)
SOP_count_WT2$rel_count <- SOP_count_WT2$count/max(SOP_count_WT2$count)
SOP_count_WT3$rel_count <- SOP_count_WT3$count/max(SOP_count_WT3$count)
SOP_count_WT4$rel_count <- SOP_count_WT4$count/max(SOP_count_WT4$count)

SOP_count_allWTs <- rbind(SOP_count_WT1,SOP_count_WT2,SOP_count_WT3,SOP_count_WT4)

myplot <- ggplot(SOP_count_allWTs, aes(realdev_time + 16, rel_count, color=movie)) +
  geom_line(size=0.8) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab(expression(paste("Time (hAPF)" ))) + 
  ylab(expression(paste("Normalised SOPs in noborder ROI"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) + 
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) 
#scale_y_continuous(limits=c(-0.1,12.1), breaks=c(0,2,4,6,8,10,12),expand = c(0,0)) 
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("SOP_count_allWTs.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.75, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


##


## extra: ks21 deformation rates for a new fig 2A. possibly try OFFSETTING THE y AXIS of EACH CURVE
avgIsoDefRateSummary_WT1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/avgIsoDefRateSummary_ks21.csv") 
avgIsoDefRateSummary_WT1$frame <- round(avgIsoDefRateSummary_WT1$dev_time*60/2.5)
avgIsoDefRateSummary_WT1$realframe <- avgIsoDefRateSummary_WT1$frame + offset_WT1
avgIsoDefRateSummary_WT1$realdev_time <- avgIsoDefRateSummary_WT1$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT1$roi <- as.character(avgIsoDefRateSummary_WT1$roi)
avgIsoDefRateSummary_WT1$isoContrib <- as.character(avgIsoDefRateSummary_WT1$isoContrib)
#
avgIsoDefRateSummary_WT2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/avgIsoDefRateSummary_ks21.csv") 
avgIsoDefRateSummary_WT2$frame <- round(avgIsoDefRateSummary_WT2$dev_time*60/2.5)
avgIsoDefRateSummary_WT2$realframe <- avgIsoDefRateSummary_WT2$frame + offset_WT2
avgIsoDefRateSummary_WT2$realdev_time <- avgIsoDefRateSummary_WT2$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT2$roi <- as.character(avgIsoDefRateSummary_WT2$roi)
avgIsoDefRateSummary_WT2$isoContrib <- as.character(avgIsoDefRateSummary_WT2$isoContrib)
#
avgIsoDefRateSummary_WT3 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/avgIsoDefRateSummary_ks21.csv") 
avgIsoDefRateSummary_WT3$frame <- round(avgIsoDefRateSummary_WT3$dev_time*60/2.5)
avgIsoDefRateSummary_WT3$realframe <- avgIsoDefRateSummary_WT3$frame + offset_WT3
avgIsoDefRateSummary_WT3$realdev_time <- avgIsoDefRateSummary_WT3$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT3$roi <- as.character(avgIsoDefRateSummary_WT3$roi)
avgIsoDefRateSummary_WT3$isoContrib <- as.character(avgIsoDefRateSummary_WT3$isoContrib)
#
avgIsoDefRateSummary_WT4 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/avgIsoDefRateSummary_ks21.csv") 
avgIsoDefRateSummary_WT4$frame <- round(avgIsoDefRateSummary_WT4$dev_time*60/2.5)
avgIsoDefRateSummary_WT4$realframe <- avgIsoDefRateSummary_WT4$frame + offset_WT4
avgIsoDefRateSummary_WT4$realdev_time <- avgIsoDefRateSummary_WT4$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT4$roi <- as.character(avgIsoDefRateSummary_WT4$roi)
avgIsoDefRateSummary_WT4$isoContrib <- as.character(avgIsoDefRateSummary_WT4$isoContrib)

avgIsoDefRateSummary_allWTs_division_ks21 <- rbind(avgIsoDefRateSummary_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="division") %>% mutate(movie = "WT1"), avgIsoDefRateSummary_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="division") %>% mutate(movie = "WT2"),
                                              avgIsoDefRateSummary_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="division") %>% mutate(movie = "WT3"), avgIsoDefRateSummary_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% filter(isoContrib=="division") %>% mutate(movie = "WT4"))

myplot <- ggplot(avgIsoDefRateSummary_allWTs_division_ks21 , aes(realdev_time + 16, value.avg, color=movie)) +
  geom_line(size=0.8, alpha=0.65) + 
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Shear rate (hr"^"-1",")"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.34), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefRateSummary_allWTs_division_ks21.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## INSERT ADDITION -- for each WT movie, plot rates: cell area, division, extrusion, sumContrib, tissue_area
## WT1
myplot <- ggplot(avgIsoDefRateSummary_WT1 %>% filter(realframe >= min_realframe & realframe <= max_realframe), aes(realdev_time + 16, value.avg, color=isoContrib)) +
  geom_line(size=0.8, alpha=0.95) + 
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Shear rate (hr"^"-1",")"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.15,0.35), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefRateSummary_WT1_ks21.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

##
## WT2
myplot <- ggplot(avgIsoDefRateSummary_WT2 %>% filter(realframe >= min_realframe & realframe <= max_realframe), aes(realdev_time + 16, value.avg, color=isoContrib)) +
  geom_line(size=0.8, alpha=0.95) + 
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Shear rate (hr"^"-1",")"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.15,0.35), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefRateSummary_WT2_ks21.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

##
## WT3
myplot <- ggplot(avgIsoDefRateSummary_WT3 %>% filter(realframe >= min_realframe & realframe <= max_realframe), aes(realdev_time + 16, value.avg, color=isoContrib)) +
  geom_line(size=0.8, alpha=0.95) + 
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Shear rate (hr"^"-1",")"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.15,0.35), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefRateSummary_WT3_ks21.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)
#
## WT4
myplot <- ggplot(avgIsoDefRateSummary_WT4 %>% filter(realframe >= min_realframe & realframe <= max_realframe), aes(realdev_time + 16, value.avg, color=isoContrib)) +
  geom_line(size=0.8, alpha=0.95) + 
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("Shear rate (hr"^"-1",")"))) +
  scale_color_manual(values=isotropColors) +
  scale_fill_manual(values=isotropColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.15,0.35), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("avgIsoDefRateSummary_WT4_ks21.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)




## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## ADDITION! MMP data for comparison. Could plot a ribbon of the WTs mean and standard deviation. then a series for the MMP

## comment this out for now, don't need to worry about it for first paper.

# 
# ## import MMP1 data (MMP2 later)
# avgIsoDefRateSummary_MMP1_ks1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/MMP1/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
# avgIsoDefRateSummary_MMP1_ks1$frame <- round(avgIsoDefRateSummary_MMP1_ks1$dev_time*60/2.5)
# avgIsoDefRateSummary_MMP1_ks1$realframe <- avgIsoDefRateSummary_MMP1_ks1$frame + offset_MMP1
# avgIsoDefRateSummary_MMP1_ks1$realdev_time <- avgIsoDefRateSummary_MMP1_ks1$realframe * 2.5/60
# # removing factors (?? what does this do?)
# avgIsoDefRateSummary_MMP1_ks1$roi <- as.character(avgIsoDefRateSummary_MMP1_ks1$roi)
# avgIsoDefRateSummary_MMP1_ks1$isoContrib <- as.character(avgIsoDefRateSummary_MMP1_ks1$isoContrib)
# 
# ## now cumulate starting from the minimum allowed realframe, which may not be the first frame in this thing. That is why we
# ## do the offsetting before cumulating. SAME FOR MMP STILL SO IS RESTRICTED
# 
# avgIsoDefCum_MMP1_ks1 <- avgIsoDefRateSummary_MMP1_ks1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>%
#   group_by(roi, isoContrib) %>%
#   mutate(timeInt=c(0,diff(dev_time)), value.cumsum=cumsum(value.avg*timeInt)) %>% 
#   group_by(roi, isoContrib, dev_time, frame, realframe, realdev_time) %>%
#   summarise(cumsum.avg=mean(value.cumsum), cumsum.sd=sd(value.cumsum))
# 
# ## import MMP2
# avgIsoDefRateSummary_MMP2_ks1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/MMP2/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
# avgIsoDefRateSummary_MMP2_ks1$frame <- round(avgIsoDefRateSummary_MMP2_ks1$dev_time*60/2.5)
# avgIsoDefRateSummary_MMP2_ks1$realframe <- avgIsoDefRateSummary_MMP2_ks1$frame + offset_MMP2
# avgIsoDefRateSummary_MMP2_ks1$realdev_time <- avgIsoDefRateSummary_MMP2_ks1$realframe * 2.5/60
# # removing factors (?? what does this do?)
# avgIsoDefRateSummary_MMP2_ks1$roi <- as.character(avgIsoDefRateSummary_MMP2_ks1$roi)
# avgIsoDefRateSummary_MMP2_ks1$isoContrib <- as.character(avgIsoDefRateSummary_MMP2_ks1$isoContrib)
# 
# ## now cumulate starting from the minimum allowed realframe, which may not be the first frame in this thing. That is why we
# ## do the offsetting before cumulating. SAME FOR MMP STILL SO IS RESTRICTED
# 
# avgIsoDefCum_MMP2_ks1 <- avgIsoDefRateSummary_MMP2_ks1 %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>%
#   group_by(roi, isoContrib) %>%
#   mutate(timeInt=c(0,diff(dev_time)), value.cumsum=cumsum(value.avg*timeInt)) %>% 
#   group_by(roi, isoContrib, dev_time, frame, realframe, realdev_time) %>%
#   summarise(cumsum.avg=mean(value.cumsum), cumsum.sd=sd(value.cumsum))
# 
# 
# ## %%%%%%%%%%%%
# ## HERE group together WT avg iso deformation stuff to make ribbon.
# avgIsoDefCum_allWTs_mean_stdev <- rbind(avgIsoDefCum_WT1_ks1,avgIsoDefCum_WT2_ks1,avgIsoDefCum_WT3_ks1,avgIsoDefCum_WT4_ks1) %>% filter(realframe >= min_realframe & realframe <= max_realframe) %>% group_by(realframe,isoContrib) %>% summarise(mean = mean(cumsum.avg), sd = sd(cumsum.avg)) %>% mutate(realdev_time = realframe*2.5/60)
# 
# ## now try to make a plot involving JUST A RIBBON for the WTs and JUST A LINE FOR MMP1.
# ## filter the tissue_area contribution out for clarity
# myplot <- ggplot(avgIsoDefCum_allWTs_mean_stdev %>% filter(isoContrib!="tissue_area"), aes(realdev_time + 16, mean, color=isoContrib)) +
#   geom_line(data=avgIsoDefCum_MMP1_ks1 %>% filter(isoContrib!="tissue_area"),aes(realdev_time + 16, cumsum.avg, color=isoContrib),size=2) + 
#   geom_ribbon(aes(ymin=(mean-sd), ymax=(mean+sd), fill=isoContrib),
#              alpha=0.2, linetype="dotted", size=0.2) +  
#   theme(text = element_text(size = 18)) +
#   xlab("Time (hAPF)")+
#   ylab(expression(paste("Cumulative deformation"))) +
#   scale_color_manual(values=isotropColors) +
#   scale_fill_manual(values=isotropColors) +
#   scale_x_continuous(limits=c(16,NA), breaks=c(16,20,24,28,32,36)) +
#   ylim(-0.5,3) 
# pdf("isotropic_cumul_WTribbon_MMP1.pdf")
# print(myplot)
# dev.off()
# 
# ## ribbon for WTs and line for WT2
# ## filter the tissue_area contribution out for clarity
# myplot <- ggplot(avgIsoDefCum_allWTs_mean_stdev %>% filter(isoContrib!="tissue_area"), aes(realdev_time + 16, mean, color=isoContrib)) +
#   geom_line(data=avgIsoDefCum_MMP2_ks1 %>% filter(isoContrib!="tissue_area"),aes(realdev_time + 16, cumsum.avg, color=isoContrib),size=2) + 
#   geom_ribbon(aes(ymin=(mean-sd), ymax=(mean+sd), fill=isoContrib),
#               alpha=0.2, linetype="dotted", size=0.2) +  
#   theme(text = element_text(size = 18)) +
#   xlab("Time (hAPF)")+
#   ylab(expression(paste("Cumulative deformation"))) +
#   scale_color_manual(values=isotropColors) +
#   scale_fill_manual(values=isotropColors) +
#   scale_x_continuous(limits=c(16,NA), breaks=c(16,20,24,28,32,36)) +
#   ylim(-0.5,3) 
# pdf("isotropic_cumul_WTribbon_MMP2_startslate.pdf")
# print(myplot)
# dev.off()
# 
# 
# ## ADDING P AND OR ALPHA ANALYSIS COMPARISON FOR MMP versus WTs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# 
# ## MMP1
# pandalpha_MMP1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/MMP1/core/noborder/pandalpha.csv") 
# pandalpha_MMP1$frame <- round(pandalpha_MMP1$dev_time*60/2.5)
# pandalpha_MMP1$realframe <- pandalpha_MMP1$frame + offset_MMP1
# pandalpha_MMP1$realdev_time <- pandalpha_MMP1$realframe * 2.5/60
# pandalpha_MMP1$std <- sqrt(pandalpha_MMP1$p*(1-pandalpha_MMP1$p)/pandalpha_MMP1$n_div) 
# 
# pandalpha_MMP1 <- pandalpha_MMP1 %>% filter(n_div !=0)
# 
# pandalpha_MMP1$std_alpha <- sqrt(pandalpha_MMP1$alpha*(1-pandalpha_MMP1$alpha)/(pandalpha_MMP1$p*pandalpha_MMP1$n_div))
# 
# pandalpha_MMP1$fraction <- pandalpha_MMP1$p * (1 + pandalpha_MMP1$alpha) / 2
# # NAs are zero in this context (alpha NA because p = 0)
# pandalpha_MMP1$fraction[is.na(pandalpha_MMP1$fraction)] <- 0
# 
# ## MMP2
# pandalpha_MMP2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/MMP2/core/noborder/pandalpha.csv") 
# pandalpha_MMP2$frame <- round(pandalpha_MMP2$dev_time*60/2.5)
# pandalpha_MMP2$realframe <- pandalpha_MMP2$frame + offset_MMP2
# pandalpha_MMP2$realdev_time <- pandalpha_MMP2$realframe * 2.5/60
# pandalpha_MMP2$std <- sqrt(pandalpha_MMP2$p*(1-pandalpha_MMP2$p)/pandalpha_MMP2$n_div) 
# 
# pandalpha_MMP2 <- pandalpha_MMP2 %>% filter(n_div !=0)
# 
# pandalpha_MMP2$std_alpha <- sqrt(pandalpha_MMP2$alpha*(1-pandalpha_MMP2$alpha)/(pandalpha_MMP2$p*pandalpha_MMP2$n_div))
# 
# pandalpha_MMP2$fraction <- pandalpha_MMP2$p * (1 + pandalpha_MMP2$alpha) / 2
# # NAs are zero in this context (alpha NA because p = 0)
# pandalpha_MMP2$fraction[is.na(pandalpha_MMP2$fraction)] <- 0
# 
# # make a ribbon of P (no use FRACTION) instead for the other WTs.
# pandalpha_allWTs_mean_stdev <- pandalpha_allWTs
# 
# ## need to rank by realframe and group every FOUR elements together (WT1,3,4,2 in realframe order) and calculate MEAN FRAME and MEAN FRACTION AND SD FRACTION
# ## to make the ribbon.
# pandalpha_allWTs_mean_stdev <- pandalpha_allWTs_mean_stdev %>% arrange(realframe) %>% mutate(group = floor((row_number() -0.5)/ 4.0))
# pandalpha_allWTs_mean_stdev <- pandalpha_allWTs_mean_stdev %>% group_by(group) %>% summarise(meanrealdev_time = mean(realdev_time), meanfraction = mean(fraction), sdfraction = sd(fraction))
# 
# ## plot with line and ribbon
# ## MMP1
# myplot <- ggplot(pandalpha_MMP1, aes(realdev_time + 16, fraction)) +
#   geom_line(size=1,color = "red") + 
#   geom_point(size=2,color = "red") + 
#   theme(text = element_text(size = 18)) +
#    geom_ribbon(inherit.aes = FALSE, data = pandalpha_allWTs_mean_stdev, aes(x=meanrealdev_time+16,ymin=(meanfraction-sdfraction), ymax=(meanfraction+sdfraction)), fill = "black",
#               alpha=0.2, linetype="dotted", size=0.2) +
#   geom_line(inherit.aes = FALSE, data = pandalpha_allWTs_mean_stdev, aes(x=meanrealdev_time+16,y=meanfraction), size=1,color = "black") +
#   xlab("Time (hAPF)")+
#   ylab(expression(paste("Quiescent fraction of created cells"))) +
#   scale_color_manual(values=movieColors) +
#   scale_fill_manual(values=movieColors) +
#   scale_x_continuous(limits=c(16,NA), breaks=c(16,20,24,28,32,36)) +
#   ylim(-0.05,1.05) 
# pdf("quiescent_fraction_allWTs_ribbon_MMP1.pdf")
# print(myplot)
# dev.off()
# 
# ## MMP2
# myplot <- ggplot(pandalpha_MMP2, aes(realdev_time + 16, fraction)) +
#   geom_line(size=1,color = "red") + 
#   geom_point(size=2,color = "red") + 
#   theme(text = element_text(size = 18)) +
#   geom_ribbon(inherit.aes = FALSE, data = pandalpha_allWTs_mean_stdev, aes(x=meanrealdev_time+16,ymin=(meanfraction-sdfraction), ymax=(meanfraction+sdfraction)), fill = "black",
#               alpha=0.2, linetype="dotted", size=0.2) +
#   geom_line(inherit.aes = FALSE, data = pandalpha_allWTs_mean_stdev, aes(x=meanrealdev_time+16,y=meanfraction), size=1,color = "black") +
#   xlab("Time (hAPF)")+
#   ylab(expression(paste("Quiescent fraction of created cells"))) +
#   scale_color_manual(values=movieColors) +
#   scale_fill_manual(values=movieColors) +
#   scale_x_continuous(limits=c(16,NA), breaks=c(16,20,24,28,32,36)) +
#   ylim(-0.05,1.05) 
# pdf("quiescent_fraction_allWTs_ribbon_MMP2.pdf")
# print(myplot)
# dev.off()
# 



### extra. versions of p_all_WTs and alpha_all_WTs with a stat function to fit them manualy.
switchtime <- 25.7
hillcoeff <- 34
totalSOPs <- 1

myplot <- ggplot(pandalpha_allWTs, aes(realdev_time + 16, p, color=movie)) +
  geom_line(size=0.6,alpha=0.6) + 
  geom_point(size=0.8,alpha=0.6) + 
  geom_errorbar(aes(ymin=(p-std), ymax=(p+std)),
                size=0.8, width=0.425, alpha=0.6) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("p"))) +
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  stat_function(fun = function(.x)  totalSOPs*((.x)/switchtime)^hillcoeff / (((.x)/switchtime)^(hillcoeff) + 1) , colour = "black", size = 0.8, linetype = "dashed"  ) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,1.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("p_allWTs_plusfit.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)
## alpha
switchtime <- 24.7
hillcoeff <- 34
totalSOPs <- 1
myplot <- ggplot(pandalpha_allWTs, aes(realdev_time + 16, alpha, color=movie)) +
  geom_line(size=0.6,alpha=0.6) + 
  geom_point(size=0.8,alpha=0.6) + 
  geom_errorbar(aes(ymin=(alpha-std_alpha), ymax=(alpha+std_alpha)),
                size=0.8, width=0.425,alpha=0.6) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  # geom_ribbon(aes(ymin=(.avg-cumsum.sd), ymax=(cumsum.avg+cumsum.sd), fill=movie),
  #            alpha=0.2, linetype="dotted", size=0.2) +
  xlab("Time (hAPF)  ")+
  ylab(expression(paste("alpha"))) +
  scale_color_manual(values=movieColors) +
  stat_function(fun = function(.x)  totalSOPs*((.x)/switchtime)^hillcoeff / (((.x)/switchtime)^(hillcoeff) + 1) , colour = "black", size = 0.8, linetype = "dashed"  ) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,33), breaks=c(16,18.5,21,23.5,26,28.5,31), expand = c(0,0), labels = every_nth(c(16,18.5,21,23.5,26,28.5,31), 2, inverse = TRUE)) +
  scale_y_continuous(limits=c(-0.1,1.1), expand = c(0,0))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("alpha_allWTs_plusfit.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

