#useful function
every_nth <- function(x, nth, empty = TRUE, inverse = FALSE) 
{
  if (!inverse) {
    if(empty) {
      x[1:nth == 1] <- ""
      x
    } else {
      x[1:nth != 1]
    }
  } else {
    if(empty) {
      x[1:nth != 1] <- ""
      x
    } else {
      x[1:nth == 1]
    }
  }
}
# egg to allow absolute panel size setting in ggplot2?
#install.packages("egg")
library("egg")

## SCRIPT to address a long series of GS requests from 17 February 2020. 
select <- dplyr::select # to avoid conflic with MASS.

offset_WT1 <- 62-62
offset_WT2 <- 0-62
offset_WT3 <- 67-62
offset_WT4 <- 69-62

dir.create("GS_requests_17feb2020")
load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")
roiPosterior <- roiCellsBT %>% filter(roi == "posterior")

# manual change here! per WT offset
adjustedframe10 <- 10 - offset_WT2


###### SPECIAL INSERT. a frame 48 ttd distribution for WT2 to try starting it later (goes along with ...wt218... python code).
fr48list <- cellsDB %>% filter(frame == 48) %>% select(cell_id) %>% unique() %>% filter(cell_id %in% roiHistoNoborder$cell_id)
frame48_ttd <- cellinfoDB %>% filter(cell_id %in% fr48list$cell_id) %>% filter(disappears_by == "Division")
frame48_ttd <- frame48_ttd %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - 48) %>% select(-last_occ)
write.csv(frame48_ttd,file="GS_requests_17feb2020/frame48_ttd_noborder.csv")
## also frame 75
fr75list <- cellsDB %>% filter(frame == 75) %>% select(cell_id) %>% unique() %>% filter(cell_id %in% roiHistoNoborder$cell_id)
frame75_ttd <- cellinfoDB %>% filter(cell_id %in% fr75list$cell_id) %>% filter(disappears_by == "Division")
frame75_ttd <- frame75_ttd %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - 75) %>% select(-last_occ)
write.csv(frame75_ttd,file="GS_requests_17feb2020/frame75_ttd_noborder.csv")

## JJW: the actualy frame10 one is needed for the startat16h simulations. so change frame10 to frame10 thru out, but then make a frame10 csv too. 

## 1) 22 MAY 202. Output in ADJUSTED FRAME 10 of the simulation, the distribution and/or a fit, of remaining times-to-division in the NOBORDER region.

fr10list <- cellsDB %>% filter(frame == adjustedframe10) %>% select(cell_id) %>% unique() %>% filter(cell_id %in% roiHistoNoborder$cell_id)
# call it frame10 still for simplicity.
frame10_ttd <- cellinfoDB %>% filter(cell_id %in% fr10list$cell_id) %>% filter(disappears_by == "Division")
frame10_ttd <- frame10_ttd %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - adjustedframe10) %>% select(-last_occ)

frame0_ttd <- cellinfoDB %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(disappears_by == "Division") %>% filter(first_occ == 0)
frame0_ttd <- frame0_ttd %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - 0) %>% select(-last_occ)
write.csv(frame0_ttd,file="GS_requests_17feb2020/frame0_ttd_noborder.csv")

### INSERT ADDITION gs request. A version of the frame0 ttd that contains the cell area in the initial frame.
frame0_ttd_with_area <- cellsDB %>% filter(frame == 0) %>% select(cell_id,area) %>% dt.merge(frame0_ttd,by="cell_id") %>% rename(initial_area=area) %>% select(cell_id,ttd,initial_area)
write.csv(frame10_ttd,file="GS_requests_17feb2020/frame0_ttd_with_area_noborder.csv")

## CSV of frame10_ttd. 
write.csv(frame10_ttd,file="GS_requests_17feb2020/frame10_ttd_noborder.csv")

## extra TTDs at different frames
## adjusted frame 15
fr15list <- cellsDB %>% filter(frame == (adjustedframe10-10 +15)) %>% select(cell_id) %>% unique() %>% filter(cell_id %in% roiHistoNoborder$cell_id)

frame15_ttd <- cellinfoDB %>% filter(cell_id %in% fr15list$cell_id) %>% filter(disappears_by == "Division")
frame15_ttd <- frame15_ttd %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - (adjustedframe10-10 +15)) %>% select(-last_occ)
write.csv(frame15_ttd,file="GS_requests_17feb2020/frame15_ttd_noborder.csv")
myplot <- ggplot(data=frame15_ttd,aes(ttd*2.5/60)) +
  geom_histogram(binwidth = 0.25,color="black") +
  ylim(0,35) + xlim(0,10) +
  xlab("TTD (h)") +
  ylab("Histogram count") +
  scale_fill_manual(values=c("anterior"="green", "posterior"="red")) +
  theme(text = element_text(size = 18), panel.grid.minor = element_blank()) 
pdf("GS_requests_17feb2020/frame15_ttd_noborder.pdf")
print(myplot)
dev.off()

## adjusted frame 20
fr20list <- cellsDB %>% filter(frame == (adjustedframe10-10 +20)) %>% select(cell_id) %>% unique() %>% filter(cell_id %in% roiHistoNoborder$cell_id)

frame20_ttd <- cellinfoDB %>% filter(cell_id %in% fr20list$cell_id) %>% filter(disappears_by == "Division")
frame20_ttd <- frame20_ttd %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - (adjustedframe10-10 +20)) %>% select(-last_occ)
write.csv(frame20_ttd,file="GS_requests_17feb2020/frame20_ttd_noborder.csv")
myplot <- ggplot(data=frame20_ttd,aes(ttd*2.5/60)) +
  geom_histogram(binwidth = 0.25,color="black") +
  ylim(0,35) + xlim(0,10) +
  xlab("TTD (h)") +
  ylab("Histogram count") +
  scale_fill_manual(values=c("anterior"="green", "posterior"="red")) +
  theme(text = element_text(size = 18), panel.grid.minor = element_blank()) 
pdf("GS_requests_17feb2020/frame20_ttd_noborder.pdf")
print(myplot)
dev.off()

## adjusted frame 25
fr25list <- cellsDB %>% filter(frame == (adjustedframe10-10 +25)) %>% select(cell_id) %>% unique() %>% filter(cell_id %in% roiHistoNoborder$cell_id)

frame25_ttd <- cellinfoDB %>% filter(cell_id %in% fr25list$cell_id) %>% filter(disappears_by == "Division")
frame25_ttd <- frame25_ttd %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - (adjustedframe10-10 +25)) %>% select(-last_occ)
write.csv(frame25_ttd,file="GS_requests_17feb2525/frame25_ttd_noborder.csv")
myplot <- ggplot(data=frame25_ttd,aes(ttd*2.5/60)) +
  geom_histogram(binwidth = 0.25,color="black") +
  ylim(0,35) + xlim(0,10) +
  xlab("TTD (h)") +
  ylab("Histogram count") +
  scale_fill_manual(values=c("anterior"="green", "posterior"="red")) +
  theme(text = element_text(size = 18), panel.grid.minor = element_blank()) 
pdf("GS_requests_17feb2020/frame25_ttd_noborder.pdf")
print(myplot)
dev.off()

## adjusted frame 30
fr30list <- cellsDB %>% filter(frame == (adjustedframe10-10 +30)) %>% select(cell_id) %>% unique() %>% filter(cell_id %in% roiHistoNoborder$cell_id)

frame30_ttd <- cellinfoDB %>% filter(cell_id %in% fr30list$cell_id) %>% filter(disappears_by == "Division")
frame30_ttd <- frame30_ttd %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - (adjustedframe10-10 +30)) %>% select(-last_occ)
write.csv(frame30_ttd,file="GS_requests_17feb2020/frame30_ttd_noborder.csv")
myplot <- ggplot(data=frame30_ttd,aes(ttd*2.5/60)) +
  geom_histogram(binwidth = 0.30,color="black") +
  ylim(0,35) + xlim(0,10) +
  xlab("TTD (h)") +
  ylab("Histogram count") +
  scale_fill_manual(values=c("anterior"="green", "posterior"="red")) +
  theme(text = element_text(size = 18), panel.grid.minor = element_blank()) 
pdf("GS_requests_17feb2020/frame30_ttd_noborder.pdf")
print(myplot)
dev.off()

## for error checking: do a fr15 ttd containing only cells that were present in the fr10 ttd
fr15list_in10only <- cellsDB %>% filter(frame == (adjustedframe10-10 +15)) %>% select(cell_id) %>% unique() %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(cell_id %in% frame10_ttd$cell_id)

frame15_ttd_in10only <- cellinfoDB %>% filter(cell_id %in% fr15list_in10only$cell_id) %>% filter(disappears_by == "Division")
frame15_ttd_in10only <- frame15_ttd_in10only %>% select(cell_id,last_occ) %>% mutate(ttd = last_occ - (adjustedframe10-10 +15)) %>% select(-last_occ)
write.csv(frame15_ttd_in10only,file="GS_requests_17feb2020/frame15_ttd_noborder_in10only.csv")
myplot <- ggplot(data=frame15_ttd_in10only,aes(ttd*2.5/60)) +
  geom_histogram(binwidth = 0.25,color="black") +
  ylim(0,35) + xlim(0,10) +
  xlab("TTD (h)") +
  ylab("Histogram count") +
  scale_fill_manual(values=c("anterior"="green", "posterior"="red")) +
  theme(text = element_text(size = 18), panel.grid.minor = element_blank()) 
pdf("GS_requests_17feb2020/frame15_ttd_noborder_in10only.pdf")
print(myplot)
dev.off()



#plot
myplot <- ggplot(data=frame10_ttd,aes(ttd*2.5/60)) +
  geom_histogram(binwidth = 0.25,color="black") +
  ylim(0,35) + xlim(0,10) +
  xlab("TTD (h)") +
  ylab("Histogram count") +
  scale_fill_manual(values=c("anterior"="green", "posterior"="red")) +
  theme(text = element_text(size = 18), panel.grid.minor = element_blank()) 
pdf("GS_requests_17feb2020/frame10_ttd_noborder.pdf")
print(myplot)
dev.off()
# looks bimodal normal I guess. look at this website for how to fit https://www.r-bloggers.com/fitting-mixture-distributions-with-the-r-package-mixtools/
#install.packages("mixtools")


## single-frame-bins (ie group by ttd and just count up)
frame10_ttd_singleframebin <- frame10_ttd %>% group_by(ttd) %>% summarise(n = n())
frame15_ttd_in10only_singleframebin <- frame15_ttd_in10only %>% group_by(ttd) %>% summarise(n = n())
frame15_ttd_singleframebin <- frame15_ttd %>% group_by(ttd) %>% summarise(n = n())
frame20_ttd_singleframebin <- frame20_ttd %>% group_by(ttd) %>% summarise(n = n())
frame25_ttd_singleframebin <- frame25_ttd %>% group_by(ttd) %>% summarise(n = n())
frame30_ttd_singleframebin <- frame30_ttd %>% group_by(ttd) %>% summarise(n = n())

frame10_totalweight <- sum(frame10_ttd_singleframebin$n)
frame15_in10only_relweight <- frame10_totalweight/sum(frame15_ttd_in10only_singleframebin$n) 

myplot <- ggplot() +
  #geom_histogram(binwidth = 0.25,color="black") +
  geom_line(data=frame10_ttd_singleframebin,aes(x=ttd*2.5/60, y=ma(n,21)),colour="black") +
  geom_line(data=frame15_ttd_in10only_singleframebin,aes(x=ttd*2.5/60, y=ma(n,21)), colour = "red") +
  #ylim(0,1) + 
  xlim(0,4) +
  xlab("TTD (h)") +
  ylab("Count") +
  scale_fill_manual(values=c("anterior"="green", "posterior"="red")) +
  theme(text = element_text(size = 18), panel.grid.minor = element_blank()) 
pdf("GS_requests_17feb2020/ttd_singleframebin_combined.pdf")
print(myplot)
dev.off()

## PRODUCTION GRAPHS: base upon singlframebin quasi-density plots, with ma (moving average).
## use correct graph format too.
## MOVING AVERAGE COMBINED GRAPH
ttd_singleframebin_combined <- rbind(frame10_ttd_singleframebin %>% mutate(series = "fr10"), frame20_ttd_singleframebin %>% mutate(series = "fr20"), frame30_ttd_singleframebin %>% mutate(series = "fr30") )

myplot <- ggplot() +
  geom_point(size=0.8, color="aquamarine3", position = position_jitter(w = 0, h = 0)) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  geom_line(data=frame10_ttd_singleframebin, aes(ttd*2.5/60,ma(n,21)), color="grey35", size=0.8) + 
  geom_line(data=frame20_ttd_singleframebin, aes(ttd*2.5/60,ma(n,21)), color = "red", size=0.8) +
  geom_line(data=frame30_ttd_singleframebin, aes(ttd*2.5/60,ma(n,21)), color = "blue", size=0.8) + 
  xlab("TTD (hr)")+
  ylab(expression(paste("Count"))) +
  #scale_y_continuous(limits=c(0,405),expand = c(0,0), breaks=c(0,100,200,300,400)) +
  scale_x_continuous(limits=c(0,4), breaks=c(0,1,2,3,4), expand = c(0,0), labels = every_nth(c(0,1,2,3,4), 2, inverse = TRUE))  
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("GS_requests_17feb2020/ttd_singleframebin_combined.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## single histogram for frame10ttd, 20, 30
myplot <- ggplot() +
  geom_point(size=0.8, color="aquamarine3", position = position_jitter(w = 0, h = 0)) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  geom_histogram(data=frame10_ttd, aes(ttd*2.5/60), binwidth=10*2.5/60) + 
  xlab("TTD (hr)")+
  ylab(expression(paste("Count"))) +
  #ylim(0,25) +
  scale_y_continuous(limits=c(0,35),expand = c(0,0)) +
  scale_x_continuous(limits=c(0,10), breaks=c(0,2,4,6,8,10), expand = c(0,0), labels = every_nth(c(0,2,4,6,8,10), 2, inverse = TRUE))  
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("GS_requests_17feb2020/frame10_ttd.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

myplot <- ggplot() +
  geom_point(size=0.8, color="aquamarine3", position = position_jitter(w = 0, h = 0)) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  geom_histogram(data=frame20_ttd, aes(ttd*2.5/60), binwidth=10*2.5/60) + 
  xlab("TTD (hr)")+
  ylab(expression(paste("Count"))) +
  #ylim(0,25) +
  scale_y_continuous(limits=c(0,35),expand = c(0,0)) +
  scale_x_continuous(limits=c(0,10), breaks=c(0,2,4,6,8,10), expand = c(0,0), labels = every_nth(c(0,2,4,6,8,10), 2, inverse = TRUE))  
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("GS_requests_17feb2020/frame20_ttd.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

myplot <- ggplot() +
  geom_point(size=0.8, color="aquamarine3", position = position_jitter(w = 0, h = 0)) + 
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  geom_histogram(data=frame30_ttd, aes(ttd*2.5/60), binwidth=10*2.5/60) + 
  xlab("TTD (hr)")+
  ylab(expression(paste("Count"))) +
  #ylim(0,25) +
  scale_y_continuous(limits=c(0,35),expand = c(0,0)) +
  scale_x_continuous(limits=c(0,10), breaks=c(0,2,4,6,8,10), expand = c(0,0), labels = every_nth(c(0,2,4,6,8,10), 2, inverse = TRUE))  
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("GS_requests_17feb2020/frame30_ttd.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)




## DENSITY plot versions. Can add multiples in here. The normalisation is different though. 
## TRY TO USE 'WEIGHT' to renormalise everything to be what it was for fr10.

myplot <- ggplot() +
  #geom_histogram(binwidth = 0.25,color="black") +
  geom_density(data=frame10_ttd,aes(ttd*2.5/60,weight=1),colour="black") +
  geom_density(data=frame15_ttd_in10only,aes(ttd*2.5/60,weight=1), colour = "red") +
  xlim(0,10) +
  xlab("TTD (h)") +
  ylab("Histogram count") +
  scale_fill_manual(values=c("anterior"="green", "posterior"="red")) +
  theme(text = element_text(size = 18), panel.grid.minor = element_blank()) 
pdf("GS_requests_17feb2020/ttd_noborder_densityplot_combined.pdf")
print(myplot)
dev.off()






library(mixtools)
xMix = normalmixEM(frame10_ttd$ttd*2.5/60)
plot(xMix,which=2)
#plot(hist(frame10_ttd$ttd,breaks=50))

# transfer to ggplot2 to get a bit more control over the plotting. https://stackoverflow.com/questions/25313578/any-suggestions-for-how-i-can-plot-mixem-type-data-using-ggplot2
sdnorm =
  function(x, mean=0, sd=1, lambda=1){lambda*dnorm(x, mean=mean, sd=sd)}

myplot <- ggplot(data.frame(x=frame10_ttd$ttd*2.5/60)) + 
  theme(text = element_text(size = 18), panel.grid.minor = element_blank())  + 
  geom_histogram(aes(x=x,y=..density..),fill="white",color="black",binwidth=0.25) +
  stat_function(fun=sdnorm,
                args=list(mean=xMix$mu[2],
                          sd=xMix$sigma[2],
                          lambda=xMix$lambda[2]),
                color="#FF000080",geom="line",lwd=2) +
  stat_function(fun=sdnorm,
                args=list(mean=xMix$mu[1],
                          sd=xMix$sigma[1],
                          lambda=xMix$lambda[1]),
                color="#00FF0080",geom="line",lwd=2)
pdf("GS_requests_17feb2020/frame10_ttd_fit_noborder.pdf")
print(myplot)
dev.off()

# output the fit parameters to a CSV files. 
write.csv(xMix$lambda,file="GS_requests_17feb2020/frame10_ttd_bimodalfit_lambda_noborder.csv")
write.csv(xMix$mu,file="GS_requests_17feb2020/frame10_ttd_bimodalfit_mu_noborder.csv")
write.csv(xMix$sigma,file="GS_requests_17feb2020/frame10_ttd_bimodalfit_sigma_noborder.csv")

### EXTRA: take from the base case simulation the simulated TTD distribution at 16.41667, and plot it like this. 
## switch 'run' of statistical manualy
simbasecase_ttd_16 <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/John_Williamson/statistical_18Nov_jjw_GS_Sim_Population_Growth_Python/results/ttd_at_16_noborderWT1_run_3.csv",header=FALSE,sep=" ")
simbasecase_ttd_16 <- simbasecase_ttd_16 %>% mutate(dev_time = V1, ttd = V3-V2) %>% select(dev_time,ttd)
myplot <- ggplot(data.frame(x=simbasecase_ttd_16$ttd)) + 
  theme(text = element_text(size = 18), panel.grid.minor = element_blank())  + 
  geom_histogram(aes(x=x,y=..density..),fill="white",color="black",binwidth=0.25) +
  xlim(0,8) 
pdf("GS_requests_17feb2020/SIM_BASE_CASE_ttd_at16h.pdf")
print(myplot)
dev.off()



## 2) the request for sister-sister correlation coefficient has been dealt with in that script and uploaded to the CSVs folder

## 3) Lifetimes histogram fit for anterior and posterior
lifetimes_bothnests <- cellinfoDB %>% dt.merge(roiBothNests,by="cell_id") %>% filter(appears_by == "Division" & disappears_by == "Division") %>% select(cell_id,first_occ,last_occ,roi) %>% mutate(lifetime = last_occ-first_occ) %>% select(cell_id,lifetime,roi)
#Could you give me the fit parameters of fits to distribution of cell cycles (and directly mean and std of the distributions); in fact we should explain and report this in the supplementary text.
lifetimes_anterior <- lifetimes_bothnests %>% filter(roi == "anterior")
lifetimes_posterior <- lifetimes_bothnests %>% filter(roi == "posterior")
#directly output the mean and SD.
write.csv(mean(lifetimes_anterior$lifetime*2.5/60),file="GS_requests_17feb2020/lifetimes_anterior_mean.csv")
write.csv(sd(lifetimes_anterior$lifetime*2.5/60),file="GS_requests_17feb2020/lifetimes_anterior_sd.csv")
write.csv(mean(lifetimes_posterior$lifetime*2.5/60),file="GS_requests_17feb2020/lifetimes_posterior_mean.csv")
write.csv(sd(lifetimes_posterior$lifetime*2.5/60),file="GS_requests_17feb2020/lifetimes_posterior_sd.csv")

# fit a LOGNORMAL distribution. ANTERIOR FIRST
#install.packages("fitdistrplus")
library(fitdistrplus)
f <- fit.dist <- fitdist((lifetimes_anterior%>%filter(lifetime>0))$lifetime*2.5/60,"lnorm")
f.coef <- coef(f)
#plot 
myplot <- ggplot(data.frame(x=lifetimes_anterior$lifetime*2.5/60)) + 
  theme(text = element_text(size = 18), panel.grid.minor = element_blank())  + 
  geom_histogram(aes(x=x,y=..density..),fill="white",color="black",binwidth=0.25) +
  stat_function(fun=dlnorm,
                args=list(f.coef["meanlog"],
                          f.coef["sdlog"]),
                color="#FF000080",geom="line",lwd=2)
pdf("GS_requests_17feb2020/lifetimes_anterior_fit.pdf")
print(myplot)
dev.off()
# write csv.
write.csv(f.coef["meanlog"],file="GS_requests_17feb2020/lifetime_lognormalfit_meanlog_anterior.csv")
write.csv(f.coef["sdlog"],file="GS_requests_17feb2020/lifetime_lognormalfit_sdlog_anterior.csv")

f <- fit.dist <- fitdist(lifetimes_posterior$lifetime*2.5/60,"lnorm")
f.coef <- coef(f)
#plot 
myplot <- ggplot(data.frame(x=lifetimes_posterior$lifetime*2.5/60)) + 
  theme(text = element_text(size = 18), panel.grid.minor = element_blank())  + 
  geom_histogram(aes(x=x,y=..density..),fill="white",color="black",binwidth=0.25) +
  stat_function(fun=dlnorm,
                args=list(f.coef["meanlog"],
                          f.coef["sdlog"]),
                color="#FF000080",geom="line",lwd=2)
pdf("GS_requests_17feb2020/lifetimes_posterior_fit.pdf")
print(myplot)
dev.off()
# write csv.
write.csv(f.coef["meanlog"],file="GS_requests_17feb2020/lifetime_lognormalfit_meanlog_posterior.csv")
write.csv(f.coef["sdlog"],file="GS_requests_17feb2020/lifetime_lognormalfit_sdlog_posterior.csv")

## EXTRA 3 JUNE 2020
## Add a movie/picture showing the ttd in adjusted frame 10
cellshapes_fr10ttd <- frame10_ttd %>% dt.merge(cellshapes,by="cell_id")
render_movie(cellshapes_fr10ttd, "GS_requests_17feb2020/cellshapes_fr10ttd.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=ttd*2.5/60)),
  scale_fill_gradientn(name="TTD at fr10 (hr)",
                       colours=c("black", "blue", "green", "yellow", "red"),
                       # ignore possible outliers by trimming the area distribution
                       limits=c(0,8),
                       na.value = "red")
))









## 4) run a 'basic' simulation as described etc. n/a to this script. 

## 5) can you make a new plot showing lifetime as a function of the final existence time (same as 2B, but different x axis); and add it to Fig. S2? This is to show more clearly that the change in lifetime can not account for the decay in cell division rate.
# implement this in the FIG 2 script instead. 
# output is inside FIG_temp_jjw

## 6) - I think maybe we should exchange the labels I and H in Figure 2, and Fig 3G could come directly after Fig 3D. Maybe this is something to discuss on Wednesday.
# nothing to do here.

## 7) - For panels 2C-2F, probably referees would want to see a correlation coefficient for each graph. Can yous calculate something like this?
# try to implement this inside the FIG 2 script. 
# output is inside FIG_temp_jjw. 

## 8) - Could you generate a new plot like Fig. 3D, but with log_2(N/N0) on the y axis (to evaluate the number of divisions), and add it to Fig S3?
# address this in the Fig 3 script I guess.
