## script for some GS requests 20april about showing mean lineage lifetime etc. on movies of cells.

#useful function
every_nth <- function(x, nth, empty = TRUE, inverse = FALSE) 
{
  if (!inverse) {
    if(empty) {
      x[1:nth == 1] <- ""
      x
    } else {
      x[1:nth != 1]
    }
  } else {
    if(empty) {
      x[1:nth != 1] <- ""
      x
    } else {
      x[1:nth == 1]
    }
  }
}
# egg to allow absolute panel size setting in ggplot2?
#install.packages("egg")
library("egg")

## script to do various things for figure 3, the bit where we compare the simulation for cell number etc. 
## first want to get the quantities of interest for all the WTs, probably TIME ALIGN THEM to WT2 by SOPs as normal
## and then make ribbon/error bar data series for them.
## then load in data for a sort of 'example'

## make panels like separately. 

offset_WT1 <- 62-62
offset_WT2 <- 0-62
offset_WT3 <- 67-62
offset_WT4 <- 69-62

## PANEL 1. Cell Number prior to 16h. We already have an R script that reads in Ana F's CSV and makes a consistent looking plot of it.
## so put that in. Then append with code to read in CSV simulation data for simulated cell number. 

dir.create("GS_requests_20april_lineagelifetimeetc")
load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")
roiPosterior <- roiCellsBT %>% filter(roi == "posterior")


# R Studio doesn't seem to be grabbing this env variable.
Sys.setenv(TM_HOME = "~/tissue_miner")
scriptsDir=Sys.getenv("TM_HOME")
#outDataBaseDir="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/PAPER/FIG3_jjw_gs_tapon/"
mcdir(outDataBaseDir)
# Load TissueMiner libraries
source(file.path(scriptsDir, "commons/TMCommons.R"))
source(file.path(scriptsDir, "db/movie_rotation/RotationFunctions.R"))
source(file.path(scriptsDir, "commons/BaseQueryFunctions.R"))
source(file.path(scriptsDir, "commons/TimeFunctions.R"))
source(file.path(scriptsDir, "config/default_config.R"))
source(file.path(scriptsDir, "iwanthue.R"))
source(file.path(scriptsDir, "commons/MovieFunctions.R"))

# Load a R library
## library("zoo")

# Set up working directory
mcdir(outDataBaseDir)

# Set general theme for graphs: more specific tuning must be done for each graph
theme_set(theme_bw())
theme_update(panel.grid.major=element_line(linetype= "dotted", color="black", size=0.2),
             panel.grid.minor = element_blank(),
             panel.border = element_rect(size=0.3,color="black",fill=NA),
             axis.ticks=element_line(size=0.2),
             axis.ticks.length=unit(0.1,"cm"),
             legend.key = element_blank()
)

## a colourblind palette? -- use first four for movieColors and last FIVE (backward) for isotropColors?
# no try colour brewer instead
# The palette with black:
#cbbPalette <- c("#000000", "#E69F00", "#56B4E9", "#009E73", "#F0E442", "#0072B2", "#D55E00", "#CC79A7")

# Hardwire isotropic deformation color scheme
isotropColors <- c("division"="#E41A1C",
                   "extrusion"="#377EB8",
                   "cell_area"="#4DAF4A",
                   "sumContrib"="#984EA3",
                   "tissue_area"="#FF7F00")

library(RColorBrewer)
display.brewer.all()
display.brewer.pal(n = 9, name = 'Set1')
brewer.pal(n = 9, name = "Set1")
# "#E41A1C" "#377EB8" "#4DAF4A" "#984EA3" "#FF7F00" "#FFFF33" "#A65628" "#F781BF" "#999999"
brewer.pal(n = 8, name = "Dark2")
# "#1B9E77" "#D95F02" "#7570B3" "#E7298A" "#66A61E" "#E6AB02" "#A6761D" "#666666"


# hardwire the movie color scheme
movieColors <- c("WT1"="#1B9E77",
                 "WT2"="#D95F02",
                 "WT3"="#7570B3",
                 "WT4"="#E7298A"
)

## Shear
shearColors <- c(
  "total_shear"="blue",
  "cell_elongation_change"="darkgreen",
  "T1"="red",
  "T2"="turquoise",
  "cell_division"="orange",
  "correlation_effects"="magenta",
  "sum_contrib"="salmon",
  "sumContrib"="salmon",
  "check"="yellow",
  "crc"="pink", "cagc"="lightgreen",
  "ct"="grey",
  "J"="grey",
  "CEwithCT"="darkgreen",
  "av_total_shear"="blue",
  "nu"="blue",
  "ShearT1"="red",
  "ShearT2"="turquoise",
  "ShearCD"="orange",
  "correlationEffects"="magenta",
  "sumContrib"="salmon")

#Extras commonly needed:
#Jet Colors
jet.colors <- colorRampPalette(c("#00007F", "blue", "#007FFF", "cyan", "#7FFF7F", "yellow", "#FF7F00", "red", "#7F0000"))

# Save plot function
savePlot <- function(myPlot) {
  pdf("myPlot.pdf")
  print(myPlot)
  dev.off()
}



## BEGIN ANALYSIS HERE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## I think I will average things 'up to that frame' so to speak, i.e. all cells in that lineage with a birthtime less than that frame.
## actuall quite complicated to do!
lifetimes_noborder <- cellinfoDB %>% filter(disappears_by == "Division" & appears_by == "Division") %>% select(cell_id, lineage_group, first_occ, last_occ) %>% mutate(lifetime = last_occ - first_occ) %>% filter(cell_id %in% roiHistoNoborder$cell_id)
lineage_current_lifetime_stats <- frames %>% select(frame) %>% merge(lifetimes_noborder)
lineage_current_lifetime_stats <- lineage_current_lifetime_stats %>% filter(first_occ < frame)

lineage_current_lifetime_stats <- lineage_current_lifetime_stats %>% group_by(frame,lineage_group) %>% summarise(n = n(), meanlifetime = mean(lifetime), sdlifetime = sd(lifetime)) %>% mutate(cv=sdlifetime/meanlifetime)

## good. now merge back into a list of frames, cellids and lineage group.

cellshapes_with_lineages <- cellinfoDB %>% select(cell_id,lineage_group) %>% dt.merge(cellshapes,by="cell_id")
cellshapes_lineage_current_lifetime_stats <- cellshapes_with_lineages %>% dt.merge(lineage_current_lifetime_stats,by=c("frame","lineage_group"))



## Separately want to do a movie of the absolute size of the lineage, rather than the number of allowed lifetimes up to that frame.

lineage_abs_size <- cellinfoDB %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,lineage_group) %>% dt.merge(cellsDB,by="cell_id") %>% select(cell_id,frame,lineage_group)
lineage_abs_size <- lineage_abs_size %>% group_by(frame,lineage_group) %>% summarise(abssize= n())

cellshapes_lineage_abs_size <- cellshapes_with_lineages %>% dt.merge(lineage_abs_size,by=c("frame","lineage_group"))



## extra request. caclculate the STD in lineage mean lifetimes.
std_in_lineagemeanlifetimes <- lineage_current_lifetime_stats %>% group_by(frame) %>% summarise(mean_lineage_mean_lifetime = mean(meanlifetime), sd_lineage_mean_lifetime = sd(meanlifetime))
write.csv(std_in_lineagemeanlifetimes, file = "GS_requests_20april_lineagelifetimeetc/std_in_lineagemeanlifetimes.csv")


## EXTRA REQUESTS 24 APRIL 2020.
# 0) print out the full lineage_stats at final frame
maxframe <- max(lineage_current_lifetime_stats$frame)
lineage_finalframe_stats <- lineage_current_lifetime_stats %>% filter(frame == maxframe)
write.csv(lineage_finalframe_stats,file="GS_requests_20april_lineagelifetimeetc/lineage_finalframe_stats.csv")

# 1) what is the average of the intra-lineage SD in the final frame
avg_intralineage_SD_finalframe <- lineage_finalframe_stats %>% na.omit() %>% summarise(mean = mean(sdlifetime))
write.csv(avg_intralineage_SD_finalframe,file = "GS_requests_20april_lineagelifetimeetc/avg_intralineage_SD_finalframe.csv")

# 2) what is the overall lifetime mean and SD
overall_lifetime_mean <- mean(lifetimes_noborder$lifetime)
overall_lifetime_sd <- sd(lifetimes_noborder$lifetime)
write.csv(overall_lifetime_mean,file = "GS_requests_20april_lineagelifetimeetc/overall_lifetime_mean.csv")
write.csv(overall_lifetime_sd,file = "GS_requests_20april_lineagelifetimeetc/overall_lifetime_sd.csv")

## 3) HISTOGRAMS. 
## a) just a histogram comparing lineage-mean-lifetimes to lifetimes overall, normalise both.
myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_histogram(data = lifetimes_noborder, aes(x=lifetime*2.5/60 ,y=..density..),colour="blue",fill="blue",alpha=0.5)+
  geom_histogram(data = lineage_finalframe_stats, aes(x=meanlifetime*2.5/60 ,y=..density..),colour="red",fill="red",alpha=0.5)+
  #scale_color_manual(values=movieColors) +
  #scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(2,9), breaks=seq(2,9,1), expand = c(0,0), labels = every_nth(seq(2,9,1), 2, inverse = TRUE)) +
  ylim(0,NA) +
  xlab("Lineage mean-lifetime")+
  ylab(expression(paste("density"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("GS_requests_20april_lineagelifetimeetc/lineage_mean_lifetime_histored_compare_lifetime_histoblue.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## b) histogram of cell lifetimes normalised by mean in their lineage, versus histogram of lifetimes normalised overall mean. 
lifetimes_normalised_variously <- lifetimes_noborder %>% select(cell_id,lineage_group,lifetime) %>% dt.merge(lineage_finalframe_stats %>% ungroup()%>% select(lineage_group,meanlifetime), by="lineage_group")
lifetimes_normalised_variously$overallmean <- overall_lifetime_mean

myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_histogram(data = lifetimes_normalised_variously, aes(x=lifetime/meanlifetime,y=..density..),colour="blue",fill="blue",alpha=0.5)+
  geom_histogram(data = lifetimes_normalised_variously, aes(x=lifetime/overallmean,y=..density..),colour="red",fill="red",alpha=0.5)+
  #scale_color_manual(values=movieColors) +
  #scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(0,2), breaks=seq(0,2,0.2), expand = c(0,0), labels = every_nth(seq(0,2,0.2), 2, inverse = TRUE)) +
  ylim(0,NA) +
  xlab("Normalised lifetime")+
  ylab(expression(paste("density"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("GS_requests_20april_lineagelifetimeetc/lineage_noramlised_overallmean_histored_compare_lifetimes_normalised_lineagemean_histoblue.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## 4) Try to build a correlation function similar to what I did before for in t1 localrate stuff. Correlating red cell
## appearance time against the mean lineage lifetime. 
cells_meanlinlifetime_end <- cellshapes_lineage_current_lifetime_stats %>% filter(frame == maxframe) %>% select(cell_id,meanlifetime) %>% unique()
# get red cells in noborder and their appearance time
redcells_appearancetime <- cellinfoDB %>% filter(disappears_by == "Unclassified") %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,first_occ)
correlate_meanlinlifetime_appearancetime <- cells_meanlinlifetime_end %>% dt.merge(redcells_appearancetime,by="cell_id")

# now construct correlation by taking deviations.
meanmeanlinlifetime <- mean(correlate_meanlinlifetime_appearancetime$meanlifetime)
sdmeanlinlifetime <- sd(correlate_meanlinlifetime_appearancetime$meanlifetime)
meanfirstocc <- mean(correlate_meanlinlifetime_appearancetime$first_occ)
sdfirstocc <- sd(correlate_meanlinlifetime_appearancetime$first_occ)
correlate_meanlinlifetime_appearancetime$dev_meanlifetime <- correlate_meanlinlifetime_appearancetime$meanlifetime - meanmeanlinlifetime
correlate_meanlinlifetime_appearancetime$dev_firstocc <- correlate_meanlinlifetime_appearancetime$first_occ - meanfirstocc
# calculate the mean and sd (just a single data point)
# Hmmm.. NORMALISATION SEEMS WRONG! Shouldn't normalise by the mean of the things, should normalise by the SD??
# may need to go back to t1localrate script and change things in there.
correlation_meanlinlifetime_appearancetime <- correlate_meanlinlifetime_appearancetime %>% summarise(normalised_corr = mean(dev_meanlifetime*dev_firstocc)/(sdmeanlinlifetime*sdfirstocc),
                                                                                                     normalised_sd = sd(dev_meanlifetime*dev_firstocc)/(sdmeanlinlifetime*sdfirstocc),
                                                                                                     normalised_sem = sd(dev_meanlifetime*dev_firstocc)/(sdmeanlinlifetime*sdfirstocc*sqrt(n()))
                                                                                                                                                         )
write.csv(correlation_meanlinlifetime_appearancetime,file="GS_requests_20april_lineagelifetimeetc/correlation_meanlinlifetime_appearancetime.csv")









## next) also possibly movies of TTD distributions






















# movies save here for not running normally
## now render movie with the n lifetimes of each lineage, the mean lifetime, and the sd lifetime, and the CV lifetime

render_movie(cellshapes_lineage_current_lifetime_stats, "GS_requests_20april_lineagelifetimeetc/cellshapes_lineage_n.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=n)),
  scale_fill_gradientn(name="lineage n (allowed lifetimes)",
                       colors  = jet.colors(7),
                       # ignore tails of distribution
                       limits=c(0,20),
                       na.value = "black")
))

render_movie(cellshapes_lineage_current_lifetime_stats, "GS_requests_20april_lineagelifetimeetc/cellshapes_lineage_meanlifetime.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=meanlifetime*2.5/60)),
  scale_fill_gradientn(name="lineage mean lifetime (h)",
                       colors  = jet.colors(7),
                       # ignore tails of distribution
                       limits=c(2,6),
                       na.value = "black")
))

render_movie(cellshapes_lineage_current_lifetime_stats, "GS_requests_20april_lineagelifetimeetc/cellshapes_lineage_sdlifetime.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=sdlifetime*2.5/60)),
  scale_fill_gradientn(name="lineage sd lifetime (h)",
                       colors  = jet.colors(7),
                       # ignore tails of distribution
                       limits=c(0,3),
                       na.value = "black")
))

render_movie(cellshapes_lineage_current_lifetime_stats, "GS_requests_20april_lineagelifetimeetc/cellshapes_lineage_cvlifetime.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=cv)),
  scale_fill_gradientn(name="lineage CV lifetime ",
                       colors  = jet.colors(7),
                       # ignore tails of distribution
                       limits=c(0,0.6),
                       na.value = "black")
))

render_movie(cellshapes_lineage_abs_size, "GS_requests_20april_lineagelifetimeetc/cellshapes_lineage_abssize.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=abssize)),
  scale_fill_gradientn(name="lineage n (allowed lifetimes)",
                       colors  = jet.colors(7),
                       # ignore tails of distribution
                       limits=c(0,24),
                       na.value = "black")
))
