#

## BEFORE THIS: need to run some stuff from my word file. Check.

# Define path to all processed movies. Example here is for the folder
# where I downloaded the example data to. It is already 'workflow' processed.

# R Studio doesn't seem to be grabbing this env variable.
Sys.setenv(TM_HOME = "~/tissue_miner")
## BASE DIRECTORY HERE
#movieDbBaseDir="/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_apop_check"
#outDataBaseDir="/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_apop_check"
movieDbBaseDir="/Users/john/TM_LOCAL_TEMP/WT2_redone_post_anna_revision"
#movieDbBaseDir="/Users/john/TM_LOCAL_TEMP/ABLATION/2ndset18jul/TM_done_todo_analysis/MAX_21hAPFDL_2017_08_04__10_22_51_corrected"
outDataBaseDir=movieDbBaseDir
#16725
scriptsDir=Sys.getenv("TM_HOME")

# Load TissueMiner libraries
source(file.path(scriptsDir, "commons/TMCommons.R"))
source(file.path(scriptsDir, "db/movie_rotation/RotationFunctions.R"))
source(file.path(scriptsDir, "commons/BaseQueryFunctions.R"))
source(file.path(scriptsDir, "commons/TimeFunctions.R"))
source(file.path(scriptsDir, "config/default_config.R"))
source(file.path(scriptsDir, "iwanthue.R"))
source(file.path(scriptsDir, "commons/MovieFunctions.R"))

# Load a R library
## library("zoo")

# Set up working directory
mcdir(outDataBaseDir)

# Set general theme for graphs: more specific tuning must be done for each graph
theme_set(theme_bw())
theme_update(panel.grid.major=element_line(linetype= "dotted", color="black", size=0.2),
             panel.border = element_rect(size=0.3,color="black",fill=NA),
             axis.ticks=element_line(size=0.2),
             axis.ticks.length=unit(0.1,"cm"),
             legend.key = element_blank()
)

# Hardwire isotropic deformation color scheme
isotropColors <- c("division"="orange",
                   "extrusion"="turquoise",
                   "cell_area"="green",
                   "sumContrib"="blue",
                   "tissue_area"="darkred")

# hardwire the movie color scheme
movieColors <- c("WT_1"="blue",
                 "WT_2"="darkgreen",
                 "WT_3"="red",
                 "time"="red"
)

## Shear
shearColors <- c(
  "total_shear"="blue",
  "cell_elongation_change"="darkgreen",
  "T1"="red",
  "T2"="turquoise",
  "cell_division"="orange",
  "correlation_effects"="magenta",
  "sum_contrib"="salmon",
  "sumContrib"="salmon",
  "check"="yellow",
  "crc"="pink", "cagc"="lightgreen",
  "ct"="grey",
  "J"="grey",
  "CEwithCT"="darkgreen",
  "av_total_shear"="blue",
  "nu"="blue",
  "ShearT1"="red",
  "ShearT2"="turquoise",
  "ShearCD"="orange",
  "correlationEffects"="magenta",
  "sumContrib"="salmon")

# extra stuff to open the database connection automatically.
## NAME OF MOVIE DIRECTORY HERE
#movieDir <- file.path(movieDbBaseDir, c("time"))
#movieDirs <- file.path(movieDbBaseDir, c("time"))
#db <- openMovieDb(movieDir)

# special for multimovie comparison. is this going to work?
movieDir <- file.path(movieDbBaseDir, c("time"))
movieDirs <- file.path(movieDbBaseDir, c("time"))
db <- openMovieDb(movieDir)



#Extras commonly needed:
#Jet Colors
jet.colors <- colorRampPalette(c("#00007F", "blue", "#007FFF", "cyan", "#7FFF7F", "yellow", "#FF7F00", "red", "#7F0000"))

#Load RData files
load("time/dbTablesFromParser/frames.RData")
load("time/dbTablesFromParser/cellinfoDB.RData")
load("time/dbTablesFromParser/cellsDB.RData")
load("time/dbTablesFromParser/cells_dbonds_ubonds_vertices.RData")
load("time/cellshapes.RData")
cellsWithLin <- dbGetQuery(db, "select cell_id, lineage_group, generation 
                                from cell_histories") %>%
  # add cell vertices for cell rendering as polygons
  dt.merge(locload(file.path(movieDir, "cellshapes.RData")), by = "cell_id") %>%
  arrange(frame, cell_id, bond_order) 


# Save plot function
savePlot <- function(myPlot) {
  pdf("myPlot.pdf")
  print(myPlot)
  dev.off()
}


