dir.create("celldetails")

#useful function
every_nth <- function(x, nth, empty = TRUE, inverse = FALSE) 
{
  if (!inverse) {
    if(empty) {
      x[1:nth == 1] <- ""
      x
    } else {
      x[1:nth != 1]
    }
  } else {
    if(empty) {
      x[1:nth != 1] <- ""
      x
    } else {
      x[1:nth == 1]
    }
  }
}
# egg to allow absolute panel size setting in ggplot2?
#install.packages("egg")
library("egg")

load("time/roi_BT/SOP_cell_id.RData")
load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")
roiPosterior <- roiCellsBT %>% filter(roi == "posterior")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")

celldetails_anterior <- cellinfoDB %>% filter(appears_by == "Division" & disappears_by == "Division") %>% filter(cell_id %in% roiAnterior$cell_id) %>% select(cell_id,first_occ,last_occ) %>% mutate(birth_time = first_occ*2.5/60, lifetime = (last_occ-first_occ)*2.5/60) %>% select(cell_id,birth_time,lifetime)
cellavgposns_anterior <- cellsDB %>% filter(cell_id %in% roiAnterior$cell_id) %>% group_by(cell_id) %>% summarise(avg_x_um = mean(center_x)*0.207, avg_y_um = mean(center_y)*0.207)
celldetails_anterior <- celldetails_anterior %>% dt.merge(cellavgposns_anterior,by="cell_id")
write.csv(celldetails_anterior,file="celldetails/celldetails_anterior.csv")

celldetails_posterior <- cellinfoDB %>% filter(appears_by == "Division" & disappears_by == "Division") %>% filter(cell_id %in% roiPosterior$cell_id) %>% select(cell_id,first_occ,last_occ) %>% mutate(birth_time = first_occ*2.5/60, lifetime = (last_occ-first_occ)*2.5/60) %>% select(cell_id,birth_time,lifetime)
cellavgposns_posterior <- cellsDB %>% filter(cell_id %in% roiPosterior$cell_id) %>% group_by(cell_id) %>% summarise(avg_x_um = mean(center_x)*0.207, avg_y_um = mean(center_y)*0.207)
celldetails_posterior <- celldetails_posterior %>% dt.merge(cellavgposns_posterior,by="cell_id")
write.csv(celldetails_posterior,file="celldetails/celldetails_posterior.csv")

celldetails_noborder <- cellinfoDB %>% filter(appears_by == "Division" & disappears_by == "Division") %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,first_occ,last_occ) %>% mutate(birth_time = first_occ*2.5/60, lifetime = (last_occ-first_occ)*2.5/60) %>% select(cell_id,birth_time,lifetime)
cellavgposns_noborder <- cellsDB %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% group_by(cell_id) %>% summarise(avg_x_um = mean(center_x)*0.207, avg_y_um = mean(center_y)*0.207)
celldetails_noborder <- celldetails_noborder %>% dt.merge(cellavgposns_noborder,by="cell_id")
write.csv(celldetails_noborder,file="celldetails/celldetails_noborder.csv")


