## start at 16 statistical USEEXPSD

## code to analyse the output of the startat16h statistical simulations in python..

N_RUNS = 10

#useful function
every_nth <- function(x, nth, empty = TRUE, inverse = FALSE) 
{
  if (!inverse) {
    if(empty) {
      x[1:nth == 1] <- ""
      x
    } else {
      x[1:nth != 1]
    }
  } else {
    if(empty) {
      x[1:nth != 1] <- ""
      x
    } else {
      x[1:nth == 1]
    }
  }
}
# egg to allow absolute panel size setting in ggplot2?
#install.packages("egg")
library("egg")

## script to do various things for figure 3, the bit where we compare the simulation for cell number etc. 
## first want to get the quantities of interest for all the WTs, probably TIME ALIGN THEM to WT2 by SOPs as normal
## and then make ribbon/error bar data series for them.
## then load in data for a sort of 'example'

## make panels like separately. 

offset_WT1 <- 62-62
offset_WT2 <- 0-62
offset_WT3 <- 67-62
offset_WT4 <- 69-62

## PANEL 1. Cell Number prior to 16h. We already have an R script that reads in Ana F's CSV and makes a consistent looking plot of it.
## so put that in. Then append with code to read in CSV simulation data for simulated cell number. 

# R Studio doesn't seem to be grabbing this env variable.
Sys.setenv(TM_HOME = "~/tissue_miner")
scriptsDir=Sys.getenv("TM_HOME")
outDataBaseDir="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/PAPER/FIG3/fromgssimp_startat16h_fixedmean_ks1"
mcdir(outDataBaseDir)
# Load TissueMiner libraries
source(file.path(scriptsDir, "commons/TMCommons.R"))
source(file.path(scriptsDir, "db/movie_rotation/RotationFunctions.R"))
source(file.path(scriptsDir, "commons/BaseQueryFunctions.R"))
source(file.path(scriptsDir, "commons/TimeFunctions.R"))
source(file.path(scriptsDir, "config/default_config.R"))
source(file.path(scriptsDir, "iwanthue.R"))
source(file.path(scriptsDir, "commons/MovieFunctions.R"))

# Load a R library
## library("zoo")

# Set up working directory
mcdir(outDataBaseDir)

# Set general theme for graphs: more specific tuning must be done for each graph
theme_set(theme_bw())
theme_update(panel.grid.major=element_line(linetype= "dotted", color="black", size=0.2),
             panel.grid.minor = element_blank(),
             panel.border = element_rect(size=0.3,color="black",fill=NA),
             axis.ticks=element_line(size=0.2),
             axis.ticks.length=unit(0.1,"cm"),
             legend.key = element_blank()
)

## a colourblind palette? -- use first four for movieColors and last FIVE (backward) for isotropColors?
# no try colour brewer instead
# The palette with black:
#cbbPalette <- c("#000000", "#E69F00", "#56B4E9", "#009E73", "#F0E442", "#0072B2", "#D55E00", "#CC79A7")

# Hardwire isotropic deformation color scheme
isotropColors <- c("division"="#E41A1C",
                   "extrusion"="#377EB8",
                   "cell_area"="#4DAF4A",
                   "sumContrib"="#984EA3",
                   "tissue_area"="#FF7F00")

library(RColorBrewer)
display.brewer.all()
display.brewer.pal(n = 9, name = 'Set1')
brewer.pal(n = 9, name = "Set1")
# "#E41A1C" "#377EB8" "#4DAF4A" "#984EA3" "#FF7F00" "#FFFF33" "#A65628" "#F781BF" "#999999"
brewer.pal(n = 8, name = "Dark2")
# "#1B9E77" "#D95F02" "#7570B3" "#E7298A" "#66A61E" "#E6AB02" "#A6761D" "#666666"


# hardwire the movie color scheme
movieColors <- c("WT1"="#1B9E77",
                 "WT2"="#D95F02",
                 "WT3"="#7570B3",
                 "WT4"="#E7298A"
)

## Shear
shearColors <- c(
  "total_shear"="blue",
  "cell_elongation_change"="darkgreen",
  "T1"="red",
  "T2"="turquoise",
  "cell_division"="orange",
  "correlation_effects"="magenta",
  "sum_contrib"="salmon",
  "sumContrib"="salmon",
  "check"="yellow",
  "crc"="pink", "cagc"="lightgreen",
  "ct"="grey",
  "J"="grey",
  "CEwithCT"="darkgreen",
  "av_total_shear"="blue",
  "nu"="blue",
  "ShearT1"="red",
  "ShearT2"="turquoise",
  "ShearCD"="orange",
  "correlationEffects"="magenta",
  "sumContrib"="salmon")

#Extras commonly needed:
#Jet Colors
jet.colors <- colorRampPalette(c("#00007F", "blue", "#007FFF", "cyan", "#7FFF7F", "yellow", "#FF7F00", "red", "#7F0000"))

# Save plot function
savePlot <- function(myPlot) {
  pdf("myPlot.pdf")
  print(myPlot)
  dev.off()
}

## copying code from fig3.R script.  CHECK THIS STILL!! 

## load in experimental data
WT1_number_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/cellnumber_noborder.csv",header=TRUE) %>% na.omit()
# mutate to offset dev_time
WT1_number_noborder <- WT1_number_noborder %>% select(frame, n) %>% mutate(movie = "WT1") %>% mutate(dev_time = frame*2.5/60) %>% select(dev_time,n,movie)
WT1_SOP_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/cumul_counts/count_SOP_noborder.csv",header=TRUE) %>% na.omit() %>% mutate
# mutate to offset dev_time
WT1_SOP_noborder <- WT1_SOP_noborder %>% select(frame,count) %>% mutate(n = count,dev_time=frame*2.5/60) %>% select(dev_time,n) %>% mutate(movie = "WT1")

WT1_dropout_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/count_dropout_noborder.csv",header=TRUE) %>% na.omit() %>% select(-X)
#pad from 0 to start.
pad <- data.frame(seq(0,149))
colnames(pad) <- "frame"
pad$dev_time <- pad$frame*2.5/60
pad$count <- 0
WT1_dropout_noborder <- WT1_dropout_noborder %>% rbind(pad) %>% arrange(frame)
# mutate to offset dev_time
WT1_dropout_noborder <- WT1_dropout_noborder %>% select(frame,count) %>% mutate(n = count,dev_time=frame*2.5/60) %>% select(dev_time,n) %>% mutate(movie = "WT1")

WT1_number_noborder$series = "noborder"
WT1_SOP_noborder$series = "SOP"
WT1_dropout_noborder$series = "quiescent"
WT1_celltypes_number <- rbind(WT1_number_noborder,WT1_SOP_noborder,WT1_dropout_noborder)

## WT2
WT2_number_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/cellnumber_noborder.csv",header=TRUE) %>% na.omit()
# mutate to offset dev_time
WT2_number_noborder <- WT2_number_noborder %>% select(frame, n) %>% mutate(movie = "WT2") %>% mutate(dev_time = frame*2.5/60) %>% select(dev_time,n,movie)
WT2_SOP_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/cumul_counts/count_SOP_noborder.csv",header=TRUE) %>% na.omit() %>% mutate
# mutate to offset dev_time
WT2_SOP_noborder <- WT2_SOP_noborder %>% select(frame,count) %>% mutate(n = count,dev_time=frame*2.5/60) %>% select(dev_time,n) %>% mutate(movie = "WT2")

WT2_dropout_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/count_dropout_noborder.csv",header=TRUE) %>% na.omit() %>% select(-X)
#pad from 0 to start.
pad <- data.frame(seq(0,149))
colnames(pad) <- "frame"
pad$dev_time <- pad$frame*2.5/60
pad$count <- 0
WT2_dropout_noborder <- WT2_dropout_noborder %>% rbind(pad) %>% arrange(frame)
# mutate to offset dev_time
WT2_dropout_noborder <- WT2_dropout_noborder %>% select(frame,count) %>% mutate(n = count,dev_time=frame*2.5/60) %>% select(dev_time,n) %>% mutate(movie = "WT2")

WT2_number_noborder$series = "noborder"
WT2_SOP_noborder$series = "SOP"
WT2_dropout_noborder$series = "quiescent"
WT2_celltypes_number <- rbind(WT2_number_noborder,WT2_SOP_noborder,WT2_dropout_noborder)

## WT3
WT3_number_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/cellnumber_noborder.csv",header=TRUE) %>% na.omit()
# mutate to offset dev_time
WT3_number_noborder <- WT3_number_noborder %>% select(frame, n) %>% mutate(movie = "WT3") %>% mutate(dev_time = frame*2.5/60) %>% select(dev_time,n,movie)
WT3_SOP_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/cumul_counts/count_SOP_noborder.csv",header=TRUE) %>% na.omit() %>% mutate
# mutate to offset dev_time
WT3_SOP_noborder <- WT3_SOP_noborder %>% select(frame,count) %>% mutate(n = count,dev_time=frame*2.5/60) %>% select(dev_time,n) %>% mutate(movie = "WT3")

WT3_dropout_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/count_dropout_noborder.csv",header=TRUE) %>% na.omit() %>% select(-X)
#pad from 0 to start.
pad <- data.frame(seq(0,149))
colnames(pad) <- "frame"
pad$dev_time <- pad$frame*2.5/60
pad$count <- 0
WT3_dropout_noborder <- WT3_dropout_noborder %>% rbind(pad) %>% arrange(frame)
# mutate to offset dev_time
WT3_dropout_noborder <- WT3_dropout_noborder %>% select(frame,count) %>% mutate(n = count,dev_time=frame*2.5/60) %>% select(dev_time,n) %>% mutate(movie = "WT3")

WT3_number_noborder$series = "noborder"
WT3_SOP_noborder$series = "SOP"
WT3_dropout_noborder$series = "quiescent"
WT3_celltypes_number <- rbind(WT3_number_noborder,WT3_SOP_noborder,WT3_dropout_noborder)

## WT4
WT4_number_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/cellnumber_noborder.csv",header=TRUE) %>% na.omit()
# mutate to offset dev_time
WT4_number_noborder <- WT4_number_noborder %>% select(frame, n) %>% mutate(movie = "WT4") %>% mutate(dev_time = frame*2.5/60) %>% select(dev_time,n,movie)
WT4_SOP_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/cumul_counts/count_SOP_noborder.csv",header=TRUE) %>% na.omit() %>% mutate
# mutate to offset dev_time
WT4_SOP_noborder <- WT4_SOP_noborder %>% select(frame,count) %>% mutate(n = count,dev_time=frame*2.5/60) %>% select(dev_time,n) %>% mutate(movie = "WT4")

WT4_dropout_noborder <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/count_dropout_noborder.csv",header=TRUE) %>% na.omit() %>% select(-X)
#pad from 0 to start.
pad <- data.frame(seq(0,149))
colnames(pad) <- "frame"
pad$dev_time <- pad$frame*2.5/60
pad$count <- 0
WT4_dropout_noborder <- WT4_dropout_noborder %>% rbind(pad) %>% arrange(frame)
# mutate to offset dev_time
WT4_dropout_noborder <- WT4_dropout_noborder %>% select(frame,count) %>% mutate(n = count,dev_time=frame*2.5/60) %>% select(dev_time,n) %>% mutate(movie = "WT4")

WT4_number_noborder$series = "noborder"
WT4_SOP_noborder$series = "SOP"
WT4_dropout_noborder$series = "quiescent"
WT4_celltypes_number <- rbind(WT4_number_noborder,WT4_SOP_noborder,WT4_dropout_noborder)

# load in experimental divrate data without trimming. use dev_time (not offset)
### import experimental data for div rate without trimming. be careful not to use realdev_time.
avgIsoDefRateSummary_WT1 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT1$frame <- round(avgIsoDefRateSummary_WT1$dev_time*60/2.5)
avgIsoDefRateSummary_WT1$realframe <- avgIsoDefRateSummary_WT1$frame + offset_WT1
avgIsoDefRateSummary_WT1$realdev_time <- avgIsoDefRateSummary_WT1$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT1$roi <- as.character(avgIsoDefRateSummary_WT1$roi)
avgIsoDefRateSummary_WT1$isoContrib <- as.character(avgIsoDefRateSummary_WT1$isoContrib)
#
avgIsoDefRateSummary_WT2 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT2$frame <- round(avgIsoDefRateSummary_WT2$dev_time*60/2.5)
avgIsoDefRateSummary_WT2$realframe <- avgIsoDefRateSummary_WT2$frame + offset_WT2
avgIsoDefRateSummary_WT2$realdev_time <- avgIsoDefRateSummary_WT2$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT2$roi <- as.character(avgIsoDefRateSummary_WT2$roi)
avgIsoDefRateSummary_WT2$isoContrib <- as.character(avgIsoDefRateSummary_WT2$isoContrib)
#
avgIsoDefRateSummary_WT3 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT3$frame <- round(avgIsoDefRateSummary_WT3$dev_time*60/2.5)
avgIsoDefRateSummary_WT3$realframe <- avgIsoDefRateSummary_WT3$frame + offset_WT3
avgIsoDefRateSummary_WT3$realdev_time <- avgIsoDefRateSummary_WT3$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT3$roi <- as.character(avgIsoDefRateSummary_WT3$roi)
avgIsoDefRateSummary_WT3$isoContrib <- as.character(avgIsoDefRateSummary_WT3$isoContrib)
#
avgIsoDefRateSummary_WT4 <- read.csv(file="/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/core/noborder/kernSize1/avgIsoDefRateSummary.csv") 
avgIsoDefRateSummary_WT4$frame <- round(avgIsoDefRateSummary_WT4$dev_time*60/2.5)
avgIsoDefRateSummary_WT4$realframe <- avgIsoDefRateSummary_WT4$frame + offset_WT4
avgIsoDefRateSummary_WT4$realdev_time <- avgIsoDefRateSummary_WT4$realframe * 2.5/60
# removing factors (?? what does this do?)
avgIsoDefRateSummary_WT4$roi <- as.character(avgIsoDefRateSummary_WT4$roi)
avgIsoDefRateSummary_WT4$isoContrib <- as.character(avgIsoDefRateSummary_WT4$isoContrib)

# frames data to calculate min and max real frame to have
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT1/frames.RData")
frames_WT1 <- frames
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT2/frames.RData")
frames_WT2 <- frames
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT3/frames.RData")
frames_WT3 <- frames
load("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/CSVs_movies_plots/WT4/frames.RData")
frames_WT4 <- frames

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Combined RATE contribs for given isoContrib (division here) from different WTs. NOTOFFSET OR TRIMMED
## IE OFFSET DATA. 
avgIsoDefRateSummary_allWTs_division <- rbind(avgIsoDefRateSummary_WT1 %>% filter(isoContrib=="division") %>% mutate(movie = "WT1"), avgIsoDefRateSummary_WT2 %>% filter(isoContrib=="division") %>% mutate(movie = "WT2"),
                                              avgIsoDefRateSummary_WT3  %>% filter(isoContrib=="division") %>% mutate(movie = "WT3"), avgIsoDefRateSummary_WT4 %>% filter(isoContrib=="division") %>% mutate(movie = "WT4"))


## write.csv for WT expt div rates kS1
write.csv(avgIsoDefRateSummary_allWTs_division %>% select(-realframe,-realdev_time), file = "divrate_ks1_allWTs.csv")

## loading in statistical simulation data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

## WT1
## need to write a for loop to go over the runs. if 10 runs, 0 to 9.
for (i in seq(0,N_RUNS-1)) {
  # noborder number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT1/nb_cells_all_types_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "noborder"
  temp$run <- i
  if (i == 0)  {
    sim_number_noborderWT1 <- temp
  } else {
    sim_number_noborderWT1 <- rbind(sim_number_noborderWT1,temp)  
  }
  # quiescent number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT1/nb_cells_arrested_cells_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "quiescent"
  temp$run <- i
  if (i == 0)  {
    sim_quiescent_noborderWT1 <- temp
  } else {
    sim_quiescent_noborderWT1 <- rbind(sim_quiescent_noborderWT1,temp)  
  }
  #SOP number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT1/nb_cells_SOPs_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "SOP"
  temp$run <- i
  if (i == 0)  {
    sim_SOP_noborderWT1 <- temp
  } else {
    sim_SOP_noborderWT1 <- rbind(sim_SOP_noborderWT1,temp)  
  }
}

## arrange:
sim_number_noborderWT1 <- sim_number_noborderWT1 %>% arrange(run)
sim_quiescent_noborderWT1 <- sim_quiescent_noborderWT1 %>% arrange(run)
sim_SOP_noborderWT1 <- sim_SOP_noborderWT1 %>% arrange(run)

## first can try plotting just with every simulation as a separate line?.
myplot <- ggplot(WT1_celltypes_number) +
  geom_line(data=WT1_celltypes_number, aes(x=dev_time+16, y= n,color=series),
            alpha=1, linetype = "dashed", size=0.8) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  geom_line(data=sim_number_noborderWT1, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  geom_line(data=sim_quiescent_noborderWT1, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  geom_line(data=sim_SOP_noborderWT1, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  scale_color_manual(values=c("noborder" = "darkgreen","quiescent"="red","SOP"="blue")) +
  scale_fill_manual(values=c("noborder" = "darkgreen","quiescent"="red","SOP"="blue")) +
  xlab("Time (hAPF)")+
  scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  ylab(expression(paste("Cell number noborder"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("startat16_statistical_useexpSD_WT1_celltypes_number.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## looks nice like that. now do the same for the division rate. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55

for (i in seq(0,N_RUNS-1)) {
  # div rate
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT1/kd_array_smoothed_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "rate")
  temp$series <- "noborder"
  temp$run <- i
  if (i == 0)  {
    sim_div_rate_noborderWT1 <- temp
  } else {
    sim_div_rate_noborderWT1 <- rbind(sim_div_rate_noborderWT1,temp)  
  }
  
  ## JJW 6 MAY. modify to read in the divs_frame_array data
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT1/divs_frame_array_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "divs")
  temp$run <- i
  if (i == 0)  {
    sim_divs_frame_arrayWT1 <- temp
  } else {
    sim_divs_frame_arrayWT1 <- rbind(sim_divs_frame_arrayWT1,temp)  
  }
}

## now use divs frame array and cell number count to calculate division rate
# MAGIC NUMBER for TIME INTERVAL
timeinthr <- 0.04167
kernSize <- 1
recalc_div_rateWT1 <- sim_divs_frame_arrayWT1 %>% dt.merge(sim_number_noborderWT1,by=c("run","dev_time"))
recalc_div_rateWT1 <- recalc_div_rateWT1 %>% mutate(rate = divs/(n*(2.5/60)))
#smooth
recalc_div_rateWT1 <- recalc_div_rateWT1 %>% group_by(run) %>% mutate(rate = ma(rate,kernSize)) %>% na.omit()
# use this instead of the previous. i.e. it weill be autoatmically used in fourier too.
## jjw 4 nov 2020 frame shift to simulation div rate
recalc_div_rateWT1$dev_time <- recalc_div_rateWT1$dev_time + (2.5/60)
sim_div_rate_noborderWT1 <- recalc_div_rateWT1

## further test: directly compare divs_frame_array with same data from WT1 expt. 
cellinfoWT1 <- locload("/Users/john/TM_LOCAL_TEMP/WT1_redone/time/dbTablesFromParser/cellinfoDB.RData")
noborderdefnWT1 <- locload("/Users/john/TM_LOCAL_TEMP/WT1_redone/time/roi_bt/lgRoiSmoothed.RData") %>% filter(roi == "anterior")
expt_divs_frameWT1 <- cellinfoWT1 %>% filter(cell_id %in% noborderdefnWT1$cell_id) %>% filter(disappears_by == "Division") %>% arrange(last_occ)
expt_divs_frameWT1 <- expt_divs_frameWT1 %>% group_by(last_occ) %>% summarise(ndiv = n()) %>% mutate(dev_time = (last_occ+1) * (2.5/60) + 16)



# test weird 16.5 hours that doesn't work. 
test <- cellinfoWT1 %>% filter(cell_id %in% noborderdefnWT1$cell_id) %>% filter(last_occ == 12)

# comparative plot
myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_point(data=expt_divs_frameWT1, aes(dev_time, ndiv),color="black",size=0.5,alpha=0.6)+
  geom_point(data=sim_divs_frame_arrayWT1 %>% filter(run == 0) %>% filter(divs != 0), aes(dev_time,divs), color = "red",size=0.5,alpha=0.6,shape = 4) + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  # scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  xlim(15.5,18) + 
  ylim(0,6) +
  xlab("Time (hAPF)")+
  ylab(expression(paste("ndivs"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("divs_frame_compare_WT1.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



## plot simulation and experiment for div rate
myplot <- ggplot(sim_div_rate_noborderWT1) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=avgIsoDefRateSummary_allWTs_division %>% filter(movie == "WT1"), aes(dev_time + 16, value.avg, color=movie),size=0.8,alpha=0.75)+
  #geom_line(data=sim_div_rate_noborderWT1, aes(dev_time,rate,group=run), size=0.3, color="grey35") + 
  geom_line(data=recalc_div_rateWT1 %>% filter(run == 5 | run == 0 | run == 1 | run == 2), aes(dev_time,rate,group=run), size=0.8, alpha=0.5, color="black") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  xlim(15.5,33) + 
  ylim(0,0.4) +
  xlab("Time (hAPF)")+
  ylab(expression(paste("Rate (hr"^"-1",")"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("startat16_statistical_useexpSD_div_rate_WT1.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

# fine. doesnt look so great, i.e peaks still a bit lower. DOUBLE CHECK THE SMOOTHING IS THE SAME.

## WT2
## need to write a for loop to go over the runs. if 10 runs, 0 to 9.
for (i in seq(0,N_RUNS-1)) {
  # noborder number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT2/nb_cells_all_types_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "noborder"
  temp$run <- i
  if (i == 0)  {
    sim_number_noborderWT2 <- temp
  } else {
    sim_number_noborderWT2 <- rbind(sim_number_noborderWT2,temp)  
  }
  # quiescent number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT2/nb_cells_arrested_cells_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "quiescent"
  temp$run <- i
  if (i == 0)  {
    sim_quiescent_noborderWT2 <- temp
  } else {
    sim_quiescent_noborderWT2 <- rbind(sim_quiescent_noborderWT2,temp)  
  }
  #SOP number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT2/nb_cells_SOPs_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "SOP"
  temp$run <- i
  if (i == 0)  {
    sim_SOP_noborderWT2 <- temp
  } else {
    sim_SOP_noborderWT2 <- rbind(sim_SOP_noborderWT2,temp)  
  }
}

## arrange:
sim_number_noborderWT2 <- sim_number_noborderWT2 %>% arrange(run)
sim_quiescent_noborderWT2 <- sim_quiescent_noborderWT2 %>% arrange(run)
sim_SOP_noborderWT2 <- sim_SOP_noborderWT2 %>% arrange(run)

## first can try plotting just with every simulation as a separate line?.
myplot <- ggplot(WT2_celltypes_number) +
  geom_line(data=WT2_celltypes_number, aes(x=dev_time+16, y= n,color=series),
            alpha=1, linetype = "dashed", size=0.8) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  geom_line(data=sim_number_noborderWT2, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  geom_line(data=sim_quiescent_noborderWT2, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  geom_line(data=sim_SOP_noborderWT2, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  scale_color_manual(values=c("noborder" = "darkgreen","quiescent"="red","SOP"="blue")) +
  scale_fill_manual(values=c("noborder" = "darkgreen","quiescent"="red","SOP"="blue")) +
  xlab("Time (hAPF)")+
  scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  ylab(expression(paste("Cell number noborder"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("startat16_statistical_useexpSD_WT2_celltypes_number.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## looks nice like that. now do the same for the division rate. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55

for (i in seq(0,N_RUNS-1)) {
  # div rate
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT2/kd_array_smoothed_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "rate")
  temp$series <- "noborder"
  temp$run <- i
  if (i == 0)  {
    sim_div_rate_noborderWT2 <- temp
  } else {
    sim_div_rate_noborderWT2 <- rbind(sim_div_rate_noborderWT2,temp)  
  }
  ## JJW 6 MAY. modify to read in the divs_frame_array data
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT2/divs_frame_array_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "divs")
  temp$run <- i

  if (i == 0)  {
    sim_divs_frame_arrayWT2 <- temp
  } else {
    sim_divs_frame_arrayWT2 <- rbind(sim_divs_frame_arrayWT2,temp)  
  }
}

timeinthr <- 0.04167
kernSize <- 1
recalc_div_rateWT2 <- sim_divs_frame_arrayWT2 %>% dt.merge(sim_number_noborderWT2,by=c("run","dev_time"))
recalc_div_rateWT2 <- recalc_div_rateWT2 %>% mutate(rate = divs/(n*0.04167))
#smooth
recalc_div_rateWT2 <- recalc_div_rateWT2 %>% group_by(run) %>% mutate(rate = ma(rate,kernSize)) %>% na.omit()
## jjw 4 nov 2020 frame shift to simulation div rate
recalc_div_rateWT2$dev_time <- recalc_div_rateWT2$dev_time + (2.5/60)
sim_div_rate_noborderWT2 <- recalc_div_rateWT2


## plot simulation and experiment for div rate
myplot <- ggplot(sim_div_rate_noborderWT2) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=avgIsoDefRateSummary_allWTs_division %>% filter(movie == "WT2"), aes(dev_time + 16, value.avg, color=movie),size=0.8,alpha=0.75)+
  #geom_line(data=sim_div_rate_noborderWT2, aes(dev_time,rate,group=run), size=0.3, color="grey35") +
  geom_line(data=recalc_div_rateWT2 %>% filter(run == 5), aes(dev_time,rate,group=run), size=0.8, alpha=0.5, color="black") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  ylim(0,0.4) +
  xlab("Time (hAPF)")+
  ylab(expression(paste("Rate (hr"^"-1",")"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("startat16_statistical_useexpSD_div_rate_WT2.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## WT3
## need to write a for loop to go over the runs. if 10 runs, 0 to 9.
for (i in seq(0,N_RUNS-1)) {
  # noborder number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT3/nb_cells_all_types_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "noborder"
  temp$run <- i
  if (i == 0)  {
    sim_number_noborderWT3 <- temp
  } else {
    sim_number_noborderWT3 <- rbind(sim_number_noborderWT3,temp)  
  }
  # quiescent number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT3/nb_cells_arrested_cells_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "quiescent"
  temp$run <- i
  if (i == 0)  {
    sim_quiescent_noborderWT3 <- temp
  } else {
    sim_quiescent_noborderWT3 <- rbind(sim_quiescent_noborderWT3,temp)  
  }
  #SOP number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT3/nb_cells_SOPs_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "SOP"
  temp$run <- i
  if (i == 0)  {
    sim_SOP_noborderWT3 <- temp
  } else {
    sim_SOP_noborderWT3 <- rbind(sim_SOP_noborderWT3,temp)  
  }
}

## arrange:
sim_number_noborderWT3 <- sim_number_noborderWT3 %>% arrange(run)
sim_quiescent_noborderWT3 <- sim_quiescent_noborderWT3 %>% arrange(run)
sim_SOP_noborderWT3 <- sim_SOP_noborderWT3 %>% arrange(run)

## first can try plotting just with every simulation as a separate line?.
myplot <- ggplot(WT3_celltypes_number) +
  geom_line(data=WT3_celltypes_number, aes(x=dev_time+16, y= n,color=series),
            alpha=1, linetype = "dashed", size=0.8) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  geom_line(data=sim_number_noborderWT3, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  geom_line(data=sim_quiescent_noborderWT3, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  geom_line(data=sim_SOP_noborderWT3, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  scale_color_manual(values=c("noborder" = "darkgreen","quiescent"="red","SOP"="blue")) +
  scale_fill_manual(values=c("noborder" = "darkgreen","quiescent"="red","SOP"="blue")) +
  xlab("Time (hAPF)")+
  scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  ylab(expression(paste("Cell number noborder"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("startat16_statistical_useexpSD_WT3_celltypes_number.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## looks nice like that. now do the same for the division rate. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55

for (i in seq(0,N_RUNS-1)) {
  # div rate
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT3/kd_array_smoothed_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "rate")
  temp$series <- "noborder"
  temp$run <- i
  if (i == 0)  {
    sim_div_rate_noborderWT3 <- temp
  } else {
    sim_div_rate_noborderWT3 <- rbind(sim_div_rate_noborderWT3,temp)  
  }
  ## JJW 6 MAY. modify to read in the divs_frame_array data
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT3/divs_frame_array_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "divs")
  temp$run <- i

  if (i == 0)  {
    sim_divs_frame_arrayWT3 <- temp
  } else {
    sim_divs_frame_arrayWT3 <- rbind(sim_divs_frame_arrayWT3,temp)  
  }
}

timeinthr <- 0.04167
kernSize <- 1
recalc_div_rateWT3 <- sim_divs_frame_arrayWT3 %>% dt.merge(sim_number_noborderWT3,by=c("run","dev_time"))
recalc_div_rateWT3 <- recalc_div_rateWT3 %>% mutate(rate = divs/(n*0.04167))

#smooth
recalc_div_rateWT3 <- recalc_div_rateWT3 %>% group_by(run) %>% mutate(rate = ma(rate,kernSize)) %>% na.omit()
## jjw 4 nov 2020 frame shift to simulation div rate
recalc_div_rateWT3$dev_time <- recalc_div_rateWT3$dev_time + (2.5/60)
sim_div_rate_noborderWT3 <- recalc_div_rateWT3

## plot simulation and experiment for div rate
myplot <- ggplot(sim_div_rate_noborderWT3) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=avgIsoDefRateSummary_allWTs_division %>% filter(movie == "WT3"), aes(dev_time + 16, value.avg, color=movie),size=0.8,alpha=0.75)+
  #geom_line(data=sim_div_rate_noborderWT3, aes(dev_time,rate,group=run), size=0.3, color="grey35") + 
  geom_line(data=recalc_div_rateWT3 %>% filter(run == 5), aes(dev_time,rate,group=run), size=0.8, alpha=0.5, color="black") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  ylim(0,0.4) +
  xlab("Time (hAPF)")+
  ylab(expression(paste("Rate (hr"^"-1",")"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("startat16_statistical_useexpSD_div_rate_WT3.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## WT4
## need to write a for loop to go over the runs. if 10 runs, 0 to 9.
for (i in seq(0,N_RUNS-1)) {
  # noborder number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT4/nb_cells_all_types_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "noborder"
  temp$run <- i
  if (i == 0)  {
    sim_number_noborderWT4 <- temp
  } else {
    sim_number_noborderWT4 <- rbind(sim_number_noborderWT4,temp)  
  }
  # quiescent number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT4/nb_cells_arrested_cells_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "quiescent"
  temp$run <- i
  if (i == 0)  {
    sim_quiescent_noborderWT4 <- temp
  } else {
    sim_quiescent_noborderWT4 <- rbind(sim_quiescent_noborderWT4,temp)  
  }
  #SOP number
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT4/nb_cells_SOPs_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "n")
  temp$series <- "SOP"
  temp$run <- i
  if (i == 0)  {
    sim_SOP_noborderWT4 <- temp
  } else {
    sim_SOP_noborderWT4 <- rbind(sim_SOP_noborderWT4,temp)  
  }
}

## arrange:
sim_number_noborderWT4 <- sim_number_noborderWT4 %>% arrange(run)
sim_quiescent_noborderWT4 <- sim_quiescent_noborderWT4 %>% arrange(run)
sim_SOP_noborderWT4 <- sim_SOP_noborderWT4 %>% arrange(run)

## first can try plotting just with every simulation as a separate line?.
myplot <- ggplot(WT4_celltypes_number) +
  geom_line(data=WT4_celltypes_number, aes(x=dev_time+16, y= n,color=series),
            alpha=1, linetype = "dashed", size=0.8) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  geom_line(data=sim_number_noborderWT4, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  geom_line(data=sim_quiescent_noborderWT4, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  geom_line(data=sim_SOP_noborderWT4, aes(dev_time,n,color=series,group=run), size=0.3,alpha=0.5) + 
  scale_color_manual(values=c("noborder" = "darkgreen","quiescent"="red","SOP"="blue")) +
  scale_fill_manual(values=c("noborder" = "darkgreen","quiescent"="red","SOP"="blue")) +
  xlab("Time (hAPF)")+
  scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  ylab(expression(paste("Cell number noborder"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("startat16_statistical_useexpSD_WT4_celltypes_number.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## looks nice like that. now do the same for the division rate. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55

for (i in seq(0,N_RUNS-1)) {
  # div rate
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT4/kd_array_smoothed_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "rate")
  temp$series <- "noborder"
  temp$run <- i
  if (i == 0)  {
    sim_div_rate_noborderWT4 <- temp
  } else {
    sim_div_rate_noborderWT4 <- rbind(sim_div_rate_noborderWT4,temp)  
  }
  ## JJW 6 MAY. modify to read in the divs_frame_array data
  filename = gsub(" \\d ", paste(i), paste("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT4/divs_frame_array_run_",i,".csv",sep=""))
  temp <- read.csv(filename,header=FALSE, sep= " ") %>% na.omit() 
  colnames(temp) <- c("dev_time", "divs")
  temp$run <- i

  if (i == 0)  {
    sim_divs_frame_arrayWT4 <- temp
  } else {
    sim_divs_frame_arrayWT4 <- rbind(sim_divs_frame_arrayWT4,temp)  
  }
}

timeinthr <- 0.04167
kernSize <- 1
recalc_div_rateWT4 <- sim_divs_frame_arrayWT4 %>% dt.merge(sim_number_noborderWT4,by=c("run","dev_time"))
recalc_div_rateWT4 <- recalc_div_rateWT4 %>% mutate(rate = divs/(n*0.04167))
#smooth
recalc_div_rateWT4 <- recalc_div_rateWT4 %>% group_by(run) %>% mutate(rate = ma(rate,kernSize)) %>% na.omit()
## jjw 4 nov 2020 frame shift to simulation div rate
recalc_div_rateWT4$dev_time <- recalc_div_rateWT4$dev_time + (2.5/60)
sim_div_rate_noborderWT4 <- recalc_div_rateWT4

## EXTRA CSVs for GS. separate WTs into  div rate CSVs
write.csv(sim_div_rate_noborderWT1,file="sim_div_rate_noborderWT1.csv")
write.csv(sim_div_rate_noborderWT2,file="sim_div_rate_noborderWT2.csv")
write.csv(sim_div_rate_noborderWT3,file="sim_div_rate_noborderWT3.csv")
write.csv(sim_div_rate_noborderWT4,file="sim_div_rate_noborderWT4.csv")



## plot simulation and experiment for div rate
myplot <- ggplot(sim_div_rate_noborderWT4) +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=avgIsoDefRateSummary_allWTs_division %>% filter(movie == "WT4"), aes(dev_time + 16, value.avg, color=movie),size=0.8,alpha=0.75)+
  #geom_line(data=sim_div_rate_noborderWT4, aes(dev_time,rate,group=run), size=0.3, color="grey35") + 
  geom_line(data=recalc_div_rateWT4 %>% filter(run == 5 | run == 0 | run == 1 | run == 2), aes(dev_time,rate,group=run), size=0.8, alpha=0.5, color="black") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  ylim(0,0.4) +
  xlab("Time (hAPF)")+
  ylab(expression(paste("Rate (hr"^"-1",")"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("startat16_statistical_useexpSD_div_rate_WT4.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



## FOURIER TRANSFORMS FOR PEAK HEIGHTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## look into normalisation and precise formula btw too https://www.rdocumentation.org/packages/stats/versions/3.6.2/topics/fft 
## experimental
## for simplicity I might choose the smallest number of frames that exist in all movies
library("stats")
for_fourier_div_rate_WT1 <- avgIsoDefRateSummary_allWTs_division %>% filter(movie == "WT1")
for_fourier_div_rate_WT2 <- avgIsoDefRateSummary_allWTs_division %>% filter(movie == "WT2")
for_fourier_div_rate_WT3 <- avgIsoDefRateSummary_allWTs_division %>% filter(movie == "WT3")
for_fourier_div_rate_WT4 <- avgIsoDefRateSummary_allWTs_division %>% filter(movie == "WT4")
minlength <- min(nrow(for_fourier_div_rate_WT1),nrow(for_fourier_div_rate_WT2),nrow(for_fourier_div_rate_WT3),nrow(for_fourier_div_rate_WT4))

## choose cutofftime which must be shorter than the shortest data. 
# add an extra filter to trim off the start and have exactly the same start time for data as in simulation 
cutofftime <- 28.5-16
for_fourier_div_rate_WT1 <- for_fourier_div_rate_WT1 %>% filter(dev_time < cutofftime, dev_time > 0)
for_fourier_div_rate_WT2 <- for_fourier_div_rate_WT2 %>% filter(dev_time < cutofftime, dev_time > 0)
for_fourier_div_rate_WT3 <- for_fourier_div_rate_WT3 %>% filter(dev_time < cutofftime, dev_time > 0)
for_fourier_div_rate_WT4 <- for_fourier_div_rate_WT4 %>% filter(dev_time < cutofftime, dev_time > 0)

timespacing <- for_fourier_div_rate_WT1[2,4] - for_fourier_div_rate_WT1[1,4]


# use abs() of fft. need to figure out meaning of frequency bins, been a while. be careful to do this right
fourier_div_rate_WT1 <- abs(fft(for_fourier_div_rate_WT1$value.avg))
fourier_div_rate_WT2 <- abs(fft(for_fourier_div_rate_WT2$value.avg))
fourier_div_rate_WT3 <- abs(fft(for_fourier_div_rate_WT3$value.avg))
fourier_div_rate_WT4 <- abs(fft(for_fourier_div_rate_WT4$value.avg))

# convert to data frame and figure out units of x axis of FFT
xunit <- (1/timespacing) / nrow(for_fourier_div_rate_WT1)

fourier_div_rate_WT1 <- data.frame(fourier_div_rate_WT1)
colnames(fourier_div_rate_WT1) <- "absfft"
fourier_div_rate_WT1$row <- seq.int(nrow(fourier_div_rate_WT1))
fourier_div_rate_WT1$movie <- "WT1"
fourier_div_rate_WT1$freq <- (fourier_div_rate_WT1$row-1)*xunit
normWT1 <- (fourier_div_rate_WT1 %>% filter(freq == 0))$absfft 
fourier_div_rate_WT1$absfft <- fourier_div_rate_WT1$absfft/normWT1

fourier_div_rate_WT2 <- data.frame(fourier_div_rate_WT2)
colnames(fourier_div_rate_WT2) <- "absfft"
fourier_div_rate_WT2$row <- seq.int(nrow(fourier_div_rate_WT2))
fourier_div_rate_WT2$movie <- "WT2"
fourier_div_rate_WT2$freq <- (fourier_div_rate_WT2$row-1)*xunit
normWT2 <- (fourier_div_rate_WT2 %>% filter(freq == 0))$absfft 
fourier_div_rate_WT2$absfft <- fourier_div_rate_WT2$absfft/normWT2

fourier_div_rate_WT3 <- data.frame(fourier_div_rate_WT3)
colnames(fourier_div_rate_WT3) <- "absfft"
fourier_div_rate_WT3$row <- seq.int(nrow(fourier_div_rate_WT3))
fourier_div_rate_WT3$movie <- "WT3"
fourier_div_rate_WT3$freq <- (fourier_div_rate_WT3$row-1)*xunit
normWT3 <- (fourier_div_rate_WT3 %>% filter(freq == 0))$absfft
fourier_div_rate_WT3$absfft <- fourier_div_rate_WT3$absfft/normWT3

fourier_div_rate_WT4 <- data.frame(fourier_div_rate_WT4)
colnames(fourier_div_rate_WT4) <- "absfft"
fourier_div_rate_WT4$row <- seq.int(nrow(fourier_div_rate_WT4))
fourier_div_rate_WT4$movie <- "WT4"
fourier_div_rate_WT4$freq <- (fourier_div_rate_WT4$row-1)*xunit
normWT4 <- (fourier_div_rate_WT4 %>% filter(freq == 0))$absfft 
fourier_div_rate_WT4$absfft <- fourier_div_rate_WT4$absfft/normWT4

# do a quick plot comparing WTs FFTs. 
myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT1, aes(freq,absfft,colour=movie), size=0.4) + 
  geom_line(data=fourier_div_rate_WT2, aes(freq,absfft,colour=movie), size=0.4) + 
  geom_line(data=fourier_div_rate_WT3, aes(freq,absfft,colour=movie), size=0.4) + 
  geom_line(data=fourier_div_rate_WT4, aes(freq,absfft,colour=movie), size=0.4) + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWTs_exp.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## also try averaging together
fourier_div_rate_all <- rbind(fourier_div_rate_WT1,fourier_div_rate_WT2,fourier_div_rate_WT3,fourier_div_rate_WT4)
fourier_div_rate_avg_exp <- fourier_div_rate_all %>% group_by(row) %>% summarise(freq=mean(freq),absfft=mean(absfft))

myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_avg_exp, aes(freq,absfft), size=0.4) + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWTs_avg_exp.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

### the averaged out one at least sort of looks like it makes sense, a peak at roughly 0.25 inverse hours. 
### however I probably shouldn't average them together.

### Anyway, now get Fourier transform of sim data. For this, can average the FT within a WT over the different random seeds? 
timespacing_sim <- timespacing # or set manually 
cutoff_sim <- 28.5
# use a trick to group by run then run the Fourier

sim_fourier_WT1 <- sim_div_rate_noborderWT1 %>% filter(dev_time < cutoff_sim) %>% group_by(run) %>%
  summarise(value = list(abs(fft(rate))), row = list(seq.int(n())), N = n()) %>%
  unnest() %>% mutate(freq = (row-1)*(1/timespacing_sim)/N  )
# then I guess average over runs
#do a version that doesn't!'
sim_fourier_WT1 <- sim_fourier_WT1 %>% group_by(run) %>% mutate(value = value / max(value)) %>% ungroup()
sim_fourier_WT1_separateruns <- sim_fourier_WT1
sim_fourier_WT1 <- sim_fourier_WT1 %>% group_by(row) %>% summarise(sdfreq=sd(freq), sdabsfft = sd(value), freq=mean(freq), absfft=mean(value), movie="WT1")

sim_fourier_WT2 <- sim_div_rate_noborderWT2 %>% filter(dev_time < cutoff_sim) %>% group_by(run) %>%
  summarise(value = list(abs(fft(rate))), row = list(seq.int(n())), N = n()) %>%
  unnest() %>% mutate(freq = (row-1)*(1/timespacing_sim)/N  )
# then I guess average over runs
sim_fourier_WT2 <- sim_fourier_WT2 %>% group_by(run) %>% mutate(value = value / max(value)) %>% ungroup()
sim_fourier_WT2_separateruns <- sim_fourier_WT2
sim_fourier_WT2 <- sim_fourier_WT2 %>% group_by(row) %>% summarise(sdfreq=sd(freq), sdabsfft = sd(value), freq=mean(freq), absfft=mean(value), movie="WT2")

sim_fourier_WT3 <- sim_div_rate_noborderWT3 %>% filter(dev_time < cutoff_sim) %>% group_by(run) %>%
  summarise(value = list(abs(fft(rate))), row = list(seq.int(n())), N = n()) %>%
  unnest() %>% mutate(freq = (row-1)*(1/timespacing_sim)/N  )
# then I guess average over runs
sim_fourier_WT3 <- sim_fourier_WT3 %>% group_by(run) %>% mutate(value = value / max(value)) %>% ungroup()
sim_fourier_WT3_separateruns <- sim_fourier_WT3
sim_fourier_WT3 <- sim_fourier_WT3 %>% group_by(row) %>% summarise(sdfreq=sd(freq), sdabsfft = sd(value), freq=mean(freq), absfft=mean(value), movie="WT3")

sim_fourier_WT4 <- sim_div_rate_noborderWT4 %>% filter(dev_time < cutoff_sim) %>% group_by(run) %>%
  summarise(value = list(abs(fft(rate))), row = list(seq.int(n())), N = n()) %>%
  unnest() %>% mutate(freq = (row-1)*(1/timespacing_sim)/N  )
# then I guess average over runs
sim_fourier_WT4 <- sim_fourier_WT4 %>% group_by(run) %>% mutate(value = value / max(value)) %>% ungroup()
sim_fourier_WT4_separateruns <- sim_fourier_WT4
sim_fourier_WT4 <- sim_fourier_WT4 %>% group_by(row) %>% summarise(sdfreq=sd(freq), sdabsfft = sd(value), freq=mean(freq), absfft=mean(value), movie="WT4")

sim_fourier_all <- rbind(sim_fourier_WT1,sim_fourier_WT2,sim_fourier_WT3,sim_fourier_WT4)

#### COMPARATIVE PLOTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#try plotting all WTs and all sims on a plot, dashed lines for sims
myplot <- ggplot() +
  theme(legend.direction="horizontal",legend.position="top", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT1, aes(freq,absfft,colour=movie), size=0.2) + 
  geom_line(data=fourier_div_rate_WT2, aes(freq,absfft,colour=movie), size=0.2) + 
  geom_line(data=fourier_div_rate_WT3, aes(freq,absfft,colour=movie), size=0.2) + 
  geom_line(data=fourier_div_rate_WT4, aes(freq,absfft,colour=movie), size=0.2) + 
  geom_line(data=sim_fourier_all, aes(freq,absfft,colour=movie,group=movie), linetype="dashed",size=0.2) + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWTs_exp_sim_runavgd.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

# try averaging together all the WT sims and then plotting comparing to avg exp.
sim_fourier_div_rate_avg <- sim_fourier_all %>% group_by(row) %>% summarise(sdfreq=sd(freq),sdabsfft=sd(absfft),freq=mean(freq),absfft=mean(absfft))

myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_avg_exp, aes(freq,absfft), size=0.6) + 
  geom_line(data=sim_fourier_div_rate_avg, aes(freq,absfft), size=0.6, colour = "red") + 
  geom_ribbon(data=sim_fourier_div_rate_avg, aes(freq,ymin=absfft-sdabsfft,ymax=absfft+sdabsfft), size=0,alpha=0.5, fill = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWTs_avg_sim_vs_exp.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## INSERT CSVS
write.csv(fourier_div_rate_avg_exp,file="fourier_div_rate_avg_exp.csv")
write.csv(sim_fourier_div_rate_avg,file="sim_fourier_div_rate_avg.csv")

write.csv(fourier_div_rate_WT1,file="fourier_div_rate_WT1.csv")
write.csv(fourier_div_rate_WT2,file="fourier_div_rate_WT2.csv")
write.csv(fourier_div_rate_WT3,file="fourier_div_rate_WT3.csv")
write.csv(fourier_div_rate_WT4,file="fourier_div_rate_WT4.csv")

write.csv(sim_fourier_WT1_separateruns,file="sim_fourier_WT1_separateruns.csv")
write.csv(sim_fourier_WT2_separateruns,file="sim_fourier_WT2_separateruns.csv")
write.csv(sim_fourier_WT3_separateruns,file="sim_fourier_WT3_separateruns.csv")
write.csv(sim_fourier_WT4_separateruns,file="sim_fourier_WT4_separateruns.csv")


## DO FOR SAY WT1 ALONE A COMPARISON OF JUST RUN 1 (or individual runs) to the WT.
myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT1, aes(freq,absfft), size=0.4) + 
  geom_line(data=sim_fourier_WT1_separateruns, aes(freq,value, group = run), size=0.4, alpha = 0.5, colour = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWT1_exp_vs_separate_sims.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## average over sim runs for WT1 and show SD
myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT1, aes(freq,absfft), size=0.4) + 
  geom_line(data=sim_fourier_WT1, aes(freq,absfft), size=0.4, alpha = 0.75, colour = "red") +
  geom_ribbon(data=sim_fourier_WT1, aes(freq,ymax=absfft+sdabsfft,ymin=absfft-sdabsfft), size=0.4, alpha = 0.5, fill = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWT1_exp_vs_avg_sims.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT2, aes(freq,absfft), size=0.4) + 
  geom_line(data=sim_fourier_WT2_separateruns, aes(freq,value, group = run), size=0.4, alpha = 0.5, colour = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWT2_exp_vs_separate_sims.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## average over sim runs for WT2 and show SD
myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT2, aes(freq,absfft), size=0.4) + 
  geom_line(data=sim_fourier_WT2, aes(freq,absfft), size=0.4, alpha = 0.75, colour = "red") +
  geom_ribbon(data=sim_fourier_WT2, aes(freq,ymax=absfft+sdabsfft,ymin=absfft-sdabsfft), size=0.4, alpha = 0.5, fill = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWT2_exp_vs_avg_sims.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT3, aes(freq,absfft), size=0.4) + 
  geom_line(data=sim_fourier_WT3_separateruns, aes(freq,value, group = run), size=0.4, alpha = 0.5, colour = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWT3_exp_vs_separate_sims.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

## average over sim runs for WT3 and show SD
myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT3, aes(freq,absfft), size=0.4) + 
  geom_line(data=sim_fourier_WT3, aes(freq,absfft), size=0.4, alpha = 0.75, colour = "red") +
  geom_ribbon(data=sim_fourier_WT3, aes(freq,ymax=absfft+sdabsfft,ymin=absfft-sdabsfft), size=0.4, alpha = 0.5, fill = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWT3_exp_vs_avg_sims.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT4, aes(freq,absfft), size=0.4) + 
  geom_line(data=sim_fourier_WT4_separateruns, aes(freq,value, group = run), size=0.4, alpha = 0.5, colour = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWT4_exp_vs_separate_sims.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


## average over sim runs for WT4 and show SD
myplot <- ggplot() +
  theme(legend.direction="vertical",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) + ### use dev_time not realdev_time!!!!
  geom_line(data=fourier_div_rate_WT4, aes(freq,absfft), size=0.4) + 
  geom_line(data=sim_fourier_WT4, aes(freq,absfft), size=0.4, alpha = 0.75, colour = "red") +
  geom_ribbon(data=sim_fourier_WT4, aes(freq,ymax=absfft+sdabsfft,ymin=absfft-sdabsfft), size=0.4, alpha = 0.5, fill = "red") + 
  scale_color_manual(values=movieColors) +
  scale_fill_manual(values=movieColors) +
  #scale_x_continuous(limits=c(16,36), breaks=seq(16,36,2.5), expand = c(0,0), labels = every_nth(seq(16,36,2.5), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,2.1), breaks=seq(0,2,1), expand = c(0,0), labels = every_nth(seq(0,2,1), 1, inverse = TRUE)) +
  scale_y_continuous(limits=c(0,0.21), breaks=seq(0,0.21,0.05), expand = c(0,0), labels = every_nth(seq(0,0.21,0.05), 2, inverse = TRUE)) +
  xlab("Freq (hr-1)")+
  ylab(expression(paste("FT div. rate"))) 
#scale_x_continuous(limits=c(-2,18), breaks=c(0,4,8,12,16))
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("absfft_useexpSDWT4_exp_vs_avg_sims.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.58, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)



### quick test of lifetimes array sd etc from wt1 run 0.
lifetimeswt1run0 <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT1/LIFETIMES_ARRAY_run_0.csv",header=TRUE, sep = " ")
colnames(lifetimeswt1run0) <- c("dev_time", "lifetime", "type")
overallsd <- sd(lifetimeswt1run0$lifetime)

## from this plot type 0 lifetimes as a function of time. are they U shaped or something similar due to the anticorrelation? 


## run 1
lifetimeswt1run1 <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT1/LIFETIMES_ARRAY_run_1.csv",header=TRUE, sep = " ")
colnames(lifetimeswt1run1) <- c("dev_time", "lifetime", "type")
overallsd <- sd(lifetimeswt1run1$lifetime)

## from this plot type 0 lifetimes as a function of time. are they U shaped or something similar due to the anticorrelation? 

### WT2 run 0 and run 1
### quick test of lifetimes array sd etc from wt1 run 0.
lifetimeswt2run0 <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT2/LIFETIMES_ARRAY_run_0.csv",header=TRUE, sep = " ")
colnames(lifetimeswt2run0) <- c("dev_time", "lifetime", "type")
overallsd <- sd(lifetimeswt2run0$lifetime)

## from this plot type 0 lifetimes as a function of time. are they U shaped or something similar due to the anticorrelation? 

## run 1
lifetimeswt2run1 <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT2/LIFETIMES_ARRAY_run_1.csv",header=TRUE, sep = " ")
colnames(lifetimeswt2run1) <- c("dev_time", "lifetime", "type")
overallsd <- sd(lifetimeswt2run1$lifetime)

## from this plot type 0 lifetimes as a function of time. are they U shaped or something similar due to the anticorrelation? 


## WT3
lifetimeswt3run0 <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT3/LIFETIMES_ARRAY_run_0.csv",header=TRUE, sep = " ")
colnames(lifetimeswt3run0) <- c("dev_time", "lifetime", "type")
overallsd <- sd(lifetimeswt3run0$lifetime)

## from this plot type 0 lifetimes as a function of time. are they U shaped or something similar due to the anticorrelation? 

## run 1
lifetimeswt3run1 <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT3/LIFETIMES_ARRAY_run_1.csv",header=TRUE, sep = " ")
colnames(lifetimeswt3run1) <- c("dev_time", "lifetime", "type")
overallsd <- sd(lifetimeswt3run1$lifetime)

## from this plot type 0 lifetimes as a function of time. are they U shaped or something similar due to the anticorrelation? 

### EXTRA: for anticorr stuff. try to measure the direct pearson corelation coefficient as done in the mother correlation no dup code.
mother_daughter_wt1_run_0 <- read.csv("/Users/john/Dropbox (The Francis Crick)/CRICK/FIRST_HISTOBLAST_PAPER/Simulations_Final/Simulation_from16hAPF/results_constant_meanWT1/LIFETIMES_ARRAY_run_0.csv",header=TRUE, sep = " ")
colnames(mother_daughter_wt1_run_0 ) <- c("mother_lifetime", "daughter_lifetime")

CORR_simulation_mother_daughter_wt1_run_0 <- cor.test(mother_daughter_wt1_run_0$mother_lifetime, mother_daughter_wt1_run_0$daughter_lifetime, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_simulation_mother_daughter_wt1_run_0$estimate, file="CORR_simulation_mother_daughter_wt1_run_0_estimate.csv")
write.csv(CORR_simulation_mother_daughter_wt1_run_0$p.value, file="CORR_simulation_mother_daughter_wt1_run_0_pvalue.csv")

