dir.create("lifetime_extrarequests_jul20")



### script to do brief analysis of the new quadrant

#useful function
every_nth <- function(x, nth, empty = TRUE, inverse = FALSE) 
{
  if (!inverse) {
    if(empty) {
      x[1:nth == 1] <- ""
      x
    } else {
      x[1:nth != 1]
    }
  } else {
    if(empty) {
      x[1:nth != 1] <- ""
      x
    } else {
      x[1:nth == 1]
    }
  }
}
# egg to allow absolute panel size setting in ggplot2?
#install.packages("egg")
library("egg")

load("time/roi_BT/SOP_cell_id.RData")
load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")
roiPosterior <- roiCellsBT %>% filter(roi == "posterior")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")


## unrestricted lifetime colour gauge movie
lifetimes_noborder <- cellinfoDB %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,first_occ,last_occ)
lifetimes_noborder$lifetime <- lifetimes_noborder$last_occ - lifetimes_noborder$first_occ

cellshapes_lifetime <- lifetimes_noborder %>% select(cell_id,lifetime) %>% dt.merge(cellshapes,by="cell_id")
# render_movie(cellshapes_lifetime, "lifetime_extrarequests_jul20/cellshapes_lifetime.mp4", list(
#   geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=lifetime*2.5/60)),
#   scale_fill_gradientn(name="lifetime (hr)",
#                        colors  = jet.colors(7),
#                        limits=c(0,10),
#                        # ignore tails of distribution
#                        na.value = "black")
# ))
## anterior 
lifetimes_anterior <- cellinfoDB %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiAnterior$cell_id) %>% select(cell_id,first_occ,last_occ)
lifetimes_anterior$lifetime <- lifetimes_anterior$last_occ - lifetimes_anterior$first_occ

test <- lifetimes_anterior %>% filter(lifetime >= 10*60/2.5)

## write the CSV of mean whole-anterior lifetime measurements
mean_anterior_lifetime <- mean(lifetimes_anterior$lifetime)*2.5/60
write.csv(mean_anterior_lifetime,file="lifetime_extrarequests_jul20/mean_anterior_lifetimes.csv")

### EXTRA 6 OCT 2020
# for full anterior, create pearson correlation data for lifetime-initial area, mean area, and mean elongation norm
# start from liftimes_anterior.
avglifenorm <- cellsDB %>% group_by(cell_id) %>% summarise(avglifenorm = mean(sqrt(elong_xx^2 + elong_xy^2)))
avglifearea <- cellsDB %>% group_by(cell_id) %>% summarise(avglifearea = mean(area))
initial_area <- cellinfoDB %>% select(cell_id,first_occ) %>% dt.merge(cellsDB,by="cell_id") %>% filter(frame == first_occ) %>% select(cell_id,area)
#merges
lifetime_initial_area <- initial_area %>% dt.merge(lifetimes_anterior,by="cell_id")
lifetime_avglifearea <- avglifearea %>% dt.merge(lifetimes_anterior,by="cell_id")
lifetime_avglifenorm <- avglifenorm %>% dt.merge(lifetimes_anterior,by="cell_id")

CORR_lifetimes_initial_area <- cor.test(lifetime_initial_area$area, lifetime_initial_area$lifetime, method = c("pearson"))
CORR_lifetimes_avglifearea <- cor.test(lifetime_avglifearea$avglifearea, lifetime_avglifearea$lifetime, method = c("pearson"))
CORR_lifetimes_avglifenorm <- cor.test(lifetime_avglifenorm$avglifenorm, lifetime_avglifenorm$lifetime, method = c("pearson"))

# CSV files
write.csv(CORR_lifetimes_initial_area$estimate, file="lifetime_extrarequests_jul20/CORR_lifetimes_initial_area_estimate.csv")
write.csv(CORR_lifetimes_initial_area$p.value, file="lifetime_extrarequests_jul20/CORR_lifetimes_initial_area_pvalue.csv")
#
write.csv(CORR_lifetimes_avglifearea$estimate, file="lifetime_extrarequests_jul20/CORR_lifetimes_avglifearea_estimate.csv")
write.csv(CORR_lifetimes_avglifearea$p.value, file="lifetime_extrarequests_jul20/CORR_lifetimes_avglifearea_pvalue.csv")
#
write.csv(CORR_lifetimes_avglifenorm$estimate, file="lifetime_extrarequests_jul20/CORR_lifetimes_avglifenorm_estimate.csv")
write.csv(CORR_lifetimes_avglifenorm$p.value, file="lifetime_extrarequests_jul20/CORR_lifetimes_avglifenorm_pvalue.csv")



cellshapes_lifetime_anterior <- lifetimes_anterior %>% select(cell_id,lifetime) %>% dt.merge(cellshapes,by="cell_id")
render_movie(cellshapes_lifetime_anterior, "lifetime_extrarequests_jul20/cellshapes_lifetime_anterior.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=lifetime*2.5/60)),
  scale_fill_gradientn(name="lifetime (hr)",
                       colors  = jet.colors(7),
                       limits=c(0,10),
                       # ignore tails of distribution
                       na.value = "black")
))

## posterior
lifetimes_posterior <- cellinfoDB %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiPosterior$cell_id) %>% select(cell_id,first_occ,last_occ)
lifetimes_posterior$lifetime <- lifetimes_posterior$last_occ - lifetimes_posterior$first_occ

cellshapes_lifetime_posterior <- lifetimes_posterior %>% select(cell_id,lifetime) %>% dt.merge(cellshapes,by="cell_id")
render_movie(cellshapes_lifetime_posterior, "lifetime_extrarequests_jul20/cellshapes_lifetime_posterior.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=lifetime*2.5/60)),
  scale_fill_gradientn(name="lifetime (hr)",
                       colors  = jet.colors(7),
                       limits=c(0,10),
                       # ignore tails of distribution
                       na.value = "black")
))


## movie with divisions marked in blue for anterior and posterior I guess.

dividingcells_anterior <- cellinfoDB %>% filter(cell_id %in% roiAnterior$cell_id) %>% select(cell_id,disappears_by,last_occ) %>% dt.merge(cellshapes,by="cell_id") 
dividingcells_anterior <- dividingcells_anterior %>% mutate(dividing = (disappears_by == "Division" & frame == last_occ))

render_movie(dividingcells_anterior, "lifetime_extrarequests_jul20/cellshapes_dividing_anterior.mp4", list( 
  # geometrical layer to represent cells as polygons
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill = dividing), alpha=0.65), # this was 0.75 before, trying this for overlaying multiple with transparency. see evernote. 
  scale_fill_manual(values=c("FALSE"="white", "TRUE"="blue"))
))

# posterior
dividingcells_posterior <- cellinfoDB %>% filter(cell_id %in% roiPosterior$cell_id) %>% select(cell_id,disappears_by,last_occ) %>% dt.merge(cellshapes,by="cell_id") 
dividingcells_posterior <- dividingcells_posterior %>% mutate(dividing = (disappears_by == "Division" & frame == last_occ))

render_movie(dividingcells_posterior, "lifetime_extrarequests_jul20/cellshapes_dividing_posterior.mp4", list( 
  # geometrical layer to represent cells as polygons
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill = dividing), alpha=0.65), # this was 0.75 before, trying this for overlaying multiple with transparency. see evernote. 
  scale_fill_manual(values=c("FALSE"="white", "TRUE"="blue"))
))

## do one with both, colouring with red for posteriro and green for anteriro UNLESS dividing. 
temp <- dividingcells_anterior
temp$dividing[temp$dividing == "FALSE"] <- "anterior"

temp1 <- dividingcells_posterior
temp1$dividing[temp1$dividing == "FALSE"] <- "posterior"

dividingcells_antandpos <- rbind(temp,temp1)

render_movie(dividingcells_antandpos, "lifetime_extrarequests_jul20/cellshapes_dividing_antandpos.mp4", list( 
  # geometrical layer to represent cells as polygons
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill = dividing), alpha=0.65), # this was 0.75 before, trying this for overlaying multiple with transparency. see evernote. 
  scale_fill_manual(values=c("anterior" = "green", "posterior" = "red", "TRUE"="blue"))
))


### add extra code to try and create a simple horizontal colour bar to be extracted in isolation from a pdf.




myplot <- ggplot(lifetimes_noborder %>% filter(cell_id == 10605), aes(first_occ,lifetime,color=lifetime)) +
  geom_point()+
  theme(legend.direction="horizontal",legend.position="top", 
        aspect.ratio=2/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  xlab(expression(paste("r from COM (um)" ))) +
  scale_color_gradientn(name="time (s)",
                        colors  = jet.colors(7),
                        limits = c(0,10),
                        na.value = "black") +
  scale_fill_gradientn(name="time (s)",
                       colors  = jet.colors(7),
                       limits = c(0,10),
                       na.value = "black") +
  #xlim(0,20)+
  ylab(expression(paste("mean norm"))) 
myplot <- set_panel_size(myplot,width  = unit(39, "mm"),
                         height = unit(39*2/3, "mm"))
ggsave("for_colourbar.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.65, height=103*0.75, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)





