## lineage_red_cells stuff. Looking for correlations within lineages of red-cell creation.
## 1) make a version of initial_final or whatever with two extra columns: the number of cells in the lineage at the last frame,
## and the number of red cells in the lineage at the last frame.
## 2) do something clever like a colour map of lineages ranked by first-red-cell on one axis, time on other axis, colour as fraction of red cells in the lineage.
## 3) WHITE LINES around lineages on a red cell movie
## 4) BLACK LINES AROUND ANTERIOR NEST FOR TRANSPARENCY STUFF. RUN 1 FIRST THOUGH.

dir.create("lineage_redcell_stuff")
load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")

load("time/roi_BT/SOP_cell_id.RData")
dropout_full_noborder <- cellinfoDB %>% filter(disappears_by == "Unclassified") %>% select(cell_id,first_occ) %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(!(cell_id %in% SOP_cell_id$cell_id))

## 1) make some data that for each lineage group at each frame has the number of cells and the number of red cells. 
# plain lineage occupancy at each frame, and red occupancy at same time
lineage_occs <- cellsWithLin %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,frame,lineage_group) %>% unique()
# make lg numerical
lineage_occs$lineage_group <- as.numeric(gsub("lg_","", lineage_occs$lineage_group))
# count occupancy
lineage_occs <- lineage_occs %>% group_by(lineage_group,frame) %>% summarise(occupancy = n(), occupancy_red = sum(cell_id %in% dropout_full_noborder$cell_id))

# make list of each cell's lineage group
cells_lingroups <- cellsWithLin %>% select(cell_id, lineage_group)
cells_lingroups$lineage_group <- as.numeric(gsub("lg_","", cells_lingroups$lineage_group))
cells_lingroups <- cells_lingroups %>% unique()

# get last_occ of each cell in cells_lingroups
cells_lingroups <- cellinfoDB %>% select(cell_id,last_occ) %>% dt.merge(cells_lingroups,by="cell_id")
addedcols <- cells_lingroups %>% dt.merge(lineage_occs,by="lineage_group",allow.cartesian=TRUE) %>% filter(frame == last_occ)
addedcols <- addedcols %>% select(cell_id, occupancy, occupancy_red)

# now can just bolt on the code from before from the standard core code about initial_final data (whole neighbourship NOT required to stay in)
# initial final and red cell nred data etc. in noborder. this is only div-div cells remember.
app_dis_by_div <- cellinfoDB %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% select(cell_id)
initial_areas_daughters_noborder <- cellinfoDB %>% select(cell_id,first_occ) %>% rename(frame = first_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(initial_area = area) %>% rename(first_occ = frame)
# then do the final areas too
final_areas <- cellinfoDB %>% select(cell_id,last_occ) %>% rename(frame = last_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(final_area = area) %>% rename(last_occ = frame)
# merge and keep only div-div cells in noborder region
initial_areas_daughters_noborder <- initial_areas_daughters_noborder %>% dt.merge(final_areas, by = "cell_id") %>% filter(cell_id %in% app_dis_by_div$cell_id) %>% filter(cell_id %in% roiHistoNoborder$cell_id)
# mistake lol
initial_final_areas_daughters_noborder <- initial_areas_daughters_noborder
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(cellinfoDB %>% select(cell_id, left_daughter_cell_id, right_daughter_cell_id),by="cell_id")
initial_final_areas_daughters_noborder$nred <- as.numeric(initial_final_areas_daughters_noborder$left_daughter_cell_id %in% dropout_full_noborder$cell_id) + as.numeric(initial_final_areas_daughters_noborder$right_daughter_cell_id %in% dropout_full_noborder$cell_id)
# re order columns to be like before
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder[,c(1,2,4,3,5,6,7,8)]

neighbours_red <- cellinfoDB %>% filter(disappears_by == "Division") %>% filter(appears_by == "Division") %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id, last_occ)
load("time/topochanges/cellNeighbors.RData") # has multiplicity remember
cellNeighbors <- cellNeighbors %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(neighbor_cell_id %in% roiHistoNoborder$cell_id) # only count neigbhbors in noborder as that's where red cells are defined.
neighbours_red <- neighbours_red %>% dt.merge(cellNeighbors,by="cell_id") # this gets the first neighbours for each cell

# now get the second neighbours . frame must be the same because we require neighbor_cell is a neighbor of cell at the same time second_neighbor is a neighbor of neighbor_cell. try this. CHECK AFTER
neighbours_red <- cellNeighbors %>% rename(second_neighbor = neighbor_cell_id) %>% rename(neighbor_cell_id = cell_id) %>% dt.merge(neighbours_red,by=c("neighbor_cell_id","frame"), allow.cartesian=TRUE)
neighbours_red <- neighbours_red %>% filter(cell_id != second_neighbor)
neighbours_red <- neighbours_red %>% select(cell_id,frame,last_occ,neighbor_cell_id,second_neighbor) #reorder columns
# say in 1 or 0 if neighbour and second neighbour are red
neighbours_red$neigh_red <-  as.integer(neighbours_red$neighbor_cell_id %in% dropout_full_noborder$cell_id)
neighbours_red$sec_neigh_red <-  as.integer(neighbours_red$second_neighbor %in% dropout_full_noborder$cell_id)
# now do this version of table for final frame only and do the counts. 
neighbours_red_last_frame <- neighbours_red %>% filter(last_occ == frame)
neighbours_red_last_frame <- neighbours_red_last_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]), n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1])    )

# now do version for all frames 
neighbours_red_all_frame <- neighbours_red 
neighbours_red_all_frame <- neighbours_red_all_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]), n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1])    )

#merge onto end
initial_final_areas_daughters_noborder$cell_id_merge <- initial_areas_daughters_noborder$cell_id
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(neighbours_red_last_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% rename(n_neigh_last = n_neigh, nred_neigh_last = nred_neigh, n_sec_neigh_last = n_sec_neigh, nred_sec_neigh_last = nred_sec_neigh)
# merge extra two columns
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(addedcols %>% rename(cell_id_merge = cell_id, occ_last = occupancy, occ_last_red = occupancy_red), by = "cell_id_merge" )

initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(neighbours_red_all_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )

initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% select(-cell_id_merge)

# CSV of this :
write.csv(initial_final_areas_daughters_noborder, file = "lineage_redcell_stuff/initial_final_areas_daughters_noborder_added_linocc.csv")




## 2) make a thing that can be plotted as a colour map plot or printed to csv. x axis: lineage group ID, ordered by the time of first-red-cell appearance
## y axis: time, colour = fraction of red cells in lineage group. but keep both total occ and red cell occ integers too for CSV.

# got lineage_occs already. need to make a rank for each lineage based on this. needs to contain all and only noborder lineage groups. 
dropout_w_lg <- cells_lingroups %>% select(cell_id, lineage_group) %>% dt.merge(dropout_full_noborder,by="cell_id")
lineage_ranks <- dropout_w_lg %>% select(lineage_group,first_occ) %>% group_by(lineage_group) %>% summarise(first_occ = min(first_occ) )%>% arrange(first_occ) %>% mutate(rank=row_number())
# now here is the thing I will plot more or less
lineage_red_occs_ranks <- lineage_ranks %>% dt.merge(lineage_occs, by="lineage_group")


# NOW PLOT!
myplot <- ggplot(lineage_red_occs_ranks, aes(frame*2.5/60, rank)) + geom_tile(aes(fill = (occupancy_red/occupancy))) + scale_fill_gradientn(colors  = jet.colors(7)) + ylab(expression(paste("rank"))) + xlab(expression(paste("time (hr)")))
pdf("lineage_redcell_stuff/lineage_red_occs_ranks.pdf")
print(myplot)
dev.off()

# CSV
write.csv(lineage_red_occs_ranks,file="lineage_redcell_stuff/lineage_red_occs_ranks.csv")


### 3) Make a red cell movie with white lines around each lineage
## try to make a list of all bonds or dbonds which separate cells of different lineages.
load("time/dbTablesFromParser/dbondsDB.RData")
dbondsDB_unique <- dbondsDB[!duplicated(dbondsDB[,c('bond_id')]),]
bonds_neighbours <- unique(dbondsDB %>% select(bond_id,frame))
bonds_neighbours$cell_id1 <- dbondsDB$cell_id[match(dbondsDB_unique$dbond_id[match(dbondsDB_unique$bond_id, bonds_neighbours$bond_id)], dbondsDB$dbond_id)]
#add a column to test that says the cell matching the relevant conj_dbond — this is the other cell the bond belongs to
bonds_neighbours$cell_id2 <- dbondsDB$cell_id[match(dbondsDB_unique$dbond_id[match(dbondsDB_unique$bond_id, bonds_neighbours$bond_id)], dbondsDB$conj_dbond_id)]
# add a column that says whether the two cells of the bond are in different lineages
bonds_neighbours <- cellsWithLin %>% select(cell_id, lineage_group) %>% unique() %>% rename(cell_id2 = cell_id) %>% dt.merge(bonds_neighbours,by="cell_id2",allow.cartesian=TRUE) %>% rename(lineage_group2 = lineage_group)
bonds_neighbours <- cellsWithLin %>% select(cell_id, lineage_group) %>% unique() %>% rename(cell_id1 = cell_id) %>% dt.merge(bonds_neighbours,by="cell_id1",allow.cartesian=TRUE) %>% rename(lineage_group1 = lineage_group)
bonds_neighbours$difflin <- as.numeric(bonds_neighbours$lineage_group1 != bonds_neighbours$lineage_group2)

# okay so not totally useful yet. I need to manipulate cellshapes table so that it has the 'next along' vertex (circles back ground, too) as 
# another column. first count vertices for each cell in each frame
cellshapes_bonds <- cellshapes
cellshapes_bonds <- cellshapes_bonds %>% group_by(frame,cell_id) %>% summarise(nvertices = n()) %>% ungroup() %>% dt.merge(cellshapes_bonds,by=c("frame","cell_id"))
cellshapes_bonds$next_bond_order <- cellshapes_bonds$bond_order + 1 - as.numeric(cellshapes_bonds$bond_order == cellshapes_bonds$nvertices) * cellshapes_bonds$nvertices
cellshapes_bonds <- cellshapes_bonds %>% dt.merge(cellshapes_bonds %>% select(frame,cell_id,x_pos,y_pos, bond_order) %>% rename(next_bond_order = bond_order, next_x_pos = x_pos, next_y_pos = y_pos),by = c("frame","cell_id","next_bond_order")) %>% arrange(frame,cell_id,bond_order) %>% select(frame,cell_id,nvertices,x_pos,y_pos,bond_order,next_x_pos,next_y_pos,next_bond_order)
# good. now need to determine the bond name for the bond between bond_order and next_bond_order vertices

# problem HERE for movies that have rotation applied. positions have decimal places x_pos etc. 
# so load transformed_vertices instead from the SQL db, which has rotation applied. they are now floats not ints but should merge okay as they have finite decimal places I think?
transformed_vertices <- dbGetQuery(db,"select frame, vertex_id, x_pos, y_pos from vertices")
# to be better safe than sorry, truncate the decimal places of x_pos, y_pos, next_x_pos, next_y_pos within cellshapes_bonds and within transformed_vertices
transformed_vertices$x_pos <- round(transformed_vertices$x_pos,2)
transformed_vertices$y_pos <- round(transformed_vertices$y_pos,2)
cellshapes_bonds$x_pos <- round(cellshapes_bonds$x_pos,2)
cellshapes_bonds$y_pos <- round(cellshapes_bonds$y_pos,2)
cellshapes_bonds$next_x_pos <- round(cellshapes_bonds$next_x_pos,2)
cellshapes_bonds$next_y_pos <- round(cellshapes_bonds$next_y_pos,2)

cellshapes_bonds <- transformed_vertices %>% dt.merge(cellshapes_bonds,by=c("frame","x_pos","y_pos"))
cellshapes_bonds <- transformed_vertices %>% rename(next_x_pos = x_pos, next_y_pos = y_pos, next_vertex_id = vertex_id) %>% dt.merge(cellshapes_bonds,by=c("frame","next_x_pos","next_y_pos")) %>% select(frame,cell_id,nvertices,x_pos,y_pos,vertex_id,bond_order,next_x_pos,next_y_pos,next_vertex_id, next_bond_order) %>% arrange(frame,cell_id,bond_order)

dbondsDB_next <- dbondsDB
dbondsDB_next$next_vertex_id <- dbondsDB_next$vertex_id[match(dbondsDB_next$dbond_id,dbondsDB_next$conj_dbond_id)]

# ok to here

cellshapes_bonds <- dbondsDB_next %>% select(frame,vertex_id,next_vertex_id,bond_id) %>% dt.merge(cellshapes_bonds,by=c("frame","vertex_id","next_vertex_id")) %>% select(frame,cell_id,nvertices,bond_id, x_pos,y_pos,vertex_id,bond_order,next_x_pos,next_y_pos,next_vertex_id, next_bond_order) %>% arrange(frame,cell_id,bond_order)
# good. now flag whether the bond is a lineage boundary. not sure why this reduces number of elements but it does if merge. do an %in% instead
cellshapes_bonds$difflin <- as.numeric(cellshapes_bonds$bond_id %in% (bonds_neighbours %>% filter(difflin == 1))$bond_id )

cellshapes_bonds %>%
  render_frame(10) + 
  geom_polygon(aes(x_pos, y_pos, group=cell_id),  alpha=0.5, fill="blue") +
  geom_segment(aes(x=x_pos,y=y_pos,xend=next_x_pos,yend=next_y_pos,size=difflin),lineend="round", color="orange") + scale_size_continuous(limits=c(0,1),range=c(0,0.5), guide=FALSE)

# great. so now cellshapes_bonds can be plotted like that and the line thickness depend on the difflin
# now make final data
cellshapes_dropout_difflin <- cellshapes_bonds %>% filter(cell_id %in% roiHistoNoborder$cell_id)
cellshapes_dropout_difflin$dropout <- cellshapes_dropout_difflin$cell_id %in% dropout_full_noborder$cell_id
# add lineage group for testing purposes
cellshapes_dropout_difflin <- cellshapes_dropout_difflin %>% dt.merge(cells_lingroups,by="cell_id")

cellshapes_dropout_difflin %>%
  render_frame(10) + 
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=dropout),  alpha=0.65) +
  scale_fill_manual(values=c("FALSE"="darkgreen", "TRUE"="red"),guide=FALSE) + 
  #testing:
  #geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=lineage_group),  alpha=0.65) + 
  #scale_fill_gradientn(colors  = jet.colors(7), guide = FALSE) + 
  geom_segment(aes(x=x_pos,y=y_pos,xend=next_x_pos,yend=next_y_pos,size=difflin),lineend="round", color="white") + scale_size_continuous(limits=c(0,1),range=c(0,0.5), guide=FALSE)


# make movie
dir.create("lineage_redcell_stuff")
# render_movie(cellshapes_dropout_difflin, "lineage_redcell_stuff/cellshapes_dropout_difflin.mp4", list( 
#   geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=dropout),  alpha=0.65),
#   scale_fill_manual(values=c("FALSE"="darkgreen", "TRUE"="red"),guide=FALSE),
#   geom_segment(aes(x=x_pos,y=y_pos,xend=next_x_pos,yend=next_y_pos,size=difflin),lineend="round", color="white"),
#   scale_size_continuous(limits=c(0,1),range=c(0,0.5), guide=FALSE)
# )
# )

## 4) Tweak of 3. For transparency overlay. Try to make a movie with lines around the ANTERIOR NEST instead of distinct lineages
load("time/dbTablesFromParser/dbondsDB.RData")
dbondsDB_unique <- dbondsDB[!duplicated(dbondsDB[,c('bond_id')]),]
bonds_neighbours <- unique(dbondsDB %>% select(bond_id,frame))
bonds_neighbours$cell_id1 <- dbondsDB$cell_id[match(dbondsDB_unique$dbond_id[match(dbondsDB_unique$bond_id, bonds_neighbours$bond_id)], dbondsDB$dbond_id)]
#add a column to test that says the cell matching the relevant conj_dbond — this is the other cell the bond belongs to
bonds_neighbours$cell_id2 <- dbondsDB$cell_id[match(dbondsDB_unique$dbond_id[match(dbondsDB_unique$bond_id, bonds_neighbours$bond_id)], dbondsDB$conj_dbond_id)]
# add a column that says whether the two cells of the bond are in different lineages
bonds_neighbours <- cellsWithLin %>% select(cell_id, lineage_group) %>% unique() %>% rename(cell_id2 = cell_id) %>% dt.merge(bonds_neighbours,by="cell_id2",allow.cartesian=TRUE) %>% rename(lineage_group2 = lineage_group)
bonds_neighbours <- cellsWithLin %>% select(cell_id, lineage_group) %>% unique() %>% rename(cell_id1 = cell_id) %>% dt.merge(bonds_neighbours,by="cell_id1",allow.cartesian=TRUE) %>% rename(lineage_group1 = lineage_group)
bonds_neighbours$difflin <- (bonds_neighbours$cell_id1 %in% roiAnterior$cell_id & !(bonds_neighbours$cell_id2 %in% roiAnterior$cell_id)) | (bonds_neighbours$cell_id2 %in% roiAnterior$cell_id & !(bonds_neighbours$cell_id1 %in% roiAnterior$cell_id))
bonds_neighbours$difflin <- as.numeric(bonds_neighbours$difflin)

# okay so not totally useful yet. I need to manipulate cellshapes table so that it has the 'next along' vertex (circles back ground, too) as 
# another column. first count vertices for each cell in each frame
cellshapes_bonds <- cellshapes
cellshapes_bonds <- cellshapes_bonds %>% group_by(frame,cell_id) %>% summarise(nvertices = n()) %>% ungroup() %>% dt.merge(cellshapes_bonds,by=c("frame","cell_id"))
cellshapes_bonds$next_bond_order <- cellshapes_bonds$bond_order + 1 - as.numeric(cellshapes_bonds$bond_order == cellshapes_bonds$nvertices) * cellshapes_bonds$nvertices
cellshapes_bonds <- cellshapes_bonds %>% dt.merge(cellshapes_bonds %>% select(frame,cell_id,x_pos,y_pos, bond_order) %>% rename(next_bond_order = bond_order, next_x_pos = x_pos, next_y_pos = y_pos),by = c("frame","cell_id","next_bond_order")) %>% arrange(frame,cell_id,bond_order) %>% select(frame,cell_id,nvertices,x_pos,y_pos,bond_order,next_x_pos,next_y_pos,next_bond_order)
# good. now need to determine the bond name for the bond between bond_order and next_bond_order vertices

# problem HERE for movies that have rotation applied. positions have decimal places x_pos etc. 
# so load transformed_vertices instead from the SQL db, which has rotation applied. they are now floats not ints but should merge okay as they have finite decimal places I think?
transformed_vertices <- dbGetQuery(db,"select frame, vertex_id, x_pos, y_pos from vertices")
# to be better safe than sorry, truncate the decimal places of x_pos, y_pos, next_x_pos, next_y_pos within cellshapes_bonds and within transformed_vertices
transformed_vertices$x_pos <- round(transformed_vertices$x_pos,2)
transformed_vertices$y_pos <- round(transformed_vertices$y_pos,2)
cellshapes_bonds$x_pos <- round(cellshapes_bonds$x_pos,2)
cellshapes_bonds$y_pos <- round(cellshapes_bonds$y_pos,2)
cellshapes_bonds$next_x_pos <- round(cellshapes_bonds$next_x_pos,2)
cellshapes_bonds$next_y_pos <- round(cellshapes_bonds$next_y_pos,2)

cellshapes_bonds <- transformed_vertices %>% dt.merge(cellshapes_bonds,by=c("frame","x_pos","y_pos"))
cellshapes_bonds <- transformed_vertices %>% rename(next_x_pos = x_pos, next_y_pos = y_pos, next_vertex_id = vertex_id) %>% dt.merge(cellshapes_bonds,by=c("frame","next_x_pos","next_y_pos")) %>% select(frame,cell_id,nvertices,x_pos,y_pos,vertex_id,bond_order,next_x_pos,next_y_pos,next_vertex_id, next_bond_order) %>% arrange(frame,cell_id,bond_order)

dbondsDB_next <- dbondsDB
dbondsDB_next$next_vertex_id <- dbondsDB_next$vertex_id[match(dbondsDB_next$dbond_id,dbondsDB_next$conj_dbond_id)]

# ok to here

cellshapes_bonds <- dbondsDB_next %>% select(frame,vertex_id,next_vertex_id,bond_id) %>% dt.merge(cellshapes_bonds,by=c("frame","vertex_id","next_vertex_id")) %>% select(frame,cell_id,nvertices,bond_id, x_pos,y_pos,vertex_id,bond_order,next_x_pos,next_y_pos,next_vertex_id, next_bond_order) %>% arrange(frame,cell_id,bond_order)
# good. now flag whether the bond is a lineage boundary. not sure why this reduces number of elements but it does if merge. do an %in% instead
cellshapes_bonds$difflin <- as.numeric(cellshapes_bonds$bond_id %in% (bonds_neighbours %>% filter(difflin == 1))$bond_id )

cellshapes_bonds %>%
  render_frame(10) + 
  geom_polygon(aes(x_pos, y_pos, group=cell_id),  alpha=0.5, fill="blue") +
  geom_segment(aes(x=x_pos,y=y_pos,xend=next_x_pos,yend=next_y_pos,size=difflin),lineend="round", color="orange") + scale_size_continuous(limits=c(0,1),range=c(0,0.5), guide=FALSE)

# great. so now cellshapes_bonds can be plotted like that and the line thickness depend on the difflin
# now make final data
cellshapes_dropout_difflin <- cellshapes_bonds %>% filter(cell_id %in% roiAnterior$cell_id)
cellshapes_dropout_difflin$dropout <- cellshapes_dropout_difflin$cell_id %in% dropout_full_noborder$cell_id
# add lineage group for testing purposes
cellshapes_dropout_difflin <- cellshapes_dropout_difflin %>% dt.merge(cells_lingroups,by="cell_id")

cellshapes_dropout_difflin %>%
  render_frame(10) + 
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=dropout),  alpha=0.65) +
  scale_fill_manual(values=c("FALSE"="darkgreen", "TRUE"="red"),guide=FALSE) + 
  #testing:
  #geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=lineage_group),  alpha=0.65) + 
  #scale_fill_gradientn(colors  = jet.colors(7), guide = FALSE) + 
  geom_segment(aes(x=x_pos,y=y_pos,xend=next_x_pos,yend=next_y_pos,size=difflin),lineend="round", color="white") + scale_size_continuous(limits=c(0,1),range=c(0,0.5), guide=FALSE)

# make movie
dir.create("lineage_redcell_stuff")
# render_movie(cellshapes_dropout_difflin, "lineage_redcell_stuff/cellshapes_dropout_anteriorborder.mp4", list( 
#   geom_polygon(aes(x_pos, y_pos, group=cell_id, fill=dropout),  alpha=0.5),
#   scale_fill_manual(values=c("FALSE"="white", "TRUE"="red"),guide=FALSE),
#   geom_segment(aes(x=x_pos,y=y_pos,xend=next_x_pos,yend=next_y_pos,size=difflin),lineend="round", color="black",alpha=0.5),
#   scale_size_continuous(limits=c(0,1),range=c(0,0.5), guide=FALSE)
# )
# )





##### extra GS request, initial_final_areas table but not requiring to appear by division.
just_dis_by_div <- cellinfoDB  %>% filter(disappears_by == "Division") %>% select(cell_id)
initial_areas_daughters_noborder <- cellinfoDB %>% select(cell_id,first_occ) %>% rename(frame = first_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(initial_area = area) %>% rename(first_occ = frame)
# then do the final areas too
final_areas <- cellinfoDB %>% select(cell_id,last_occ) %>% rename(frame = last_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(final_area = area) %>% rename(last_occ = frame)
# merge and keep only div-div cells in noborder region
initial_areas_daughters_noborder <- initial_areas_daughters_noborder %>% dt.merge(final_areas, by = "cell_id") %>% filter(cell_id %in% just_dis_by_div$cell_id) %>% filter(cell_id %in% roiHistoNoborder$cell_id)
# mistake lol
initial_final_areas_daughters_noborder <- initial_areas_daughters_noborder
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(cellinfoDB %>% select(cell_id, left_daughter_cell_id, right_daughter_cell_id),by="cell_id")
initial_final_areas_daughters_noborder$nred <- as.numeric(initial_final_areas_daughters_noborder$left_daughter_cell_id %in% dropout_full_noborder$cell_id) + as.numeric(initial_final_areas_daughters_noborder$right_daughter_cell_id %in% dropout_full_noborder$cell_id)
# re order columns to be like before
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder[,c(1,2,4,3,5,6,7,8)]

neighbours_red <- cellinfoDB %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id, last_occ)
load("time/topochanges/cellNeighbors.RData") # has multiplicity remember
cellNeighbors <- cellNeighbors %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(neighbor_cell_id %in% roiHistoNoborder$cell_id) # only count neigbhbors in noborder as that's where red cells are defined.
neighbours_red <- neighbours_red %>% dt.merge(cellNeighbors,by="cell_id") # this gets the first neighbours for each cell

# now get the second neighbours . frame must be the same because we require neighbor_cell is a neighbor of cell at the same time second_neighbor is a neighbor of neighbor_cell. try this. CHECK AFTER
neighbours_red <- cellNeighbors %>% rename(second_neighbor = neighbor_cell_id) %>% rename(neighbor_cell_id = cell_id) %>% dt.merge(neighbours_red,by=c("neighbor_cell_id","frame"), allow.cartesian=TRUE)
neighbours_red <- neighbours_red %>% filter(cell_id != second_neighbor)
neighbours_red <- neighbours_red %>% select(cell_id,frame,last_occ,neighbor_cell_id,second_neighbor) #reorder columns
# say in 1 or 0 if neighbour and second neighbour are red
neighbours_red$neigh_red <-  as.integer(neighbours_red$neighbor_cell_id %in% dropout_full_noborder$cell_id)
neighbours_red$sec_neigh_red <-  as.integer(neighbours_red$second_neighbor %in% dropout_full_noborder$cell_id)
# now do this version of table for final frame only and do the counts. 
neighbours_red_last_frame <- neighbours_red %>% filter(last_occ == frame)
neighbours_red_last_frame <- neighbours_red_last_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]), n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1])    )

# now do version for all frames 
neighbours_red_all_frame <- neighbours_red 
neighbours_red_all_frame <- neighbours_red_all_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]), n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1])    )

#merge onto end
initial_final_areas_daughters_noborder$cell_id_merge <- initial_areas_daughters_noborder$cell_id
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(neighbours_red_last_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% rename(n_neigh_last = n_neigh, nred_neigh_last = nred_neigh, n_sec_neigh_last = n_sec_neigh, nred_sec_neigh_last = nred_sec_neigh)
# merge extra two columns
initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(addedcols %>% rename(cell_id_merge = cell_id, occ_last = occupancy, occ_last_red = occupancy_red), by = "cell_id_merge" )

initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% dt.merge(neighbours_red_all_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )

initial_final_areas_daughters_noborder <- initial_final_areas_daughters_noborder %>% select(-cell_id_merge)

# CSV of this :
write.csv(initial_final_areas_daughters_noborder, file = "lineage_redcell_stuff/initial_final_areas_daughters_noborder_added_linocc_just_disbydiv.csv")
