### full anterior version of this script. Note that the nred variable should now be set to NA
### since defining red cells for the full anterior nest is problematic.

## lineage_red_cells stuff. Looking for correlations within lineages of red-cell creation.
## 1) make a version of initial_final or whatever with two extra columns: the number of cells in the lineage at the last frame,
## and the number of red cells in the lineage at the last frame.
## 2) do something clever like a colour map of lineages ranked by first-red-cell on one axis, time on other axis, colour as fraction of red cells in the lineage.
## 3) WHITE LINES around lineages on a red cell movie
## 4) BLACK LINES AROUND ANTERIOR NEST FOR TRANSPARENCY STUFF. RUN 1 FIRST THOUGH.

dir.create("lineage_redcell_stuff")
load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")

load("time/roi_BT/SOP_cell_id.RData")
dropout_full_noborder <- cellinfoDB %>% filter(disappears_by == "Unclassified") %>% select(cell_id,first_occ) %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(!(cell_id %in% SOP_cell_id$cell_id))

## 1) make some data that for each lineage group at each frame has the number of cells and the number of red cells. 
# plain lineage occupancy at each frame, and red occupancy at same time
lineage_occs <- cellsWithLin %>% filter(cell_id %in% roiAnterior$cell_id) %>% select(cell_id,frame,lineage_group) %>% unique()
# make lg numerical
lineage_occs$lineage_group <- as.numeric(gsub("lg_","", lineage_occs$lineage_group))
# count occupancy
lineage_occs <- lineage_occs %>% group_by(lineage_group,frame) %>% summarise(occupancy = n(), occupancy_red = sum(cell_id %in% dropout_full_noborder$cell_id))

# make list of each cell's lineage group
cells_lingroups <- cellsWithLin %>% select(cell_id, lineage_group)
cells_lingroups$lineage_group <- as.numeric(gsub("lg_","", cells_lingroups$lineage_group))
cells_lingroups <- cells_lingroups %>% unique()

# get last_occ of each cell in cells_lingroups
cells_lingroups <- cellinfoDB %>% select(cell_id,last_occ) %>% dt.merge(cells_lingroups,by="cell_id")
addedcols <- cells_lingroups %>% dt.merge(lineage_occs,by="lineage_group",allow.cartesian=TRUE) %>% filter(frame == last_occ)
addedcols <- addedcols %>% select(cell_id, occupancy, occupancy_red)

# now can just bolt on the code from before from the standard core code about initial_final data (whole neighbourship NOT required to stay in)
# initial final and red cell nred data etc. in noborder. this is only div-div cells remember.
app_dis_by_div <- cellinfoDB %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% select(cell_id)
initial_areas_daughters_anterior <- cellinfoDB %>% select(cell_id,first_occ) %>% rename(frame = first_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(initial_area = area) %>% rename(first_occ = frame)
# then do the final areas too
final_areas <- cellinfoDB %>% select(cell_id,last_occ) %>% rename(frame = last_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(final_area = area) %>% rename(last_occ = frame)
# merge and keep only div-div cells in anterior region
initial_areas_daughters_anterior <- initial_areas_daughters_anterior %>% dt.merge(final_areas, by = "cell_id") %>% filter(cell_id %in% app_dis_by_div$cell_id) %>% filter(cell_id %in% roiAnterior$cell_id)
# mistake lol
initial_final_areas_daughters_anterior <- initial_areas_daughters_anterior
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% dt.merge(cellinfoDB %>% select(cell_id, left_daughter_cell_id, right_daughter_cell_id),by="cell_id")
initial_final_areas_daughters_anterior$nred <- as.numeric(initial_final_areas_daughters_anterior$left_daughter_cell_id %in% dropout_full_noborder$cell_id) + as.numeric(initial_final_areas_daughters_anterior$right_daughter_cell_id %in% dropout_full_noborder$cell_id)
# re order columns to be like before
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior[,c(1,2,4,3,5,6,7,8)]

neighbours_red <- cellinfoDB %>% filter(disappears_by == "Division") %>% filter(appears_by == "Division") %>% filter(cell_id %in% roiAnterior$cell_id) %>% select(cell_id, last_occ)
load("time/topochanges/cellNeighbors.RData") # has multiplicity remember
cellNeighbors <- cellNeighbors %>% filter(cell_id %in% roiAnterior$cell_id) %>% filter(neighbor_cell_id %in% roiAnterior$cell_id) # only count neigbhbors in anterior as that's where red cells are defined.
neighbours_red <- neighbours_red %>% dt.merge(cellNeighbors,by="cell_id") # this gets the first neighbours for each cell

# now get the second neighbours . frame must be the same because we require neighbor_cell is a neighbor of cell at the same time second_neighbor is a neighbor of neighbor_cell. try this. CHECK AFTER
neighbours_red <- cellNeighbors %>% rename(second_neighbor = neighbor_cell_id) %>% rename(neighbor_cell_id = cell_id) %>% dt.merge(neighbours_red,by=c("neighbor_cell_id","frame"), allow.cartesian=TRUE)
neighbours_red <- neighbours_red %>% filter(cell_id != second_neighbor)
neighbours_red <- neighbours_red %>% select(cell_id,frame,last_occ,neighbor_cell_id,second_neighbor) #reorder columns
# say in 1 or 0 if neighbour and second neighbour are red
neighbours_red$neigh_red <-  as.integer(neighbours_red$neighbor_cell_id %in% dropout_full_noborder$cell_id)
neighbours_red$sec_neigh_red <-  as.integer(neighbours_red$second_neighbor %in% dropout_full_noborder$cell_id)
# now do this version of table for final frame only and do the counts. 
neighbours_red_last_frame <- neighbours_red %>% filter(last_occ == frame)
neighbours_red_last_frame <- neighbours_red_last_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]), n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1])    )

# now do version for all frames 
neighbours_red_all_frame <- neighbours_red 
neighbours_red_all_frame <- neighbours_red_all_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]), n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1])    )

#merge onto end
initial_final_areas_daughters_anterior$cell_id_merge <- initial_areas_daughters_anterior$cell_id
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% dt.merge(neighbours_red_last_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% rename(n_neigh_last = n_neigh, nred_neigh_last = nred_neigh, n_sec_neigh_last = n_sec_neigh, nred_sec_neigh_last = nred_sec_neigh)
# merge extra two columns
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% dt.merge(addedcols %>% rename(cell_id_merge = cell_id, occ_last = occupancy, occ_last_red = occupancy_red), by = "cell_id_merge" )

initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% dt.merge(neighbours_red_all_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )

initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% select(-cell_id_merge)

## make all nred data NA

initial_final_areas_daughters_anterior$nred <- NA
initial_final_areas_daughters_anterior$nred_neigh_last <- NA
initial_final_areas_daughters_anterior$nred_sec_neigh_last <- NA
initial_final_areas_daughters_anterior$occ_last_red <- NA
initial_final_areas_daughters_anterior$occ_last_red <- NA
initial_final_areas_daughters_anterior$nred_neigh <- NA
initial_final_areas_daughters_anterior$nred_sec_neigh <- NA

# CSV of this :
write.csv(initial_final_areas_daughters_anterior, file = "lineage_redcell_stuff/initial_final_areas_daughters_anterior_added_linocc.csv")


### anterior
##### extra GS request, initial_final_areas table but not requiring to appear by division.
just_dis_by_div <- cellinfoDB  %>% filter(disappears_by == "Division") %>% select(cell_id)
initial_areas_daughters_anterior <- cellinfoDB %>% select(cell_id,first_occ) %>% rename(frame = first_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(initial_area = area) %>% rename(first_occ = frame)
# then do the final areas too
final_areas <- cellinfoDB %>% select(cell_id,last_occ) %>% rename(frame = last_occ) %>% dt.merge(cellsDB %>% select(cell_id,frame,area), by = c("frame","cell_id") ) %>% rename(final_area = area) %>% rename(last_occ = frame)
# merge and keep only div-div cells in anterior region
initial_areas_daughters_anterior <- initial_areas_daughters_anterior %>% dt.merge(final_areas, by = "cell_id") %>% filter(cell_id %in% just_dis_by_div$cell_id) %>% filter(cell_id %in% roiAnterior$cell_id)
# mistake lol
initial_final_areas_daughters_anterior <- initial_areas_daughters_anterior
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% dt.merge(cellinfoDB %>% select(cell_id, left_daughter_cell_id, right_daughter_cell_id),by="cell_id")
initial_final_areas_daughters_anterior$nred <- as.numeric(initial_final_areas_daughters_anterior$left_daughter_cell_id %in% dropout_full_noborder$cell_id) + as.numeric(initial_final_areas_daughters_anterior$right_daughter_cell_id %in% dropout_full_noborder$cell_id)
# re order columns to be like before
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior[,c(1,2,4,3,5,6,7,8)]

neighbours_red <- cellinfoDB %>% filter(disappears_by == "Division") %>% filter(cell_id %in% roiAnterior$cell_id) %>% select(cell_id, last_occ)
load("time/topochanges/cellNeighbors.RData") # has multiplicity remember
cellNeighbors <- cellNeighbors %>% filter(cell_id %in% roiAnterior$cell_id) %>% filter(neighbor_cell_id %in% roiAnterior$cell_id) # only count neigbhbors in anterior as that's where red cells are defined.
neighbours_red <- neighbours_red %>% dt.merge(cellNeighbors,by="cell_id") # this gets the first neighbours for each cell

# now get the second neighbours . frame must be the same because we require neighbor_cell is a neighbor of cell at the same time second_neighbor is a neighbor of neighbor_cell. try this. CHECK AFTER
neighbours_red <- cellNeighbors %>% rename(second_neighbor = neighbor_cell_id) %>% rename(neighbor_cell_id = cell_id) %>% dt.merge(neighbours_red,by=c("neighbor_cell_id","frame"), allow.cartesian=TRUE)
neighbours_red <- neighbours_red %>% filter(cell_id != second_neighbor)
neighbours_red <- neighbours_red %>% select(cell_id,frame,last_occ,neighbor_cell_id,second_neighbor) #reorder columns
# say in 1 or 0 if neighbour and second neighbour are red
neighbours_red$neigh_red <-  as.integer(neighbours_red$neighbor_cell_id %in% dropout_full_noborder$cell_id)
neighbours_red$sec_neigh_red <-  as.integer(neighbours_red$second_neighbor %in% dropout_full_noborder$cell_id)
# now do this version of table for final frame only and do the counts. 
neighbours_red_last_frame <- neighbours_red %>% filter(last_occ == frame)
neighbours_red_last_frame <- neighbours_red_last_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]), n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1])    )

# now do version for all frames 
neighbours_red_all_frame <- neighbours_red 
neighbours_red_all_frame <- neighbours_red_all_frame %>% group_by(cell_id) %>% summarise(n_neigh = n_distinct(neighbor_cell_id), nred_neigh = uniqueN(neighbor_cell_id[neigh_red == 1]), n_sec_neigh = n_distinct(second_neighbor), nred_sec_neigh = uniqueN(second_neighbor[sec_neigh_red == 1])    )

#merge onto end
initial_final_areas_daughters_anterior$cell_id_merge <- initial_areas_daughters_anterior$cell_id
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% dt.merge(neighbours_red_last_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% rename(n_neigh_last = n_neigh, nred_neigh_last = nred_neigh, n_sec_neigh_last = n_sec_neigh, nred_sec_neigh_last = nred_sec_neigh)
# merge extra two columns
initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% dt.merge(addedcols %>% rename(cell_id_merge = cell_id, occ_last = occupancy, occ_last_red = occupancy_red), by = "cell_id_merge" )

initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% dt.merge(neighbours_red_all_frame %>% rename(cell_id_merge = cell_id), by = "cell_id_merge" )

initial_final_areas_daughters_anterior <- initial_final_areas_daughters_anterior %>% select(-cell_id_merge)

## make all nred data NA

initial_final_areas_daughters_anterior$nred <- NA
initial_final_areas_daughters_anterior$nred_neigh_last <- NA
initial_final_areas_daughters_anterior$nred_sec_neigh_last <- NA
initial_final_areas_daughters_anterior$occ_last_red <- NA
initial_final_areas_daughters_anterior$occ_last_red <- NA
initial_final_areas_daughters_anterior$nred_neigh <- NA
initial_final_areas_daughters_anterior$nred_sec_neigh <- NA

# CSV of this :
write.csv(initial_final_areas_daughters_anterior, file = "lineage_redcell_stuff/initial_final_areas_daughters_anterior_added_linocc_just_disbydiv.csv")
