## THIS IS VERY IMPORTANT
## I have a modified version of UserRoiTracking.R which creates a file allblackHoles inside roi_bt
## This script uses that file to make a modification to the lgRoiSmoothed data.
## if any cell has been part of a black hole (a non-largest connected component of non-border cells)
## then its entire lineage is removed from the whole_tissue/noborder region. 

load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/allblackHoles.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")

### Quick check after GS identifies that in WT4, cell 12589 is weird: 'generation 0' and yet appears by Division and is in noborder.
### find out how many others have this in each WT, in an automated way.
strangecells_anywhere <- cellinfoDB %>% filter(appears_by == "Division" & generation == 0)
strangecells_noborder <- strangecells_anywhere %>% filter(cell_id %in% roiHistoNoborder$cell_id)


#HA1 manual modification - excluding two LECs that get absorbed inside anterior roi. 11274425. 3180699 for HA1. 5797993 1578114
# cut <- cellinfoDB %>% filter(tissue_analyzer_group_id == 5797993 | tissue_analyzer_group_id == 1578114) %>% select(cell_id)
# #deconstruct and reconstruct roicellsBT.
# roiCellsBT_notanterior <- roiCellsBT %>% filter(roi != "anterior")
# roiCellsBT_anterior <- roiCellsBT %>% filter(roi == "anterior")
# roiCellsBT_anterior <- roiCellsBT_anterior %>% filter(!(cell_id %in% cut$cell_id))
# roiCellsBT <- rbind(roiCellsBT_anterior,roiCellsBT_notanterior)
# save(roiCellsBT,file = "time/roi_bt/roiCellsBT.RData")

## The below was the 20th July attempt to fix this. But it does not guarantee contiguous noborder region so still isn't right.

# blackholelineages <- cellinfoDB %>% select(cell_id,lineage_group) %>% dt.merge(allblackHoles %>% rename(cell_id = blackHoles),by="cell_id") %>% select(lineage_group) %>% unique()
# 
#fixed <- cellinfoDB %>% select(cell_id,lineage_group) %>% dt.merge(lgRoiSmoothed,by="cell_id") %>% filter(!(lineage_group %in% blackholelineages$lineage_group)) %>% select(-lineage_group)
# # inspect /compare the fixed and lgRoiSmoothed here before replacing...
# # ...
# # then
# test <- cellinfoDB %>% filter(cell_id %in% lgRoiSmoothed$cell_id) %>% filter(!(cell_id %in% fixed$cell_id))
# 
# 
#lgRoiSmoothed <- fixed
# 
# 
# 
# save(lgRoiSmoothed,file="time/roi_bt/lgRoiSmoothed_FIXED.RData")
# 
# ## Then go into the folder, save the original lgRoiSmoothed but use this fixed one for anything to do with noborder!
# 
# 
# ## Trying to see where the black hole lineages are in TSC1 revised. Why is this procedure leading to the noborder fixed being non contiguous.
# blackholelineagecells <- cellinfoDB %>% filter(lineage_group %in% blackholelineages$lineage_group) %>% select(cell_id)
# 
# render_movie(cellshapes %>% filter(cell_id %in% blackholelineagecells$cell_id), "blackholelineagecells.mp4", list(
#   geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
#   scale_fill_identity(guide = "none")
# ))

## Now trying another approach. Since we are having issues with contiguity anyway, let's just try 
## to find the lineages which you can see the entirety of the lineage for the whole movie.
## If the tracking was perfect (it isn't hmm) that would mean, only lineages for which 
## all cells appear by unclassified or division, and disappear by apoptosis or division or unclassified,
## AND whose time visible is equal to their last_occ - first_occ
## so I should make the *opposite* of that list of cells and start from there. 

cells_exclude <- cellinfoDB %>% select(cell_id,appears_by,disappears_by,first_occ,last_occ) 
visibility <- cellsDB %>% select(frame,cell_id) %>% group_by(cell_id) %>% summarise(frames_visible = n())
cells_exclude <- cells_exclude %>% dt.merge(visibility,by="cell_id")

# now filter for any one of a number of conditions, only one is required to make the cell excludeable.
# including that the cell is cell_id = 10000.
cells_exclude <- cells_exclude %>% filter(cell_id == 10000 | appears_by == "SegErrAppearance" | appears_by == "MovedIntoMask" | disappears_by == "MovesOutOfMask" | frames_visible != last_occ - first_occ + 1)
lineages_exclude <- cellinfoDB %>% select(cell_id,lineage_group) %>% dt.merge(cells_exclude,by="cell_id") %>% select(lineage_group) %>% unique()
cells_all_exclude <- cellinfoDB %>% filter(lineage_group %in% lineages_exclude$lineage_group) %>% select(cell_id)

doublecheck <- roiAnterior %>% filter(!(cell_id %in% cells_all_exclude$cell_id))

triplecheck <- lgRoiSmoothed %>% dt.merge(doublecheck,by="cell_id")

# second pass through : check no of the cells we're interested in are in the posterior as weirdly seemed to happen in WT2. should be zero. 
check <- roiBothNests %>% filter(roi == "posterior") %>% filter(cell_id %in% triplecheck$cell_id)
# in WT2 it's one cell. why.
check <- roiBothNests %>% filter(roi == "posterior") %>% filter(cell_id %in% roiAnterior$cell_id)
# one cell is in both posterior and anterior rois. 
check <- check %>% dt.merge(cellsDB, by ="cell_id")
check <- check %>% dt.merge(cellinfoDB, by = "cell_id")
# it seems its just because that cell gets entirely surrounded by cells from anterior at some point so TM calls it both. fine. 

# define testing the new noborder by taking anterior cells and removing the ones in the cells_all_exclude list
new_noborder <- roiAnterior %>% filter(!(cell_id %in% cells_all_exclude$cell_id))
cellshapes_new_noborder <- cellshapes %>% filter(cell_id %in% new_noborder$cell_id)
render_movie(cellshapes_new_noborder, "cellshapes_new_noborder.mp4", list(
geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
  scale_fill_identity(guide = "none")
))

# looks alright. now save it as a fake lgRoiSmoothed which we will later rename to lgRoiSmoothed to generate shear data etc

lgRoiSmoothed <- new_noborder
save(lgRoiSmoothed,file = "time/roi_bt/lgRoiSmoothed_new_noborder.RData")



# STOP HERE UNLESS INVESTIGATING FURTHER
# %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# STOP HERE UNLESS INVESTIGATING FURTHER

# running sm shear_calculate then pop over to kernSize1_data for a bit to run the kS1 shear calculations. Then try to compare and see how it works.
# run ks1 data in here

# then look at the results. first let's see what the tensors are all called.
# sheartypes <- shearData %>% select(tensor) %>% unique()
# 15 different types. so what do I add together to try and build the total? look in the R script responsible which is named CalculateShearContributions.R, and the files that it calls within too. 
# the file that describes each tensor is ShearByCellEvents2.R. Read it...

# try to at least find a word-based name for each of these. 
# 1
# cagc -- CELL AREA GROWTH CORRELATION
# 2
# CEwithCT -- combine corotational term with CE
# 3
# correlationEffects -- combination cagc_xx+crc_xx
# 4
# crc -- cell rotation correlation 
# 5
# ct -- corotational term 
# 6
# deltaCheck -- Check that dQtot is equal to Nu (symmetric traceless part of Tu describing total shear) where dqtot_xx=cecr_xx + ct_xx + cagc_xx + crc_xx,  deltaCheck_xx = nu_xx - (dqtot_xx),
# 7
# dqtot -- dqtot_xx=cecr_xx + ct_xx + cagc_xx + crc_xx
# 8
# nu -- starts from: "Fine-grained total shear: Let's define Tu, the affine transformation that describes deformation
#  calculate matrix product component wise and get norm and angle of the symmetric traceless part (nematic) of Tu " and then 
#                nu_xx=0.5*(tu_xx-tu_yy),
# nu_xy=0.5*(tu_xy+tu_yx), # also in of diagonal of whole symmetric part
# 9
# Q -- not clear. maybe it's like the overall or something?
# 10
# ShearCD -- Calculate CD shear contribution between I3 and tp1
# 11
# ShearCE -- Calculate coarse grained cell elongation changes (triangles) between frame t and t+1
# 12
# ShearT1 -- ## Calculate T1 shear contribution shear between I2 and I3
# 13
# ShearT2 -- calculate shear caused by cell death 
# 14
# sumContrib -- a sum of certain things. 
# correlationEffects_xx=cagc_xx+crc_xx,
# correlationEffects_xy=cagc_xy+crc_xy,
# CEwithCT_xx=ShearCE_xx+ct_xx,
# CEwithCT_xy=ShearCE_xy+ct_xy,
# sumContrib_xx=correlationEffects_xx+CEwithCT_xx+ShearT1_xx+ShearT2_xx+ShearCD_xx,
# sumContrib_xy=correlationEffects_xy+CEwithCT_xy+ShearT1_xy+ShearT2_xy+ShearCD_xy)
# 15
# u
# Avg other Tu components to later extract whole symmetric part: u_xx, u_yy, 0.5*(u_xy+u_yx), 0.5*(u_xx-u_yy)
# Note: the displacement gradient tensor is u_ij= Tu_ji - delta_ij, see Matthias'notes

## SO. What is the relevant comparison of things? because dqtot is itself constructed from other things. so perhaps deltacheck is key. since that seems likely from above? 
## line 166...
## combine the different intermediate steps into the 4 terms that describe total shear:
# cell elongation change rate notopo (cecr), corotational term (ct), cell area growth correlation (cagc), cell rotation correlation (crc)
# Of note, cecr = dQ(t, tp1) + dQ_CD + dQ_T1/T2 that we will compute later, see below
# avgDeltaQtot2 <- with(avgDeltaQtot, data.frame(
#   cecr_xx = Q_xx.i2 - Q_xx.i1,
#   cecr_xy = Q_xy.i2 - Q_xy.i1,
#   
#   ct_xx = ThetaU * (Q_xy.i1 + Q_xy.ti2),
#   ct_xy = -1*ThetaU * (Q_xx.i1 + Q_xx.ti2),
#   
#   cagc_xx = Q_xx.ti2 - QxxExp2S/Exp2S,
#   cagc_xy = Q_xy.ti2 - QxyExp2S/Exp2S,
#   
#   crc_xx = QxyThetaU - ThetaU*(Q_xy.i1 + Q_xy.ti2), # partially cancels out with corotational term
#   crc_xy = -1*(QxxThetaU - ThetaU*(Q_xx.i1 + Q_xx.ti2)),
#   nu_xx, nu_xy, frame, u_xx, u_xy, u_yx, u_yy
# ))
# 
# # Note: avgDeltaQtot (pure shear) and avgDeltaQtot2 (+correlations), where frame refers to time t of the interval [t,t+1]
# 
# 
# ####################################################################################################
# ## Check that dQtot is equal to Nu (symmetric traceless part of Tu describing total shear)
# avgDeltaQtot2 <- mutate(avgDeltaQtot2,
#                         ## calucate difference of Nu and compare it to the sum
#                         dqtot_xx=cecr_xx + ct_xx + cagc_xx + crc_xx,
#                         dqtot_xy=cecr_xy + ct_xy + cagc_xy + crc_xy,
#                         deltaCheck_xx = nu_xx - (dqtot_xx),
#                         deltaCheck_xy = nu_xy - (dqtot_xy)
# )

## Trying to look through the file at places where areaweightedmean is used, as this should indicate quantities which are TOTAL for that whole roi as it were. 
## See EVERNOTE.


## EXTRA STUFF BELOW...
## 'TEST FACTOR APPROACH' 
## trying to set up a false set of say four cells which gain an extra region of cells and then see what happens. 
## here are the tissue analyzer group IDs, and the frame is frame 20. i will define two regions that are discontiguous in frame 20 then aren't after. 
# 8405182 7082114 2652265 8694964 (THAT IS ONE discontiguous bit of the fake roi i will make)
# 2nd: 8416391 4463741 7391412 1600652

# make an roi out of whatever are the cell IDs in frame 20 for these group IDs.
# test <- cellsDB %>% select(frame,cell_id)
# test <- cellinfoDB %>% select(cell_id,tissue_analyzer_group_id) %>% dt.merge(test,by="cell_id")
# test <- test %>% filter(frame == 20)
# test <- test %>% filter(tissue_analyzer_group_id %in% c(8405182, 7082114, 2652265, 8694964, 8416391, 4463741, 7391412, 1600652))
# test <- test %>% select(cell_id)
# test$roi <- "test_roi"

# save(test,file="time/roi_bt/test_roi.RData")
# then run shear_calculate on this having renamed it to lgRoiSmoothed. 
# done
# now get kernsize 1 shear data for this roi.
# shearData <- multi_db_query(movieDirs, mqf_cg_roi_rate_shear, "test_roi", kernSize = 1)

# need to determine what frame to look for effects of merger of zones in. 20 or 21? to do so maybe look for a division event in this ROI. render a movie of the roi
# first then of divisions
# cellshapes_test_roi <- cellshapes %>% filter(cell_id %in% test$cell_id)
# render_movie(cellshapes_test_roi, "cellshapes_test_roi.mp4", list( 
#   # geometrical layer to represent cells as polygons
#   geom_polygon(aes(x_pos, y_pos, group=cell_id), alpha=0.75, fill = "green")
# ))
# # no looking for a division won't help because i only defined the solo cell IDs so they will exit the ROI upon division. 
# # look at frames 20 and 21 in shear data. 
# shear2021 <- shearData %>% filter(frame == 19 | frame == 20 | frame == 21)
# 
# # still struggling to understand impact on shear data as I can't tell what quantity to compare to what other. delta check etc. god.
# ## ANYWAY look now at ISOTROPIC instead. at about 0.4 hr (check precise frame) this fake test roi goes from 1 to 3 cells, by two cells becoming attached
# # though their mother wasn't in. so ideal to see where it goes in the isotropic decomp.
# cellnumber_test_roi<- cellsDB %>% filter(cell_id %in% test$cell_id) %>% select(cell_id,frame) %>% group_by(frame) %>% summarise(n = n())
# isoContrib <- multi_db_query(movieDirs, mqf_cg_roi_rate_isotropic_contrib, c("test_roi"),kernSize = 1)
# # so from frame 10 to 11 the cell number increases from 1 to 3. how is this handled? look at isoContrib. 
# inspect <- isoContrib %>% filter(frame == 10 | frame == 11 | frame == 12)
# 
# 
# # for the 'new noborder definition' based on all fully trackable lineages, check that total shear equals sumContrib all the time.
isoContrib <- multi_db_query(movieDirs, mqf_cg_roi_rate_isotropic_contrib, c("anterior"),kernSize = 1)
check <- isoContrib %>% filter(isoContrib == "sumContrib") %>% dt.merge(isoContrib %>% filter(isoContrib == "tissue_area"), by = "frame")
check$reldiff <- 2*abs(check$value.ma.x - check$value.ma.y)/abs(check$value.ma.x + check$value.ma.y)
# maximum diff is 15%. wonder why it can even get that high really. plot as fn of frame
# cellarea
myplot <- ggplot(check, aes(frame, reldiff)) +
  geom_line(size = 2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("abs rel diff tissue_area vs sumContrib"))) +
  scale_y_continuous(limits = c(0,NA))
pdf("new_noborder_tissue_area_vs_sumContrib.pdf")
print(myplot)
dev.off()


## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% TESTING ISOTROPIC DECOMPOSITION FOR NEW NOBORER (all fully trackable lineages)
## as suggested by GS 26 July 2019.

# Ok yes, but so to check this I suggest to start from the simple, easy relation above A=Na. If it satisfied (at is should) then it leads to the decomposition
# 1/A dA/dt = 1/N dN/dt + 1/a da/dt.
# which should also be satisfied. And one can make the connection with the general decomposition with kd-ka=1/N dN/dt. So I am suggesting to calculate A, N, a, verify the relation A=Na, then plot the 3 contributions, 1/A dA/dt; 1/N dN/dt, 1/a da/dt, and compare with the current output for changes in tissue area, division+extrusion, and avg cell area, and one should be able then to find what fits and what does not fit.
# Best,
# Guillaume

# I am testing this out for the all fully trackable lineages (anterior) definition of noborder. 

# the code in mqf_cg_roi_rate_isotropic_contrib seems to do precisely what Guillaume says here. 
# except I guess that it relies on division and apoptosis, not actual cell number change which could include others. 
# but I thought I excluded segerrappearance and so on from this ROI anyway. Hmm. 

# so try to manually replicate the code that determines if A = aN and then the implied time thing (only exact for infinitesimal time difference) 1/A dA / dt etc. 
cellnumber_noborder <- cellsDB %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,frame) %>% group_by(frame) %>% summarise(n = n())
totalarea_noborder <- cellsDB %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% select(cell_id,frame,area) %>% group_by(frame) %>% summarise(total_area = sum(area))
# can manually calculate the avg area here to compare with the mqf version.
avgarea_noborder <- cellnumber_noborder %>% dt.merge(totalarea_noborder,by="frame")
avgarea_noborder$avg <- avgarea_noborder$total_area / avgarea_noborder$n

# compare mqf version
automatic_avgarea_noborder <- mqf_cg_roi_cell_area(movieDir, rois="anterior")
compare_avgarea_noborder <- automatic_avgarea_noborder %>% dt.merge(avgarea_noborder,by="frame")
compare_avgarea_noborder$diff <- abs(compare_avgarea_noborder$area.avg - compare_avgarea_noborder$avg)

# precisely match.
# to look at differences between frames, we must compare frame t with frame tp1 ie t plus 1, the next after. 
dtcheck <- compare_avgarea_noborder %>% select(frame,total_area,avg,n)
dtcheck_tp1 <- dtcheck %>% mutate(frame = frame - 1)
dtcheck_tp1 <- dtcheck_tp1 %>% rename(total_area_tp1 = total_area,avg_tp1 = avg, n_tp1= n)
dtcheck <- dtcheck %>% dt.merge(dtcheck_tp1,by="frame")

# now check that 1/A dA/dt = 1/n dn/dt + 1/a da/dt here. GS says that is implied by A = n a but maybe that isn't true for finite time intervals I guess.
dtcheck$dAdtnorm <- (dtcheck$total_area_tp1 - dtcheck$total_area)/(dtcheck$total_area * (2.5/60))
dtcheck$dndtnorm <- (dtcheck$n_tp1 - dtcheck$n)/(dtcheck$n * (2.5/60))
dtcheck$dadtnorm <- (dtcheck$avg_tp1 - dtcheck$avg)/(dtcheck$avg * (2.5/60))
dtcheck$sumdadn <- dtcheck$dndtnorm + dtcheck$dadtnorm
dtcheck$reldiff <- 2*abs(dtcheck$dAdtnorm - dtcheck$sumdadn)/abs(dtcheck$dAdtnorm + dtcheck$sumdadn)

# now could rbind this with 'check' which is the difference between the sumContrib and total_area to see what happens plot on same graph.
# having to shift alignment by one frame, bit annoying. 
plotchecks <- check %>% select(frame,reldiff) 
plotchecks <- plotchecks %>% mutate(frame = frame - 1)
plotchecks$series <- "auto"
plotchecks <- dtcheck %>% select(frame,reldiff) %>% mutate(series = "manual") %>% rbind(plotchecks)
# plot on same graph. 
myplot <- ggplot(plotchecks, aes(frame, reldiff,color = series)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("diff between dAdtnorm and sumdadn in auto and manual"))) 
pdf("new_noborder_dAdtnorm_vs_sumdadn_auto_manual.pdf")
print(myplot)
dev.off()

## OKAY. So this verifies that manually doing the decomposition into A, n a gives the same result as comparing total_area and sumContrib, for this new noborder ROI.
## the magnitude of error can be quite big strangely. but at least it shows that for this new noborder region, division and apoptosis account for the 
## same thing as dn/dt does.

## but now I need to do the cumulative add up. so that is by taking logs etc. use dtcheck for this. merge to get initial values of A, n, a.
dtcheckframe0 <- dtcheck %>% filter(frame == 0) %>% select(total_area,avg,n) %>% rename(total_area0 = total_area, avg0 = avg, n0 = n)
dtcheckwithframe0 <- merge(dtcheck,dtcheckframe0,all.x=TRUE)
dtcheckwithframe0$lnAoverA0 <- log(dtcheckwithframe0$total_area/ dtcheckwithframe0$total_area0)
dtcheckwithframe0$lnaovera0 <- log(dtcheckwithframe0$avg/dtcheckwithframe0$avg0)
dtcheckwithframe0$lnnovern0 <- log(dtcheckwithframe0$n/ dtcheckwithframe0$n0)
dtcheckwithframe0 <- dtcheckwithframe0 %>% select(frame,lnAoverA0,lnaovera0,lnnovern0)
dtcheckwithframe0$sumlndadn <- dtcheckwithframe0$lnaovera0 + dtcheckwithframe0$lnnovern0
dtcheckwithframe0$reldiff <- 2*abs(dtcheckwithframe0$lnAoverA0 - dtcheckwithframe0$sumlndadn)/abs(dtcheckwithframe0$lnAoverA0  + dtcheckwithframe0$sumlndadn)
myplot <- ggplot(dtcheckwithframe0, aes(frame, reldiff)) +
  geom_line(size = 1)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("reldiff between ln(A/A0) vs ln(a/a0) + ln(n/n0)"))) 
pdf("new_noborder_lndA_lnda_lnn_check.pdf")
print(myplot)
dev.off()

## the ln-based check is satisfied as it must be for the 'manual' version where I directly counted cell number changes.
## since the manual version agrees with the auto version for the ROI that just summed division and extrusion, the auto works too.
## but note that the isoContrib cumulative sum in tissue miner is not done by ln's but by integration of the finite-time data. 
## So here, do a comparison for the total tissue_area term relative to the ln(A/A0) thing. 
# go into the ks1 script and generate kernSize = 1 avgisodefcum.
# keep in the tissue_area Contrib for this. 
checkagainstln <- avgIsoDefCum %>% filter(isoContrib == "tissue_area")
# there may be a one frame offset between the things I'm comparing here, but don't worry too much. Try just rbinding and comparing.
checkagainstln$frame <- round(checkagainstln$dev_time/(2.5/60))
integralvsln <- checkagainstln %>% ungroup()  %>% select(frame,cumsum.avg) %>% rename(cumsum = cumsum.avg) %>% mutate(series = "integral") %>%
  rbind(dtcheckwithframe0 %>% ungroup() %>% select(frame,lnAoverA0) %>% rename(cumsum = lnAoverA0) %>% mutate(series ="ln"))
# then plot 
myplot <- ggplot(integralvsln, aes(frame, cumsum,color = series)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("cumsum integral vs explicit ln(A/A0) for tissue_area term"))) 
pdf("cumsum_integral_vs_explicit_lnAoverA0_tissue_area.pdf")
print(myplot)
dev.off()

# %%%%%%%%%%% do the same for the cell_area contribution
checkagainstln <- avgIsoDefCum %>% filter(isoContrib == "cell_area")
# there may be a one frame offset between the things I'm comparing here, but don't worry too much. Try just rbinding and comparing.
checkagainstln$frame <- round(checkagainstln$dev_time/(2.5/60))
integralvsln <- checkagainstln %>% ungroup()  %>% select(frame,cumsum.avg) %>% rename(cumsum = cumsum.avg) %>% mutate(series = "integral") %>%
  rbind(dtcheckwithframe0 %>% ungroup() %>% select(frame,lnaovera0) %>% rename(cumsum = lnaovera0) %>% mutate(series ="ln"))
# then plot 
myplot <- ggplot(integralvsln, aes(frame, cumsum,color = series)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("cumsum integral vs explicit ln(a/a0) for cell_area term"))) 
pdf("cumsum_integral_vs_explicit_lnaovera0_cell_area.pdf")
print(myplot)
dev.off()

# %%%%%%%%%%%%% do the same for the number, checking the sum of division + extrusion vs the ln(n/n0) stuff.
checkagainstln <- avgIsoDefCum %>% filter(isoContrib == "division")
checkagainstln$frame <- round(checkagainstln$dev_time/(2.5/60))
checkagainstln1 <- avgIsoDefCum %>% filter(isoContrib == "extrusion")
checkagainstln1$frame <- round(checkagainstln1$dev_time/(2.5/60))
checkagainstln <- checkagainstln %>% dt.merge(checkagainstln1,by="frame")
checkagainstln$cumsum.avg <- checkagainstln$cumsum.avg.x + checkagainstln$cumsum.avg.y

integralvsln <- checkagainstln %>% ungroup() %>% select(frame,cumsum.avg) %>% rename(cumsum = cumsum.avg) %>% mutate(series = "integral") %>%
  rbind(dtcheckwithframe0 %>% ungroup() %>% select(frame,lnnovern0) %>% rename(cumsum = lnnovern0) %>% mutate(series ="ln"))
# then plot 
myplot <- ggplot(integralvsln, aes(frame, cumsum,color = series)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("cumsum integral vs explicit ln(n/n0) for division+extrusion vs plain n term"))) 
pdf("cumsum_integral_vs_explicit_lnnovern0_cell_number.pdf")
print(myplot)
dev.off()

## Now look at full sheardata for this new noborder ROI. Still don't know what to add to what to compare sum. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## Go into the KS1 script again and get the shear data to have a look at it. 

## HERE IS WHERE I TESTING DEMO_SMALL WITH CELLS REMOVED ETC

cellshapes_2frameslater <- cellshapes %>% filter(cell_id %in% lgRoiSmoothed$cell_id)
# render_movie(cellshapes_2frameslater, "cellshapes_2frameslater.mp4", list(
#   geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
#   scale_fill_identity(guide = "none")
# ))

## done. let's for example compare sumContrib to dqtot to see if they are always the same by definition or just very close. 
sumContrib_vs_dqtot <- shearData %>% select(frame,tensor,xx.ma) %>% filter(tensor == "sumContrib") %>% dt.merge(shearData %>% select(frame,tensor,xx.ma) %>% rename(dqtot = xx.ma) %>% filter(tensor == "dqtot"), by = "frame")
sumContrib_vs_dqtot$diff <- abs(sumContrib_vs_dqtot$xx.ma - sumContrib_vs_dqtot$dqtot)
sumContrib_vs_dqtot$reldiff <- sumContrib_vs_dqtot$diff / (0.5*(abs(sumContrib_vs_dqtot$xx.ma + sumContrib_vs_dqtot$dqtot))  )

# the biggest reldiff is really tiny so these things are the same. Not the right comparison to test for effects I guess. 

# let's try plotting deltaCheck as a function of frame
myplot <- ggplot(shearData %>% filter(tensor == "deltaCheck"), aes(frame, xx.ma)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("deltaCheck"))) 
pdf("deltaCheck_clean.pdf")
print(myplot)
dev.off()

# not much to see there really but isn't that it? compares the nematic part of 'Tu describing total shear' to dqtot which is the same as sumContrib? 
# try integrating deltaCheck over time. 
deltaCheckCumSum <- shearData %>% filter(tensor == "deltaCheck") %>%
  group_by(movie, roi, tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)), xx.cumsum=cumsum(xx.ma*timeInt)) %>% 
  group_by(roi, tensor, dev_time) %>%
  summarise(cumsum.avg=mean(xx.cumsum), cumsum.sd=sd(xx.cumsum))

deltaCheckCumSum$frame <- round(deltaCheckCumSum$dev_time/(2.5/60))

# plot cumulation of deltaCheck as fn of frame
myplot <- ggplot(deltaCheckCumSum, aes(frame, cumsum.avg)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("deltaCheck cumulation"))) 
pdf("deltaCheck_CumSum_thickbridge.pdf")
print(myplot)
dev.off()

# Hmm. This is so hard to figure out. Try re-running sm shear_calculate but saving avgdQtot to file to inspect. Open that file now. no good. 

# Marko replies 1 Aug 2019. He says to try using like in Fig 11 of Merkel to calculate the shear of a tracked region based on its outline.
# the change will be discontinuous if the topology of the tracked region changes. 

# Going back to looking at the test_roi which explicitly has fusion of two smallish regions etc. look at shear data of it. 
# Okay I THINK that nu vs sumcontrib is the comparison to make. Try plotting both of these explicitly on top of one another. Try for test_roi or the alltracked lineages roi. 
# %%%%%%%%%%%%%%%%%%%%%% HERE IS CODE TO PLOT THE NU_XX AND SUMCONTRIB COMPARISON
nu_xx <- shearData %>% filter(tensor == "nu") %>% select(frame,dev_time,tensor,xx.ma)
sumContrib_xx <- shearData %>% filter(tensor == "sumContrib") %>% select(frame,dev_time,tensor,xx.ma)
nu_and_sumContrib_xx <- rbind(nu_xx,sumContrib_xx) %>% arrange(frame)

# do cumulation
nu_and_sumContrib_xx_cumulative <- nu_and_sumContrib_xx %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))

# This is the rate plot.
myplot <- ggplot(nu_and_sumContrib_xx, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx"))) 
pdf("nu_and_sumContrib_xx_thickbridge.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(nu_and_sumContrib_xx_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx cumul"))) 
pdf("nu_and_sumContrib_xx_cumulative_thickbridge.pdf")
print(myplot)
dev.off()

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%% now GS wants to test it for a possibly small perfectly-contiguous ROI to see that the decomposition holds properly then.
## loading with lgRoiSmoothed_orig
cellshapes_noborder <- cellshapes %>% filter(cell_id %in% roiHistoNoborder$cell_id)
 # render_movie(cellshapes %>% filter(cell_id, "cellshapes_whole_tissue.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
 #   scale_fill_identity(guide = "none")
 # ))
 
## right this looks contiguous up to 3.5 hours or so. look at the nu and sumContrib comparison. plot it up to 70 frames. still not total agreement but
 # hard to find what is due to the integration of finite-time data maybe?

##

 ## Now for the test_roi one, do the difference between the cumulative nu and sumContrib and see if discrete jumps occur when contiguity changes.
 ## 
 nu_minus_sumContrib_xx_cumulative <- nu_and_sumContrib_xx_cumulative %>% filter(tensor == "nu") %>% dt.merge(nu_and_sumContrib_xx_cumulative %>% filter(tensor == "sumContrib"), by = "frame")
 nu_minus_sumContrib_xx_cumulative$diff <- nu_minus_sumContrib_xx_cumulative$xxCumSum.avg.x - nu_minus_sumContrib_xx_cumulative$xxCumSum.avg.y
 myplot <- ggplot( nu_minus_sumContrib_xx_cumulative, aes(frame, diff)) +
   geom_line(size = 0.5)+
   theme(text = element_text(size = 18)) +
   ylab(expression(paste("nu_xx minus sumContrib_xx"))) 
 pdf("nu_minus_sumContrib_xx_cumulative.pdf")
 print(myplot)
 dev.off()
 
 ## so now make movies focused on specific frame intervals basedon
 ## where is the nu minus sumContrib seems big.
 cellshapes_test_roi <- cellshapes %>% filter(cell_id %in% test$cell_id)
 triProperties <- mqf_fg_triangle_properties(movieDir, "whole_tissue", triContour = T)
 # try to plot triangles in specific frame intervals
 # render_movie( triProperties %>% filter(frame > 13 & frame < 30), "triangles_13_30.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, group=tri_id),
 #                fill="yellow", color="black", alpha=0.75, size=0.1),
 #   scale_fill_identity(guide = "none")
 # ))
 
 # render_movie(  cellshapes_test_roi %>% filter(frame > 13 & frame < 30), "cells_13_30.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
 #   scale_fill_identity(guide = "none")
 # ))
 # 60 -90
 # render_movie( triProperties %>% filter(frame > 60 & frame < 90), "triangles_60_90.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, group=tri_id),
 #                fill="yellow", color="black", alpha=0.75, size=0.1),
 #   scale_fill_identity(guide = "none")
 # ))
 
 # render_movie(  cellshapes_test_roi %>% filter(frame > 60 & frame < 90), "cells_60_90.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
 #   scale_fill_identity(guide = "none")
 # ))
 # 90-120
 # render_movie( triProperties %>% filter(frame > 90 & frame < 120), "triangles_90_120.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, group=tri_id),
 #                fill="yellow", color="black", alpha=0.75, size=0.1),
 #   scale_fill_identity(guide = "none")
 # ))
 
 # render_movie(  cellshapes_test_roi %>% filter(frame > 90 & frame < 120), "cells_90_120.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
 #   scale_fill_identity(guide = "none")
 # ))
 
 # GS: when tissue miner calculates the correlative term as in Eq. 26 of the first eLife paper, it probably uses that approximation so there could be a difference. Dij.
 # GS: the blue and green-dashed terms still do not agree as well as they do in e.g. Merkel's paper. 
 # GS: try out with trial DEMO data set and see if the match between nu and sumContrib exists the same. 
 
 ## Tested this. There is still an error. So now Guillaume suggests directly to look at the triangulation
 ## for a noncontiguous ROI that becomes contiguous. So try DOCTORING the demo data by deleting a strip from the ROI.
 ## simply remove from the ROI any cell_IDs that have x between 320 and 3600 in frame 0
 positionsframe0 <- cellsDB %>% filter(frame ==0) %>% select(cell_id,center_x,center_y)
 exclude <- positionsframe0 %>% filter(center_x > 320 & center_x < 360) %>% select(cell_id)
 exclude <- exclude %>% filter(cell_id != 10491) # based on adding back in the one cell that will at some point bridge the two regions
 load("demo/roi_bt/lgRoiSmoothed.RData")
 lgRoiSmoothed <- lgRoiSmoothed %>% filter(!(cell_id %in% exclude$cell_id))
 save(lgRoiSmoothed,file="demo/roi_bt/lgRoiSmoothed_stripremoved.RData")
 ## adding back in one cell which I know will become contiguous. 15067725 is TA group ID
 #addin <- cellinfoDB %>% filter(tissue_analyzer_group_id == 15067725)
 # cell id is 10491
 # check it starts discontiguous then starts to.
 cellshapes_wholetissue <- cellshapes %>% filter(cell_id %in% (lgRoiSmoothed %>% filter(roi == "whole_tissue"))$cell_id)
 # render_movie(cellshapes_wholetissue, "cellshapes_whole_tissue.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
 #   scale_fill_identity(guide = "none")
 # ))
 # 
 # now look at the triangulation behaviour
 triProperties <- mqf_fg_triangle_properties(movieDir, rois = c("whole_tissue"), triContour = T)
 # try to plot triangles in specific frame intervals
 # render_movie( triProperties, "triangles.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, group=tri_id),
 #                fill="yellow", color="black", alpha=0.75, size=0.1),
 #   scale_fill_identity(guide = "none")
 # ))
 # the triangulation seems to cover over the removed strip. why??? read the mqf_fg_triangle_properties code.
 # Hmm. AHH.
 # It's because the stupid MQF looks for multiple files with Ta_t etc. not just those in the real shear_contrib folder. DAMN! So change the tissue miner code. MODIFIED TO FIX NOW.
 
 # Okay the triangulation is interesting but doesn't truly 'bridge' the discontiguous bits because the bridge is only one cell. 
 # add in TA group id 2574972
 addin <- cellinfoDB %>% filter(tissue_analyzer_group_id == 2574972) %>% select(cell_id) %>% mutate(roi = "whole_tissue")
 lgRoiSmoothed <- rbind(lgRoiSmoothed,addin)
 save(lgRoiSmoothed,file="demo/roi_bt/lgRoiSmoothed_thickbridge.RData")
 
 # now do the same cellshapes movie and triangles.
 load("demo/roi_bt/lgRoiSmoothed.RData")
 cellshapes_wholetissue <- cellshapes %>% filter(cell_id %in% (lgRoiSmoothed %>% filter(roi == "whole_tissue"))$cell_id)
 # render_movie(cellshapes_wholetissue, "cellshapes_whole_tissue.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, fill=color, group=cell_id),fill = "red", alpha=0.7),
 #   scale_fill_identity(guide = "none")
 # ))
 
 ## NEW %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 30 Aug INVESTIGATION OF DEMO DATA 
 triProperties <- mqf_fg_triangle_properties(movieDir, rois = c("whole_tissue"), triContour = T)
 # try to plot triangles in specific frame intervals
 # render_movie( triProperties, "triangles.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, group=tri_id),
 #                fill="yellow", color="black", alpha=0.75, size=0.1),
 #   scale_fill_identity(guide = "none")
 # ))
 
 # okay now we're better. so now pinpoint the frame in which the triangles are addded at the new contiguity bridge.
 # and try to identify when those triangles appear in the 'intermediates' Ta_i1.RData files whatever. Render frame a few times to pinpoint it.
 triProperties %>%
   render_frame(55) +
   geom_polygon(aes(x_pos, y_pos, group=tri_id),
                fill="yellow", color="black", alpha=0.9, size=0.1)
 triProperties %>%
   render_frame(60) +
   geom_polygon(aes(x_pos, y_pos, group=tri_id),
                fill="yellow", color="black", alpha=0.9, size=0.1)
 triProperties %>%
   render_frame(59) +
   geom_polygon(aes(x_pos, y_pos, group=tri_id),
                fill="yellow", color="black", alpha=0.9, size=0.1)
 triProperties %>%
   render_frame(62) +
   geom_polygon(aes(x_pos, y_pos, group=tri_id),
                fill="yellow", color="black", alpha=0.9, size=0.1)
 
 # in FRAME 59 a triangle is not there
 # in FRAME 60 it is there. so look into where this triangle is formed and what intermediate it appears in.
 # see if its a triangle associated with cell 10491
 check <- triProperties %>% filter(cell_id == 10491) #%>% filter(frame == 60)
 # tri ID 48391, 48435 or 52914
 check <- triProperties %>% filter(tri_id == 52914) #%>% filter(frame == 60)
 
 ## NEW 30 AUGUST 2019. cells involved in this triangle that is present in frame 60 are: 10076, 10491, 10529. 
 ## Search through triProperties for any other triangles that involve these three cells
 triProperties_10076 <- triProperties %>% filter(cell_id == 10076)
 triProperties_10491 <- triProperties %>% filter(cell_id == 10491)
 triProperties_10529 <- triProperties %>% filter(cell_id == 10529)
 triProperties_allthree <- triProperties %>% filter(tri_id %in% triProperties_10076$tri_id & tri_id %in% triProperties_10491$tri_id & tri_id %in% triProperties_10529$tri_id)
 ## so that's good because now it says all the distinct names, i.e. tri_ids, by which a triangle between those cells is known. make a quick movie of all those versions of the triangle
 # render_movie( triProperties_allthree, "triangles_52914_and_same_cells.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, group=tri_id),
 #                fill="yellow", color="black", alpha=0.75, size=0.1),
 #   scale_fill_identity(guide = "none")
 # ))
 
 ## now can we look in to the intermediates involving ANY of these triangle IDs etc.?
 
 # load each of them intermediaries etc. and look for any of the tri_ids from the 'allthree' group.
 load("demo/shear_contrib/whole_tissue/Ta_t.RData")
 load("demo/shear_contrib/whole_tissue/Ta_i1.RData")
 load("demo/shear_contrib/whole_tissue/Ta_i2.RData")
 load("demo/shear_contrib/whole_tissue/Ta_i3.RData")
 ## NEW 30 Aug 2019
 ## make a version of Ta_t thru Ta_i3 which feature any of these allthree tri_ids.
 Ta_t_allthree <- Ta_t %>% filter(tri_id %in% triProperties_allthree$tri_id)
 Ta_i1_allthree <- Ta_i1 %>% filter(tri_id %in% triProperties_allthree$tri_id)
 Ta_i2_allthree <- Ta_i2 %>% filter(tri_id %in% triProperties_allthree$tri_id)
 Ta_i3_allthree <- Ta_i3 %>% filter(tri_id %in% triProperties_allthree$tri_id)
 
 ## see if there is any such thing as a triangle that isn't present in ALL intermediates.
 Ta_all <- rbind(Ta_t %>% mutate(table = "t"),Ta_i1 %>% mutate(table = "i1"),Ta_i2 %>% mutate(table = "i2"),Ta_i3 %>% mutate(table = "i3"))
 Ta_all_count <- Ta_all %>% group_by(tri_id) %>% summarise(count = n())
 ## there are some, very few, where count = 3. Find out if they are always in the same intermediates. no, they aren't. so for all these 'inthree'
 ## ones, make a string that says what ones they are in.
 Ta_all_inthree <- Ta_all %>% filter(tri_id %in% (Ta_all_count %>% filter(count == 3))$tri_id)
 Ta_all_inthree_whichones <- Ta_all_inthree %>% group_by(tri_id) %>% mutate(whichones = paste0(table, collapse = " ")) %>% select(tri_id,whichones) %>% ungroup() %>% unique()
 whichones_exist <- Ta_all_inthree_whichones %>% select(whichones) %>% group_by(whichones) %>% summarise(count = n())
 
 # let's look at tri_id = 190 which is of t, i1, i3 type. 
 triProperties_190 <- triProperties %>% filter(tri_id == 190)
 #doesn't exist! ditto for 359, another triangle of that type.
 # look into mqf_fg_triangle_properties to see why triProperties doesn't contain such triangles
 # look into where triList.RData gets made.
 # try remaking triProperties with RAW roi. didn't work, put back. 
 # now manually running through the mqf function for this, to see where triangleProperties loses cell 190.
 # it is in the addtimeFunc step. so weird. compare both directly in ppt. 
 #triangleProperties_with190 <- triangleProperties # then run manually with addTimeFunc included.
 #triangleProperties_without190 <- triangleProperties
 # AH! It appears to me that it could be because the triangles exist in the final frame, that they are removed by addTimeFunc. Check this
 Ta_all_inthree_whichones <- triList %>% select(tri_id,frame) %>% unique() %>% dt.merge(Ta_all_inthree_whichones,by="tri_id")
 
 # Let's now look at spot checks of the t i1 i2 type instead then. 
 
 Ta_inthree_secondtype <- Ta_all_inthree_whichones %>% filter(frame != 70)
 
 # let's first try and make a movie of all these triangles. then a movie of all these triangles PLUS their 'same triangle' logical relations.
 triProperties_inthree_secondtype <- triProperties %>% filter(tri_id %in% Ta_inthree_secondtype$tri_id)
 # render_movie(  triProperties_inthree_secondtype, " triProperties_inthree_secondtype.mp4", list(
 #   geom_polygon(aes(x_pos, y_pos, group=tri_id),
 #                fill="yellow", color="black", alpha=0.75, size=0.1),
 #   scale_fill_identity(guide = "none")
 # ))
 
 ## it appears to me they may occur when cell divisions take place. make a list of all divisions and compare. 
 cdNematics <- mqf_fg_unit_nematics_CD(movieDir, rois = "whole_tissue")
 
 # now make a movie where these triangles are in yellow and their 'same triangle' partners are in green.
 tri_yellow <- triProperties_inthree_secondtype %>% select(tri_id,cell_id) %>% filter(tri_id == 62245 | tri_id == 62206) %>% mutate(type = "main")
 # cells in question are, 10629, 10628, and 10373 OR 10298
triProperties_10629 <- triProperties %>% filter(cell_id == 10629)
triProperties_10628 <- triProperties %>% filter(cell_id == 10628)
triProperties_10373 <- triProperties %>% filter(cell_id == 10373)
triProperties_10298 <- triProperties %>% filter(cell_id == 10298)
tri_green <- triProperties %>% filter(tri_id %in% triProperties_10629$tri_id)
tri_green <- tri_green %>% filter(tri_id %in% triProperties_10628$tri_id)
tri_green <- tri_green %>% filter(tri_id %in% triProperties_10373$tri_id | tri_id %in% triProperties_10298$tri_id)
tri_green <- tri_green %>% select(tri_id,cell_id) %>% mutate(type = "sametri")
tri_yellow_green <- rbind(tri_yellow,tri_green)
tri_yellow_green <- triProperties %>% dt.merge(tri_yellow_green, by = "tri_id")
# render_movie(  tri_yellow_green, " tri_yellow_green.mp4", list(
#   geom_polygon(aes(x_pos, y_pos, group=tri_id,  fill=type), color="black", alpha=0.75, size=0.1),
#   scale_fill_manual(values=c("main" = "yellow","sametri"= "green"))
# ))




## TESTING MARKO PYTHON VERSION OUTPUT WITH DIFFERENT TIME RESOLUTIONS (10 100 1000 N_STEPS) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## (adapting below code for either demo data or WT1 as and when)
## import a csv file that contains just the rate of sumContrib and total_shear_xx calculated using that stuff. 
## first re-get shear data with ks1
shearData <- multi_db_query(movieDirs, mqf_cg_roi_rate_shear, "whole_tissue", kernSize = 1)
nu_xx <- shearData %>% filter(tensor == "nu") %>% select(frame,dev_time,tensor,xx.ma)
sumContrib_xx <- shearData %>% filter(tensor == "sumContrib") %>% select(frame,dev_time,tensor,xx.ma)
nu_and_sumContrib_xx <- rbind(nu_xx,sumContrib_xx) %>% arrange(frame)
# do cumulation
nu_and_sumContrib_xx_cumulative <- nu_and_sumContrib_xx %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(nu_and_sumContrib_xx, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  ylim(-0.2,0.2)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx"))) 
pdf("nu_and_sumContrib_xx_noborder.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(nu_and_sumContrib_xx_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("nu_xx compare sumContrib_xx cumul"))) 
pdf("nu_and_sumContrib_xx_cumulative_noborder.pdf")
print(myplot)
dev.off()

## LOAD IN THE PYTHON DATA. header false N STEPS = 10!!! note dev time is not 2.5/60 but 291/3600
python_sumcontrib_total_10 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/2frameslater/output/movie_10_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% rename(frame = V1, sumContrib_py10 = V2, total_shear_py10 = V3)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% select(frame,sumContrib_py10) %>% rename(xx.ma = sumContrib_py10) %>% mutate(tensor = "sumContrib_py10") %>% rbind(python_sumcontrib_total_10 %>% select(frame,total_shear_py10) %>% rename(xx.ma = total_shear_py10) %>% mutate(tensor = "total_shear_py10")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)
## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10$xx.ma <- python_sumcontrib_total_10$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10_cumulative <- python_sumcontrib_total_10 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 100 
python_sumcontrib_total_100 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/2frameslater/output/movie_100_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% rename(frame = V1, sumContrib_py100 = V2, total_shear_py100 = V3)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% select(frame,sumContrib_py100) %>% rename(xx.ma = sumContrib_py100) %>% mutate(tensor = "sumContrib_py100") %>% rbind(python_sumcontrib_total_100 %>% select(frame,total_shear_py100) %>% rename(xx.ma = total_shear_py100) %>% mutate(tensor = "total_shear_py100")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_100$xx.ma <- python_sumcontrib_total_100$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_100_cumulative <- python_sumcontrib_total_100 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_100, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_100.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_100_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_100_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 1000 
python_sumcontrib_total_1000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/2frameslater/output/movie_1000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% rename(frame = V1, sumContrib_py1000 = V2, total_shear_py1000 = V3)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% select(frame,sumContrib_py1000) %>% rename(xx.ma = sumContrib_py1000) %>% mutate(tensor = "sumContrib_py1000") %>% rbind(python_sumcontrib_total_1000 %>% select(frame,total_shear_py1000) %>% rename(xx.ma = total_shear_py1000) %>% mutate(tensor = "total_shear_py1000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_1000$xx.ma <- python_sumcontrib_total_1000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_1000_cumulative <- python_sumcontrib_total_1000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_1000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_1000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_1000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_1000_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 10000 
python_sumcontrib_total_10000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/2frameslater/output/movie_10000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% rename(frame = V1, sumContrib_py10000 = V2, total_shear_py10000 = V3)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% select(frame,sumContrib_py10000) %>% rename(xx.ma = sumContrib_py10000) %>% mutate(tensor = "sumContrib_py10000") %>% rbind(python_sumcontrib_total_10000 %>% select(frame,total_shear_py10000) %>% rename(xx.ma = total_shear_py10000) %>% mutate(tensor = "total_shear_py10000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10000$xx.ma <- python_sumcontrib_total_10000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10000_cumulative <- python_sumcontrib_total_10000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10000_cumul.pdf")
print(myplot)
dev.off()

## continue rbinding to look at e.g. if sum in PYTHON version is more similar or less similar to sum or total in R version. Baffled that
## sum vs total difference is reversed in R vs PYTHON. 

cumulative_r_and_10_100_1000 <- rbind(nu_and_sumContrib_xx_cumulative, python_sumcontrib_total_10_cumulative, python_sumcontrib_total_100_cumulative, python_sumcontrib_total_1000_cumulative)
myplot <- ggplot(cumulative_r_and_10_100_1000 %>% filter(tensor %like% "sumContrib" | tensor %like% "nu") , aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.3)+
  theme(text = element_text(size = 18)) +
  ylim(-0.1,0.5) + 
  ylab(expression(paste("cumulative_r_and_10_100_1000"))) 
pdf("cumulative_r_and_10_100_1000_sumContrib.pdf")
print(myplot)
dev.off()

myplot <- ggplot(cumulative_r_and_10_100_1000 %>% filter(tensor == "sumContrib" | tensor ==  "nu" | tensor %like% "total_shear") , aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.3)+
  theme(text = element_text(size = 18)) +
  ylim(-0.1,0.5) + 
  ylab(expression(paste("cumulative_r_and_10_100_1000"))) 
pdf("cumulative_r_and_10_100_1000_total_shear.pdf")
print(myplot)
dev.off()

## print again but just in a small y range to disentangle what series overlay what etc
myplot <- ggplot(cumulative_r_and_10_100_1000 %>% filter(tensor %like% "sumContrib" | tensor %like% "nu") , aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.3)+
  theme(text = element_text(size = 18)) +
  ylim(0.35,0.4) + 
  xlim(300,350) +
  ylab(expression(paste("cumulative_r_and_10_100_1000"))) 
pdf("cumulative_r_and_10_100_1000_sumContrib_zoom.pdf")
print(myplot)
dev.off()

myplot <- ggplot(cumulative_r_and_10_100_1000 %>% filter(tensor == "sumContrib" | tensor ==  "nu" | tensor %like% "total_shear") , aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.3)+
  theme(text = element_text(size = 18)) +
  ylim(0.35,0.4) +
  xlim(300,350) +
  ylab(expression(paste("cumulative_r_and_10_100_1000"))) 
pdf("cumulative_r_and_10_100_1000_total_shear_zoom.pdf")
print(myplot)
dev.off()


## %% NEW -- CONVERGENCE (9 SEP 2019) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# for each python sumcontrib and total cumulative data table, keep track of the normalised difference between sumcontrib and total.
# find the MEAN of this over the series (omitting any NA in initial frame)
# and plot it as a function of N_STEPS.

converge_10 <- python_sumcontrib_total_10_cumulative %>% filter(tensor %like% "sumContrib") %>% dt.merge(python_sumcontrib_total_10_cumulative %>% filter(tensor %like% "total"), by = c("frame","dev_time"))
converge_10 <- converge_10 %>% mutate(normdiff = abs(2*(xxCumSum.avg.x - xxCumSum.avg.y)/(xxCumSum.avg.x + xxCumSum.avg.y))) %>% select(frame,normdiff)
converge_10 <- mean(na.omit(converge_10$normdiff))
converge_100 <- python_sumcontrib_total_100_cumulative %>% filter(tensor %like% "sumContrib") %>% dt.merge(python_sumcontrib_total_100_cumulative %>% filter(tensor %like% "total"), by = c("frame","dev_time"))
converge_100 <- converge_100 %>% mutate(normdiff = abs(2*(xxCumSum.avg.x - xxCumSum.avg.y)/(xxCumSum.avg.x + xxCumSum.avg.y))) %>% select(frame,normdiff)
converge_100 <- mean(na.omit(converge_100$normdiff))
converge_1000 <- python_sumcontrib_total_1000_cumulative %>% filter(tensor %like% "sumContrib") %>% dt.merge(python_sumcontrib_total_1000_cumulative %>% filter(tensor %like% "total"), by = c("frame","dev_time"))
converge_1000 <- converge_1000 %>% mutate(normdiff = abs(2*(xxCumSum.avg.x - xxCumSum.avg.y)/(xxCumSum.avg.x + xxCumSum.avg.y))) %>% select(frame,normdiff)
converge_1000 <- mean(na.omit(converge_1000$normdiff))
converge_10000 <- python_sumcontrib_total_10000_cumulative %>% filter(tensor %like% "sumContrib") %>% dt.merge(python_sumcontrib_total_10000_cumulative %>% filter(tensor %like% "total"), by = c("frame","dev_time"))
converge_10000 <- converge_10000 %>% mutate(normdiff = abs(2*(xxCumSum.avg.x - xxCumSum.avg.y)/(xxCumSum.avg.x + xxCumSum.avg.y))) %>% select(frame,normdiff)
converge_10000 <- mean(na.omit(converge_10000$normdiff))
converge_10$nsteps <- 10
names(converge_10)[1] <- "meannormdiff"
converge_100$nsteps <- 100
names(converge_100)[1] <- "meannormdiff"
converge_1000$nsteps <- 1000
names(converge_1000)[1] <- "meannormdiff"
converge_10000$nsteps <- 10000
names(converge_10000)[1] <- "meannormdiff"
converge <- rbind(as.data.frame(converge_10),as.data.frame(converge_100),as.data.frame(converge_1000),as.data.frame(converge_10000))
myplot <- ggplot(converge, aes(nsteps, meannormdiff)) +
  geom_point(size = 1)+
  theme(text = element_text(size = 18)) +
  scale_x_log10() +
  scale_y_log10() +
  ylab(expression(paste("mean norm'd difference"))) 
pdf("converge_nsteps.pdf")
print(myplot)
dev.off()


## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## NEW: EXAMPLE DATA CLEAN : using it to divide into some quadrants just based on first frame and then lineages. see
## in which one the big error in frame 1 occurs or is it distributed.
load("demo/roi_bt/lgRoiSmoothed.RData")
meanx0 <- cellsDB %>% filter(cell_id %in% lgRoiSmoothed$cell_id) %>% filter(frame == 0) %>% select(center_x) %>% summarise(meanx0 = mean(center_x))
meany0 <- cellsDB %>% filter(cell_id %in% lgRoiSmoothed$cell_id) %>% filter(frame == 0) %>% select(center_y) %>% summarise(meany0 = mean(center_y))
quad1 <- cellsDB %>% filter(cell_id != 10000) %>% filter(frame == 0) %>% filter(center_x < meanx0$meanx0) %>% filter(center_y < meany0$meany0) %>% select(cell_id) %>% dt.merge(cellinfoDB %>% select(cell_id,lineage_group),by="cell_id")
quad1 <- cellinfoDB %>% select(cell_id,lineage_group) %>% filter(lineage_group %in% quad1$lineage_group) %>% rbind(quad1) %>% unique()
#not quad1 has no divisions so gains no cells by this second step.
quad2 <- cellsDB %>% filter(cell_id != 10000) %>% filter(frame == 0) %>% filter(center_x > meanx0$meanx0) %>% filter(center_y < meany0$meany0) %>% select(cell_id) %>% dt.merge(cellinfoDB %>% select(cell_id,lineage_group),by="cell_id")
quad2 <- cellinfoDB %>% select(cell_id,lineage_group) %>% filter(lineage_group %in% quad2$lineage_group) %>% rbind(quad2) %>% unique()
#gains 2 cells
quad3 <- cellsDB %>% filter(cell_id != 10000) %>% filter(frame == 0) %>% filter(center_x > meanx0$meanx0) %>% filter(center_y > meany0$meany0) %>% select(cell_id) %>% dt.merge(cellinfoDB %>% select(cell_id,lineage_group),by="cell_id")
quad3 <- cellinfoDB %>% select(cell_id,lineage_group) %>% filter(lineage_group %in% quad3$lineage_group) %>% rbind(quad3) %>% unique()
#gains 18 cells by this
quad4 <- cellsDB %>% filter(cell_id != 10000) %>% filter(frame == 0) %>% filter(center_x < meanx0$meanx0) %>% filter(center_y > meany0$meany0) %>% select(cell_id) %>% dt.merge(cellinfoDB %>% select(cell_id,lineage_group),by="cell_id")
quad4 <- cellinfoDB %>% select(cell_id,lineage_group) %>% filter(lineage_group %in% quad4$lineage_group) %>% rbind(quad4) %>% unique()
#gains 22 cells by this
quad1 <- quad1 %>% select(cell_id) %>% mutate(roi = "quad1")
quad2 <- quad2 %>% select(cell_id) %>% mutate(roi = "quad2")
quad3 <- quad3 %>% select(cell_id) %>% mutate(roi = "quad3")
quad4 <- quad4 %>% select(cell_id) %>% mutate(roi = "quad4")
lgRoiSmoothed_quads <- rbind(quad1,quad2,quad3,quad4)
# FILTER FOR EXISTENCE IN WHOLE TISSUE!!!! IMPORTANT!
#lgRoiSmoothed_quads <- lgRoiSmoothed_quads %>% filter(cell_id %in% lgRoiSmoothed$cell_id)
#save(lgRoiSmoothed,file="demo/roi_bt/lgRoiSmoothed_quads.RData")
# running shear_calculate again after renaming lgRoiSmoothed file temporarily.

# now look at sumContrib and total_shear cumulative for each quad roi separately. 
shearData <- multi_db_query(movieDirs, mqf_cg_roi_rate_shear, c("quad1","quad2","quad3","quad4"), kernSize = 1)
nu_xx <- shearData %>% filter(tensor == "nu") %>% select(roi, frame,dev_time,tensor,xx.ma)
sumContrib_xx <- shearData %>% filter(tensor == "sumContrib") %>% select(roi, frame,dev_time,tensor,xx.ma)
nu_and_sumContrib_xx <- rbind(nu_xx,sumContrib_xx) %>% arrange(frame)
# do cumulation
nu_and_sumContrib_xx_cumulative <- nu_and_sumContrib_xx %>%
  group_by(roi,tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(roi,tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(nu_and_sumContrib_xx %>% filter(roi == "quad1"), aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx"))) 
pdf("nu_and_sumContrib_xx_quad1.pdf")
print(myplot)
dev.off()
myplot <- ggplot(nu_and_sumContrib_xx %>% filter(roi == "quad2"), aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx"))) 
pdf("nu_and_sumContrib_xx_quad2.pdf")
print(myplot)
dev.off()
myplot <- ggplot(nu_and_sumContrib_xx %>% filter(roi == "quad3"), aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx"))) 
pdf("nu_and_sumContrib_xx_quad3.pdf")
print(myplot)
dev.off()
myplot <- ggplot(nu_and_sumContrib_xx %>% filter(roi == "quad4"), aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx"))) 
pdf("nu_and_sumContrib_xx_quad4.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(nu_and_sumContrib_xx_cumulative %>% filter(roi == "quad1"), aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx cumul"))) 
pdf("nu_and_sumContrib_xx_cumulative_quad1.pdf")
print(myplot)
dev.off()
myplot <- ggplot(nu_and_sumContrib_xx_cumulative %>% filter(roi == "quad2"), aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx cumul"))) 
pdf("nu_and_sumContrib_xx_cumulative_quad2.pdf")
print(myplot)
dev.off()
myplot <- ggplot(nu_and_sumContrib_xx_cumulative %>% filter(roi == "quad3"), aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx cumul"))) 
pdf("nu_and_sumContrib_xx_cumulative_quad3.pdf")
print(myplot)
dev.off()
myplot <- ggplot(nu_and_sumContrib_xx_cumulative %>% filter(roi == "quad4"), aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("nu_xx compare sumContrib_xx cumul"))) 
pdf("nu_and_sumContrib_xx_cumulative_quad4.pdf")
print(myplot)
dev.off()

# not clear where error is most concentrated. certainly in frame 1 there isn't a huge error in any quadrant?? 
# make a movie of the cells in each quadrant
cellshapes_quads <- cellshapes %>% dt.merge(lgRoiSmoothed_quads,by="cell_id")
# render_movie(cellshapes_quads, "cellshapes_quads.mp4", list( 
#   # geometrical layer to represent cells as polygons
#   geom_polygon(aes(x_pos, y_pos, group=cell_id,fill = roi), alpha=0.75),
#   scale_fill_manual(values=c("quad1" = "red", "quad2" = "green", "quad3" = "blue", "quad4" = "purple", "whole_tissue" = "white"))
# ))

## plot the individual triangulations for quadrants. 
triProperties_quads <- mqf_fg_triangle_properties(movieDir, c("quad1","quad2","quad3","quad4"), triContour = T) 
# render_movie(triProperties_quads, "triProperties_quads.mp4", list( 
#   # geometrical layer to represent cells as polygons
#   geom_polygon(aes(x_pos, y_pos, group=tri_id,fill = roi), alpha=0.7, color = "black"),
#   scale_fill_manual(values=c("quad1" = "red", "quad2" = "green", "quad3" = "blue", "quad4" = "purple", "whole_tissue" = "white"))
# ))


#FOR PYTHON!
 # lgRoiSmoothed <- lgRoiSmoothed_quads
 # save(lgRoiSmoothed,file="demo/roi_bt/lgRoiSmoothed.RData")

## now python-version data plotting for each quadrant %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
## QUAD1
## LOAD IN THE PYTHON DATA. header false N STEPS = 10!!! note dev time is not 2.5/60 but 291/3600 QUAD1
python_sumcontrib_total_10 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad1/movie_10_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% rename(frame = V1, sumContrib_py10 = V2, total_shear_py10 = V3)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% select(frame,sumContrib_py10) %>% rename(xx.ma = sumContrib_py10) %>% mutate(tensor = "sumContrib_py10") %>% rbind(python_sumcontrib_total_10 %>% select(frame,total_shear_py10) %>% rename(xx.ma = total_shear_py10) %>% mutate(tensor = "total_shear_py10")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10$xx.ma <- python_sumcontrib_total_10$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10_cumulative <- python_sumcontrib_total_10 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 100 
python_sumcontrib_total_100 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad1/movie_100_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% rename(frame = V1, sumContrib_py100 = V2, total_shear_py100 = V3)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% select(frame,sumContrib_py100) %>% rename(xx.ma = sumContrib_py100) %>% mutate(tensor = "sumContrib_py100") %>% rbind(python_sumcontrib_total_100 %>% select(frame,total_shear_py100) %>% rename(xx.ma = total_shear_py100) %>% mutate(tensor = "total_shear_py100")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_100$xx.ma <- python_sumcontrib_total_100$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_100_cumulative <- python_sumcontrib_total_100 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_100, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_100.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_100_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_100_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 1000 
python_sumcontrib_total_1000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad1/movie_1000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% rename(frame = V1, sumContrib_py1000 = V2, total_shear_py1000 = V3)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% select(frame,sumContrib_py1000) %>% rename(xx.ma = sumContrib_py1000) %>% mutate(tensor = "sumContrib_py1000") %>% rbind(python_sumcontrib_total_1000 %>% select(frame,total_shear_py1000) %>% rename(xx.ma = total_shear_py1000) %>% mutate(tensor = "total_shear_py1000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_1000$xx.ma <- python_sumcontrib_total_1000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_1000_cumulative <- python_sumcontrib_total_1000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_1000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_1000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_1000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_1000_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 10000 
python_sumcontrib_total_10000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad1/movie_10000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% rename(frame = V1, sumContrib_py10000 = V2, total_shear_py10000 = V3)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% select(frame,sumContrib_py10000) %>% rename(xx.ma = sumContrib_py10000) %>% mutate(tensor = "sumContrib_py10000") %>% rbind(python_sumcontrib_total_10000 %>% select(frame,total_shear_py10000) %>% rename(xx.ma = total_shear_py10000) %>% mutate(tensor = "total_shear_py10000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10000$xx.ma <- python_sumcontrib_total_10000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10000_cumulative <- python_sumcontrib_total_10000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10000_cumul.pdf")
print(myplot)
dev.off()

# now move data to a special quad1 folder

## quad2
## LOAD IN THE PYTHON DATA. header false N STEPS = 10!!! note dev time is not 2.5/60 but 291/3600 quad2
python_sumcontrib_total_10 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad2/movie_10_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% rename(frame = V1, sumContrib_py10 = V2, total_shear_py10 = V3)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% select(frame,sumContrib_py10) %>% rename(xx.ma = sumContrib_py10) %>% mutate(tensor = "sumContrib_py10") %>% rbind(python_sumcontrib_total_10 %>% select(frame,total_shear_py10) %>% rename(xx.ma = total_shear_py10) %>% mutate(tensor = "total_shear_py10")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10$xx.ma <- python_sumcontrib_total_10$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10_cumulative <- python_sumcontrib_total_10 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 100 
python_sumcontrib_total_100 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad2/movie_100_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% rename(frame = V1, sumContrib_py100 = V2, total_shear_py100 = V3)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% select(frame,sumContrib_py100) %>% rename(xx.ma = sumContrib_py100) %>% mutate(tensor = "sumContrib_py100") %>% rbind(python_sumcontrib_total_100 %>% select(frame,total_shear_py100) %>% rename(xx.ma = total_shear_py100) %>% mutate(tensor = "total_shear_py100")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_100$xx.ma <- python_sumcontrib_total_100$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_100_cumulative <- python_sumcontrib_total_100 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_100, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_100.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_100_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_100_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 1000 
python_sumcontrib_total_1000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad2/movie_1000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% rename(frame = V1, sumContrib_py1000 = V2, total_shear_py1000 = V3)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% select(frame,sumContrib_py1000) %>% rename(xx.ma = sumContrib_py1000) %>% mutate(tensor = "sumContrib_py1000") %>% rbind(python_sumcontrib_total_1000 %>% select(frame,total_shear_py1000) %>% rename(xx.ma = total_shear_py1000) %>% mutate(tensor = "total_shear_py1000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_1000$xx.ma <- python_sumcontrib_total_1000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_1000_cumulative <- python_sumcontrib_total_1000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_1000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_1000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_1000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_1000_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 10000 
python_sumcontrib_total_10000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad2/movie_10000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% rename(frame = V1, sumContrib_py10000 = V2, total_shear_py10000 = V3)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% select(frame,sumContrib_py10000) %>% rename(xx.ma = sumContrib_py10000) %>% mutate(tensor = "sumContrib_py10000") %>% rbind(python_sumcontrib_total_10000 %>% select(frame,total_shear_py10000) %>% rename(xx.ma = total_shear_py10000) %>% mutate(tensor = "total_shear_py10000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10000$xx.ma <- python_sumcontrib_total_10000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10000_cumulative <- python_sumcontrib_total_10000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10000_cumul.pdf")
print(myplot)
dev.off()

# now move data to a special quad2 folder

## quad3
## LOAD IN THE PYTHON DATA. header false N STEPS = 10!!! note dev time is not 2.5/60 but 291/3600 quad3
python_sumcontrib_total_10 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad3/movie_10_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% rename(frame = V1, sumContrib_py10 = V2, total_shear_py10 = V3)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% select(frame,sumContrib_py10) %>% rename(xx.ma = sumContrib_py10) %>% mutate(tensor = "sumContrib_py10") %>% rbind(python_sumcontrib_total_10 %>% select(frame,total_shear_py10) %>% rename(xx.ma = total_shear_py10) %>% mutate(tensor = "total_shear_py10")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10$xx.ma <- python_sumcontrib_total_10$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10_cumulative <- python_sumcontrib_total_10 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 100 
python_sumcontrib_total_100 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad3/movie_100_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% rename(frame = V1, sumContrib_py100 = V2, total_shear_py100 = V3)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% select(frame,sumContrib_py100) %>% rename(xx.ma = sumContrib_py100) %>% mutate(tensor = "sumContrib_py100") %>% rbind(python_sumcontrib_total_100 %>% select(frame,total_shear_py100) %>% rename(xx.ma = total_shear_py100) %>% mutate(tensor = "total_shear_py100")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_100$xx.ma <- python_sumcontrib_total_100$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_100_cumulative <- python_sumcontrib_total_100 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_100, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_100.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_100_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_100_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 1000 
python_sumcontrib_total_1000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad3/movie_1000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% rename(frame = V1, sumContrib_py1000 = V2, total_shear_py1000 = V3)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% select(frame,sumContrib_py1000) %>% rename(xx.ma = sumContrib_py1000) %>% mutate(tensor = "sumContrib_py1000") %>% rbind(python_sumcontrib_total_1000 %>% select(frame,total_shear_py1000) %>% rename(xx.ma = total_shear_py1000) %>% mutate(tensor = "total_shear_py1000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_1000$xx.ma <- python_sumcontrib_total_1000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_1000_cumulative <- python_sumcontrib_total_1000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_1000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_1000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_1000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_1000_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 10000 
python_sumcontrib_total_10000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad3/movie_10000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% rename(frame = V1, sumContrib_py10000 = V2, total_shear_py10000 = V3)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% select(frame,sumContrib_py10000) %>% rename(xx.ma = sumContrib_py10000) %>% mutate(tensor = "sumContrib_py10000") %>% rbind(python_sumcontrib_total_10000 %>% select(frame,total_shear_py10000) %>% rename(xx.ma = total_shear_py10000) %>% mutate(tensor = "total_shear_py10000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10000$xx.ma <- python_sumcontrib_total_10000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10000_cumulative <- python_sumcontrib_total_10000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10000_cumul.pdf")
print(myplot)
dev.off()

# now move data to a special quad3 folder

## quad4
## LOAD IN THE PYTHON DATA. header false N STEPS = 10!!! note dev time is not 2.5/60 but 291/3600 quad4
python_sumcontrib_total_10 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad4/movie_10_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% rename(frame = V1, sumContrib_py10 = V2, total_shear_py10 = V3)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% select(frame,sumContrib_py10) %>% rename(xx.ma = sumContrib_py10) %>% mutate(tensor = "sumContrib_py10") %>% rbind(python_sumcontrib_total_10 %>% select(frame,total_shear_py10) %>% rename(xx.ma = total_shear_py10) %>% mutate(tensor = "total_shear_py10")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10$xx.ma <- python_sumcontrib_total_10$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10_cumulative <- python_sumcontrib_total_10 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 100 
python_sumcontrib_total_100 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad4/movie_100_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% rename(frame = V1, sumContrib_py100 = V2, total_shear_py100 = V3)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% select(frame,sumContrib_py100) %>% rename(xx.ma = sumContrib_py100) %>% mutate(tensor = "sumContrib_py100") %>% rbind(python_sumcontrib_total_100 %>% select(frame,total_shear_py100) %>% rename(xx.ma = total_shear_py100) %>% mutate(tensor = "total_shear_py100")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_100$xx.ma <- python_sumcontrib_total_100$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_100_cumulative <- python_sumcontrib_total_100 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_100, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_100.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_100_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_100_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 1000 
python_sumcontrib_total_1000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad4/movie_1000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% rename(frame = V1, sumContrib_py1000 = V2, total_shear_py1000 = V3)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% select(frame,sumContrib_py1000) %>% rename(xx.ma = sumContrib_py1000) %>% mutate(tensor = "sumContrib_py1000") %>% rbind(python_sumcontrib_total_1000 %>% select(frame,total_shear_py1000) %>% rename(xx.ma = total_shear_py1000) %>% mutate(tensor = "total_shear_py1000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_1000$xx.ma <- python_sumcontrib_total_1000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_1000_cumulative <- python_sumcontrib_total_1000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_1000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_1000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_1000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_1000_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 10000 
python_sumcontrib_total_10000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output_quad4/movie_10000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% rename(frame = V1, sumContrib_py10000 = V2, total_shear_py10000 = V3)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% select(frame,sumContrib_py10000) %>% rename(xx.ma = sumContrib_py10000) %>% mutate(tensor = "sumContrib_py10000") %>% rbind(python_sumcontrib_total_10000 %>% select(frame,total_shear_py10000) %>% rename(xx.ma = total_shear_py10000) %>% mutate(tensor = "total_shear_py10000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10000$xx.ma <- python_sumcontrib_total_10000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10000_cumulative <- python_sumcontrib_total_10000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10000_cumul.pdf")
print(myplot)
dev.off()

# now move data to a special quad4 folder.

## NEXT............................. check if error in full example_data_clean persists when run through python.
## LOAD IN THE PYTHON DATA. header false N STEPS = 10!!! note dev time is not 2.5/60 but 291/3600 quad4
python_sumcontrib_total_10 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output/movie_10_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% rename(frame = V1, sumContrib_py10 = V2, total_shear_py10 = V3)
python_sumcontrib_total_10 <- python_sumcontrib_total_10 %>% select(frame,sumContrib_py10) %>% rename(xx.ma = sumContrib_py10) %>% mutate(tensor = "sumContrib_py10") %>% rbind(python_sumcontrib_total_10 %>% select(frame,total_shear_py10) %>% rename(xx.ma = total_shear_py10) %>% mutate(tensor = "total_shear_py10")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10$xx.ma <- python_sumcontrib_total_10$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10_cumulative <- python_sumcontrib_total_10 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 100 
python_sumcontrib_total_100 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output/movie_100_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% rename(frame = V1, sumContrib_py100 = V2, total_shear_py100 = V3)
python_sumcontrib_total_100 <- python_sumcontrib_total_100 %>% select(frame,sumContrib_py100) %>% rename(xx.ma = sumContrib_py100) %>% mutate(tensor = "sumContrib_py100") %>% rbind(python_sumcontrib_total_100 %>% select(frame,total_shear_py100) %>% rename(xx.ma = total_shear_py100) %>% mutate(tensor = "total_shear_py100")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_100$xx.ma <- python_sumcontrib_total_100$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_100_cumulative <- python_sumcontrib_total_100 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_100, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_100.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_100_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_100 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_100_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 1000 
python_sumcontrib_total_1000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output/movie_1000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% rename(frame = V1, sumContrib_py1000 = V2, total_shear_py1000 = V3)
python_sumcontrib_total_1000 <- python_sumcontrib_total_1000 %>% select(frame,sumContrib_py1000) %>% rename(xx.ma = sumContrib_py1000) %>% mutate(tensor = "sumContrib_py1000") %>% rbind(python_sumcontrib_total_1000 %>% select(frame,total_shear_py1000) %>% rename(xx.ma = total_shear_py1000) %>% mutate(tensor = "total_shear_py1000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_1000$xx.ma <- python_sumcontrib_total_1000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_1000_cumulative <- python_sumcontrib_total_1000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_1000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_1000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_1000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_1000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_1000_cumul.pdf")
print(myplot)
dev.off()

## N STEPS 10000 
python_sumcontrib_total_10000 <- read.csv("/Users/john/TM_LOCAL_TEMP/TM_DEMO_SMALL/example_data_clean/output/movie_10000_sumContrib_and_total.csv", header = F)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% rename(frame = V1, sumContrib_py10000 = V2, total_shear_py10000 = V3)
python_sumcontrib_total_10000 <- python_sumcontrib_total_10000 %>% select(frame,sumContrib_py10000) %>% rename(xx.ma = sumContrib_py10000) %>% mutate(tensor = "sumContrib_py10000") %>% rbind(python_sumcontrib_total_10000 %>% select(frame,total_shear_py10000) %>% rename(xx.ma = total_shear_py10000) %>% mutate(tensor = "total_shear_py10000")) %>% arrange(frame) %>% mutate(dev_time = frame*291/3600) %>% select(frame,dev_time,tensor,xx.ma)

## version from python approximately a factor of ten too small. is this just like xx.ma vs xx in the R stuff I had? Yes think so.
python_sumcontrib_total_10000$xx.ma <- python_sumcontrib_total_10000$xx.ma * 3600/291

## so now first do a cumulative and rate plots of total and sum as above. 
# do cumulation
python_sumcontrib_total_10000_cumulative <- python_sumcontrib_total_10000 %>%
  group_by(tensor) %>%
  mutate(timeInt=c(0,diff(dev_time)),cumSum_xx=cumsum(xx.ma*timeInt)) %>%
  group_by(tensor, dev_time,frame) %>%
  summarise(xxCumSum.avg=mean(cumSum_xx, na.rm = F), xxCumSum.sd=sd(cumSum_xx, na.rm = F))
# This is the rate plot.
myplot <- ggplot(python_sumcontrib_total_10000, aes(frame, xx.ma, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.2,0.2)+
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx"))) 
pdf("python_sumcontrib_total_10000.pdf")
print(myplot)
dev.off()

# This is the cumulative plot.
myplot <- ggplot(python_sumcontrib_total_10000_cumulative, aes(frame, xxCumSum.avg, color = tensor)) +
  geom_line(size = 0.5)+
  theme(text = element_text(size = 18)) +
  ylim(-0.05,0.1) + 
  ylab(expression(paste("PY_10000 nu_xx compare sumContrib_xx cumul"))) 
pdf("python_sumcontrib_total_10000_cumul.pdf")
print(myplot)
dev.off()

















 
 ### OLD %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Ta_t_59 <- Ta_t %>% dt.merge(triProperties,by="tri_id") %>% filter(frame == 59) %>% filter(tri_id == 52914)
 Ta_i1_59 <- Ta_i1 %>% dt.merge(triProperties,by="tri_id") %>% filter(frame == 59) %>% filter(tri_id == 52914)
 Ta_i2_59 <- Ta_i2 %>% dt.merge(triProperties,by="tri_id") %>% filter(frame == 59) %>% filter(tri_id == 52914)
 Ta_i3_59 <- Ta_i2 %>% dt.merge(triProperties,by="tri_id") %>% filter(frame == 59) %>% filter(tri_id == 52914)
 
 # NOPE this isn't the right way to get it. The triangles I suppose change identities per frame so in some way this triangle will ONLY exist in frame 60?
 check <- triProperties %>% filter(tri_id == 52914)
 
 # so I guess a better question is. AT what frame is a triangle in existence that has the cell IDs 10076,10491,10529 in it. 
 # but first, let's just see how many of the Ta_ files have triangle 52914 in them.
 Ta_t_5291 <- Ta_t %>% filter(tri_id == 52914)
 Ta_i1_5291 <- Ta_i1 %>% filter(tri_id == 52914)
 Ta_i2_5291 <- Ta_i2 %>% filter(tri_id == 52914)
 Ta_i3_5291 <- Ta_i3 %>% filter(tri_id == 52914)
 # okay this is interesting. the triangle properties of this one are present in all of the above.
 # they are unchanged between t, i1, i and i3, but change in i2. bizarre. Which one corresponds to the triProperties entry?
 triProperties_5291 <- triProperties %>% filter(tri_id == 52914)
 # the triproperties entry is the same as for i3, i1, and t.  but not i2. why?
 triList_5219 <- triList %>% filter(tri_id == 52914)
 # loaded in firstInt and sndInt thirdInt by hand. check them too.
 firstInt_5219 <- firstInt %>% filter(tri_id == 52914)
 sndInt_5219 <- sndInt %>% filter(tri_id == 52914)
 thirdInt_5219 <- thirdInt %>% filter(tri_id == 52914)
 # weird. the triangle appears in the firstInt data for frame 60 (and in general for frame 60)
 # BUT in the sndInt data for frame 61. what can that possibly mean? I think there may be some weirdness in the ordering
 # convention as I have seen somewhere in the comments in the code. 
 # what frame are the cell positions in sndInt_5219 from?
 check <- cellsDB %>% filter(cell_id == 10076)
 # they are really from frame 61. Hmm I don't get this. 
 