## red cells coloured by time of appearance (similarly as we do for the SOPs within Francois script)
load("time/roi_BT/SOP_cell_id.RData")

dir.create("redcells_colour_appearance")
## Pre-running tasks
# import as dataset TissueHeightR.csv

## THIS VERSION IS FOR NOBORDER. Do that first then make other versions.
## Append all things with _noborder.

## %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% #### %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ##  

## COLOUR SCALE REQUEST FROM GS: centre on the switch-time FOR THAT MOVIE, then use a consistent distance to max and minimum in every movie:
## WT1 p switch time = 26.5 = 10.5 = 252 frames
## WT2 p switch time = 27.5 = 11.5 = 276 frames
## WT3 p switch time = 26.0 = 10.0 = 240 frames
## HA1 p switch time 25.0 = 9.0 = 216 frames
## MMP1 p switch time = 11.0 = 264 frames .. has a couple of super early appearing SOPs that may not be SOPs hmm.
## MMP2 p switch time = 9.3 = 223 frames

## min red cell app = 75 (WT1), max = 468 (WT2)
## so go +- 195 frames for colour scale, centred on the p switch time.

load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")

dropout_full_noborder <- cellinfoDB %>% filter(disappears_by == "Unclassified") %>% select(cell_id,first_occ) %>% filter(cell_id %in% roiHistoNoborder$cell_id) %>% filter(!(cell_id %in% SOP_cell_id$cell_id))
count_dropout_noborder <- frames %>% select(frame)
# cross join to get every combination of frame and dropout times
count_dropout_noborder <- merge(x = count_dropout_noborder, y = dropout_full_noborder, by = NULL)
# then filter
count_dropout_noborder <- count_dropout_noborder %>% filter(first_occ < frame)
count_dropout_noborder <- count_dropout_noborder %>% select(frame) %>% group_by(frame) %>% summarise(count = n())
count_dropout_noborder$dev_time <- count_dropout_noborder$frame*2.5/60
count_dropout_noborder <- count_dropout_noborder %>% select(frame,dev_time,count)

cellshapes_dropout_full_noborder <- cellshapes %>% dt.merge(dropout_full_noborder,by="cell_id")


render_movie(cellshapes_dropout_full_noborder, "redcells_colour_appearance/cellshapes_dropout_full_noborder.mp4", list(
  geom_polygon(aes(x_pos, y_pos, group=cell_id, fill = first_occ*2.5/60),  alpha=0.75),
  scale_fill_gradientn(name="appearance time (hr)",colors  = jet.colors(7), limits= c((223-195)*2.5/60,(223+195)*2.5/60))
))



## TURN OFF FOR NOW! MMP1.
## GS Request 4th July 2019. Write the final-frame coordinates and time of appearance of every red cell. Also write the transformed (translated relative to 0,0)
## coordinates based on the bottom-left SOP thing of JRD and Ana.
# finalframepositions <- cellsDB %>% filter(frame == 399) %>% select(cell_id, center_x,center_y) %>% dt.merge(dropout_full_noborder,by="cell_id")
# finalframepositions$trans_x <- finalframepositions$center_x - 16
# finalframepositions$trans_y <- finalframepositions$center_y + 292
# finalframepositions <- finalframepositions %>% select(cell_id,first_occ,center_x,center_y,trans_x,trans_y)
# write.csv(finalframepositions, "redcells_colour_appearance/finalframepositions.csv")