## NOTE: the distribution fitting procedure here is bad, the methods used seem to select a subset of data. 

## JJW 11 March 2020 going through this again for new graph formatting. may add mother correlation analysis in too. 

## JJW 18 MARCH addition: directly measure the correlation coefficient from the data. do this both before and after the duplication thing. 

every_nth <- function(x, nth, empty = TRUE, inverse = FALSE) 
{
  if (!inverse) {
    if(empty) {
      x[1:nth == 1] <- ""
      x
    } else {
      x[1:nth != 1]
    }
  } else {
    if(empty) {
      x[1:nth != 1] <- ""
      x
    } else {
      x[1:nth == 1]
    }
  }
}

library("egg")

## sister lifetime correlation versus contemporaneously-dividing non-sisters.
## for starters don't even make a graph, just look to compare the mean lifetime offset (normalised by mean) of sisters
## to that of same-frame non-sister dividers. Could then look into making bins of frames later?

dir.create("sisters_lifetime_correlation")
load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")
roiPosterior <- roiCellsBT %>% filter(roi == "posterior")

## restrict to Anterior btw.
## SET BINSIZE PARAMETER
binsize <- 5

sisters_lifetime_correlation <- cellinfoDB %>% filter(cell_id %in% roiAnterior$cell_id) %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% select(cell_id,first_occ,last_occ,lineage_group)
sisters_lifetime_correlation$lifetime <- sisters_lifetime_correlation$last_occ - sisters_lifetime_correlation$first_occ
## NOW AT THIS STAGE DEFINE THE MID_FRAME BEFORE MERGING WITH ITSELF, TO GET PAIRS THAT ARE NONSISTERS AND ARE IN DIFFERENT FRAMES BUT SAME BIN


sisters_lifetime_correlation <- sisters_lifetime_correlation %>% mutate(mid_frame = binsize*floor(first_occ / binsize) + (binsize/2))

sisters_lifetime_correlation <- sisters_lifetime_correlation %>% dt.merge(sisters_lifetime_correlation,by="mid_frame", allow.cartesian=TRUE) %>% filter(!(cell_id.x == cell_id.y)) %>% select(-last_occ.x,-last_occ.y)
## label sisters
sisters_lifetime_correlation$sisters <- (sisters_lifetime_correlation$lineage_group.x == sisters_lifetime_correlation$lineage_group.y)

## GS FEEDBACK 28 NOVEMBER 2019. Wants to compute the covariance for sisters and nonsisters directly. 
# One way to do this would be to calculate the correlation coefficient Cov(X,Y)/(sigma_X sigma_Y) where X, Y 
# denote the lifetime of either a cell and its sister, or a cell and a randomly chosen non-sister as a control 
# (we could do it as a function of time as you are currently doing I guess?)

# make a table with just the mean lifetime for each frame bin.
meanlifetime_bin <- sisters_lifetime_correlation %>% group_by(mid_frame) %>% summarise(mean_lifetime = mean(lifetime.x),sd_lifetime = sd(lifetime.x))
# merge this back to the original table.
sisters_lifetime_correlation <- sisters_lifetime_correlation %>% dt.merge(meanlifetime_bin, by = "mid_frame")
# compute covariance, normalised by square of std dev (right?) separately for sisters and non-sisters, grouping by bin. discard half of double-counted group
cov_sisters <- sisters_lifetime_correlation %>% filter(sisters == TRUE) %>% filter(cell_id.y > cell_id.x) %>% group_by(mid_frame) %>% summarise(cov_norm = mean((lifetime.x-mean_lifetime)*(lifetime.y-mean_lifetime))/(mean(sd_lifetime)^2) )
cov_nonsisters <- sisters_lifetime_correlation %>% filter(sisters == FALSE) %>% filter(cell_id.y > cell_id.x) %>% group_by(mid_frame) %>% summarise(cov_norm = mean((lifetime.x-mean_lifetime)*(lifetime.y-mean_lifetime))/(mean(sd_lifetime)^2) )

cov_plot <- cov_sisters %>% mutate(series="sisters") %>% rbind(cov_nonsisters %>% mutate(series="nonsisters"))

myplot <- ggplot(cov_plot, aes(16 + mid_frame*2.5/60, cov_norm, color=series)) +
  geom_point(size = 2) +
  geom_line(size = 1) +
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("COV_norm of lifetime"))) +
  xlab(expression(paste("Birth time (hr) (not time-aligned)"))) +
  ggtitle("sister and nonsister lifetime correlation")
pdf("sisters_lifetime_correlation/cov_plot.pdf")
print(myplot)
dev.off()





## second part of this: 
# Guillaume wants p(X,Y) where X and Y are lifetimes of sisters. I.e. a 2D probability distribution. 
# bin in both dimensions, and use RECIPROCAL DATA FOR SISTERS (i.e. i will end up with a symmetric plot I think).
# and the colour scale will be the density of points. 
# so first just get the sisters information and then restrict to div-div cells and attach the lifetimes. 


sisters <- cellinfoDB %>% select(left_daughter_cell_id,right_daughter_cell_id) %>% rename(left_sister = left_daughter_cell_id, right_sister = right_daughter_cell_id) %>% na.omit()
divdiv <- cellinfoDB %>% filter(appears_by == "Division" & disappears_by == "Division")
sisters <- sisters %>% filter(left_sister %in% divdiv$cell_id & right_sister %in% divdiv$cell_id) 

## RESTRICT TO ANTERIOR
sisters <- sisters %>% filter(left_sister %in% roiAnterior$cell_id & right_sister %in% roiAnterior$cell_id) 


# make a swapped version
temp1 <- sisters %>% select(left_sister) %>% rename(right_sister = left_sister) 
temp2 <- sisters %>% select(right_sister) %>% rename(left_sister = right_sister) 
sisters_swapped <- temp2
sisters_swapped$right_sister <- temp1$right_sister
sisters <- rbind(sisters,sisters_swapped)
remove(sisters_swapped)

# add lifetime info.
sisters <- cellinfoDB %>% mutate(left_sister = cell_id, left_lifetime = last_occ - first_occ) %>% select(left_sister, left_lifetime) %>% dt.merge(sisters,by="left_sister")
sisters <- cellinfoDB %>% mutate(right_sister = cell_id, right_lifetime = last_occ - first_occ) %>% select(right_sister, right_lifetime) %>% dt.merge(sisters,by="right_sister")

sisters <- sisters %>% mutate(mid_left_lifetime = binsize*floor(left_lifetime / binsize) + (binsize/2)) %>% mutate(mid_right_lifetime = binsize*floor(right_lifetime / binsize) + (binsize/2)) 

### INSERT HERE 18 MARCH 2020. Just directly measure the pearson correlation as I did in FIG_2 script too.
# do it both with and without the duplication thing. 
# with duplication.
CORR_sister_lifetime_with_dup <- cor.test(sisters$right_lifetime*2.5/60, sisters$left_lifetime*2.5/60, method = c("pearson"))
# CSV files for both binned and nonbinned. 
write.csv(CORR_sister_lifetime_with_dup$estimate, file="sisters_lifetime_correlation/CORR_sister_lifetime_with_dup_estimate.csv")
write.csv(CORR_sister_lifetime_with_dup$p.value, file="sisters_lifetime_correlation/CORR_sister_lifetime_with_dup_pvalue.csv")
# without duplication
CORR_sister_lifetime_without_dup <- cor.test((sisters %>% filter(right_sister > left_sister))$right_lifetime*2.5/60, (sisters %>% filter(right_sister > left_sister))$left_lifetime*2.5/60, method = c("pearson"))
write.csv(CORR_sister_lifetime_without_dup$estimate, file="sisters_lifetime_correlation/CORR_sister_lifetime_without_dup_estimate.csv")
write.csv(CORR_sister_lifetime_without_dup$p.value, file="sisters_lifetime_correlation/CORR_sister_lifetime_without_dup_pvalue.csv")

### CHECKING FOR COMPARISON WITH GS's method in Jupyter notebook.
### on the basis of the without_dup data first. see if number of pairs counted, and so on, is same as GS.
test <- sisters %>% filter(right_sister > left_sister)
## has 922 entries. GS's uses the duplicated version I guess since it has 1844 pairs.
## proceed from here replicating GS's calculation as he describes it to me
tau <- mean(sisters$right_lifetime)
sigma_tau <- sd(sisters$right_lifetime)
gs_correlation <- sisters %>% mutate(contr = (right_lifetime-tau)*(left_lifetime-tau)/(sigma_tau^2) )
gs_correlation_result <- mean(gs_correlation$contr)




# need to somehow make it create Bins with ZERO count when no cell pairs exist for that bin.
# so lets make a fake table which lists one entry for each combination of mid_left_lifetime and mid_right_lifetime up to some limit, then combine it
# and then afterward subtract one from the count of all bins. 

dummy <- as.df(seq((binsize/2), 300+(binsize/2), by = binsize)) %>% rename(mid_right_lifetime = dt)
dummy <- as.df(seq((binsize/2), 300+(binsize/2), by = binsize)) %>% rename(mid_left_lifetime = dt) %>% merge(dummy)
dummy$right_sister <- 1
dummy$left_sister <- 1
dummy$left_lifetime <- 1
dummy$right_lifetime <- 1

sisters_plus_dummy <- rbind(sisters,dummy)

# make the count unnormalised first.
pxy_sisters <- sisters_plus_dummy %>% group_by(mid_left_lifetime,mid_right_lifetime) %>% summarise(count = n())
# substract ONE from each count to remove the dummy that I used to get zeros where there are no cell pairs
pxy_sisters$count <- pxy_sisters$count - 1
# normalise by total of count and by 'area' of a bin in frames^2 (IS THIS RIGHT?)
normalisation <- sum(pxy_sisters$count)*binsize^2
pxy_sisters$density <- pxy_sisters$count/normalisation
check <- sum(pxy_sisters$density)*binsize^2 #should be 1. 

## arrange nicely for CSV etc.
pxy_sisters <- pxy_sisters %>% arrange(mid_right_lifetime,mid_left_lifetime)
# make a plot
myplot <- ggplot(pxy_sisters, aes(mid_right_lifetime*2.5/60, mid_left_lifetime*2.5/60, fill=density)) + 
  geom_tile() +
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=3/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_blank(), # special for heatmaps element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
  ylab(expression(paste("Sister lifetime (hr)"))) +
  xlab(expression(paste("Sister lifetime (hr)"))) +
  scale_y_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE))
myplot <- set_panel_size(myplot,width  = unit(39*2/3, "mm"), #special square aspect
                         height = unit(39*2/3, "mm")) # special square aspect ratio for these heatmaps
ggsave("sisters_lifetime_correlation/pxy_heatmap_anterior.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


# make a CSV:
write.csv(pxy_sisters,file="sisters_lifetime_correlation/pxy_heatmap_anterior.csv")

## 3d surface plot??
#install.packages("plotly")
library("plotly")

#p <- plot_ly(z = ~volcano) %>% add_surface()
p <- plot_ly(x = as.vector(pxy_sisters$mid_right_lifetime), y= as.vector(pxy_sisters$mid_left_lifetime), z = as.vector(pxy_sisters$density), type = 'mesh3d',intensity=as.vector(pxy_sisters$density)) 
#p <- plot_ly(z = as.matrix(pxy_sisters %>% select(-count)), type = "surface")
p
#if (!require("processx")) install.packages("processx")
library("processx")
orca(p, "sisters_lifetime_correlation/plotly_test.png")


# whatever.


# now want to either MEASURE or FIT the pxy as a bivariate normal distribution.
# http://mathworld.wolfram.com/BivariateNormalDistribution.html
# https://bioconductor.org/packages/release/bioc/vignettes/prada/inst/doc/norm2.pdf
# if (!requireNamespace("BiocManager", quietly = TRUE))
#   install.packages("BiocManager")
# BiocManager::install(version = "3.10")
#BiocManager::install(c("prada"))

# should be able to use prada as specified in the bioconductor vignette website above. I thiiiink I should apply it to the binned data
# not the raw data? could try both. 
# so start with sisters data but use the mid_right_lifetime and mid_left_lifetime
library("prada")

# meaning of fit output
# A list containing items mu (midpoint of distribution), S (covariance matrix), 
# p (density values for each data pair), sel (selection of data points), 
# scalefac (factor of standard deviations used for data selection), 
# data (x and y values of data points) and gate, an object of class gate containing the selection.
fit_input <- sisters %>% select(mid_right_lifetime,mid_left_lifetime)
# try to perform the fit. scalefac is just for plotting purposes says how wide to show the ellipse which is an equiprobable contour
# it doesnt affect the fit values found
fit1 <- fitNorm2(as.vector(fit_input$mid_right_lifetime), y=as.vector(fit_input$mid_left_lifetime), scalefac=1, method="covMcd", gateName = "fitNorm")
#fit2 <- fitNorm2(as.vector(fit_input$mid_right_lifetime), y=as.vector(fit_input$mid_left_lifetime), scalefac=2, method="covMcd", gateName = "fitNorm")
#plot the fit to see
plot1 <- plotNorm2(fit1, selection=TRUE, ellipse=TRUE, col = "dens")
dev.copy(png,"sisters_lifetime_correlation/fit_plot1.png")
dev.off()
#plotNorm2(fit2, selection=TRUE, ellipse=TRUE)

## ALSO plot from just the raw data, not the binned data.  think this is better
fit_input_raw <- sisters %>% select(right_lifetime,left_lifetime)
fit1_raw <- fitNorm2(as.vector(fit_input_raw$right_lifetime), y=as.vector(fit_input_raw$left_lifetime), scalefac=1, method="covMcd", gateName = "fitNorm")
#plot the fit to see
plot1_raw <- plotNorm2(fit1_raw, selection=TRUE, ellipse=TRUE, col = "dens")
dev.copy(png,"sisters_lifetime_correlation/fit_plot1_raw.png")
dev.off()

# now output the fit distribution properties in CSV. calculate basic properties of the fitted distribution.
write.csv(fit1_raw$mu,file="sisters_lifetime_correlation/fit_plot1_raw_mus.csv")
write.csv(fit1_raw$S,file="sisters_lifetime_correlation/fit_plot1_raw_S.csv")
rho <- fit1_raw$S[1,2]/( sqrt(fit1_raw$S[1,1]) * sqrt(fit1_raw$S[2,2]) )
sigmasq <- fit1_raw$S[1,1]
sigma <- sqrt(sigmasq)
mu <- fit1_raw$mu[[1]]
write.csv(rho, file="sisters_lifetime_correlation/fit_plot1_raw_rho.csv")
write.csv(sigmasq, file="sisters_lifetime_correlation/fit_plot1_raw_sigmasq.csv")

### ADDITION try cov.rob method
fit1_raw_covrob <- fitNorm2(as.vector(fit_input_raw$right_lifetime), y=as.vector(fit_input_raw$left_lifetime), scalefac=1, method="cov.rob", gateName = "fitNorm")
rho <- fit1_raw_covrob$S[1,2]/( sqrt(fit1_raw_covrob$S[1,1]) * sqrt(fit1_raw_covrob$S[2,2]) )
### END ADDITION

## now need to synthesise a bivariate normal distribution with this means, variance and covariance and plot it to see that it looks similar. 
library(MASS)
# how many samples to take to mimic the real data.
number_of_samples <- nrow(sisters)/2
synthetic_from_fit1_raw <- mvrnorm(number_of_samples, mu = fit1_raw$mu, Sigma = fit1_raw$S, 2) %>% as.data.frame() %>% rename(right_lifetime = x, left_lifetime = y)
# now replicate the histogram heatmap making procedure on this data. need
# to do everything perhaps even starting from reciprocal-ising the data. 
# remove MASS now so that I CAN USE  dplyr properly
detach("package:prada", unload=TRUE)
detach("package:MASS", unload=TRUE)
# make a swapped version
temp1 <- synthetic_from_fit1_raw %>% select(left_lifetime) %>% rename(right_lifetime = left_lifetime) 
temp2 <- synthetic_from_fit1_raw %>% select(right_lifetime) %>% rename(left_lifetime = right_lifetime) 
synthetic_from_fit1_raw_swapped <- temp2
synthetic_from_fit1_raw_swapped$right_lifetime <- temp1$right_lifetime
synthetic_from_fit1_raw <- rbind(synthetic_from_fit1_raw,synthetic_from_fit1_raw_swapped)
remove(synthetic_from_fit1_raw_swapped)

# add lifetime info
synthetic_from_fit1_raw <- synthetic_from_fit1_raw %>% mutate(mid_left_lifetime = binsize*floor(left_lifetime / binsize) + (binsize/2)) %>% mutate(mid_right_lifetime = binsize*floor(right_lifetime / binsize) + (binsize/2)) 

# need to somehow make it create Bins with ZERO count when no cell pairs exist for that bin.
# so lets make a fake table which lists one entry for each combination of mid_left_lifetime and mid_right_lifetime up to some limit, then combine it
# and then afterward subtract one from the count of all bins. 

dummy <- as.df(seq((binsize/2), 300+(binsize/2), by = binsize)) %>% rename(mid_right_lifetime = dt)
dummy <- as.df(seq((binsize/2), 300+(binsize/2), by = binsize)) %>% rename(mid_left_lifetime = dt) %>% merge(dummy)
dummy$left_lifetime <- 1
dummy$right_lifetime <- 1

synthetic_from_fit1_raw_plus_dummy <- rbind(synthetic_from_fit1_raw,dummy)

# make the count unnormalised first.
pxy_synthetic_from_fit1_raw <- synthetic_from_fit1_raw_plus_dummy %>% group_by(mid_left_lifetime,mid_right_lifetime) %>% summarise(count = n())
# substract ONE from each count to remove the dummy that I used to get zeros where there are no cell pairs
pxy_synthetic_from_fit1_raw$count <- pxy_synthetic_from_fit1_raw$count - 1
# normalise by total of count and by 'area' of a bin in frames^2 (IS THIS RIGHT?)
normalisation <- sum(pxy_synthetic_from_fit1_raw$count)*binsize^2
pxy_synthetic_from_fit1_raw$density <- pxy_synthetic_from_fit1_raw$count/normalisation
check <- sum(pxy_synthetic_from_fit1_raw$density)*binsize^2 #should be 1. 

## arrange nicely for CSV etc.
pxy_synthetic_from_fit1_raw <- pxy_synthetic_from_fit1_raw %>% arrange(mid_right_lifetime,mid_left_lifetime)
# make a plot
myplot <- ggplot(pxy_synthetic_from_fit1_raw, aes(mid_right_lifetime*2.5/60, mid_left_lifetime*2.5/60, fill=density)) + 
  geom_tile() +
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=3/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_blank(), # special for heatmaps element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
  ylab(expression(paste("Sister lifetime (hr)"))) +
  xlab(expression(paste("Sister lifetime (hr)"))) +
  scale_y_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE))
myplot <- set_panel_size(myplot,width  = unit(39*2/3, "mm"), #special square aspect
                         height = unit(39*2/3, "mm")) # special square aspect ratio for these heatmaps
ggsave("sisters_lifetime_correlation/pxy_heatmap_synthetic_from_fit1_raw.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

# myplot <- ggplot(pxy_synthetic_from_fit1_raw, aes(mid_right_lifetime*2.5/60, mid_left_lifetime*2.5/60, fill=density)) + 
#   geom_tile() +
#   theme(legend.position = "none") +
#   theme(text = element_text(size = 18)) +
#   scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
#   ylab(expression(paste("Sister lifetime (hr)"))) +
#   xlab(expression(paste("Sister lifetime (hr)"))) +
#   ylim(0,8.5) +
#   xlim(0,8.5) 
# pdf("sisters_lifetime_correlation/pxy_heatmap_synthetic_from_fit1_raw.pdf")
# print(myplot)
# dev.off()

# make a CSV:
write.csv(pxy_sisters,file="sisters_lifetime_correlation/pxy_heatmap_synthetic_from_fit1_raw.csv")

## try making a smooth heatmap of the completely ANALYTIC i.e. not sampled distribution.
# https://www.rdocumentation.org/packages/emdbook/versions/1.3.11/topics/dmvnorm
# https://stackoverflow.com/questions/26106086/2d-normal-pdf-with-ggplot-and-r
#install.packages("mvtnorm")
library("mvtnorm")
mvtnorm::dmvnorm()

pxy_analytic_from_fit1_raw <- as.df(seq((binsize/2), 300+(binsize/2), by = 1)) %>% rename(mid_right_lifetime = dt)
pxy_analytic_from_fit1_raw <- as.df(seq((binsize/2), 300+(binsize/2), by = 1)) %>% rename(mid_left_lifetime = dt) %>% merge(pxy_analytic_from_fit1_raw)

# ___________________________ analytic parameters
pxy_analytic_from_fit1_raw <- pxy_analytic_from_fit1_raw  %>% mutate(density = mvtnorm::dmvnorm(x=matrix(c(mid_left_lifetime,mid_right_lifetime),ncol=2),mean=matrix(c(104,104),ncol=2),sigma=matrix(c(424,308,308,424),ncol=2) ) )
# ___________________________ analytic parameters

myplot <- ggplot(pxy_analytic_from_fit1_raw, aes(mid_right_lifetime*2.5/60, mid_left_lifetime*2.5/60, fill=density)) + 
  geom_tile() +
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=3/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_blank(), # special for heatmaps element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
  ylab(expression(paste("Sister lifetime (hr)"))) +
  xlab(expression(paste("Sister lifetime (hr)"))) +
  scale_y_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE))
myplot <- set_panel_size(myplot,width  = unit(39*2/3, "mm"), #special square aspect
                         height = unit(39*2/3, "mm")) # special square aspect ratio for these heatmaps
ggsave("sisters_lifetime_correlation/pxy_heatmap_analytic_from_fit1_raw.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


# myplot <- ggplot(pxy_analytic_from_fit1_raw, aes(mid_right_lifetime*2.5/60, mid_left_lifetime*2.5/60, fill=density)) + 
#   geom_tile() +
#   geom_raster() + 
#   theme(legend.position = "none") +
#   theme(text = element_text(size = 18)) +
#   scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
#   ylab(expression(paste("Sister lifetime (hr)"))) +
#   xlab(expression(paste("Sister lifetime (hr)"))) +
#   ylim(0,8.5) +
#   xlim(0,8.5) 
# pdf("sisters_lifetime_correlation/pxy_heatmap_analytic_from_fit1_raw.pdf")
# print(myplot)
# dev.off()




## ADDITIONS!
#look at 3d surface for both synthetic and natural data
#plot slices along the y=x and perpendicularly thereto for both to see

# Y = X SLICE
prefactor <- 1 / (2*pi*sigmasq * sqrt((1 - rho^2))    )
prefactorexp <- -1/(2*(1-rho^2))
data_slice <- pxy_sisters %>% filter(mid_left_lifetime == mid_right_lifetime)
myplot <- ggplot(data_slice, aes(mid_left_lifetime, density)) + 
  geom_line(size = 2) +
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("density"))) + 
  stat_function(fun = function(.x)  prefactor*exp(prefactorexp * ( (((.x - mu)^2)/sigmasq)*(2 - 2*rho)))     , colour = "red", size = 2   ) 
pdf("sisters_lifetime_correlation/data_slice_and_analytic.pdf")
print(myplot)
dev.off()

# Y - mu = - (X - mu) slice
prefactor <- 1 / (2*pi*sigmasq * sqrt((1 - rho^2))    )
prefactorexp <- -1/(2*(1-rho^2))
# I need to now find the bin of mid_lifetime what is closest to the mean
mean_bin <- binsize*floor(mu / binsize) + (binsize/2)
# now define the data for perpendicular slice using this approximate mean
data_slice_perp <- pxy_sisters %>% filter(mid_left_lifetime - mean_bin == -(mid_right_lifetime - mean_bin))
# now this is subtle for the analytic part because I want to plot
# not exactly the line going through the mean, but the offset one
myplot <- ggplot(data_slice_perp, aes(mid_left_lifetime, density)) + 
  geom_line(size = 2) +
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("density"))) + 
  stat_function(fun = function(.x)  prefactor*exp(prefactorexp * ( ((.x-mu)/sigma)^2  - 2*rho*( ((.x-mu)/sigma)*((2*mean_bin-.x-mu)/sigma)) + ((2*mean_bin-.x-mu)/sigma)^2 ) ) , colour = "red", size = 2   ) 
pdf("sisters_lifetime_correlation/data_slice_perp_and_analytic.pdf")
print(myplot)
dev.off()

## NOW CHECK SLICES FOR SYNTHETIC DATA
#y=x
synth_slice <- pxy_synthetic_from_fit1_raw %>% filter(mid_left_lifetime == mid_right_lifetime)
myplot <- ggplot(synth_slice, aes(mid_left_lifetime, density)) + 
  geom_line(size = 2) +
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("density"))) + 
  stat_function(fun = function(.x)  prefactor*exp(prefactorexp * ( (((.x - mu)^2)/sigmasq)*(2 - 2*rho)))     , colour = "red", size = 2   ) 
pdf("sisters_lifetime_correlation/synth_slice_and_analytic.pdf")
print(myplot)
dev.off()
# perpendicular
synth_slice_perp <- pxy_synthetic_from_fit1_raw %>% filter(mid_left_lifetime - mean_bin == -(mid_right_lifetime - mean_bin))
# now this is subtle for the analytic part because I want to plot
# not exactly the line going through the mean, but the offset one
myplot <- ggplot(synth_slice_perp, aes(mid_left_lifetime, density)) + 
  geom_line(size = 2) +
  theme(text = element_text(size = 18)) +
  ylab(expression(paste("density"))) + 
  stat_function(fun = function(.x)  prefactor*exp(prefactorexp * ( ((.x-mu)/sigma)^2  - 2*rho*( ((.x-mu)/sigma)*((2*mean_bin-.x-mu)/sigma)) + ((2*mean_bin-.x-mu)/sigma)^2 ) ) , colour = "red", size = 2   ) 
pdf("sisters_lifetime_correlation/synth_slice_perp_and_analytic.pdf")
print(myplot)
dev.off()


#check that statistically generating with that data produces a good synthetic data


















## for comparison why not make a plot which contains  randomised pairs of div-div cells 
## THOUGH: nb unlike the COV think there is no restriction for them to born in similar time periods hmm
# divdiv_anterior <- divdiv %>% filter(cell_id %in% roiAnterior$cell_id)
# 
# randompairs <- divdiv_anterior %>% filter()



# %%%%%%%%%%%%%%%%%%%%%%%% OLD SIMPLE CHECK THING
## quick-check before making a graph or anything. just group all sisters and all nonsisters pairs.
# quick_check_sisters <- sisters_lifetime_correlation %>% filter(sisters == TRUE) %>% summarise(mean_offset_norm = mean(offset_norm)) %>% mutate(series = "sisters")
# quick_check_nonsisters <- sisters_lifetime_correlation %>% filter(sisters == FALSE) %>% summarise(mean_offset_norm = mean(offset_norm)) %>% mutate(series = "same frame non-sisters")
# 
# ## print csv
# tosave <- rbind(quick_check_sisters,quick_check_nonsisters)
# write.csv(tosave,file="sisters_lifetime_correlation/mean_normalised_lifetime_offset.csv")
# 
# ## print scatter graph as a function of first_occ, first for sisters then separately nonsisters
# myplot <- ggplot(sisters_lifetime_correlation %>% filter(sisters == TRUE), aes(16 + first_occ*2.5/60, offset_norm)) + 
#   geom_point(size = 1,alpha=0.25) +
#   stat_summary_bin(fun.y='mean',bins=10,geom='point',size=2,color="orange") +
#   stat_summary_bin(fun.data = mean_se, geom = "errorbar", bins=10,color="orange") +
#   theme(text = element_text(size = 18)) +
#   ylab(expression(paste("offset_norm"))) + 
#   xlab(expression(paste("Birth time (hr) (not time-aligned)"))) + 
#   ggtitle("lifetime offset_norm (sisters)")
# pdf("sisters_lifetime_correlation/sisters_lifetime_correlation_sisters.pdf")
# print(myplot)
# dev.off()
# #non sisters
# myplot <- ggplot(sisters_lifetime_correlation %>% filter(sisters == FALSE), aes(16 + first_occ*2.5/60, offset_norm)) + 
#   geom_point(size = 1,alpha=0.25) +
#   stat_summary_bin(fun.y='mean',bins=10,geom='point',size=2,color="orange") +
#   stat_summary_bin(fun.data = mean_se, geom = "errorbar", bins=10,color="orange") +
#   theme(text = element_text(size = 18)) +
#   ylab(expression(paste("offset_norm"))) + 
#   xlab(expression(paste("Birth time (hr) (not time-aligned)"))) + 
#   ggtitle("lifetime offset_norm (nonsisters)")
# pdf("sisters_lifetime_correlation/sisters_lifetime_correlation_nonsisters.pdf")
# print(myplot)
# dev.off()